SystemOrganization addCategory: #'SmaCCDev-ParserGenerator'!
SystemOrganization addCategory: #'SmaCCDev-ScannerGenerator'!
SystemOrganization addCategory: #'SmaCCDev-UI'!
SystemOrganization addCategory: #'SmaCCDev-Examples'!
SystemOrganization addCategory: #'SmaCCDev-Tests'!

Notification subclass: #SmaCCCompilationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCCompilationNotification commentStamp: 'jmb' prior: 0!
SmaCCCompilationNotification is a notification that is raised when we discover a problem with the parser. For example, a shift/reduce conflict will raise this notification.!

StringHolder subclass: #SmaCCCodeHolder
	instanceVariableNames: 'contentsMorph owner ownerAcceptSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-UI'!

!SmaCCCodeHolder classSide methodsFor: 'instance creation' stamp: 'apl 2/18/2003 13:44'!
owner: aSmaCCParserGenerator 
	^ self owner: aSmaCCParserGenerator ownerAcceptSelector: nil! !

!SmaCCCodeHolder classSide methodsFor: 'instance creation' stamp: 'apl 2/17/2003 11:26'!
owner: aSmaCCParserGenerator ownerAcceptSelector: aSymbol 
	^ self new owner: aSmaCCParserGenerator ownerAcceptSelector: aSymbol ! !

!SmaCCCodeHolder methodsFor: 'menus' stamp: 'apl 2/18/2003 12:39'!
contents: aStringOrText notifying: aRequestor 
	| result |
	self ownerAcceptSelector notNil ifTrue: [result := (self owner
			perform: self ownerAcceptSelector
			with: aStringOrText
			with: aRequestor)] ifFalse: [result := true].
		result ifTrue: [self acceptContents: aStringOrText.
			^ true].
	^ false! !

!SmaCCCodeHolder methodsFor: 'menus' stamp: 'ThierryGoubier 3/13/2012 23:22'!
contentsMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:,  
	PluggableTextController will respond to all menu items in a text pane"
	| selections labelsString linesArray |
	selections := #(#find #findAgain #setSearchString #again #undo #copySelection #cut #paste #pasteRecent #accept #cancel #saveContentsInFile #sendContentsToPrinter #printerSetup #readContentsFromFile ).
	labelsString := 'find...(f)\find again (g)\set search string (h)\do again (j)\undo (z)\copy (c)\cut (x)\paste (v)\paste...\accept (s)\cancel (l)\save contents to file...\send contents to printer\printer setup\read contents from file...' withCRs.
	linesArray := #(3 5 9 11 14).
	^ aMenu
		labels: labelsString
		lines: linesArray
		selections: selections! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'lr 11/25/2009 18:30'!
contentsMorph
   contentsMorph isNil
       ifTrue: [
           contentsMorph := PluggableTextMorph
                       on: self
                       text: #contents
                       accept: #contents:notifying:
                       readSelection: nil
                       menu: #contentsMenu:shifted:].
   ^ contentsMorph
! !

!SmaCCCodeHolder methodsFor: 'edit flag' stamp: 'apl 2/18/2003 10:25'!
hasUnacceptedEdits
	^ self contentsMorph hasUnacceptedEdits! !

!SmaCCCodeHolder methodsFor: 'edit flag' stamp: 'apl 2/17/2003 11:39'!
hasUnacceptedEdits: aBoolean 
	^ self contentsMorph hasUnacceptedEdits: aBoolean! !

!SmaCCCodeHolder methodsFor: 'edit flag' stamp: 'apl 2/17/2003 11:39'!
okToChange
	^ super okToChange! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 11:23'!
owner
	^owner! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 11:23'!
owner: anObject
	owner := anObject! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 12:30'!
owner: aSmaCCParserGenerator ownerAcceptSelector: aSymbol 
	self owner: aSmaCCParserGenerator.
	self ownerAcceptSelector: aSymbol.
! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 11:26'!
ownerAcceptSelector
	^ownerAcceptSelector! !

!SmaCCCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2003 11:26'!
ownerAcceptSelector: anObject
	ownerAcceptSelector := anObject! !

!SmaCCCodeHolder methodsFor: 'menus' stamp: 'apl 2/17/2003 11:16'!
perform: selector orSendTo: otherTarget 
	"Selector was just chosen from a menu by a user. If can respond, 
	then perform it on myself. If not, send it to otherTarget,  
	presumably the editPane from which the menu was invoked."
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SmaCCCodeHolder methodsFor: 'menus' stamp: 'AlainPlantec 12/10/2010 08:22'!
readContentsFromFile
	| result  |
	(result := UIManager default
			chooseFileMatching: nil 
			label: 'Choose file to open' translated)
		ifNotNil: [
			(FileDirectory default fileExists: result)
				ifFalse: [^ UIManager default inform: ' ' , result , ' doesn''t exists '].
			self acceptContents: (FileStream fileNamed: result) contents. self changed: #contents]! !

Model subclass: #SmaCCSymbolSet
	instanceVariableNames: 'symbols components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCSymbolSet commentStamp: 'jmb' prior: 0!
SmaCCSymbolSet represents a set of follow symbols in the LALR(1) item sets.

Instance Variables:
	components	<Collection of: SmaCCSymbolSet>	other SmaCCSymbolSets that we depend on, we include all items in these sets also
	symbols	<Collection of: SmaCCTerminalSymbol>	our follow symbols!

!SmaCCSymbolSet classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
basedOn: aSmaCCSymbolSet 
	^(self new)
		baseOn: aSmaCCSymbolSet;
		yourself! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
add: aSmaCCSymbol 
	(symbols includes: aSmaCCSymbol) ifTrue: [^self].
	symbols add: aSmaCCSymbol.
	self changed! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addAll: aCollection 
	| oldSize |
	oldSize := symbols size.
	symbols addAll: aCollection.
	oldSize ~= symbols size ifTrue: [self changed]! !

!SmaCCSymbolSet methodsFor: 'private' stamp: ' 6/1/07 21:19'!
addComponent: each 
	(each = self or: [components includes: each]) ifTrue: [^self].
	components add: each.
	each addDependent: self.
	self addAll: each symbols! !

!SmaCCSymbolSet methodsFor: 'private' stamp: ' 6/1/07 21:19'!
addComponentsFrom: aSmaCCSymbolSet 
	aSmaCCSymbolSet components do: [:each | self addComponent: each]! !

!SmaCCSymbolSet methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
allSatisfy: aBlock 
	^symbols allSatisfy: aBlock! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
baseOn: aSmaCCSymbolSet 
	self addComponent: aSmaCCSymbolSet.
	self addAll: aSmaCCSymbolSet symbols! !

!SmaCCSymbolSet methodsFor: 'private' stamp: ' 6/1/07 21:19'!
components
	^components! !

!SmaCCSymbolSet methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
includes: aSmaCCSymbol 
	^symbols includes: aSmaCCSymbol! !

!SmaCCSymbolSet methodsFor: 'initialize-release' stamp: 'lr 1/8/2007 14:42'!
initialize
	symbols := Set new.
	components := Set new! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
mergeWith: aSmaCCSymbolSet 
	self addAll: aSmaCCSymbolSet symbols.
	self addComponentsFrom: aSmaCCSymbolSet! !

!SmaCCSymbolSet methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	symbols do: [:each | aStream nextPutAll: each printString]
		separatedBy: [aStream space]! !

!SmaCCSymbolSet methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
size
	^symbols size! !

!SmaCCSymbolSet methodsFor: 'private' stamp: ' 6/1/07 21:19'!
symbols
	^symbols! !

!SmaCCSymbolSet methodsFor: 'updating' stamp: 'lr 1/8/2007 14:47'!
update: aSender
	(components includes: aSender) ifTrue: [self addAll: aSender symbols]! !

SmaCCScanner subclass: #CScanner
	instanceVariableNames: 'typeNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Examples'!

!CScanner classSide methodsFor: 'generated-initialization' stamp: 'lr 4/12/2010 17:49'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(#IDENTIFIER 'auto' 65) #(#IDENTIFIER 'break' 48) #(#IDENTIFIER 'case' 38) #(#IDENTIFIER 'char' 73) #(#IDENTIFIER 'const' 40) #(#IDENTIFIER 'continue' 47) #(#IDENTIFIER 'default' 39) #(#IDENTIFIER 'do' 54) #(#IDENTIFIER 'double' 70) #(#IDENTIFIER 'else' 46) #(#IDENTIFIER 'enum' 45) #(#IDENTIFIER 'extern' 58) #(#IDENTIFIER 'float' 67) #(#IDENTIFIER 'for' 49) #(#IDENTIFIER 'goto' 50) #(#IDENTIFIER 'if' 42) #(#IDENTIFIER 'int' 69) #(#IDENTIFIER 'long' 66) #(#IDENTIFIER 'register' 71) #(#IDENTIFIER 'return' 56) #(#IDENTIFIER 'short' 68) #(#IDENTIFIER 'signed' 51) #(#IDENTIFIER 'sizeof' 24) #(#IDENTIFIER 'static' 61) #(#IDENTIFIER 'struct' 43) #(#IDENTIFIER 'switch' 52) #(#IDENTIFIER 'typedef' 57) #(#IDENTIFIER 'union' 44) #(#IDENTIFIER 'unsigned' 55) #(#IDENTIFIER 'void' 72) #(#IDENTIFIER 'volatile' 41) #(#IDENTIFIER 'while' 53))
		do: [ :each | (keywordMap at: each first ifAbsentPut: [ Dictionary new ]) at: (each at: 2) put: each last ].
	^ keywordMap! !

!CScanner classSide methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
needsLineNumbers
	^true! !

!CScanner classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:49'!
scannerDefinitionComment

	"<H>: [a-fA-F0-9]	;
<IS>: [uUlL]	;
<D>: [0-9]	;
<E>: [Ee][\+\-]?<D>+	;
<FS>: [fFlL]	;
<ELLIPSIS> : \.\.\. ;
<comment>: \/ \*	;
<LETTER> : [a-zA-Z_] ;
<DIGIT> : [0-9] ;
<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
<CONSTANT>: (0[xX]<H>+<IS>?) | 
				(<D>+<IS>?) | 
				(<D>+<E><FS>?) | 
				<D>*\.<D>+<E>?<FS>? | 
				(L? \' ( (\\ .) | ([^\\\""]) )+ \')	;

<STRING_LITERAL>: L? \"" ( (\\ .) | ([^\\\""]) )* \""	;

<LEFT_BLOCK>: \[ | (\< \:)	;
<RIGHT_BLOCK>: \] | (\: \>)	;
<LEFT_BRACE>: \{ | (\< \%)	;
<RIGHT_BRACE>: \} | (\% \>)	;

<whitespace>: \s+	;"! !

!CScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
CONSTANTId
	^77! !

!CScanner methodsFor: 'scanning' stamp: ' 6/1/07 21:19'!
IDENTIFIER
	| name |
	name := outputStream contents.
	matchActions := (typeNames includes: name) 
				ifTrue: [Array with: self TypeNameId]
				ifFalse: [Array with: self IDENTIFIERId].
	outputStream reset.
	^SmaCCToken 
		value: name
		start: start
		id: matchActions! !

!CScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
IDENTIFIERId
	^76! !

!CScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
TypeNameId
	^132! !

!CScanner methodsFor: 'scanning' stamp: ' 6/1/07 21:19'!
addTypeName: aString 
	typeNames add: aString! !

!CScanner methodsFor: 'default token handling' stamp: ' 6/1/07 21:19'!
comment
	| char |
	
	[[(char := stream next) isNil or: [char == $*]] whileFalse.
	stream atEnd ifTrue: [self scannerError].
	stream peekFor: $/] 
			whileFalse.
	^self whitespace! !

!CScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
emptySymbolTokenId
	^147! !

!CScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
errorTokenId
	^148! !

!CScanner methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	super initialize.
	typeNames := Set new! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan1
	[ 
	self recordMatch: #(77).
	self step.
	currentCharacter between: $0 and: $9 ] whileTrue.
	(currentCharacter = $F or: [ currentCharacter = $L or: [ currentCharacter = $f or: [ currentCharacter = $l ] ] ])
		ifTrue: [ ^ self recordAndReportMatch: #(77) ].
	(currentCharacter = $E or: [ currentCharacter = $e ])
		ifTrue: [ ^ self scan3 ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan2
	self step.
	(currentCharacter between: $0 and: $9)
		ifTrue: [ ^ self scan1 ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan3
	self step.
	(currentCharacter between: $0 and: $9)
		ifTrue: [ ^ self scan4 ].
	(currentCharacter = $+ or: [ currentCharacter = $- ])
		ifTrue: [ 
			self step.
			(currentCharacter between: $0 and: $9)
				ifTrue: [ ^ self scan4 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan4
	[ 
	self recordMatch: #(77).
	self step.
	currentCharacter between: $0 and: $9 ] whileTrue.
	(currentCharacter = $F or: [ currentCharacter = $L or: [ currentCharacter = $f or: [ currentCharacter = $l ] ] ])
		ifTrue: [ ^ self recordAndReportMatch: #(77) ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan5
	[ 
	self recordMatch: #(77).
	self step.
	currentCharacter between: $0 and: $9 ] whileTrue.
	(currentCharacter = $L or: [ currentCharacter = $U or: [ currentCharacter = $l or: [ currentCharacter = $u ] ] ])
		ifTrue: [ ^ self recordAndReportMatch: #(77) ].
	(currentCharacter = $E or: [ currentCharacter = $e ])
		ifTrue: [ ^ self scan3 ].
	currentCharacter = $.
		ifTrue: [ ^ self scan2 ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan6
	[ 
	self step.
	currentCharacter <= $!! or: [ (currentCharacter between: $# and: $[) or: [ currentCharacter >= $] ] ] ] whileTrue.
	currentCharacter = $"
		ifTrue: [ ^ self recordAndReportMatch: #(78) ].
	currentCharacter = $\
		ifTrue: [ 
			self step.
			currentCharacter <= $
				ifTrue: [ ^ self scan6 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan7
	self step.
	(currentCharacter <= $!! or: [ (currentCharacter between: $# and: $[) or: [ currentCharacter >= $] ] ])
		ifTrue: [ ^ self scan8 ].
	currentCharacter = $\
		ifTrue: [ ^ self scan9 ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan8
	[ 
	self step.
	currentCharacter <= $!!
		or: [ (currentCharacter between: $# and: $&) or: [ (currentCharacter between: $( and: $[) or: [ currentCharacter >= $] ] ] ] ]
		whileTrue.
	currentCharacter = $'
		ifTrue: [ 
			[ 
			self recordMatch: #(77).
			self step.
			(currentCharacter <= $!!
				or: [ (currentCharacter between: $# and: $&) or: [ (currentCharacter between: $( and: $[) or: [ currentCharacter >= $] ] ] ])
				ifTrue: [ ^ self scan8 ].
			currentCharacter = $' ] whileTrue.
			currentCharacter = $\
				ifTrue: [ ^ self scan9 ].
			^ self reportLastMatch ].
	currentCharacter = $\
		ifTrue: [ ^ self scan9 ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan9
	self step.
	currentCharacter <= $
		ifTrue: [ ^ self scan8 ].
	^ self reportLastMatch! !

!CScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scanForToken
	self step.
	((currentCharacter between: $A and: $K)
		or: [ (currentCharacter between: $M and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ])
		ifTrue: [ 
			[ 
			self recordMatch: #IDENTIFIER.
			self step.
			(currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	(currentCharacter between: $1 and: $9)
		ifTrue: [ ^ self scan5 ].
	((currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ])
		ifTrue: [ 
			[ 
			self recordMatch: #whitespace.
			self step.
			(currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ] ] whileTrue.
			^ self reportLastMatch ].
	currentCharacter = $!!
		ifTrue: [ 
			self recordMatch: #(32).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(4) ].
			^ self reportLastMatch ].
	currentCharacter = $"
		ifTrue: [ ^ self scan6 ].
	currentCharacter = $%
		ifTrue: [ 
			self recordMatch: #(30).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(10) ].
			currentCharacter = $>
				ifTrue: [ ^ self recordAndReportMatch: #(82) ].
			^ self reportLastMatch ].
	currentCharacter = $&
		ifTrue: [ 
			self recordMatch: #(28).
			self step.
			currentCharacter = $&
				ifTrue: [ ^ self recordAndReportMatch: #(5) ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(63) ].
			^ self reportLastMatch ].
	currentCharacter = $'
		ifTrue: [ ^ self scan7 ].
	currentCharacter = $(
		ifTrue: [ ^ self recordAndReportMatch: #(25) ].
	currentCharacter = $)
		ifTrue: [ ^ self recordAndReportMatch: #(26) ].
	currentCharacter = $*
		ifTrue: [ 
			self recordMatch: #(34).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(12) ].
			^ self reportLastMatch ].
	currentCharacter = $+
		ifTrue: [ 
			self recordMatch: #(35).
			self step.
			currentCharacter = $+
				ifTrue: [ ^ self recordAndReportMatch: #(23) ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(11) ].
			^ self reportLastMatch ].
	currentCharacter = $,
		ifTrue: [ ^ self recordAndReportMatch: #(21) ].
	currentCharacter = $-
		ifTrue: [ 
			self recordMatch: #(36).
			self step.
			currentCharacter = $-
				ifTrue: [ ^ self recordAndReportMatch: #(20) ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(19) ].
			currentCharacter = $>
				ifTrue: [ ^ self recordAndReportMatch: #(22) ].
			^ self reportLastMatch ].
	currentCharacter = $.
		ifTrue: [ 
			self recordMatch: #(27).
			self step.
			(currentCharacter between: $0 and: $9)
				ifTrue: [ ^ self scan1 ].
			currentCharacter = $.
				ifTrue: [ 
					self step.
					currentCharacter = $.
						ifTrue: [ ^ self recordAndReportMatch: #(74) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $/
		ifTrue: [ 
			self recordMatch: #(29).
			self step.
			currentCharacter = $*
				ifTrue: [ ^ self recordAndReportMatch: #comment ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(13) ].
			^ self reportLastMatch ].
	currentCharacter = $0
		ifTrue: [ 
			self recordMatch: #(77).
			self step.
			(currentCharacter between: $0 and: $9)
				ifTrue: [ ^ self scan5 ].
			(currentCharacter = $L or: [ currentCharacter = $U or: [ currentCharacter = $l or: [ currentCharacter = $u ] ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(77) ].
			(currentCharacter = $E or: [ currentCharacter = $e ])
				ifTrue: [ ^ self scan3 ].
			(currentCharacter = $X or: [ currentCharacter = $x ])
				ifTrue: [ 
					self step.
					((currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ])
						ifTrue: [ 
							[ 
							self recordMatch: #(77).
							self step.
							(currentCharacter between: $0 and: $9)
								or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ] ] whileTrue.
							(currentCharacter = $L or: [ currentCharacter = $U or: [ currentCharacter = $l or: [ currentCharacter = $u ] ] ])
								ifTrue: [ ^ self recordAndReportMatch: #(77) ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			currentCharacter = $.
				ifTrue: [ ^ self scan2 ].
			^ self reportLastMatch ].
	currentCharacter = $:
		ifTrue: [ 
			self recordMatch: #(16).
			self step.
			currentCharacter = $>
				ifTrue: [ ^ self recordAndReportMatch: #(80) ].
			^ self reportLastMatch ].
	currentCharacter = $;
		ifTrue: [ ^ self recordAndReportMatch: #(60) ].
	currentCharacter = $<
		ifTrue: [ 
			self recordMatch: #(18).
			self step.
			currentCharacter = $%
				ifTrue: [ ^ self recordAndReportMatch: #(81) ].
			currentCharacter = $:
				ifTrue: [ ^ self recordAndReportMatch: #(79) ].
			currentCharacter = $<
				ifTrue: [ 
					self recordMatch: #(33).
					self step.
					currentCharacter = $=
						ifTrue: [ ^ self recordAndReportMatch: #(37) ].
					^ self reportLastMatch ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(7) ].
			^ self reportLastMatch ].
	currentCharacter = $=
		ifTrue: [ 
			self recordMatch: #(17).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(3) ].
			^ self reportLastMatch ].
	currentCharacter = $>
		ifTrue: [ 
			self recordMatch: #(6).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(8) ].
			currentCharacter = $>
				ifTrue: [ 
					self recordMatch: #(14).
					self step.
					currentCharacter = $=
						ifTrue: [ ^ self recordAndReportMatch: #(62) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $?
		ifTrue: [ ^ self recordAndReportMatch: #(15) ].
	currentCharacter = $L
		ifTrue: [ 
			self recordMatch: #IDENTIFIER.
			self step.
			((currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ])
				ifTrue: [ 
					[ 
					self recordMatch: #IDENTIFIER.
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
						whileTrue.
					^ self reportLastMatch ].
			currentCharacter = $"
				ifTrue: [ ^ self scan6 ].
			currentCharacter = $'
				ifTrue: [ ^ self scan7 ].
			^ self reportLastMatch ].
	currentCharacter = $[
		ifTrue: [ ^ self recordAndReportMatch: #(79) ].
	currentCharacter = $]
		ifTrue: [ ^ self recordAndReportMatch: #(80) ].
	currentCharacter = $^
		ifTrue: [ 
			self recordMatch: #(1).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(64) ].
			^ self reportLastMatch ].
	currentCharacter = ${
		ifTrue: [ ^ self recordAndReportMatch: #(81) ].
	currentCharacter = $|
		ifTrue: [ 
			self recordMatch: #(2).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(59) ].
			currentCharacter = $|
				ifTrue: [ ^ self recordAndReportMatch: #(9) ].
			^ self reportLastMatch ].
	currentCharacter = $}
		ifTrue: [ ^ self recordAndReportMatch: #(82) ].
	currentCharacter = $~
		ifTrue: [ ^ self recordAndReportMatch: #(31) ].
	^ self reportLastMatch! !

SmaCCScanner subclass: #JavaScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Examples'!

!JavaScanner classSide methodsFor: 'generated-initialization' stamp: 'lr 4/12/2010 17:50'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(99 'abstract' 38) #(99 'boolean' 30) #(99 'break' 81) #(99 'byte' 31) #(99 'case' 41) #(99 'catch' 72) #(99 'char' 26) #(99 'class' 8) #(99 'continue' 80) #(99 'default' 47) #(99 'do' 77) #(99 'double' 25) #(99 'else' 14) #(99 'extends' 11) #(99 'false' 95) #(99 'final' 36) #(99 'finally' 75) #(99 'float' 24) #(99 'for' 78) #(99 'if' 35) #(99 'implements' 10) #(99 'import' 44) #(99 'instanceof' 58) #(99 'int' 33) #(99 'interface' 16) #(99 'long' 27) #(99 'native' 37) #(99 'new' 76) #(99 'null' 98) #(99 'package' 29) #(99 'private' 45) #(99 'protected' 46) #(99 'public' 43) #(99 'return' 74) #(99 'short' 34) #(99 'static' 39) #(99 'strictfp' 7) #(99 'super' 22) #(99 'switch' 17) #(99 'synchronized' 40) #(99 'this' 23) #(99 'throw' 73) #(99 'throws' 20) #(99 'transient' 18) #(99 'true' 95) #(99 'try' 79) #(99 'void' 9) #(99 'volatile' 12) #(99 'while' 57))
		do: [ :each | (keywordMap at: each first ifAbsentPut: [ Dictionary new ]) at: (each at: 2) put: each last ].
	^ keywordMap! !

!JavaScanner classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:50'!
scannerDefinitionComment

	"<DECIMAL_INTEGER>: 0 | [1-9] [0-9]*	;
<HEX_INTEGER>: 0[xX][0-9a-fA-F]+	;
<OCTAL_INTEGER>: 0[0-7]+	;

<EXPONENT>: [eE] [\-\+]? [0-9]+ 	;
<FLOAT_TYPE>: [fFdD]	;

<ESCAPE_SEQUENCE>: \\ ([btnfr\""\'\\] | ([0-3] [0-7]{0,2} | [4-7][0-7]?))	;

<INTEGER_LITERAL>: (<DECIMAL_INTEGER> | <HEX_INTEGER> | <OCTAL_INTEGER>) [lL]?	;
<FLOATING_POINT_LITERAL>: [0-9]+ \. [0-9]* <EXPONENT>? <FLOAT_TYPE>? | \. [0-9]+ <EXPONENT>? <FLOAT_TYPE>? | [0-9]+ <EXPONENT> <FLOAT_TYPE>? | [0-9]+ <FLOAT_TYPE>	;
<BOOLEAN_LITERAL>: true | false	;
<CHARACTER_LITERAL>: \' ([^\\\'] | <ESCAPE_SEQUENCE> ) \'	;
<STRING_LITERAL>: \"" ([^\\\""] | <ESCAPE_SEQUENCE> )* \""	;
<NULL_LITERAL>: null	;

<IDENTIFIER>: [a-zA-Z_] \w*	;

<eol>: \r | \n | \r\n	;
<whitespace>: \s+	;
<comment>: \/\/ [^\r\n]* <eol>	;
<multipleLineComment>: \/ \* 	;"! !

!JavaScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:50'!
emptySymbolTokenId
	^255! !

!JavaScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:50'!
errorTokenId
	^256! !

!JavaScanner methodsFor: 'scanning' stamp: ' 6/1/07 21:19'!
multipleLineComment
	| char |
	
	[[(char := stream next) isNil or: [char == $*]] whileFalse.
	stream atEnd ifTrue: [self scannerError].
	stream peekFor: $/] 
			whileFalse.
	^self whitespace! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan1
	[ 
	self recordMatch: #(94).
	self step.
	currentCharacter between: $0 and: $9 ] whileTrue.
	(currentCharacter = $D or: [ currentCharacter = $F or: [ currentCharacter = $d or: [ currentCharacter = $f ] ] ])
		ifTrue: [ ^ self recordAndReportMatch: #(94) ].
	(currentCharacter = $E or: [ currentCharacter = $e ])
		ifTrue: [ ^ self scan2 ].
	^ self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan2
	self step.
	(currentCharacter between: $0 and: $9)
		ifTrue: [ ^ self scan4 ].
	(currentCharacter = $+ or: [ currentCharacter = $- ])
		ifTrue: [ 
			self step.
			(currentCharacter between: $0 and: $9)
				ifTrue: [ ^ self scan4 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan3
	[ 
	self step.
	currentCharacter between: $0 and: $9 ] whileTrue.
	(currentCharacter = $D or: [ currentCharacter = $F or: [ currentCharacter = $d or: [ currentCharacter = $f ] ] ])
		ifTrue: [ ^ self recordAndReportMatch: #(94) ].
	(currentCharacter = $E or: [ currentCharacter = $e ])
		ifTrue: [ ^ self scan2 ].
	currentCharacter = $.
		ifTrue: [ ^ self scan1 ].
	^ self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan4
	[ 
	self recordMatch: #(94).
	self step.
	currentCharacter between: $0 and: $9 ] whileTrue.
	(currentCharacter = $D or: [ currentCharacter = $F or: [ currentCharacter = $d or: [ currentCharacter = $f ] ] ])
		ifTrue: [ ^ self recordAndReportMatch: #(94) ].
	^ self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan5
	[ 
	self step.
	currentCharacter <= $!! or: [ (currentCharacter between: $# and: $[) or: [ currentCharacter >= $] ] ] ] whileTrue.
	currentCharacter = $"
		ifTrue: [ ^ self recordAndReportMatch: #(97) ].
	currentCharacter = $\
		ifTrue: [ 
			self step.
			(currentCharacter = $"
				or: [ 
					currentCharacter = $'
						or: [ 
							(currentCharacter between: $0 and: $7)
								or: [ 
									currentCharacter = $\
										or: [ 
											currentCharacter = $b
												or: [ currentCharacter = $f or: [ currentCharacter = $n or: [ currentCharacter = $r or: [ currentCharacter = $t ] ] ] ] ] ] ] ])
				ifTrue: [ ^ self scan5 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan6
	self step.
	currentCharacter = $'
		ifTrue: [ ^ self recordAndReportMatch: #(96) ].
	^ self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan7
	self step.
	(currentCharacter between: $0 and: $7)
		ifTrue: [ ^ self scan6 ].
	currentCharacter = $'
		ifTrue: [ ^ self recordAndReportMatch: #(96) ].
	^ self reportLastMatch! !

!JavaScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ])
		ifTrue: [ 
			[ 
			self recordMatch: #(99).
			self step.
			(currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	(currentCharacter between: $1 and: $9)
		ifTrue: [ 
			[ 
			self recordMatch: #(93).
			self step.
			currentCharacter between: $0 and: $9 ] whileTrue.
			(currentCharacter = $D or: [ currentCharacter = $F or: [ currentCharacter = $d or: [ currentCharacter = $f ] ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(94) ].
			(currentCharacter = $E or: [ currentCharacter = $e ])
				ifTrue: [ ^ self scan2 ].
			(currentCharacter = $L or: [ currentCharacter = $l ])
				ifTrue: [ ^ self recordAndReportMatch: #(93) ].
			currentCharacter = $.
				ifTrue: [ ^ self scan1 ].
			^ self reportLastMatch ].
	((currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ])
		ifTrue: [ 
			[ 
			self recordMatch: #whitespace.
			self step.
			(currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ] ] whileTrue.
			^ self reportLastMatch ].
	currentCharacter = $!!
		ifTrue: [ 
			self recordMatch: #(91).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(51) ].
			^ self reportLastMatch ].
	currentCharacter = $"
		ifTrue: [ ^ self scan5 ].
	currentCharacter = $%
		ifTrue: [ 
			self recordMatch: #(85).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(67) ].
			^ self reportLastMatch ].
	currentCharacter = $&
		ifTrue: [ 
			self recordMatch: #(50).
			self step.
			currentCharacter = $&
				ifTrue: [ ^ self recordAndReportMatch: #(52) ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(61) ].
			^ self reportLastMatch ].
	currentCharacter = $'
		ifTrue: [ 
			self step.
			(currentCharacter <= $& or: [ (currentCharacter between: $( and: $[) or: [ currentCharacter >= $] ] ])
				ifTrue: [ ^ self scan6 ].
			currentCharacter = $\
				ifTrue: [ 
					self step.
					(currentCharacter = $"
						or: [ 
							currentCharacter = $'
								or: [ 
									currentCharacter = $\
										or: [ 
											currentCharacter = $b
												or: [ currentCharacter = $f or: [ currentCharacter = $n or: [ currentCharacter = $r or: [ currentCharacter = $t ] ] ] ] ] ] ])
						ifTrue: [ ^ self scan6 ].
					(currentCharacter between: $0 and: $3)
						ifTrue: [ 
							self step.
							(currentCharacter between: $0 and: $7)
								ifTrue: [ ^ self scan7 ].
							currentCharacter = $'
								ifTrue: [ ^ self recordAndReportMatch: #(96) ].
							^ self reportLastMatch ].
					(currentCharacter between: $4 and: $7)
						ifTrue: [ ^ self scan7 ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $(
		ifTrue: [ ^ self recordAndReportMatch: #(21) ].
	currentCharacter = $)
		ifTrue: [ ^ self recordAndReportMatch: #(19) ].
	currentCharacter = $*
		ifTrue: [ 
			self recordMatch: #(42).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(68) ].
			^ self reportLastMatch ].
	currentCharacter = $+
		ifTrue: [ 
			self recordMatch: #(89).
			self step.
			currentCharacter = $+
				ifTrue: [ ^ self recordAndReportMatch: #(82) ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(70) ].
			^ self reportLastMatch ].
	currentCharacter = $,
		ifTrue: [ ^ self recordAndReportMatch: #(4) ].
	currentCharacter = $-
		ifTrue: [ 
			self recordMatch: #(90).
			self step.
			currentCharacter = $-
				ifTrue: [ ^ self recordAndReportMatch: #(87) ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(69) ].
			^ self reportLastMatch ].
	currentCharacter = $.
		ifTrue: [ 
			self recordMatch: #(28).
			self step.
			(currentCharacter between: $0 and: $9)
				ifTrue: [ ^ self scan1 ].
			^ self reportLastMatch ].
	currentCharacter = $/
		ifTrue: [ 
			self recordMatch: #(88).
			self step.
			currentCharacter = $*
				ifTrue: [ ^ self recordAndReportMatch: #multipleLineComment ].
			currentCharacter = $/
				ifTrue: [ 
					[ 
					self step.
					currentCharacter <= Character tab
						or: [ (currentCharacter between: Character pageUp and: Character newPage) or: [ currentCharacter >= (Character value: 14) ] ] ]
						whileTrue.
					currentCharacter = Character lf
						ifTrue: [ ^ self recordAndReportMatch: #comment ].
					currentCharacter = Character cr
						ifTrue: [ 
							self recordMatch: #comment.
							self step.
							currentCharacter = Character lf
								ifTrue: [ ^ self recordAndReportMatch: #comment ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(66) ].
			^ self reportLastMatch ].
	currentCharacter = $0
		ifTrue: [ 
			self recordMatch: #(93).
			self step.
			(currentCharacter between: $0 and: $7)
				ifTrue: [ 
					[ 
					self recordMatch: #(93).
					self step.
					currentCharacter between: $0 and: $7 ] whileTrue.
					(currentCharacter = $D or: [ currentCharacter = $F or: [ currentCharacter = $d or: [ currentCharacter = $f ] ] ])
						ifTrue: [ ^ self recordAndReportMatch: #(94) ].
					(currentCharacter between: $8 and: $9)
						ifTrue: [ ^ self scan3 ].
					(currentCharacter = $E or: [ currentCharacter = $e ])
						ifTrue: [ ^ self scan2 ].
					(currentCharacter = $L or: [ currentCharacter = $l ])
						ifTrue: [ ^ self recordAndReportMatch: #(93) ].
					currentCharacter = $.
						ifTrue: [ ^ self scan1 ].
					^ self reportLastMatch ].
			(currentCharacter = $D or: [ currentCharacter = $F or: [ currentCharacter = $d or: [ currentCharacter = $f ] ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(94) ].
			(currentCharacter between: $8 and: $9)
				ifTrue: [ ^ self scan3 ].
			(currentCharacter = $E or: [ currentCharacter = $e ])
				ifTrue: [ ^ self scan2 ].
			(currentCharacter = $L or: [ currentCharacter = $l ])
				ifTrue: [ ^ self recordAndReportMatch: #(93) ].
			(currentCharacter = $X or: [ currentCharacter = $x ])
				ifTrue: [ 
					self step.
					((currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ])
						ifTrue: [ 
							[ 
							self recordMatch: #(93).
							self step.
							(currentCharacter between: $0 and: $9)
								or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ] ] whileTrue.
							(currentCharacter = $L or: [ currentCharacter = $l ])
								ifTrue: [ ^ self recordAndReportMatch: #(93) ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			currentCharacter = $.
				ifTrue: [ ^ self scan1 ].
			^ self reportLastMatch ].
	currentCharacter = $:
		ifTrue: [ ^ self recordAndReportMatch: #(15) ].
	currentCharacter = $;
		ifTrue: [ ^ self recordAndReportMatch: #(32) ].
	currentCharacter = $<
		ifTrue: [ 
			self recordMatch: #(71).
			self step.
			currentCharacter = $<
				ifTrue: [ 
					self recordMatch: #(83).
					self step.
					currentCharacter = $=
						ifTrue: [ ^ self recordAndReportMatch: #(63) ].
					^ self reportLastMatch ].
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(54) ].
			^ self reportLastMatch ].
	currentCharacter = $=
		ifTrue: [ 
			self recordMatch: #(2).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(65) ].
			^ self reportLastMatch ].
	currentCharacter = $>
		ifTrue: [ 
			self recordMatch: #(59).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(55) ].
			currentCharacter = $>
				ifTrue: [ 
					self recordMatch: #(84).
					self step.
					currentCharacter = $=
						ifTrue: [ ^ self recordAndReportMatch: #(62) ].
					currentCharacter = $>
						ifTrue: [ 
							self recordMatch: #(86).
							self step.
							currentCharacter = $=
								ifTrue: [ ^ self recordAndReportMatch: #(60) ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $?
		ifTrue: [ ^ self recordAndReportMatch: #(56) ].
	currentCharacter = $[
		ifTrue: [ ^ self recordAndReportMatch: #(5) ].
	currentCharacter = $]
		ifTrue: [ ^ self recordAndReportMatch: #(6) ].
	currentCharacter = $^
		ifTrue: [ 
			self recordMatch: #(48).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(64) ].
			^ self reportLastMatch ].
	currentCharacter = ${
		ifTrue: [ ^ self recordAndReportMatch: #(3) ].
	currentCharacter = $|
		ifTrue: [ 
			self recordMatch: #(49).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(13) ].
			currentCharacter = $|
				ifTrue: [ ^ self recordAndReportMatch: #(53) ].
			^ self reportLastMatch ].
	currentCharacter = $}
		ifTrue: [ ^ self recordAndReportMatch: #(1) ].
	currentCharacter = $~
		ifTrue: [ ^ self recordAndReportMatch: #(92) ].
	^ self reportLastMatch! !

SmaCCScanner subclass: #SmaCCGrammarScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCGrammarScanner commentStamp: 'jmb' prior: 0!
SmaCCGrammarScanner is the scanner for the grammar parser!

!SmaCCGrammarScanner classSide methodsFor: 'generated-initialization' stamp: 'lr 4/12/2010 17:49'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(20 'error' 15))
		do: [ :each | (keywordMap at: each first ifAbsentPut: [ Dictionary new ]) at: (each at: 2) put: each last ].
	^ keywordMap! !

!SmaCCGrammarScanner classSide methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
needsLineNumbers
	^true! !

!SmaCCGrammarScanner classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:49'!
scannerDefinitionComment

	"<name> : [a-zA-Z_] \w* ;
<whitespace>	:	\s+ ;
<tokenname>	:	\< <name> \> ;
<symbolname>	:	<name>	 ;
<keyword>	:	(\"" [^\""]* \"") + ;
<comment>	:	(\# [^\r\n]*) | (\/\* [^\*]* \*+ ([^\/\*] [^\*]* \*+)* \/) ;
<code>:	\{ [^\}]+ \} ;
<variablename> :	\' <name> \' ;
<production> : \: (\: \=)? ;"! !

!SmaCCGrammarScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
emptySymbolTokenId
	^43! !

!SmaCCGrammarScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
errorTokenId
	^44! !

!SmaCCGrammarScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan1
	self step.
	currentCharacter = $>
		ifTrue: [ ^ self recordAndReportMatch: #(12) ].
	currentCharacter = $i
		ifTrue: [ 
			self step.
			currentCharacter = $d
				ifTrue: [ ^ self recordAndReportMatch: #(4) ].
			^ self reportLastMatch ].
	currentCharacter = $l
		ifTrue: [ 
			self step.
			currentCharacter = $e
				ifTrue: [ 
					self step.
					currentCharacter = $f
						ifTrue: [ 
							self step.
							currentCharacter = $t
								ifTrue: [ ^ self recordAndReportMatch: #(6) ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $n
		ifTrue: [ 
			self step.
			currentCharacter = $o
				ifTrue: [ 
					self step.
					currentCharacter = $n
						ifTrue: [ 
							self step.
							currentCharacter = $a
								ifTrue: [ 
									self step.
									currentCharacter = $s
										ifTrue: [ 
											self step.
											currentCharacter = $s
												ifTrue: [ 
													self step.
													currentCharacter = $o
														ifTrue: [ 
															self step.
															currentCharacter = $c
																ifTrue: [ ^ self recordAndReportMatch: #(3) ].
															^ self reportLastMatch ].
													^ self reportLastMatch ].
											^ self reportLastMatch ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $r
		ifTrue: [ 
			self step.
			currentCharacter = $i
				ifTrue: [ 
					self step.
					currentCharacter = $g
						ifTrue: [ 
							self step.
							currentCharacter = $h
								ifTrue: [ 
									self step.
									currentCharacter = $t
										ifTrue: [ ^ self recordAndReportMatch: #(8) ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $s
		ifTrue: [ 
			self step.
			currentCharacter = $t
				ifTrue: [ 
					self step.
					currentCharacter = $a
						ifTrue: [ 
							self step.
							currentCharacter = $r
								ifTrue: [ 
									self step.
									currentCharacter = $t
										ifTrue: [ ^ self recordAndReportMatch: #(1) ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!SmaCCGrammarScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan2
	[ 
	self step.
	currentCharacter ~= $" ] whileTrue.
	currentCharacter = $"
		ifTrue: [ 
			self recordMatch: #(21).
			self step.
			currentCharacter = $"
				ifTrue: [ ^ self scan2 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!SmaCCGrammarScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan3
	[ 
	self step.
	currentCharacter ~= $* ] whileTrue.
	currentCharacter = $*
		ifTrue: [ 
			[ 
			self step.
			(currentCharacter <= $) or: [ (currentCharacter between: $+ and: $.) or: [ currentCharacter >= $0 ] ])
				ifTrue: [ ^ self scan3 ].
			currentCharacter = $* ] whileTrue.
			currentCharacter = $/
				ifTrue: [ ^ self recordAndReportMatch: #comment ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!SmaCCGrammarScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ])
		ifTrue: [ 
			[ 
			self recordMatch: #(20).
			self step.
			(currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	((currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ])
		ifTrue: [ 
			[ 
			self recordMatch: #whitespace.
			self step.
			(currentCharacter between: Character tab and: Character cr) or: [ currentCharacter = Character space ] ] whileTrue.
			^ self reportLastMatch ].
	currentCharacter = $"
		ifTrue: [ ^ self scan2 ].
	currentCharacter = $#
		ifTrue: [ 
			[ 
			self recordMatch: #comment.
			self step.
			currentCharacter <= Character tab
				or: [ (currentCharacter between: Character pageUp and: Character newPage) or: [ currentCharacter >= (Character value: 14) ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	currentCharacter = $%
		ifTrue: [ ^ self scan1 ].
	currentCharacter = $'
		ifTrue: [ 
			self step.
			((currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ])
				ifTrue: [ 
					[ 
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
						whileTrue.
					currentCharacter = $'
						ifTrue: [ ^ self recordAndReportMatch: #(24) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $(
		ifTrue: [ ^ self recordAndReportMatch: #(17) ].
	currentCharacter = $)
		ifTrue: [ ^ self recordAndReportMatch: #(14) ].
	currentCharacter = $*
		ifTrue: [ ^ self recordAndReportMatch: #(10) ].
	currentCharacter = $+
		ifTrue: [ ^ self recordAndReportMatch: #(16) ].
	currentCharacter = $/
		ifTrue: [ 
			self step.
			currentCharacter = $*
				ifTrue: [ ^ self scan3 ].
			^ self reportLastMatch ].
	currentCharacter = $:
		ifTrue: [ 
			self recordMatch: #(25).
			self step.
			currentCharacter = $:
				ifTrue: [ 
					self step.
					currentCharacter = $=
						ifTrue: [ ^ self recordAndReportMatch: #(25) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $;
		ifTrue: [ ^ self recordAndReportMatch: #(7) ].
	currentCharacter = $<
		ifTrue: [ 
			self step.
			((currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ])
				ifTrue: [ 
					[ 
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
						whileTrue.
					currentCharacter = $>
						ifTrue: [ ^ self recordAndReportMatch: #(19) ].
					^ self reportLastMatch ].
			currentCharacter = $%
				ifTrue: [ ^ self recordAndReportMatch: #(13) ].
			^ self reportLastMatch ].
	currentCharacter = $?
		ifTrue: [ ^ self recordAndReportMatch: #(5) ].
	currentCharacter = $[
		ifTrue: [ ^ self recordAndReportMatch: #(11) ].
	currentCharacter = $]
		ifTrue: [ ^ self recordAndReportMatch: #(2) ].
	currentCharacter = ${
		ifTrue: [ 
			self step.
			currentCharacter ~= $}
				ifTrue: [ 
					[ 
					self step.
					currentCharacter ~= $} ] whileTrue.
					currentCharacter = $}
						ifTrue: [ ^ self recordAndReportMatch: #(23) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $|
		ifTrue: [ ^ self recordAndReportMatch: #(9) ].
	^ self reportLastMatch! !

SmaCCScanner subclass: #SmaCCScannerScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCScannerScanner commentStamp: 'jmb' prior: 0!
SmaCCScannerScanner is the scanner for the scanner definition!

!SmaCCScannerScanner classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:49'!
scannerDefinitionComment

	"<backslashcharacter>	:	\\ [^cx] | \\ c [A-Z] | \\ x [0-9A-Fa-f]{1,4} ;
<characterblock>	: \[ ([^\]\\] | <backslashcharacter> )+ \] ;
<whitespace>	:	[\ \t\v\r\n]+ ;
<tokenname>	:	\< [a-zA-Z_] \w* \> ;
<comment>	:	(\# [^\r\n]*) | (\/\* [^\*]* \*+ ([^\/\*] [^\*]* \*+)* \/) ;
<repeat>	:	\{ [0-9]* \, [0-9]* \} ;
<symbol> : [a-zA-Z_] \w* ;
<character>	:	[^\ \t\v\\\r\n\{\(\[\.] ; 
<anycharacter>	: \. ;"! !

!SmaCCScannerScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
emptySymbolTokenId
	^30! !

!SmaCCScannerScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:49'!
errorTokenId
	^31! !

!SmaCCScannerScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan1
	[ 
	self step.
	currentCharacter ~= $* ] whileTrue.
	currentCharacter = $*
		ifTrue: [ 
			[ 
			self step.
			(currentCharacter <= $) or: [ (currentCharacter between: $+ and: $.) or: [ currentCharacter >= $0 ] ])
				ifTrue: [ ^ self scan1 ].
			currentCharacter = $* ] whileTrue.
			currentCharacter = $/
				ifTrue: [ ^ self recordAndReportMatch: #comment ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!SmaCCScannerScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan2
	self step.
	(currentCharacter <= $b or: [ (currentCharacter between: $d and: $w) or: [ currentCharacter >= $y ] ])
		ifTrue: [ ^ self scan3 ].
	currentCharacter = $c
		ifTrue: [ 
			self step.
			(currentCharacter between: $A and: $Z)
				ifTrue: [ ^ self scan4 ].
			^ self reportLastMatch ].
	currentCharacter = $x
		ifTrue: [ 
			self step.
			((currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ])
				ifTrue: [ ^ self scan4 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!SmaCCScannerScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan3
	[ 
	self step.
	currentCharacter <= $[ or: [ currentCharacter >= $^ ] ] whileTrue.
	currentCharacter = $\
		ifTrue: [ ^ self scan2 ].
	currentCharacter = $]
		ifTrue: [ ^ self recordAndReportMatch: #(12) ].
	^ self reportLastMatch! !

!SmaCCScannerScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scan4
	self step.
	(currentCharacter <= $[ or: [ currentCharacter >= $^ ])
		ifTrue: [ ^ self scan3 ].
	currentCharacter = $\
		ifTrue: [ ^ self scan2 ].
	currentCharacter = $]
		ifTrue: [ ^ self recordAndReportMatch: #(12) ].
	^ self reportLastMatch! !

!SmaCCScannerScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:49'!
scanForToken
	self step.
	(currentCharacter <= Character backspace
		or: [ 
			currentCharacter = Character newPage
				or: [ 
					(currentCharacter between: (Character value: 14) and: Character arrowDown)
						or: [ 
							(currentCharacter between: $!! and: $")
								or: [ 
									currentCharacter = $$
										or: [ 
											(currentCharacter between: $& and: $')
												or: [ 
													(currentCharacter between: $, and: $-)
														or: [ 
															(currentCharacter between: $0 and: $9)
																or: [ 
																	(currentCharacter between: $= and: $>)
																		or: [ 
																			currentCharacter = $@
																				or: [ (currentCharacter between: $] and: $^) or: [ currentCharacter = $` or: [ currentCharacter >= $} ] ] ] ] ] ] ] ] ] ] ] ])
		ifTrue: [ ^ self recordAndReportMatch: #(18) ].
	((currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ])
		ifTrue: [ 
			self recordMatch: #(17 18).
			self step.
			((currentCharacter between: $0 and: $9)
				or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ])
				ifTrue: [ 
					[ 
					self recordMatch: #(17).
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
						whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	((currentCharacter between: Character tab and: Character pageUp)
		or: [ currentCharacter = Character cr or: [ currentCharacter = Character space ] ])
		ifTrue: [ 
			[ 
			self recordMatch: #whitespace.
			self step.
			(currentCharacter between: Character tab and: Character pageUp)
				or: [ currentCharacter = Character cr or: [ currentCharacter = Character space ] ] ] whileTrue.
			^ self reportLastMatch ].
	currentCharacter = $#
		ifTrue: [ 
			self recordMatch: #comment.
			self step.
			(currentCharacter <= Character tab
				or: [ (currentCharacter between: Character pageUp and: Character newPage) or: [ currentCharacter >= (Character value: 14) ] ])
				ifTrue: [ 
					[ 
					self recordMatch: #comment.
					self step.
					currentCharacter <= Character tab
						or: [ (currentCharacter between: Character pageUp and: Character newPage) or: [ currentCharacter >= (Character value: 14) ] ] ]
						whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $%
		ifTrue: [ 
			self recordMatch: #(18).
			self step.
			currentCharacter = $e
				ifTrue: [ 
					self step.
					currentCharacter = $x
						ifTrue: [ 
							self step.
							currentCharacter = $c
								ifTrue: [ 
									self step.
									currentCharacter = $l
										ifTrue: [ 
											self step.
											currentCharacter = $u
												ifTrue: [ 
													self step.
													currentCharacter = $d
														ifTrue: [ 
															self step.
															currentCharacter = $e
																ifTrue: [ 
																	self step.
																	currentCharacter = $s
																		ifTrue: [ ^ self recordAndReportMatch: #(7) ].
																	^ self reportLastMatch ].
															^ self reportLastMatch ].
													^ self reportLastMatch ].
											^ self reportLastMatch ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			currentCharacter = $s
				ifTrue: [ 
					self step.
					currentCharacter = $t
						ifTrue: [ 
							self step.
							currentCharacter = $a
								ifTrue: [ 
									self step.
									currentCharacter = $t
										ifTrue: [ 
											self step.
											currentCharacter = $e
												ifTrue: [ 
													self step.
													currentCharacter = $s
														ifTrue: [ ^ self recordAndReportMatch: #(8) ].
													^ self reportLastMatch ].
											^ self reportLastMatch ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $(
		ifTrue: [ ^ self recordAndReportMatch: #(2) ].
	currentCharacter = $)
		ifTrue: [ ^ self recordAndReportMatch: #(1 18) ].
	currentCharacter = $*
		ifTrue: [ ^ self recordAndReportMatch: #(4 18) ].
	currentCharacter = $+
		ifTrue: [ ^ self recordAndReportMatch: #(3 18) ].
	currentCharacter = $.
		ifTrue: [ ^ self recordAndReportMatch: #(19) ].
	currentCharacter = $/
		ifTrue: [ 
			self recordMatch: #(18).
			self step.
			currentCharacter = $*
				ifTrue: [ ^ self scan1 ].
			^ self reportLastMatch ].
	currentCharacter = $:
		ifTrue: [ ^ self recordAndReportMatch: #(10 18) ].
	currentCharacter = $;
		ifTrue: [ ^ self recordAndReportMatch: #(9 18) ].
	currentCharacter = $<
		ifTrue: [ 
			self recordMatch: #(18).
			self step.
			((currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ])
				ifTrue: [ 
					[ 
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z) or: [ currentCharacter = $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
						whileTrue.
					currentCharacter = $>
						ifTrue: [ ^ self recordAndReportMatch: #(14) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $?
		ifTrue: [ ^ self recordAndReportMatch: #(6 18) ].
	currentCharacter = $[
		ifTrue: [ 
			self step.
			(currentCharacter <= $[ or: [ currentCharacter >= $^ ])
				ifTrue: [ ^ self scan3 ].
			currentCharacter = $\
				ifTrue: [ ^ self scan2 ].
			^ self reportLastMatch ].
	currentCharacter = $\
		ifTrue: [ 
			self step.
			(currentCharacter <= $b or: [ (currentCharacter between: $d and: $w) or: [ currentCharacter >= $y ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(11) ].
			currentCharacter = $c
				ifTrue: [ 
					self step.
					(currentCharacter between: $A and: $Z)
						ifTrue: [ ^ self recordAndReportMatch: #(11) ].
					^ self reportLastMatch ].
			currentCharacter = $x
				ifTrue: [ 
					self step.
					((currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ])
						ifTrue: [ 
							self recordMatch: #(11).
							self step.
							((currentCharacter between: $0 and: $9)
								or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ])
								ifTrue: [ 
									self recordMatch: #(11).
									self step.
									((currentCharacter between: $0 and: $9)
										or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ])
										ifTrue: [ 
											self recordMatch: #(11).
											self step.
											((currentCharacter between: $0 and: $9)
												or: [ (currentCharacter between: $A and: $F) or: [ currentCharacter between: $a and: $f ] ])
												ifTrue: [ ^ self recordAndReportMatch: #(11) ].
											^ self reportLastMatch ].
									^ self reportLastMatch ].
							^ self reportLastMatch ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = ${
		ifTrue: [ 
			[ 
			self step.
			currentCharacter between: $0 and: $9 ] whileTrue.
			currentCharacter = $,
				ifTrue: [ 
					[ 
					self step.
					currentCharacter between: $0 and: $9 ] whileTrue.
					currentCharacter = $}
						ifTrue: [ ^ self recordAndReportMatch: #(16) ].
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter = $|
		ifTrue: [ ^ self recordAndReportMatch: #(5 18) ].
	^ self reportLastMatch! !

SmaCCScanner subclass: #StScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Examples'!

!StScanner classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
frequencyTable
	^#(0.0 1.31372e-7 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0481767 0.0 0.0 0.0 0.0252514 0.0 0.0 2.62743e-7 1.31372e-7 5.25487e-7 1.31372e-7 1.31372e-7 0.0 1.31372e-7 0.0 2.62743e-7 0.0 1.31372e-7 7.8823e-7 2.62743e-7 2.62743e-7 1.31372e-7 5.25487e-7 0.106011 5.13007e-5 0.004554 0.00655584 2.41133e-4 3.60615e-5 1.93248e-4 0.00410241 0.00463893 0.0046369 2.82712e-4 4.64268e-4 0.0011675 9.75895e-4 0.00982753 2.26945e-4 0.00795055 0.00590903 0.0036363 0.00220212 0.00180485 0.00224265 0.00183191 0.00138545 0.00146217 0.00115246 0.0248349 0.00129723 7.50395e-4 0.00496762 8.97532e-4 1.44378e-4 0.00164497 0.00403659 0.00332443 0.00587547 0.00266882 0.00223293 0.00382922 9.91266e-4 9.99673e-4 0.00418163 3.27773e-5 6.31044e-4 0.00271013 0.00248917 0.00292348 0.00278226 0.00359742 7.08751e-4 0.00239287 0.00749351 0.00486778 0.00145908 0.00167453 0.00112251 2.2458e-4 2.32856e-4 4.40752e-5 0.00467815 1.22701e-4 0.00470173 0.00298378 7.73451e-4 2.634e-4 0.0515694 0.00918972 0.0257636 0.0226939 0.09244 0.0167193 0.0108988 0.0138365 0.042864 9.52379e-4 0.00366494 0.0402202 0.0159142 0.0440905 0.0418992 0.0154463 5.66869e-4 0.043972 0.0443068 0.0543899 0.0180997 0.00593537 0.00725816 0.00494884 0.00808567 0.00128285 7.45009e-4 0.00281083 7.45206e-4 1.08907e-4 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 6.56859e-8 3.28429e-7 0.0 0.0 1.97058e-7 0.0 0.0 0.0 0.0 3.94115e-7 6.56859e-8 0.0 2.62743e-7 1.31372e-7 0.0 1.31372e-7 1.31372e-7 0.0 0.0 1.97058e-7 1.31372e-7 6.56859e-8 1.31372e-7 0.0 0.0 7.8823e-7 0.0 0.0 1.31372e-7 1.31372e-7 4.59801e-7 7.8823e-7 0.0 9.85288e-7 5.25487e-7 1.31372e-7 6.56859e-8 1.05097e-6 0.0 2.62743e-7 0.0 1.97058e-7 4.59801e-7 1.97058e-7 5.25487e-7 2.62743e-7 0.0 1.51078e-6 5.91173e-7 1.11666e-6 0.0 1.97058e-7 8.53916e-7 1.57646e-6 0.0 0.0 0.0 0.0 0.0 0.0 0.0 6.56859e-8 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 5.25487e-7 0.0 0.0 0.0 0.0 0.0 0.0 7.8823e-7 0.0 2.62743e-7 0.0 0.0 3.28429e-7 1.31372e-7 0.0 2.62743e-7 0.0 3.28429e-7 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 2.62743e-7 0.0 5.25487e-7 0.0 0.0 1.31372e-7 0.0 0.0 0.0 0.0)! !

!StScanner classSide methodsFor: 'generated-initialization' stamp: 'lr 4/12/2010 17:50'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(20 'false' 12) #(20 'nil' 14) #(20 'true' 11) #(26 '||' 15))
		do: [ :each | (keywordMap at: each first ifAbsentPut: [ Dictionary new ]) at: (each at: 2) put: each last ].
	^ keywordMap! !

!StScanner classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:50'!
scannerDefinitionComment

	"<name>	:	(<isLetter> | \_) (<isLetter> | [\d\_]) *;
<number>:	\d	;
<negativeNumber>	:	\- <number>	;
<string>	:	\'  [^\']* \' (\' [^\']* \')*	;
<keyword>	:	<name> \:	;
<multikeyword>	:	<name> \: (<name> \: )+	;
<binarySymbol>	:	[\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]?	;
<whitespace>	:	<isSeparator>+	;
<comment>	:	\"" [^\""]* \""	;
<dottedName>	:	<name> (\. <name>)+	;
<character>	:	\$ .	;
<variableAssignment> : <name> \: \=	;

<anyChar> : . ; # For VW literal arrays that handle #(;) -> #(#';')"! !

!StScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:50'!
binarySymbolId
	^26! !

!StScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:50'!
emptySymbolTokenId
	^64! !

!StScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:50'!
errorTokenId
	^65! !

!StScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:50'!
nameId
	^20! !

!StScanner methodsFor: 'scanning' stamp: 'lr 6/28/2007 12:06'!
negativeNumber
	stream skip: -2.
	^self scanNumber: self negativeNumberId! !

!StScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:50'!
negativeNumberId
	^22! !

!StScanner methodsFor: 'scanning' stamp: 'lr 6/28/2007 12:06'!
number
	stream skip: -1.
	^self scanNumber: self numberId! !

!StScanner methodsFor: 'generated-tokens' stamp: 'lr 4/12/2010 17:50'!
numberId
	^21! !

!StScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan1
	[ 
	self step.
	currentCharacter ~= $' ] whileTrue.
	currentCharacter = $'
		ifTrue: [ ^ self scan2 ].
	^ self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan2
	self recordMatch: #(23).
	self step.
	currentCharacter = $'
		ifTrue: [ ^ self scan1 ].
	^ self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan3
	self recordMatch: #(24).
	self step.
	((currentCharacter between: $A and: $Z)
		or: [ 
			currentCharacter = $_
				or: [ 
					(currentCharacter between: $a and: $z)
						or: [ 
							currentCharacter = $
								or: [ 
									currentCharacter = $
										or: [ 
											currentCharacter = $
												or: [ (currentCharacter between: $ and: $) or: [ (currentCharacter between: $ and: $) or: [ currentCharacter >= $ ] ] ] ] ] ] ] ])
		ifTrue: [ ^ self scan4 ].
	currentCharacter = $=
		ifTrue: [ ^ self recordAndReportMatch: #variableAssignment ].
	^ self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan4
	[ 
	self step.
	(currentCharacter between: $0 and: $9)
		or: [ 
			(currentCharacter between: $A and: $Z)
				or: [ 
					currentCharacter = $_
						or: [ 
							(currentCharacter between: $a and: $z)
								or: [ 
									currentCharacter = $
										or: [ 
											currentCharacter = $
												or: [ 
													currentCharacter = $
														or: [ (currentCharacter between: $ and: $) or: [ (currentCharacter between: $ and: $) or: [ currentCharacter >= $ ] ] ] ] ] ] ] ] ] ]
		whileTrue.
	currentCharacter = $:
		ifTrue: [ 
			self recordMatch: #(25).
			self step.
			((currentCharacter between: $A and: $Z)
				or: [ 
					currentCharacter = $_
						or: [ 
							(currentCharacter between: $a and: $z)
								or: [ 
									currentCharacter = $
										or: [ 
											currentCharacter = $
												or: [ 
													currentCharacter = $
														or: [ (currentCharacter between: $ and: $) or: [ (currentCharacter between: $ and: $) or: [ currentCharacter >= $ ] ] ] ] ] ] ] ])
				ifTrue: [ ^ self scan4 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scan5
	self step.
	((currentCharacter between: $A and: $Z)
		or: [ 
			currentCharacter = $_
				or: [ 
					(currentCharacter between: $a and: $z)
						or: [ 
							currentCharacter = $
								or: [ 
									currentCharacter = $
										or: [ 
											currentCharacter = $
												or: [ (currentCharacter between: $ and: $) or: [ (currentCharacter between: $ and: $) or: [ currentCharacter >= $ ] ] ] ] ] ] ] ])
		ifTrue: [ 
			[ 
			self recordMatch: #(29).
			self step.
			(currentCharacter between: $0 and: $9)
				or: [ 
					(currentCharacter between: $A and: $Z)
						or: [ 
							currentCharacter = $_
								or: [ 
									(currentCharacter between: $a and: $z)
										or: [ 
											currentCharacter = $
												or: [ 
													currentCharacter = $
														or: [ 
															currentCharacter = $
																or: [ (currentCharacter between: $ and: $) or: [ (currentCharacter between: $ and: $) or: [ currentCharacter >= $ ] ] ] ] ] ] ] ] ] ]
				whileTrue.
			currentCharacter = $.
				ifTrue: [ ^ self scan5 ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!StScanner methodsFor: 'generated-scanner' stamp: 'lr 4/12/2010 17:50'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z)
		or: [ 
			currentCharacter = $_
				or: [ 
					(currentCharacter between: $a and: $z)
						or: [ 
							currentCharacter = $
								or: [ 
									currentCharacter = $
										or: [ 
											currentCharacter = $
												or: [ (currentCharacter between: $ and: $) or: [ (currentCharacter between: $ and: $) or: [ currentCharacter >= $ ] ] ] ] ] ] ] ])
		ifTrue: [ 
			self recordMatch: #(20 32).
			self step.
			((currentCharacter between: $0 and: $9)
				or: [ 
					(currentCharacter between: $A and: $Z)
						or: [ 
							currentCharacter = $_
								or: [ 
									(currentCharacter between: $a and: $z)
										or: [ 
											currentCharacter = $
												or: [ 
													currentCharacter = $
														or: [ 
															currentCharacter = $
																or: [ (currentCharacter between: $ and: $) or: [ (currentCharacter between: $ and: $) or: [ currentCharacter >= $ ] ] ] ] ] ] ] ] ])
				ifTrue: [ 
					[ 
					self recordMatch: #(20).
					self step.
					(currentCharacter between: $0 and: $9)
						or: [ 
							(currentCharacter between: $A and: $Z)
								or: [ 
									currentCharacter = $_
										or: [ 
											(currentCharacter between: $a and: $z)
												or: [ 
													currentCharacter = $
														or: [ 
															currentCharacter = $
																or: [ 
																	currentCharacter = $
																		or: [ (currentCharacter between: $ and: $) or: [ (currentCharacter between: $ and: $) or: [ currentCharacter >= $ ] ] ] ] ] ] ] ] ] ]
						whileTrue.
					currentCharacter = $:
						ifTrue: [ ^ self scan3 ].
					currentCharacter = $.
						ifTrue: [ ^ self scan5 ].
					^ self reportLastMatch ].
			currentCharacter = $:
				ifTrue: [ ^ self scan3 ].
			currentCharacter = $.
				ifTrue: [ ^ self scan5 ].
			^ self reportLastMatch ].
	((currentCharacter between: Character tab and: Character lf)
		or: [ (currentCharacter between: Character newPage and: Character cr) or: [ currentCharacter = Character space ] ])
		ifTrue: [ 
			self recordMatch: #whitespace.
			self step.
			((currentCharacter between: Character tab and: Character lf)
				or: [ (currentCharacter between: Character newPage and: Character cr) or: [ currentCharacter = Character space ] ])
				ifTrue: [ 
					[ 
					self recordMatch: #whitespace.
					self step.
					(currentCharacter between: Character tab and: Character lf)
						or: [ (currentCharacter between: Character newPage and: Character cr) or: [ currentCharacter = Character space ] ] ]
						whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	(currentCharacter between: $0 and: $9)
		ifTrue: [ ^ self recordAndReportMatch: #number ].
	currentCharacter = $:
		ifTrue: [ 
			self recordMatch: #(18 32).
			self step.
			currentCharacter = $=
				ifTrue: [ ^ self recordAndReportMatch: #(13) ].
			^ self reportLastMatch ].
	currentCharacter = $.
		ifTrue: [ ^ self recordAndReportMatch: #(5 32) ].
	(currentCharacter = $!!
		or: [ 
			(currentCharacter between: $% and: $&)
				or: [ 
					(currentCharacter between: $* and: $,)
						or: [ 
							currentCharacter = $/
								or: [ 
									currentCharacter = $=
										or: [ (currentCharacter between: $? and: $@) or: [ currentCharacter = $\ or: [ currentCharacter = $~ ] ] ] ] ] ] ])
		ifTrue: [ 
			self recordMatch: #(26 32).
			self step.
			(currentCharacter = $!!
				or: [ 
					(currentCharacter between: $% and: $&)
						or: [ 
							(currentCharacter between: $* and: $,)
								or: [ 
									currentCharacter = $/
										or: [ 
											(currentCharacter between: $< and: $@)
												or: [ currentCharacter = $\ or: [ currentCharacter = $| or: [ currentCharacter = $~ ] ] ] ] ] ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(26) ].
			^ self reportLastMatch ].
	currentCharacter = $#
		ifTrue: [ ^ self recordAndReportMatch: #(1 32) ].
	currentCharacter = $]
		ifTrue: [ ^ self recordAndReportMatch: #(19 32) ].
	currentCharacter = $[
		ifTrue: [ ^ self recordAndReportMatch: #(17 32) ].
	currentCharacter = $(
		ifTrue: [ ^ self recordAndReportMatch: #(10 32) ].
	currentCharacter = $)
		ifTrue: [ ^ self recordAndReportMatch: #(4 32) ].
	currentCharacter = $"
		ifTrue: [ 
			self recordMatch: #(32).
			self step.
			currentCharacter ~= $"
				ifTrue: [ 
					[ 
					self step.
					currentCharacter ~= $" ] whileTrue.
					currentCharacter = $"
						ifTrue: [ ^ self recordAndReportMatch: #comment ].
					^ self reportLastMatch ].
			currentCharacter = $"
				ifTrue: [ ^ self recordAndReportMatch: #comment ].
			^ self reportLastMatch ].
	currentCharacter = $'
		ifTrue: [ 
			self recordMatch: #(32).
			self step.
			currentCharacter ~= $'
				ifTrue: [ ^ self scan1 ].
			currentCharacter = $'
				ifTrue: [ ^ self scan2 ].
			^ self reportLastMatch ].
	currentCharacter = $^
		ifTrue: [ ^ self recordAndReportMatch: #(16 32) ].
	currentCharacter = $|
		ifTrue: [ 
			self recordMatch: #(9 26 32).
			self step.
			(currentCharacter = $!!
				or: [ 
					(currentCharacter between: $% and: $&)
						or: [ 
							(currentCharacter between: $* and: $,)
								or: [ 
									currentCharacter = $/
										or: [ 
											(currentCharacter between: $< and: $@)
												or: [ currentCharacter = $\ or: [ currentCharacter = $| or: [ currentCharacter = $~ ] ] ] ] ] ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(26) ].
			^ self reportLastMatch ].
	currentCharacter = $;
		ifTrue: [ ^ self recordAndReportMatch: #(2 32) ].
	currentCharacter = $-
		ifTrue: [ 
			self recordMatch: #(26 32).
			self step.
			(currentCharacter between: $0 and: $9)
				ifTrue: [ ^ self recordAndReportMatch: #negativeNumber ].
			(currentCharacter = $!!
				or: [ 
					(currentCharacter between: $% and: $&)
						or: [ 
							(currentCharacter between: $* and: $,)
								or: [ 
									currentCharacter = $/
										or: [ 
											(currentCharacter between: $< and: $@)
												or: [ currentCharacter = $\ or: [ currentCharacter = $| or: [ currentCharacter = $~ ] ] ] ] ] ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(26) ].
			^ self reportLastMatch ].
	currentCharacter = $>
		ifTrue: [ 
			self recordMatch: #(7 26 32).
			self step.
			(currentCharacter = $!!
				or: [ 
					(currentCharacter between: $% and: $&)
						or: [ 
							(currentCharacter between: $* and: $,)
								or: [ 
									currentCharacter = $/
										or: [ 
											(currentCharacter between: $< and: $@)
												or: [ currentCharacter = $\ or: [ currentCharacter = $| or: [ currentCharacter = $~ ] ] ] ] ] ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(26) ].
			^ self reportLastMatch ].
	currentCharacter = $<
		ifTrue: [ 
			self recordMatch: #(6 26 32).
			self step.
			(currentCharacter = $!!
				or: [ 
					(currentCharacter between: $% and: $&)
						or: [ 
							(currentCharacter between: $* and: $,)
								or: [ 
									currentCharacter = $/
										or: [ 
											(currentCharacter between: $< and: $@)
												or: [ currentCharacter = $\ or: [ currentCharacter = $| or: [ currentCharacter = $~ ] ] ] ] ] ] ])
				ifTrue: [ ^ self recordAndReportMatch: #(26) ].
			^ self reportLastMatch ].
	currentCharacter = $}
		ifTrue: [ ^ self recordAndReportMatch: #(8 32) ].
	currentCharacter = ${
		ifTrue: [ ^ self recordAndReportMatch: #(3 32) ].
	(currentCharacter <= Character backspace
		or: [ 
			currentCharacter = Character pageUp
				or: [ 
					(currentCharacter between: (Character value: 14) and: Character arrowDown)
						or: [ 
							currentCharacter = $`
								or: [ 
									(currentCharacter between: $ and: $)
										or: [ 
											(currentCharacter between: $ and: $)
												or: [ 
													(currentCharacter between: $ and: $)
														or: [ (currentCharacter between: $ and: $) or: [ currentCharacter = $ or: [ currentCharacter = $ ] ] ] ] ] ] ] ] ])
		ifTrue: [ ^ self recordAndReportMatch: #(32) ].
	currentCharacter = $$
		ifTrue: [ 
			self recordMatch: #(32).
			self step.
			currentCharacter <= $
				ifTrue: [ ^ self recordAndReportMatch: #(30) ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!StScanner methodsFor: 'scanning' stamp: ' 6/1/07 21:19'!
scanNumber: id 
	| number |
	number := Number readFrom: stream.
	outputStream reset.
	matchActions := Array with: id.
	^self createTokenFor: number! !

!StScanner methodsFor: 'scanning' stamp: ' 6/1/07 21:19'!
variableAssignment
	| token |
	outputStream skip: -2.
	stream skip: -2.
	matchActions := Array with: self nameId.
	token := self createTokenFor: outputStream contents.
	outputStream reset.
	^token! !

SmaCCScanner subclass: #TestScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

Set variableSubclass: #SmaCCItemSet
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCItemSet commentStamp: 'jmb' prior: 0!
SmaCCItemSet represents a LALR(1) or a LR(1) item set.

Instance Variables:
	type	<Symbol>	#LALR1 or #LR1

!

!SmaCCItemSet methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
= aSmaCCItemSet 
	self class = aSmaCCItemSet class 
		ifTrue: 
			[type == #LALR1
				ifTrue: [^self isLALREqualTo: aSmaCCItemSet]
				ifFalse: [^self isLREqualTo: aSmaCCItemSet]].
	^false! !

!SmaCCItemSet methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
action: aSmaCCSymbol prefer: aClass 
	| action actionItem eachAction |
	action := SmaCCRejectAction new.
	self do: 
			[:each | 
			eachAction := each action: aSmaCCSymbol.
			action class = SmaCCRejectAction 
				ifTrue: 
					[action := eachAction.
					actionItem := each]
				ifFalse: 
					[(eachAction = action or: [eachAction class = SmaCCRejectAction]) 
						ifFalse: 
							[eachAction class = SmaCCShiftAction | (action class = SmaCCShiftAction) 
								ifTrue: 
									["Shift/Reduce conflict -- check precedence"

									(aSmaCCSymbol precedence isNil 
										or: [each precedence isNil or: [actionItem precedence isNil]]) 
											ifTrue: 
												["No precedence, choose shift"

												eachAction class = SmaCCShiftAction 
													ifTrue: 
														[self 
															raiseXReduceNotification: each
															with: actionItem
															type: 'Shift/Reduce Conflict'.
														action := eachAction.
														actionItem := each]
													ifFalse: 
														[self 
															raiseXReduceNotification: actionItem
															with: each
															type: 'Shift/Reduce Conflict']]
											ifFalse: 
												[(each precedence > actionItem precedence 
													or: [each precedence = actionItem precedence and: [eachAction class = aClass]]) 
														ifTrue: 
															[self 
																raiseXReduceNotification: each
																with: actionItem
																type: 'Shift/Reduce Conflict (handled by precedence rules)'.
															action := eachAction.
															actionItem := each]
														ifFalse: 
															[(each precedence = actionItem precedence and: [SmaCCRejectAction = aClass]) 
																ifTrue: 
																	[self 
																		raiseXReduceNotificationWithNoPreferredItem: actionItem
																		with: each
																		type: 'Shift/Reduce Conflict (handled by precedence rules)'.
																	^aClass new]
																ifFalse: 
																	[self 
																		raiseXReduceNotification: actionItem
																		with: each
																		type: 'Shift/Reduce Conflict (handled by precedence rules)']]]]
								ifFalse: 
									["Reduce/Reduce conflict -- just pick one and proceed"

									self 
										raiseXReduceNotification: actionItem
										with: each
										type: 'Reduce/Reduce Conflict']]]].
	^action! !

!SmaCCItemSet methodsFor: 'adding' stamp: 'lr 1/6/2007 22:24'!
add: aSmaCCLR1Item 
	| index item |
	aSmaCCLR1Item == nil ifTrue: [^aSmaCCLR1Item].
	index := self findElementOrNil: aSmaCCLR1Item.
	item := array at: index.
	item == nil 
		ifTrue: 
			[self atNewIndex: index put: aSmaCCLR1Item.
			self performClosureOn: aSmaCCLR1Item]
		ifFalse: [item mergeWith: aSmaCCLR1Item].
	^aSmaCCLR1Item! !

!SmaCCItemSet methodsFor: 'copying' stamp: 'lr 11/25/2009 18:30'!
copyEmpty: anInteger 
	^ (Set new: anInteger)
		type: type;
		yourself! !

!SmaCCItemSet methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
hash
	^self inject: self class hash into: [:sum :each | sum bitXor: each hash]! !

!SmaCCItemSet methodsFor: 'initialize-release' stamp: 'lr 11/25/2009 18:37'!
initialize
	super initialize.
	type := #LALR1! !

!SmaCCItemSet methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isLALREqualTo: aSmaCCItemSet 
	^aSmaCCItemSet size = self size 
		and: [self allSatisfy: [:each | aSmaCCItemSet includes: each]]! !

!SmaCCItemSet methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isLREqualTo: anItemSet 
	^anItemSet size = self size and: 
			[self allSatisfy: 
					[:each | 
					| item |
					(item := anItemSet itemFor: each) notNil and: [each isLR1EqualTo: item]]]! !

!SmaCCItemSet methodsFor: 'private' stamp: 'lr 1/6/2007 22:24'!
itemFor: anObject 
	^array at: (self findElementOrNil: anObject)! !

!SmaCCItemSet methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
mergeWith: aSmaCCItemSet 
	self == aSmaCCItemSet ifTrue: [^self].
	aSmaCCItemSet do: [:each | self add: each]! !

!SmaCCItemSet methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
moveOn: aSmaCCSymbol 
	| anItemSet |
	anItemSet := self class new.
	anItemSet type: type.
	self 
		do: [:each | each nextSymbol == aSmaCCSymbol ifTrue: [anItemSet add: each moveNext]].
	^anItemSet! !

!SmaCCItemSet methodsFor: 'private' stamp: ' 6/1/07 21:19'!
performClosureOn: aSmaCCLR1Item 
	| nextSymbol rest first followers |
	nextSymbol := aSmaCCLR1Item nextSymbol.
	nextSymbol isTerminal ifTrue: [^self].
	rest := aSmaCCLR1Item rest.
	first := rest firstTerminals.
	followers := SmaCCSymbolSet new.
	(first includes: SmaCCSymbol empty) 
		ifTrue: 
			[first remove: SmaCCSymbol empty.
			followers baseOn: aSmaCCLR1Item followers].
	followers addAll: first.
	nextSymbol productionsDo: 
			[:each | 
			self add: (SmaCCLR1Item 
						symbol: nextSymbol
						rhs: each
						follow: followers)]! !

!SmaCCItemSet methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	self do: 
			[:each | 
			aStream
				tab;
				nextPutAll: each printString;
				cr]! !

!SmaCCItemSet methodsFor: 'accessing' stamp: 'lr 1/7/2007 11:06'!
raiseXReduceNotification: preferredSmaCCLR1Item with: otherSmaCCLR1Item type: aString 
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: preferredSmaCCLR1Item printString;
		nextPutAll: '	*****';
		cr;
		nextPutAll: otherSmaCCLR1Item printString.
	SmaCCCompilationNotification new
		tag: stream contents;
		signal: aString! !

!SmaCCItemSet methodsFor: 'accessing' stamp: 'lr 1/7/2007 11:07'!
raiseXReduceNotificationWithNoPreferredItem: firstSmaCCLR1Item with: secondSmaCCLR1Item type: aString 
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: firstSmaCCLR1Item printString;
		cr;
		nextPutAll: secondSmaCCLR1Item printString.
	SmaCCCompilationNotification new
		tag: stream contents;
		signal: aString! !

!SmaCCItemSet methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
type: aSmaCCSymbol 
	type := aSmaCCSymbol! !

TestCase subclass: #DuplicationNodeEliminationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

!DuplicationNodeEliminationTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testDuplicateLoop
	| node1 node2 node3 |
	node1 := SmaCCNode new.
	node1 action: 1.
	node2 := SmaCCNode new.
	node2 action: 1.
	node3 := SmaCCNode new.
	node3 action: 1.
	node1 addEdgeTo: node2 onCharacters: 'a'.
	node2 addEdgeTo: node3 onCharacters: 'a'.
	node3 addEdgeTo: node1 onCharacters: 'a'.
	node1 := node1 removeDuplicateNodes.
	self assert: node1 allStates size = 1.
	self assert: node1 transitions size = 1.
	self assert: (node1 action includes: 1).
	self assert: node1 transitions first transitionObjects = 'a'.
	self assert: node1 transitions first to = node1! !

!DuplicationNodeEliminationTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testNoDuplicates
	| node1 node2 node3 |
	node1 := SmaCCNode new.
	node1 action: 1.
	node2 := SmaCCNode new.
	node2 action: 2.
	node3 := SmaCCNode new.
	node3 action: 3.
	node1 addEdgeTo: node2 onCharacters: 'a'.
	node2 addEdgeTo: node3 onCharacters: 'a'.
	node3 addEdgeTo: node1 onCharacters: 'a'.
	node1 := node1 removeDuplicateNodes.
	self assert: node1 allStates size = 3.
	self assert: node1 transitions size = 1.
	self assert: (node1 action includes: 1).
	self assert: node1 transitions first transitionObjects = 'a'.
	node2 := node1 transitions first to.
	self deny: node1 = node2.
	self assert: node2 transitions size = 1.
	self assert: (node2 action includes: 2).
	self assert: node2 transitions first transitionObjects = 'a'.
	node3 := node2 transitions first to.
	self deny: node1 = node3.
	self deny: node2 = node3.
	self assert: node3 transitions size = 1.
	self assert: (node3 action includes: 3).
	self assert: node3 transitions first transitionObjects = 'a'.
	self assert: node3 transitions first to = node1! !

!DuplicationNodeEliminationTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testSimpleDuplicateWithEdges
	| node1 node2 node3 |
	node1 := SmaCCNode new.
	node2 := SmaCCNode new.
	node2 action: 2.
	node3 := SmaCCNode new.
	node3 action: 2.
	node1 addEdgeTo: node2 onCharacters: 'a'.
	node1 addEdgeTo: node3 onCharacters: 'b'.
	node2 addEdgeTo: node1 onCharacters: 'c'.
	node3 addEdgeTo: node1 onCharacters: 'c'.
	node1 := node1 removeDuplicateNodes.
	self assert: node1 allStates size = 2.
	self assert: node1 transitions size = 1.
	self assert: node1 transitions first transitionObjects = 'ab'.
	node2 := node1 transitions first to.
	self deny: node1 = node2.
	self assert: node2 transitions size = 1.
	self assert: (node2 action includes: 2).
	self assert: node2 transitions first transitionObjects = 'c'.
	self assert: node2 transitions first to = node1! !

!DuplicationNodeEliminationTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testSimpleTerminalDuplicate
	| node1 node2 node3 |
	node1 := SmaCCNode new.
	node2 := SmaCCNode new.
	node2 action: 2.
	node3 := SmaCCNode new.
	node3 action: 2.
	node1 addEdgeTo: node2 onCharacters: 'a'.
	node1 addEdgeTo: node3 onCharacters: 'b'.
	node1 := node1 removeDuplicateNodes.
	self assert: node1 allStates size = 2.
	self assert: node1 transitions size = 1.
	self assert: node1 transitions first transitionObjects = 'ab'.
	node2 := node1 transitions first to.
	self deny: node1 = node2.
	self assert: node2 transitions isEmpty.
	self assert: (node2 action includes: 2)! !

TestCase subclass: #ExampleParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

!ExampleParserTests methodsFor: 'testing-java' stamp: 'lr 1/8/2007 22:30'!
testApplet
	JavaParser parse: '// Hello.java
import java.applet.Applet;
import java.awt.Graphics;

public class Hello extends Applet {
   public void paint(Graphics gc) {
      gc.drawString("Hello, world!!", 65, 95);
   }    
}'! !

!ExampleParserTests methodsFor: 'testing-c' stamp: 'lr 1/8/2007 22:30'!
testEcho
	CParser parse: 'int main(int argc, char *argv[]) {
	int i;
	for (i = 0; i < argc; i++) {
		printf("%s", argv[i]);
	}
}'! !

!ExampleParserTests methodsFor: 'testing-c' stamp: 'lr 1/8/2007 22:30'!
testHello
	CParser parse: 'main( ) {
	printf("Hello World\n");
}'! !

!ExampleParserTests methodsFor: 'testing-st' stamp: 'lr 1/8/2007 22:34'!
testSelfParsing
	StParser parseMethod: (self class 
		sourceCodeAt: thisContext selector)! !

!ExampleParserTests methodsFor: 'testing-java' stamp: 'lr 1/8/2007 22:30'!
testServlet
	JavaParser parse: '// Hello.java
import java.io.*;
import javax.servlet.*;

public class Hello extends GenericServlet {
    public void service(ServletRequest request, ServletResponse response) 
       throws ServletException, IOException {
       response.setContentType("text/html");
       PrintWriter pw = response.getWriter();
       pw.println("Hello, world!!");
       pw.close();
    }
}'! !

!ExampleParserTests methodsFor: 'testing-java' stamp: 'lr 1/8/2007 22:30'!
testStandAlone
	JavaParser parse: '// Hello.java
public class Hello {
    public static void main(String[] args) {
        System.out.println("Hello, World!!"); 
    } 
}'! !

!ExampleParserTests methodsFor: 'testing-java' stamp: 'lr 1/8/2007 22:30'!
testSwing
	JavaParser parse: '// Hello.java (Java SE 5)
import java.awt.BorderLayout;
import javax.swing.*;

public class Hello extends JFrame {
   public Hello() {
      super("hello");
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      setLayout(new BorderLayout());
      getContentPane().add(new JLabel("Hello, world!!"));
      pack();
   }
   public static void main(String[] args) {
      new Hello().setVisible(true);
   }
}'! !

!ExampleParserTests methodsFor: 'testing-st' stamp: 'lr 1/8/2007 22:32'!
testTranscript
	StParser parseExpression: 'Transcript show: ''Hello World''; cr'! !

TestCase subclass: #LineNumberStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

!LineNumberStreamTest methodsFor: 'private' stamp: ' 6/1/07 21:20'!
addCRLFsTo: aString 
	^aString copyReplaceAll: '\'
		with: (String with: Character cr with: Character lf)! !

!LineNumberStreamTest methodsFor: 'private' stamp: ' 6/1/07 21:20'!
addCRsTo: aString 
	^aString copyReplaceAll: '\' with: (String with: Character cr)! !

!LineNumberStreamTest methodsFor: 'private' stamp: ' 6/1/07 21:20'!
addLFsTo: aString 
	^aString copyReplaceAll: '\' with: (String with: Character lf)! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testCRLFLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRLFsTo: '1234\1234\1234\1234')).
	1 to: 4
		do:
			[:each | 
			self assert: stream lineNumber = each.
			4 timesRepeat: [self assert: stream columnNumber = (stream next asInteger - $0 asInteger)].
			stream upTo: Character lf]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testCRLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRsTo: '1234\1234\1234\1234')).
	1 to: 4
		do:
			[:each | 
			self assert: stream lineNumber = each.
			4 timesRepeat: [self assert: stream columnNumber = (stream next asInteger - $0 asInteger)].
			stream upTo: Character cr]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testEmptyLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRsTo: '\\\')).
	1 to: 4
		do: 
			[:each | 
			self assert: stream lineNumber = each.
			stream upTo: Character cr]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testForwardPositionCRLFLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRLFsTo: '1\2\3\4')).
	stream position: 3.
	self assert: stream lineNumber = 2.
	self assert: stream columnNumber = 1! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testLFLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addLFsTo: '1234\1234\1234\1234')).
	1 to: 4
		do: 
			[:each | 
			self assert: stream lineNumber = each.
			4 timesRepeat: [self assert: stream columnNumber = (stream next asInteger - $0 asInteger)].
			stream upTo: Character lf]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testNoLines
	| stream index |
	stream := SmaCCLineNumberStream on: (ReadStream on: 'this is a test').
	self assert: stream lineNumber = 1.
	index := 1.
	stream do: 
			[:each | 
			self assert: stream lineNumber = 1.
			index := index + 1.
			self assert: stream columnNumber = index]! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testPositionCRLFLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRLFsTo: '1\2\3\4')).
	self assert: stream lineNumber = 1.
	stream upTo: $5.
	self assert: stream lineNumber = 4.
	stream position: 0.
	self assert: stream lineNumber = 1.
	self assert: stream columnNumber = 1.
	stream position: 3.
	self assert: stream lineNumber = 2.
	self assert: stream columnNumber = 1! !

!LineNumberStreamTest methodsFor: 'tests' stamp: ' 6/1/07 21:20'!
testPositionCRLines
	| stream |
	stream := SmaCCLineNumberStream 
				on: (ReadStream on: (self addCRsTo: '1\2\3\4')).
	self assert: stream lineNumber = 1.
	stream upTo: $5.
	self assert: stream lineNumber = 4.
	stream skip: -1.
	self assert: stream lineNumber = 4.
	self assert: stream columnNumber = 1.
	stream position: 0.
	self assert: stream lineNumber = 1.
	self assert: stream columnNumber = 1.
	stream position: 2.
	self assert: stream lineNumber = 2.
	self assert: stream columnNumber = 1! !

TestCase subclass: #ParserGeneratorTest
	instanceVariableNames: 'wrappers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

!ParserGeneratorTest classSide methodsFor: 'accessing' stamp: 'lr 11/25/2009 18:58'!
packageNamesUnderTest
	^ #('SmaCC' 'SmaCCDev')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
expressionParserString
	^'
%left "+" "-" ;
%left "*" "/" ;
%right "^" ;

Expression: Expression ''first'' "+" Expression ''last'' {first + last}
	| Expression "-" Expression {''1'' - ''3''}
	| Expression "*" Expression {''1'' * ''3''}
	| Expression "/" Expression {''1'' / ''3''}
	| Expression "^" Expression {''1'' raisedTo: ''3''} 
	| "(" Expression ")" {''2''}
	| <number> {''1'' value asNumber};'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
expressionScannerString
	^'
<number>	:	[0-9]+ (\. [0-9]+) ? ;
<whitespace>	:	\s+;'! !

!ParserGeneratorTest methodsFor: 'private' stamp: 'lr 1/8/2007 21:49'!
removeAllSelectorsFrom: aClass 
	aClass selectors do: [ :each | aClass removeSelector: each ].
	aClass organization removeEmptyCategories! !

!ParserGeneratorTest methodsFor: 'running' stamp: 'lr 1/8/2007 21:46'!
runCase
	SystemChangeNotifier uniqueInstance 
		doSilently: [ super runCase ]! !

!ParserGeneratorTest methodsFor: 'private' stamp: ' 6/1/07 21:20'!
supportsUnicodeStrings
	^
	[String with: (Character value: 16rFF00).
	true] on: Error
			do: [:ex | ex return: false]! !

!ParserGeneratorTest methodsFor: 'running' stamp: 'lr 1/7/2007 11:19'!
tearDown
	super tearDown.
	self
		removeAllSelectorsFrom: TestParser;
		removeAllSelectorsFrom: TestParser class;
		removeAllSelectorsFrom: TestScanner;
		removeAllSelectorsFrom: TestScanner class! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testBadCharacterBlock
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	self should: 
			[parserCompiler buildScanner: '<foo> : [a-] ;' andParser: 'Start : <foo>;'.
			parserCompiler compileInto: TestScanner andParser: TestParser]
		raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testBadSmalltalkBlock
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	self should: 
			[parserCompiler buildScanner: '<foo> : foo ;' andParser: 'Start : <foo> {self printOn: };'.
			parserCompiler compileInto: TestScanner andParser: TestParser]
		raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testBraceRepeatToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <%<IDENTIFIER>%>;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self 
		assert: ((TestParser parse: 'a b c') collect: [:each | each value]) asArray 
				= #('a' 'b' 'c').
	self assert: (TestParser parse: '') size = 0! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testBracketOptionalToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> [":"] begin {''1'' value , ''3''} | <IDENTIFIER> {''1'' value};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileDefinitionComments;
		compileItemSetsComment;
		compileSymbolComment.
	self assert: (TestParser parse: 'a b : c') = 'abc'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testComments
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<a> : /* q */ /***/ /****/ a # b 
;' andParser: '/* */ /***/ /****/
#this is a comment
begin : <a> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'a')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testCrLf
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<a> : \r? \n | \r ;'
		andParser: 'A : <a> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self 
		assert: (TestParser parse: (String with: Character cr with: Character lf)).
	self 
		should: [TestParser parse: (String with: Character cr with: Character cr)]
		raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testErrorToken
	| parserCompiler countingBlock |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<name> : [a-zA-Z]+; <whitespace>: \s+;'
		andParser: '%left "+"; Expression : <name> | Expression "+" Expression {[Notification signal] on: Error do: [:ex | ex return: (Notification raise)]} | error "+" Expression ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	countingBlock := 
			[:string | 
			| count |
			count := 0.
			
			[[TestParser parse: string] on: Notification
				do: 
					[:ex | 
					count := count + 1.
					[ex resume] on: Error
						do: 
							[:ex1 | 
							ex isResumable: true.
							ex1 retry]]] 
					on: SmaCCParserError
					do: [:ex | ex return].
			count].
	#(#('a + b + c' 2) #('+ a + b + c' 2) #('a + b +' 1) #('a + 1 / 2 + b + c + 3' 2) #('1 + 1 / 2 + b + c + 3' 1)) 
		do: [:each | self assert: (countingBlock value: each first) = each last]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testErrors
	| parserCompiler position |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: self expressionScannerString
		andParser: self expressionParserString.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	TestParser parse: '+3*4' onError: [:str :pos | position := pos].
	self assert: position = 1.
	TestParser parseStream: (ReadStream on: '1+a+4')
		onError: [:str :pos | position := pos].
	self assert: position = 3! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testExcludeScannerState
	| parserCompiler parser |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '
					%excludes a;
					<foo> : b;
					a <bar> : a;'
		andParser: '
				Start : <foo> {true} | <bar> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'b').
	self should: [TestParser parse: 'a'] raise: SmaCCParserError.
	parser := TestParser on: (ReadStream on: 'a').
	parser scanner state: #a.
	self deny: parser parse.
	parser := TestParser on: (ReadStream on: 'b').
	parser scanner state: #a.
	self should: [parser parse] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testExpressions
	#(#LR1 #LALR1) do: 
			[:each | 
			| parserCompiler |
			parserCompiler := SmaCCGrammarCompiler new.
			parserCompiler grammar type: each.
			parserCompiler buildScanner: self expressionScannerString
				andParser: self expressionParserString.
			parserCompiler compileInto: TestScanner andParser: TestParser.
			self assert: (TestParser parse: '2 + 3 * 4 / 5 ^ 3 ^ 2') 
						= (2 + (3 * 4 / (5 raisedTo: (3 raisedTo: 2)))).
			self assert: (TestParser parse: '1.0*2/3+4.0^2^3+3') 
						= (1.0 * 2 / 3 + (4.0 raisedTo: (2 raisedTo: 3)) + 3).
			self assert: (TestParser parse: '(((1 + 2) * 3) ^ 2) ^ 3') 
						= (((1 + 2) * 3 raisedTo: 2) raisedTo: 3)]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testIgnoreCaseKeywords
	| parserCompiler case |
	case := SmaCCGrammar ignoreCase.
	SmaCCGrammar ignoreCase: true.
	
	[parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<identifier> : [a-z_]+ ; <whitespace> : \s+ ;'
		andParser: 'Start ::= "Foo" {true} | <identifier> <identifier> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'FOo').
	self deny: (TestParser parse: 'FoObAr ASDS')] 
			ensure: [SmaCCGrammar ignoreCase: case]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testImplicitParserTokens
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '' andParser: 'A : <isLetter> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'a').
	self should: [TestParser parse: ' '] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testImplicitScannerTokens
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<a> : <isLetter> + ;'
		andParser: 'A : <a> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'asdfssdafADSFS').
	self should: [TestParser parse: ' asdf asdf'] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testImplicitTokenPrecedence
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<a> : . ;'
		andParser: 'A : <a> {true} | <isLetter> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	0 to: 255
		do: [:each | self assert: (TestParser parse: (String with: (Character value: each)))]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testInvertedCharactersBlock
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<A> : a{1,3} ;
						<ID> : [^a]+ ;
						<comment> : \s+ ;'
		andParser: 'begin : {0} | begin <A> {''1'' + 1} | begin <ID> {''1'' - 1};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'aa') = 1.
	self assert: (TestParser parse: 'aaaa') = 2.
	self assert: (TestParser parse: 'a bab') = 0! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testKeywords
	| parserCompiler size case |
	size := SmaCCGrammar maximumCharacterValue.
	case := SmaCCGrammar ignoreCase.
	SmaCCGrammar ignoreCase: true.
	self supportsUnicodeStrings 
		ifTrue: [SmaCCGrammar maximumCharacterValue: (2 raisedTo: 16) - 1].
	
	[parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '' andParser: 'Start ::= "Foo" "bar";'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	TestParser parse: 'FoObAr'] 
			ensure: 
				[SmaCCGrammar
					ignoreCase: case;
					maximumCharacterValue: size]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testLALRErrorHandler
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<whitespace> : \s+ ;'
		andParser: 'Start : Foo "]" Foo ")";
					Foo : "a" Bar ;
					Bar : "b" | error ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: 'a ] a b )'] raise: SmaCCParserError.
	self should: [TestParser parse: 'a ) a b )'] raise: SmaCCParserError.
	self should: [TestParser parse: 'a b ] a  ]'] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testMultipleStartingPositions
	| parserCompiler position |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<name> : \w+;'
		andParser: '%start plus ;

					multiply: plus "*" plus {true};
					plus: <name> {false} | <name> "+" <name> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'a*a').
	self assert: (TestParser parse: 'a+a*a').
	self should: [TestParser parse: 'a+a'] raise: SmaCCParserError.
	self 
		deny: (TestParser parse: 'a+a' startingAt: TestParser startingStateForplus).
	TestParser 
		parse: 'a*a'
		startingAt: TestParser startingStateForplus
		onError: [:str :pos | position := pos].
	self assert: position = 2! !

!ParserGeneratorTest methodsFor: 'testing' stamp: 'lr 1/6/2007 21:32'!
testNodeAccess
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler
		buildScanner: ''
		andParser: 'start : "a" ''x'' { Array with: ''1'' value with: ''1'' value with: x value with: x value } ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'a') = #( 'a'  'a'  'a'  'a' )! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testNonAssociativeTokens
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<IDENTIFIER> : \w+ ; <whitespace> : \s+ ;'
		andParser: '%left "and" ;
					%nonassoc "=" "<=";
					%left "+" ;

					expr : expr "=" expr {true} | expr "<=" expr {true} | expr "and" expr {true} | expr "+" expr {true} | <IDENTIFIER> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: 'a=b=c'] raise: SmaCCParserError.
	self should: [TestParser parse: 'a=b<=c'] raise: SmaCCParserError.
	self should: [TestParser parse: 'a=b+c=d'] raise: SmaCCParserError.
	self assert: (TestParser parse: 'a=b and c=d')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testOptionalToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> ":" ? begin {''1'' value , ''3''} | <IDENTIFIER> {''1'' value};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self assert: (TestParser parse: 'a b : c') = 'abc'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testParenthesesOptionalToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> (":" | "|") begin {''1'' value , ''3''} | <IDENTIFIER> {''1'' value};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self assert: (TestParser parse: 'a | b : c') = 'abc'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testPriority
	| parserCompiler |
	TestScanner 
		compile: 'all ^self recordAndReportMatch: (Array with: self allId)'.
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<a> : \{ | \< \% ;
						<all> : .;'
		andParser: '%id <all> <a>;  begin : A {true}
							| All {false};
					A : <a> ;
					All: <all>;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: '{').
	self assert: (TestParser parse: '<%').
	self deny: (TestParser parse: '}')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testRecursiveRule
	#(#LR1 #LALR1) do: 
			[:each | 
			| parserCompiler |
			parserCompiler := SmaCCGrammarCompiler new.
			parserCompiler grammar type: each.
			parserCompiler buildScanner: self expressionScannerString
				andParser: 'Test: Test1 Recursive;
							Test1: <number> {''1'' value};
							Recursive: | Recursive "|" <number> {''1'' add: ''3'' value; yourself};'.
			parserCompiler compileInto: TestScanner andParser: TestParser.
			self 
				assert: ((parserCompiler grammar nonTerminalSymbolNamed: 'Recursive') 
						firstTerminals 
							includes: (parserCompiler grammar keywordTerminalNamed: '"|"')).
			self 
				assert: (TestParser parse: '2|3|4') = (OrderedCollection 
								with: '2'
								with: '3'
								with: '4')]! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testReduceReduceConflict
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<letter> : \w ;
						<whitespace>: \s+	;'
		andParser: 'begin : Foo <letter> {true} | Bar <letter> {false};
					Foo :  ;
					Bar : ;'.
	self 
		assert: (
			[parserCompiler compileInto: TestScanner andParser: TestParser.
			false] 
					on: SmaCCCompilationNotification
					do: 
						[:ex | 
						('*Reduce/Reduce*' match: ex messageText) 
							ifTrue: [ex return: true]
							ifFalse: [ex resume: nil]])! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testReduceRules
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '
					<char> : [a-zA-Z] ; 
					<ws> : \s ;'
		andParser: '
				Start ::= Chars {#liftFirstValue:};
				Chars : WS A WS {#liftSecondValue:};
				A : WS WS C {#liftLastValue:} | C WS {#liftLastValue:};
				WS : <ws> {#nil};
				C : <char> {#stringValue:};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: ' a  ') = nil.
	self assert: (TestParser parse: '   a ') = 'a'! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testRepeatMultipleToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>){1,2}	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> + ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self 
		assert: ((TestParser parse: 'a1 bb c44') collect: [:each | each value]) 
				asArray = #('a1' 'bb' 'c44').
	self 
		assert: ((TestParser parse: 'aaaaa') collect: [:each | each value]) asArray 
				= #('aaa' 'aa').
	self should: [TestParser parse: ''] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testRepeatToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> * ;'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	parserCompiler
		compileItemSetsComment;
		compileSymbolComment.
	self 
		assert: ((TestParser parse: 'a b c') collect: [:each | each value]) asArray 
				= #('a' 'b' 'c').
	self assert: (TestParser parse: '') size = 0! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testRepeatingCharactersBlock
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<A> : a{1,3} ;
						<ID> : \w+ ;
						<whitespace> : \s+ ;'
		andParser: 'begin : {true} | begin <A> {''1''} | begin <ID> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'aa').
	self deny: (TestParser parse: 'aaaa')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testReuseCompositeToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTERDIGIT> : [a-zA-Z_] \d ;
						<AAorBB> :  aa | bb;
						<IDENTIFIER>: <LETTERDIGIT> | <AAorBB>	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> begin {false} | <IDENTIFIER> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: '2'] raise: SmaCCParserError.
	self assert: (TestParser parse: 'aa').
	self assert: (TestParser parse: 'bb').
	self assert: (TestParser parse: 'a4').
	self should: [TestParser parse: 'ab'] raise: SmaCCParserError.
	self should: [TestParser parse: '4b'] raise: SmaCCParserError! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testReuseSimpleToken
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '<LETTER> : [a-zA-Z_\\] ;
						<DIGIT> : [0-9] ;
						<IDENTIFIER>: <LETTER> (<LETTER>|<DIGIT>)*	;
						<whitespace>: \s+	;'
		andParser: 'begin : <IDENTIFIER> begin {false} | <IDENTIFIER> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: '2'] raise: SmaCCParserError.
	self assert: (TestParser parse: '\')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testScannerState
	| parserCompiler parser |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler 
		buildScanner: '
					%states a ;
					<foo> : b;
					a <bar> : a;'
		andParser: '
				Start : <foo> {true} | <bar> {false};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser parse: 'b').
	self should: [TestParser parse: 'a'] raise: SmaCCParserError.
	parser := TestParser on: (ReadStream on: 'a').
	parser scanner state: #a.
	self deny: parser parse.
	parser := TestParser on: (ReadStream on: 'b').
	parser scanner state: #a.
	self assert: parser parse! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testSimple
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<a> : a ;' andParser: 'begin : <a> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self should: [TestParser parse: '2'] raise: SmaCCParserError.
	self assert: (TestParser parse: 'a')! !

!ParserGeneratorTest methodsFor: 'testing' stamp: ' 6/1/07 21:20'!
testSpecialCharacters
	| parserCompiler |
	[String with: (Character value: 16rFF00)] on: Error do: [:ex | ^self].	"Unicode characters not supported"
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler buildScanner: '<name> : \x3g \x20 \xFF \xFF1 \xFF00 \cC;'
		andParser: 'begin ::= <name> {true};'.
	parserCompiler compileInto: TestScanner andParser: TestParser.
	self assert: (TestParser 
				parse: (String withAll: (#(3 103 16r20 16rFF 16rFF1 16rFF00 2) 
								collect: [:each | Character value: each])))! !

SmaCCParser subclass: #CParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Examples'!

!CParser classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:49'!
parserDefinitionComment

	"%id <TypeName> <IDENTIFIER> <CONSTANT> ;

translationUnit
	: external_declaration
	| translationUnit external_declaration
	;

primary_expression
	: <IDENTIFIER>
	| <CONSTANT>
	| <STRING_LITERAL>
	| ""("" expression "")""
	;

postfix_expression
	: primary_expression
	| postfix_expression <LEFT_BLOCK> expression <RIGHT_BLOCK>
	| postfix_expression ""("" "")""
	| postfix_expression ""("" argument_expression_list "")""
	| postfix_expression ""."" <IDENTIFIER>
	| postfix_expression ""->"" <IDENTIFIER>
	| postfix_expression ""++""
	| postfix_expression ""--""
	;

argument_expression_list
	: assignment_expression
	| argument_expression_list "","" assignment_expression
	;

unary_expression
	: postfix_expression
	| ""++"" unary_expression
	| ""--"" unary_expression
	| unary_operator cast_expression
	| ""sizeof"" unary_expression
	| ""sizeof"" ""("" type_name "")""
	;

unary_operator
	: ""&""
	| ""*""
	| ""+""
	| ""-""
	| ""~""
	| ""!!""
	;

cast_expression
	: unary_expression
	| ""("" type_name "")"" cast_expression
	;

multiplicative_expression
	: cast_expression
	| multiplicative_expression ""*"" cast_expression
	| multiplicative_expression ""/"" cast_expression
	| multiplicative_expression ""%"" cast_expression
	;

additive_expression
	: multiplicative_expression
	| additive_expression ""+"" multiplicative_expression
	| additive_expression ""-"" multiplicative_expression
	;

shift_expression
	: additive_expression
	| shift_expression ""<<"" additive_expression
	| shift_expression "">>"" additive_expression
	;

relational_expression
	: shift_expression
	| relational_expression ""<"" shift_expression
	| relational_expression "">"" shift_expression
	| relational_expression ""<="" shift_expression
	| relational_expression "">="" shift_expression
	;

equality_expression
	: relational_expression
	| equality_expression ""=="" relational_expression
	| equality_expression ""!!="" relational_expression
	;

and_expression
	: equality_expression
	| and_expression ""&"" equality_expression
	;

exclusive_or_expression
	: and_expression
	| exclusive_or_expression ""^"" and_expression
	;

inclusive_or_expression
	: exclusive_or_expression
	| inclusive_or_expression ""|"" exclusive_or_expression
	;

logical_and_expression
	: inclusive_or_expression
	| logical_and_expression ""&&"" inclusive_or_expression
	;

logical_or_expression
	: logical_and_expression
	| logical_or_expression ""||"" logical_and_expression
	;

conditional_expression
	: logical_or_expression
	| logical_or_expression ""?"" expression "":"" conditional_expression
	;

assignment_expression
	: conditional_expression
	| unary_expression assignment_operator assignment_expression
	;

assignment_operator
	: ""=""
	| ""*=""
	| ""/=""
	| ""%=""
	| ""+=""
	| ""-=""
	| ""<<=""
	| "">>=""
	| ""&=""
	| ""^=""
	| ""|=""
	;

expression
	: assignment_expression
	| expression "","" assignment_expression
	;

constant_expression
	: conditional_expression
	;

declaration
	: declaration_specifiers "";""
	| declaration_specifiers init_declarator_list "";""
	;

declaration_specifiers
	: storage_class_specifier
	| storage_class_specifier declaration_specifiers
	| type_specifier
	| type_specifier declaration_specifiers
	| type_qualifier
	| type_qualifier declaration_specifiers
	;

init_declarator_list
	: init_declarator
	| init_declarator_list "","" init_declarator
	;

init_declarator
	: declarator
	| declarator ""="" initializer
	;

storage_class_specifier
	: ""typedef""
	| ""extern""
	| ""static""
	| ""auto""
	| ""register""
	;

type_specifier
	: ""void""
	| ""char""
	| ""short""
	| ""int""
	| ""long""
	| ""float""
	| ""double""
	| ""signed""
	| ""unsigned""
	| struct_or_union_specifier
	| enum_specifier
	| <TypeName>
	;

struct_or_union_specifier
	: struct_or_union <IDENTIFIER> <LEFT_BRACE> struct_declaration_list <RIGHT_BRACE> {self addTypeName: '2' value. self reduceFor: nodes}
	| struct_or_union <LEFT_BRACE> struct_declaration_list <RIGHT_BRACE>
	| struct_or_union <IDENTIFIER> {self addTypeName: '2' value. self reduceFor: nodes}
	;

struct_or_union
	: ""struct""
	| ""union""
	;

struct_declaration_list
	: struct_declaration
	| struct_declaration_list struct_declaration
	;

struct_declaration
	: specifier_qualifier_list struct_declarator_list "";""
	;

specifier_qualifier_list
	: type_specifier specifier_qualifier_list
	| type_specifier
	| type_qualifier specifier_qualifier_list
	| type_qualifier
	;

struct_declarator_list
	: struct_declarator
	| struct_declarator_list "","" struct_declarator
	;

struct_declarator
	: declarator
	| "":"" constant_expression
	| declarator "":"" constant_expression
	;

enum_specifier
	: ""enum"" <LEFT_BRACE> enumerator_list <RIGHT_BRACE>
	| ""enum"" <IDENTIFIER> <LEFT_BRACE> enumerator_list <RIGHT_BRACE>  {self addTypeName: '2' value. self reduceFor: nodes}
	| ""enum"" <IDENTIFIER>  {self addTypeName: '2' value. self reduceFor: nodes}
	;

enumerator_list
	: enumerator
	| enumerator_list "","" enumerator
	;

enumerator
	: <IDENTIFIER>
	| <IDENTIFIER> ""="" constant_expression
	;

type_qualifier
	: ""const""
	| ""volatile""
	;

declarator
	: pointer direct_declarator
	| direct_declarator
	;

direct_declarator
	: <IDENTIFIER>
	| ""("" declarator "")""
	| direct_declarator <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| direct_declarator <LEFT_BLOCK> <RIGHT_BLOCK>
	| direct_declarator ""("" parameter_type_list "")""
	| direct_declarator ""("" identifier_list "")""
	| direct_declarator ""("" "")""
	;

pointer
	: ""*""
	| ""*"" type_qualifier_list
	| ""*"" pointer
	| ""*"" type_qualifier_list pointer
	;

type_qualifier_list
	: type_qualifier
	| type_qualifier_list type_qualifier
	;


parameter_type_list
	: parameter_list
	| parameter_list "","" <ELLIPSIS>
	;

parameter_list
	: parameter_declaration
	| parameter_list "","" parameter_declaration
	;

parameter_declaration
	: declaration_specifiers declarator
	| declaration_specifiers abstract_declarator
	| declaration_specifiers
	;

identifier_list
	: <IDENTIFIER>
	| identifier_list "","" <IDENTIFIER>
	;

type_name
	: specifier_qualifier_list
	| specifier_qualifier_list abstract_declarator
	;

abstract_declarator
	: pointer
	| direct_abstract_declarator
	| pointer direct_abstract_declarator
	;

direct_abstract_declarator
	: ""("" abstract_declarator "")""
	| <LEFT_BLOCK> <RIGHT_BLOCK>
	| <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| direct_abstract_declarator <LEFT_BLOCK> <RIGHT_BLOCK>
	| direct_abstract_declarator <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| ""("" "")""
	| ""("" parameter_type_list "")""
	| direct_abstract_declarator ""("" "")""
	| direct_abstract_declarator ""("" parameter_type_list "")""
	;

initializer
	: assignment_expression
	| <LEFT_BRACE> initializer_list <RIGHT_BRACE>
	| <LEFT_BRACE> initializer_list "","" <RIGHT_BRACE>
	;

initializer_list
	: initializer
	| initializer_list "","" initializer
	;

statement
	: labeled_statement
	| compound_statement
	| expression_statement
	| selection_statement
	| iteration_statement
	| jump_statement
	;

labeled_statement
	: <IDENTIFIER> "":"" statement
	| ""case"" constant_expression "":"" statement
	| ""default"" "":"" statement
	;

compound_statement
	: <LEFT_BRACE> <RIGHT_BRACE>
	| <LEFT_BRACE> statement_list <RIGHT_BRACE>
	| <LEFT_BRACE> declaration_list <RIGHT_BRACE>
	| <LEFT_BRACE> declaration_list statement_list <RIGHT_BRACE>
	;

declaration_list
	: declaration
	| declaration_list declaration
	;

statement_list
	: statement
	| statement_list statement
	;

expression_statement
	: "";""
	| expression "";""
	;

selection_statement
	: ""if"" ""("" expression "")"" statement
	| ""if"" ""("" expression "")"" statement ""else"" statement
	| ""switch"" ""("" expression "")"" statement
	;

iteration_statement
	: ""while"" ""("" expression "")"" statement
	| ""do"" statement ""while"" ""("" expression "")"" "";""
	| ""for"" ""("" expression_statement expression_statement "")"" statement
	| ""for"" ""("" expression_statement expression_statement expression "")"" statement
	;

jump_statement
	: ""goto"" <IDENTIFIER> "";""
	| ""continue"" "";""
	| ""break"" "";""
	| ""return"" "";""
	| ""return"" expression "";""
	;

external_declaration
	: function_definition
	| declaration
	;

function_definition
	: declaration_specifiers declarator declaration_list compound_statement
	| declaration_specifiers declarator compound_statement
	| declarator declaration_list compound_statement
	| declarator compound_statement
	;

"! !

!CParser classSide methodsFor: 'generated-accessing' stamp: 'lr 4/12/2010 17:49'!
scannerClass
	^CScanner! !

!CParser classSide methodsFor: 'generated-starting states' stamp: 'lr 4/12/2010 17:49'!
startingStateFortranslationUnit
	^1! !

!CParser methodsFor: 'scanning' stamp: ' 6/1/07 21:19'!
addTypeName: aString 
	scanner addTypeName: aString! !

!CParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForenumXspecifier2: nodes
	self addTypeName: (nodes at: 2) value.
	^ self reduceFor: nodes! !

!CParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForenumXspecifier3: nodes
	self addTypeName: (nodes at: 2) value.
	^ self reduceFor: nodes! !

!CParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForstructXorXunionXspecifier1: nodes
	self addTypeName: (nodes at: 2) value.
	^ self reduceFor: nodes! !

!CParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForstructXorXunionXspecifier3: nodes
	self addTypeName: (nodes at: 2) value.
	^ self reduceFor: nodes! !

!CParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:49'!
reduceTable
	^#(
#(84 1 #reduceFor:)
#(84 4 #reduceFor:)
#(84 3 #reduceFor:)
#(84 4 #reduceFor:)
#(84 3 #reduceFor:)
#(84 3 #reduceFor:)
#(84 2 #reduceFor:)
#(84 2 #reduceFor:)
#(85 1 #reduceFor:)
#(85 1 #reduceFor:)
#(85 1 #reduceFor:)
#(85 3 #reduceFor:)
#(86 1 #reduceFor:)
#(86 3 #reduceFor:)
#(87 1 #reduceFor:)
#(87 3 #reduceFor:)
#(88 1 #reduceFor:)
#(88 2 #reduceFor:)
#(88 2 #reduceFor:)
#(88 2 #reduceFor:)
#(88 2 #reduceFor:)
#(88 4 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(89 1 #reduceFor:)
#(90 1 #reduceFor:)
#(90 4 #reduceFor:)
#(91 1 #reduceFor:)
#(91 2 #reduceFor:)
#(92 1 #reduceFor:)
#(92 3 #reduceFor:)
#(92 3 #reduceFor:)
#(92 3 #reduceFor:)
#(93 1 #reduceFor:)
#(93 3 #reduceFor:)
#(93 3 #reduceFor:)
#(94 1 #reduceFor:)
#(94 3 #reduceFor:)
#(94 3 #reduceFor:)
#(95 1 #reduceFor:)
#(95 3 #reduceFor:)
#(95 3 #reduceFor:)
#(95 3 #reduceFor:)
#(95 3 #reduceFor:)
#(96 1 #reduceFor:)
#(96 3 #reduceFor:)
#(96 3 #reduceFor:)
#(97 1 #reduceFor:)
#(97 3 #reduceFor:)
#(98 1 #reduceFor:)
#(98 3 #reduceFor:)
#(99 1 #reduceFor:)
#(99 3 #reduceFor:)
#(100 1 #reduceFor:)
#(100 3 #reduceFor:)
#(101 1 #reduceFor:)
#(101 3 #reduceFor:)
#(102 1 #reduceFor:)
#(102 5 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(104 1 #reduceFor:)
#(105 1 #reduceFor:)
#(105 2 #reduceFor:)
#(105 1 #reduceFor:)
#(105 2 #reduceFor:)
#(105 1 #reduceFor:)
#(105 2 #reduceFor:)
#(106 1 #reduceFor:)
#(106 3 #reduceFor:)
#(107 2 #reduceFor:)
#(107 3 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(110 1 #reduceFor:)
#(110 1 #reduceFor:)
#(111 1 #reduceFor:)
#(111 3 #reduceFor:)
#(112 2 #reduceFor:)
#(112 1 #reduceFor:)
#(113 1 #reduceFor:)
#(113 1 #reduceFor:)
#(114 5 #reduceActionForstructXorXunionXspecifier1:)
#(114 4 #reduceFor:)
#(114 2 #reduceActionForstructXorXunionXspecifier3:)
#(115 4 #reduceFor:)
#(115 5 #reduceActionForenumXspecifier2:)
#(115 2 #reduceActionForenumXspecifier3:)
#(116 1 #reduceFor:)
#(116 1 #reduceFor:)
#(117 1 #reduceFor:)
#(118 1 #reduceFor:)
#(118 2 #reduceFor:)
#(119 1 #reduceFor:)
#(119 3 #reduceFor:)
#(120 3 #reduceFor:)
#(121 2 #reduceFor:)
#(121 1 #reduceFor:)
#(121 2 #reduceFor:)
#(121 1 #reduceFor:)
#(122 1 #reduceFor:)
#(122 3 #reduceFor:)
#(123 1 #reduceFor:)
#(123 2 #reduceFor:)
#(123 3 #reduceFor:)
#(124 1 #reduceFor:)
#(124 3 #reduceFor:)
#(125 1 #reduceFor:)
#(125 3 #reduceFor:)
#(126 1 #reduceFor:)
#(126 2 #reduceFor:)
#(126 2 #reduceFor:)
#(126 3 #reduceFor:)
#(127 1 #reduceFor:)
#(127 3 #reduceFor:)
#(127 4 #reduceFor:)
#(127 3 #reduceFor:)
#(127 4 #reduceFor:)
#(127 4 #reduceFor:)
#(127 3 #reduceFor:)
#(128 1 #reduceFor:)
#(128 3 #reduceFor:)
#(129 1 #reduceFor:)
#(129 3 #reduceFor:)
#(130 1 #reduceFor:)
#(130 2 #reduceFor:)
#(131 1 #reduceFor:)
#(131 3 #reduceFor:)
#(133 2 #reduceFor:)
#(133 2 #reduceFor:)
#(133 1 #reduceFor:)
#(134 1 #reduceFor:)
#(134 1 #reduceFor:)
#(134 2 #reduceFor:)
#(135 3 #reduceFor:)
#(135 2 #reduceFor:)
#(135 3 #reduceFor:)
#(135 3 #reduceFor:)
#(135 4 #reduceFor:)
#(135 2 #reduceFor:)
#(135 3 #reduceFor:)
#(135 3 #reduceFor:)
#(135 4 #reduceFor:)
#(136 1 #reduceFor:)
#(136 3 #reduceFor:)
#(137 3 #reduceFor:)
#(137 4 #reduceFor:)
#(137 3 #reduceFor:)
#(138 2 #reduceFor:)
#(138 3 #reduceFor:)
#(138 3 #reduceFor:)
#(138 4 #reduceFor:)
#(139 1 #reduceFor:)
#(139 2 #reduceFor:)
#(140 5 #reduceFor:)
#(140 7 #reduceFor:)
#(140 5 #reduceFor:)
#(141 5 #reduceFor:)
#(141 7 #reduceFor:)
#(141 6 #reduceFor:)
#(141 7 #reduceFor:)
#(142 3 #reduceFor:)
#(142 2 #reduceFor:)
#(142 2 #reduceFor:)
#(142 2 #reduceFor:)
#(142 3 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 1 #reduceFor:)
#(144 1 #reduceFor:)
#(144 2 #reduceFor:)
#(145 1 #reduceFor:)
#(145 2 #reduceFor:)
#(146 4 #reduceFor:)
#(146 3 #reduceFor:)
#(146 3 #reduceFor:)
#(146 2 #reduceFor:)
#(149 1 #reduceFor:)
#(149 2 #reduceFor:)
#(150 1 #reduceFor:)
#(150 3 #reduceFor:)
#(150 4 #reduceFor:)
)! !

!CParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:49'!
transitionTable
	^#(
#[1 0 9 0 25 0 13 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 0 97 0 105 0 101 0 107 0 105 0 108 0 109 0 109 0 113 0 110 0 117 0 112 0 121 0 113 0 125 0 114 0 129 0 115 0 133 0 116 0 137 0 126 0 141 0 127 0 145 0 132 0 149 0 146 0 153 0 149]
#[1 0 9 0 25 0 13 0 34 0 93 0 76 0 157 0 112 0 137 0 126 0 141 0 127]
#[1 2 38 0 21 2 38 0 25 2 38 0 26 0 13 0 34 0 17 0 40 0 21 0 41 2 38 0 76 2 38 0 79 0 161 0 110 0 165 0 126 0 169 0 130]
#[0 1 154 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 158 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 210 0 76 0 81]
#[0 1 214 0 76 0 81]
#[1 0 173 0 76 0 177 0 81]
#[0 1 134 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 138 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 86 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 90 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 94 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 98 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 122 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 126 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 114 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 118 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 130 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 102 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 106 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 110 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 2 54 0 16 0 17 0 21 0 25 0 26 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 132]
#[1 0 9 0 25 0 13 0 34 0 181 0 60 0 93 0 76 0 185 0 106 0 189 0 111 0 193 0 112 0 137 0 126 0 141 0 127]
#[0 1 182 0 25 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 132 0 147]
#[1 1 46 0 21 1 46 0 25 1 46 0 26 1 46 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 1 46 0 60 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 46 0 76 1 46 0 79 0 197 0 105 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 0 145 0 132]
#[1 1 54 0 21 1 54 0 25 1 54 0 26 1 54 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 1 54 0 60 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 54 0 76 1 54 0 79 0 201 0 105 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 0 145 0 132]
#[1 1 62 0 21 1 62 0 25 1 62 0 26 1 62 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 1 62 0 60 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 62 0 76 1 62 0 79 0 205 0 105 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 0 145 0 132]
#[1 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 209 0 81 0 213 0 105 0 217 0 107 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 0 145 0 132 0 221 0 138 0 225 0 145]
#[0 3 66 0 25 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 132 0 147]
#[0 1 142 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 146 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[1 0 229 0 76 0 233 0 81]
#[1 0 9 0 25 0 93 0 76 0 237 0 127]
#[1 1 174 0 16 1 174 0 17 1 174 0 21 0 241 0 25 1 174 0 26 1 174 0 40 1 174 0 41 1 174 0 43 1 174 0 44 1 174 0 45 1 174 0 51 1 174 0 55 1 174 0 57 1 174 0 58 1 174 0 60 1 174 0 61 1 174 0 65 1 174 0 66 1 174 0 67 1 174 0 68 1 174 0 69 1 174 0 70 1 174 0 71 1 174 0 72 1 174 0 73 0 245 0 79 1 174 0 81 1 174 0 132]
#[0 1 150 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 178 0 25 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 132 0 147]
#[1 0 9 0 25 0 13 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 0 97 0 105 0 101 0 107 0 105 0 108 0 109 0 109 0 113 0 110 0 117 0 112 0 249 0 113 0 125 0 114 0 129 0 115 0 133 0 116 0 137 0 126 0 141 0 127 0 145 0 132 0 149 0 146 0 0 0 147]
#[0 0 253 0 26]
#[0 2 98 0 21 0 25 0 26 0 34 0 40 0 41 0 76 0 79]
#[0 2 46 0 21 0 25 0 26 0 76 0 79]
#[1 2 42 0 21 2 42 0 25 2 42 0 26 0 13 0 34 0 17 0 40 0 21 0 41 2 42 0 76 2 42 0 79 1 1 0 110 1 5 0 126]
#[1 1 206 0 16 1 206 0 21 1 206 0 25 1 206 0 26 1 206 0 34 1 206 0 40 1 206 0 41 1 206 0 43 1 206 0 44 1 206 0 45 1 206 0 51 1 206 0 55 1 206 0 57 1 206 0 58 1 206 0 60 1 206 0 61 1 206 0 65 1 206 0 66 1 206 0 67 1 206 0 68 1 206 0 69 1 206 0 70 1 206 0 71 1 206 0 72 1 206 0 73 1 206 0 76 1 206 0 79 1 9 0 81 1 206 0 132]
#[1 1 13 0 76 1 17 0 124 1 21 0 125]
#[0 1 78 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 132 0 147]
#[1 1 25 0 21 1 29 0 60]
#[0 1 70 0 21 0 60]
#[1 1 33 0 17 1 162 0 21 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 1 162 0 60 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 209 0 81 0 213 0 105 0 217 0 107 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 0 145 0 132 1 37 0 138 1 41 0 145]
#[0 1 50 0 21 0 25 0 26 0 34 0 60 0 76 0 79]
#[0 1 58 0 21 0 25 0 26 0 34 0 60 0 76 0 79]
#[0 1 66 0 21 0 25 0 26 0 34 0 60 0 76 0 79]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 0 17 0 40 0 21 0 41 1 93 0 42 0 25 0 43 0 29 0 44 0 33 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 0 37 0 51 1 113 0 52 1 117 0 53 1 121 0 54 0 41 0 55 1 125 0 56 0 45 0 57 0 49 0 58 1 129 0 60 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 145 0 82 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 0 213 0 105 0 217 0 107 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 1 217 0 119 0 145 0 132 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 1 245 0 143 1 249 0 144 1 253 0 145]
#[1 0 9 0 25 0 13 0 34 0 181 0 60 0 93 0 76 0 185 0 106 0 189 0 111 2 1 0 112 0 137 0 126 0 141 0 127]
#[0 3 42 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 132]
#[0 3 62 0 25 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 132 0 147]
#[1 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 209 0 81 0 213 0 105 2 5 0 107 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 0 145 0 132 2 9 0 138]
#[1 1 194 0 16 1 194 0 21 1 194 0 25 1 194 0 26 1 194 0 34 1 194 0 40 1 194 0 41 1 194 0 43 1 194 0 44 1 194 0 45 1 194 0 51 1 194 0 55 1 194 0 57 1 194 0 58 1 194 0 60 1 194 0 61 1 194 0 65 1 194 0 66 1 194 0 67 1 194 0 68 1 194 0 69 1 194 0 70 1 194 0 71 1 194 0 72 1 194 0 73 1 194 0 76 1 194 0 79 2 13 0 81 1 194 0 132]
#[1 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 85 0 72 0 89 0 73 2 17 0 109 2 21 0 110 0 125 0 114 0 129 0 115 0 133 0 116 2 25 0 118 2 29 0 120 2 33 0 121 0 145 0 132]
#[1 1 170 0 16 1 170 0 17 1 170 0 21 0 241 0 25 1 170 0 26 1 170 0 40 1 170 0 41 1 170 0 43 1 170 0 44 1 170 0 45 1 170 0 51 1 170 0 55 1 170 0 57 1 170 0 58 1 170 0 60 1 170 0 61 1 170 0 65 1 170 0 66 1 170 0 67 1 170 0 68 1 170 0 69 1 170 0 70 1 170 0 71 1 170 0 72 1 170 0 73 0 245 0 79 1 170 0 81 1 170 0 132]
#[1 2 37 0 26 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 2 41 0 76 2 45 0 105 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 2 49 0 128 2 53 0 129 2 57 0 131 0 145 0 132 2 61 0 133]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 2 69 0 80 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 2 77 0 102 2 81 0 104 1 217 0 119]
#[0 3 70 0 25 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 132 0 147]
#[0 2 58 0 16 0 17 0 21 0 25 0 26 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 132]
#[0 2 102 0 21 0 25 0 26 0 34 0 40 0 41 0 76 0 79]
#[0 2 50 0 21 0 25 0 26 0 76 0 79]
#[1 1 13 0 76 2 85 0 124 1 21 0 125]
#[1 2 89 0 17 2 30 0 21 2 30 0 82]
#[1 2 93 0 21 2 97 0 82]
#[0 2 22 0 21 0 82]
#[1 0 9 0 25 0 13 0 34 0 93 0 76 2 101 0 111 2 1 0 112 0 137 0 126 0 141 0 127]
#[0 1 82 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 132 0 147]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 2 105 0 81 1 149 0 84 1 153 0 85 2 109 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 2 113 0 150]
#[0 3 54 0 25 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 132 0 147]
#[1 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 209 0 81 0 213 0 105 2 5 0 107 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 0 145 0 132 2 117 0 138]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 2 121 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 125 0 88 1 165 0 89]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 2 121 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 129 0 88 1 165 0 89]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 2 133 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 137 0 88 1 165 0 89]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 85 0 72 0 89 0 73 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 2 141 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 2 145 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 2 17 0 109 2 21 0 110 0 125 0 114 0 129 0 115 0 133 0 116 1 217 0 119 2 149 0 121 0 145 0 132]
#[0 0 94 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 0 110 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 0 114 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 0 98 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 0 102 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 0 106 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 2 77 0 102 2 153 0 104 1 217 0 119]
#[0 2 157 0 16]
#[0 2 161 0 25]
#[0 2 165 0 60]
#[0 2 169 0 60]
#[0 2 173 0 25]
#[0 2 177 0 76]
#[0 2 181 0 25]
#[0 2 185 0 25]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 2 189 0 143]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 193 0 60 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 2 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 2 210 0 20 0 23 0 24 0 25 0 26 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 0 38 0 1 0 38 0 2 0 38 0 3 0 38 0 4 0 38 0 5 0 38 0 6 0 38 0 7 0 38 0 8 0 38 0 9 0 38 0 10 0 38 0 11 0 38 0 12 0 38 0 13 0 38 0 14 0 38 0 15 2 201 0 16 0 38 0 17 0 38 0 18 0 38 0 19 0 38 0 20 0 38 0 21 0 38 0 22 0 38 0 23 0 38 0 25 0 38 0 27 0 38 0 28 0 38 0 29 0 38 0 30 0 38 0 33 0 38 0 34 0 38 0 35 0 38 0 36 0 38 0 37 0 38 0 59 0 38 0 60 0 38 0 62 0 38 0 63 0 38 0 64 0 38 0 79]
#[0 0 42 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[0 0 46 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[0 2 194 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 132 0 147]
#[1 0 70 0 1 0 70 0 2 0 70 0 3 0 70 0 4 0 70 0 5 0 70 0 6 0 70 0 7 0 70 0 8 0 70 0 9 0 70 0 10 0 70 0 11 0 70 0 12 0 70 0 13 0 70 0 14 0 70 0 15 0 70 0 16 0 70 0 17 0 70 0 18 0 70 0 19 2 205 0 20 0 70 0 21 2 209 0 22 2 213 0 23 2 217 0 25 0 70 0 26 2 221 0 27 0 70 0 28 0 70 0 29 0 70 0 30 0 70 0 33 0 70 0 34 0 70 0 35 0 70 0 36 0 70 0 37 0 70 0 59 0 70 0 60 0 70 0 62 0 70 0 63 0 70 0 64 2 225 0 79 0 70 0 80 0 70 0 82]
#[0 0 6 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[0 0 214 0 16 0 21 0 26 0 60 0 80]
#[1 0 118 0 1 0 118 0 2 0 118 0 3 0 118 0 4 0 118 0 5 0 118 0 6 0 118 0 7 0 118 0 8 0 118 0 9 2 229 0 10 2 233 0 11 2 237 0 12 2 241 0 13 0 118 0 14 0 118 0 15 0 118 0 16 2 245 0 17 0 118 0 18 2 249 0 19 0 118 0 21 0 118 0 26 0 118 0 28 0 118 0 29 0 118 0 30 0 118 0 33 0 118 0 34 0 118 0 35 0 118 0 36 2 253 0 37 3 1 0 59 0 118 0 60 3 5 0 62 3 9 0 63 3 13 0 64 0 118 0 80 0 118 0 82 3 17 0 103]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 3 21 0 90]
#[0 0 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 14 0 15 0 16 0 18 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 60 0 80 0 82]
#[1 0 150 0 1 0 150 0 2 0 150 0 3 0 150 0 4 0 150 0 5 0 150 0 6 0 150 0 7 0 150 0 8 0 150 0 9 0 150 0 14 0 150 0 15 0 150 0 16 0 150 0 18 0 150 0 21 0 150 0 26 0 150 0 28 3 25 0 29 3 29 0 30 0 150 0 33 3 33 0 34 0 150 0 35 0 150 0 36 0 150 0 60 0 150 0 80 0 150 0 82]
#[1 0 162 0 1 0 162 0 2 0 162 0 3 0 162 0 4 0 162 0 5 0 162 0 6 0 162 0 7 0 162 0 8 0 162 0 9 0 162 0 14 0 162 0 15 0 162 0 16 0 162 0 18 0 162 0 21 0 162 0 26 0 162 0 28 0 162 0 33 3 37 0 35 3 41 0 36 0 162 0 60 0 162 0 80 0 162 0 82]
#[1 0 174 0 1 0 174 0 2 0 174 0 3 0 174 0 4 0 174 0 5 0 174 0 6 0 174 0 7 0 174 0 8 0 174 0 9 3 45 0 14 0 174 0 15 0 174 0 16 0 174 0 18 0 174 0 21 0 174 0 26 0 174 0 28 3 49 0 33 0 174 0 60 0 174 0 80 0 174 0 82]
#[1 0 194 0 1 0 194 0 2 0 194 0 3 0 194 0 4 0 194 0 5 3 53 0 6 3 57 0 7 3 61 0 8 0 194 0 9 0 194 0 15 0 194 0 16 3 65 0 18 0 194 0 21 0 194 0 26 0 194 0 28 0 194 0 60 0 194 0 80 0 194 0 82]
#[1 0 206 0 1 0 206 0 2 3 69 0 3 3 73 0 4 0 206 0 5 0 206 0 9 0 206 0 15 0 206 0 16 0 206 0 21 0 206 0 26 0 206 0 28 0 206 0 60 0 206 0 80 0 206 0 82]
#[1 1 230 0 1 1 230 0 2 1 230 0 5 1 230 0 9 1 230 0 15 1 230 0 16 1 230 0 21 1 230 0 26 3 77 0 28 1 230 0 60 1 230 0 80 1 230 0 82]
#[1 3 81 0 21 3 85 0 60]
#[1 3 89 0 2 0 230 0 5 0 230 0 9 0 230 0 15 0 230 0 16 0 230 0 21 0 230 0 26 0 230 0 60 0 230 0 80 0 230 0 82]
#[1 3 93 0 5 0 238 0 9 0 238 0 15 0 238 0 16 0 238 0 21 0 238 0 26 0 238 0 60 0 238 0 80 0 238 0 82]
#[1 3 97 0 9 3 101 0 15 0 246 0 16 0 246 0 21 0 246 0 26 0 246 0 60 0 246 0 80 0 246 0 82]
#[0 0 62 0 16 0 21 0 26 0 60 0 80 0 82]
#[1 3 105 0 1 0 222 0 2 0 222 0 5 0 222 0 9 0 222 0 15 0 222 0 16 0 222 0 21 0 222 0 26 0 222 0 60 0 222 0 80 0 222 0 82]
#[0 3 10 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 3 14 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 3 18 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 3 22 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 3 26 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 3 30 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 3 34 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 3 109 0 82 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 3 113 0 143]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 0 17 0 40 0 21 0 41 1 93 0 42 0 25 0 43 0 29 0 44 0 33 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 0 37 0 51 1 113 0 52 1 117 0 53 1 121 0 54 0 41 0 55 1 125 0 56 0 45 0 57 0 49 0 58 1 129 0 60 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 3 117 0 82 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 0 213 0 105 2 5 0 107 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 1 217 0 119 0 145 0 132 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 1 245 0 143 3 121 0 144]
#[1 1 33 0 17 1 162 0 21 1 162 0 60]
#[0 3 46 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 132]
#[0 3 58 0 25 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 132 0 147]
#[1 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 85 0 72 0 89 0 73 2 17 0 109 2 21 0 110 0 125 0 114 0 129 0 115 0 133 0 116 3 125 0 118 2 29 0 120 2 33 0 121 0 145 0 132]
#[1 1 246 0 16 1 246 0 25 1 246 0 26 1 246 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 85 0 72 0 89 0 73 1 246 0 76 1 246 0 79 2 17 0 109 2 21 0 110 0 125 0 114 0 129 0 115 0 133 0 116 3 129 0 121 0 145 0 132]
#[1 1 254 0 16 1 254 0 25 1 254 0 26 1 254 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 85 0 72 0 89 0 73 1 254 0 76 1 254 0 79 2 17 0 109 2 21 0 110 0 125 0 114 0 129 0 115 0 133 0 116 3 133 0 121 0 145 0 132]
#[1 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 85 0 72 0 89 0 73 3 137 0 82 2 17 0 109 2 21 0 110 0 125 0 114 0 129 0 115 0 133 0 116 3 141 0 120 2 33 0 121 0 145 0 132]
#[0 1 222 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 66 0 67 0 68 0 69 0 70 0 72 0 73 0 82 0 132]
#[1 3 145 0 16 0 9 0 25 0 13 0 34 0 93 0 76 3 149 0 112 3 153 0 122 3 157 0 123 0 137 0 126 0 141 0 127]
#[0 2 78 0 16 0 17 0 21 0 25 0 26 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 132]
#[0 2 90 0 21 0 26]
#[1 2 122 0 21 3 161 0 25 2 122 0 26 0 13 0 34 0 93 0 76 3 165 0 79 3 169 0 112 3 173 0 126 0 141 0 127 3 177 0 134 3 181 0 135]
#[0 3 185 0 26]
#[1 3 189 0 21 3 193 0 26]
#[1 3 197 0 21 2 82 0 26]
#[0 2 106 0 21 0 26]
#[0 0 38 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[0 2 66 0 16 0 17 0 21 0 25 0 26 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 132]
#[0 0 118 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 80 0 82]
#[0 1 42 0 16 0 21 0 60 0 80 0 82]
#[0 3 201 0 80]
#[1 2 93 0 21 3 205 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 2 77 0 102 3 209 0 104 1 217 0 119]
#[1 1 13 0 76 3 213 0 125]
#[0 1 198 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 74 0 21 0 60]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 2 105 0 81 1 149 0 84 1 153 0 85 2 109 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 3 217 0 136 3 221 0 150]
#[0 3 74 0 21 0 60 0 82]
#[0 1 166 0 21 0 60]
#[0 3 50 0 25 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 132 0 147]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 2 145 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 0 78 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 80 0 82]
#[0 0 74 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 80 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 85 0 72 0 89 0 73 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 3 225 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 2 145 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 2 17 0 109 2 21 0 110 0 125 0 114 0 129 0 115 0 133 0 116 1 217 0 119 2 149 0 121 0 145 0 132]
#[0 0 86 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 80 0 82]
#[0 3 229 0 26]
#[1 3 81 0 21 3 233 0 26]
#[1 3 237 0 25 0 126 0 26 0 13 0 34 3 165 0 79 3 241 0 126 3 245 0 134 3 181 0 135]
#[0 3 249 0 16]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 3 253 0 143]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 4 1 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 2 250 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 2 254 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 129 0 60 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 4 5 0 139]
#[0 4 9 0 60]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 4 13 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 4 17 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 4 21 0 53]
#[0 3 2 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 3 81 0 21 4 25 0 60]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 4 29 0 143]
#[0 0 34 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[0 4 33 0 76]
#[0 0 30 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 4 37 0 26 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 41 0 86 4 45 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 4 49 0 76]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 4 53 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 1 10 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 14 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 2 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 6 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 0 254 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 18 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 22 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 38 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 26 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 30 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[0 1 34 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 76 0 77 0 78]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 57 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 0 82 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 80 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 4 61 0 90]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 4 65 0 90]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 4 69 0 90]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 4 73 0 92]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 4 77 0 92]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 4 81 0 93]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 4 85 0 93]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 4 89 0 94]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 4 93 0 94]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 4 97 0 94]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 4 101 0 94]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 4 105 0 95]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 4 109 0 95]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 4 113 0 96]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 117 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 2 214 0 20 0 23 0 24 0 25 0 26 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 4 121 0 119]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 4 125 0 99 1 217 0 119]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 4 129 0 100 1 217 0 119]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 4 133 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 4 137 0 97]
#[0 2 198 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 132 0 147]
#[0 3 38 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 2 202 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 132 0 147]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 4 141 0 82 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 3 113 0 143]
#[1 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 85 0 72 0 89 0 73 4 145 0 82 2 17 0 109 2 21 0 110 0 125 0 114 0 129 0 115 0 133 0 116 3 141 0 120 2 33 0 121 0 145 0 132]
#[0 1 242 0 16 0 25 0 26 0 34 0 76 0 79]
#[0 1 250 0 16 0 25 0 26 0 34 0 76 0 79]
#[0 1 190 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 1 226 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 66 0 67 0 68 0 69 0 70 0 72 0 73 0 82 0 132]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 2 77 0 102 4 149 0 104 1 217 0 119]
#[1 4 153 0 16 2 10 0 21 2 10 0 60]
#[1 4 157 0 21 4 161 0 60]
#[0 2 2 0 21 0 60]
#[1 3 161 0 25 4 165 0 26 0 13 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 3 165 0 79 2 45 0 105 0 105 0 108 0 109 0 109 0 113 0 110 0 157 0 112 0 125 0 114 0 129 0 115 0 133 0 116 3 173 0 126 0 141 0 127 4 169 0 128 2 57 0 131 0 145 0 132 2 61 0 133 4 173 0 134 3 181 0 135]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 4 177 0 80 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 2 77 0 102 4 181 0 104 1 217 0 119]
#[0 2 114 0 21 0 26]
#[1 2 126 0 21 3 161 0 25 2 126 0 26 0 93 0 76 3 165 0 79 0 237 0 127 4 185 0 135]
#[0 2 118 0 21 0 26]
#[1 2 130 0 21 4 189 0 25 2 130 0 26 4 193 0 79]
#[0 2 70 0 16 0 17 0 21 0 25 0 26 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 132]
#[0 4 197 0 76]
#[0 2 74 0 16 0 17 0 21 0 25 0 26 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 132]
#[1 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 4 201 0 74 2 45 0 105 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 0 145 0 132 4 205 0 133]
#[0 2 62 0 16 0 17 0 21 0 25 0 26 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 132]
#[0 1 202 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 2 34 0 21 0 82]
#[0 2 26 0 21 0 82]
#[1 4 209 0 21 4 213 0 82]
#[0 2 174 0 21 0 82]
#[0 4 217 0 26]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 4 221 0 90]
#[0 0 50 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[1 3 237 0 25 4 165 0 26 0 13 0 34 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 3 165 0 79 2 45 0 105 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 3 241 0 126 4 169 0 128 2 57 0 131 0 145 0 132 2 61 0 133 4 173 0 134 3 181 0 135]
#[1 3 237 0 25 2 126 0 26 3 165 0 79 4 185 0 135]
#[0 0 130 0 26]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 4 225 0 143]
#[0 2 190 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 3 81 0 21 4 229 0 26]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 129 0 60 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 4 233 0 139]
#[0 2 246 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 3 81 0 21 4 237 0 26]
#[1 3 81 0 21 4 241 0 26]
#[0 4 245 0 25]
#[0 3 6 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 2 182 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 0 26 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[0 0 14 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[1 4 249 0 21 4 253 0 26]
#[0 0 54 0 21 0 26]
#[0 0 22 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[1 3 81 0 21 5 1 0 80]
#[0 0 66 0 16 0 21 0 26 0 60 0 80 0 82]
#[0 0 142 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 14 0 15 0 16 0 18 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 60 0 80 0 82]
#[0 0 146 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 14 0 15 0 16 0 18 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 60 0 80 0 82]
#[0 0 138 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 14 0 15 0 16 0 18 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 60 0 80 0 82]
#[1 0 154 0 1 0 154 0 2 0 154 0 3 0 154 0 4 0 154 0 5 0 154 0 6 0 154 0 7 0 154 0 8 0 154 0 9 0 154 0 14 0 154 0 15 0 154 0 16 0 154 0 18 0 154 0 21 0 154 0 26 0 154 0 28 3 25 0 29 3 29 0 30 0 154 0 33 3 33 0 34 0 154 0 35 0 154 0 36 0 154 0 60 0 154 0 80 0 154 0 82]
#[1 0 158 0 1 0 158 0 2 0 158 0 3 0 158 0 4 0 158 0 5 0 158 0 6 0 158 0 7 0 158 0 8 0 158 0 9 0 158 0 14 0 158 0 15 0 158 0 16 0 158 0 18 0 158 0 21 0 158 0 26 0 158 0 28 3 25 0 29 3 29 0 30 0 158 0 33 3 33 0 34 0 158 0 35 0 158 0 36 0 158 0 60 0 158 0 80 0 158 0 82]
#[1 0 170 0 1 0 170 0 2 0 170 0 3 0 170 0 4 0 170 0 5 0 170 0 6 0 170 0 7 0 170 0 8 0 170 0 9 0 170 0 14 0 170 0 15 0 170 0 16 0 170 0 18 0 170 0 21 0 170 0 26 0 170 0 28 0 170 0 33 3 37 0 35 3 41 0 36 0 170 0 60 0 170 0 80 0 170 0 82]
#[1 0 166 0 1 0 166 0 2 0 166 0 3 0 166 0 4 0 166 0 5 0 166 0 6 0 166 0 7 0 166 0 8 0 166 0 9 0 166 0 14 0 166 0 15 0 166 0 16 0 166 0 18 0 166 0 21 0 166 0 26 0 166 0 28 0 166 0 33 3 37 0 35 3 41 0 36 0 166 0 60 0 166 0 80 0 166 0 82]
#[1 0 182 0 1 0 182 0 2 0 182 0 3 0 182 0 4 0 182 0 5 0 182 0 6 0 182 0 7 0 182 0 8 0 182 0 9 3 45 0 14 0 182 0 15 0 182 0 16 0 182 0 18 0 182 0 21 0 182 0 26 0 182 0 28 3 49 0 33 0 182 0 60 0 182 0 80 0 182 0 82]
#[1 0 186 0 1 0 186 0 2 0 186 0 3 0 186 0 4 0 186 0 5 0 186 0 6 0 186 0 7 0 186 0 8 0 186 0 9 3 45 0 14 0 186 0 15 0 186 0 16 0 186 0 18 0 186 0 21 0 186 0 26 0 186 0 28 3 49 0 33 0 186 0 60 0 186 0 80 0 186 0 82]
#[1 0 190 0 1 0 190 0 2 0 190 0 3 0 190 0 4 0 190 0 5 0 190 0 6 0 190 0 7 0 190 0 8 0 190 0 9 3 45 0 14 0 190 0 15 0 190 0 16 0 190 0 18 0 190 0 21 0 190 0 26 0 190 0 28 3 49 0 33 0 190 0 60 0 190 0 80 0 190 0 82]
#[1 0 178 0 1 0 178 0 2 0 178 0 3 0 178 0 4 0 178 0 5 0 178 0 6 0 178 0 7 0 178 0 8 0 178 0 9 3 45 0 14 0 178 0 15 0 178 0 16 0 178 0 18 0 178 0 21 0 178 0 26 0 178 0 28 3 49 0 33 0 178 0 60 0 178 0 80 0 178 0 82]
#[1 0 198 0 1 0 198 0 2 0 198 0 3 0 198 0 4 0 198 0 5 3 53 0 6 3 57 0 7 3 61 0 8 0 198 0 9 0 198 0 15 0 198 0 16 3 65 0 18 0 198 0 21 0 198 0 26 0 198 0 28 0 198 0 60 0 198 0 80 0 198 0 82]
#[1 0 202 0 1 0 202 0 2 0 202 0 3 0 202 0 4 0 202 0 5 3 53 0 6 3 57 0 7 3 61 0 8 0 202 0 9 0 202 0 15 0 202 0 16 3 65 0 18 0 202 0 21 0 202 0 26 0 202 0 28 0 202 0 60 0 202 0 80 0 202 0 82]
#[1 0 210 0 1 0 210 0 2 3 69 0 3 3 73 0 4 0 210 0 5 0 210 0 9 0 210 0 15 0 210 0 16 0 210 0 21 0 210 0 26 0 210 0 28 0 210 0 60 0 210 0 80 0 210 0 82]
#[0 0 218 0 16 0 21 0 26 0 60 0 80]
#[1 3 105 0 1 0 226 0 2 0 226 0 5 0 226 0 9 0 226 0 15 0 226 0 16 0 226 0 21 0 226 0 26 0 226 0 60 0 226 0 80 0 226 0 82]
#[1 3 89 0 2 0 234 0 5 0 234 0 9 0 234 0 15 0 234 0 16 0 234 0 21 0 234 0 26 0 234 0 60 0 234 0 80 0 234 0 82]
#[1 3 93 0 5 0 242 0 9 0 242 0 15 0 242 0 16 0 242 0 21 0 242 0 26 0 242 0 60 0 242 0 80 0 242 0 82]
#[1 5 5 0 16 3 81 0 21]
#[1 1 234 0 1 1 234 0 2 1 234 0 5 1 234 0 9 1 234 0 15 1 234 0 16 1 234 0 21 1 234 0 26 3 77 0 28 1 234 0 60 1 234 0 80 1 234 0 82]
#[0 2 206 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 132 0 147]
#[0 1 186 0 16 0 21 0 25 0 26 0 34 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 57 0 58 0 60 0 61 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 132]
#[0 2 14 0 21 0 60]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 2 77 0 102 5 9 0 104 1 217 0 119]
#[1 3 145 0 16 0 9 0 25 0 13 0 34 0 93 0 76 3 149 0 112 5 13 0 123 0 137 0 126 0 141 0 127]
#[0 1 238 0 40 0 41 0 43 0 44 0 45 0 51 0 55 0 66 0 67 0 68 0 69 0 70 0 72 0 73 0 82 0 132]
#[0 2 158 0 21 0 25 0 26 0 79]
#[0 5 17 0 26]
#[0 5 21 0 26]
#[0 2 142 0 21 0 25 0 26 0 79]
#[0 5 25 0 80]
#[1 2 134 0 21 4 189 0 25 2 134 0 26 4 193 0 79]
#[1 5 29 0 26 0 17 0 40 0 21 0 41 0 25 0 43 0 29 0 44 0 33 0 45 0 37 0 51 0 41 0 55 0 45 0 57 0 49 0 58 0 53 0 61 0 57 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 2 45 0 105 0 105 0 108 0 109 0 109 0 113 0 110 0 125 0 114 0 129 0 115 0 133 0 116 5 33 0 128 2 57 0 131 0 145 0 132 2 61 0 133]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 5 37 0 80 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 2 77 0 102 5 41 0 104 1 217 0 119]
#[0 2 94 0 21 0 26]
#[0 2 86 0 26]
#[0 2 110 0 21 0 26]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 2 105 0 81 5 45 0 82 1 149 0 84 1 153 0 85 2 109 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 5 49 0 150]
#[0 3 78 0 21 0 60 0 82]
#[0 0 90 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 80 0 82]
#[0 0 122 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 21 0 26 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 80 0 82]
#[0 2 186 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 5 53 0 143]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 5 57 0 26 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 5 61 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 5 65 0 143]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 5 69 0 143]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 5 73 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 5 77 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119]
#[0 0 18 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[0 0 10 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 33 0 34 0 35 0 36 0 37 0 59 0 60 0 62 0 63 0 64 0 79 0 80 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 73 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 201 0 99 1 205 0 100 1 209 0 101 5 81 0 102 1 217 0 119]
#[0 2 18 0 21 0 60]
#[0 2 6 0 21 0 60]
#[0 2 162 0 21 0 25 0 26 0 79]
#[0 2 138 0 21 0 25 0 26 0 79]
#[0 2 146 0 21 0 25 0 26 0 79]
#[0 2 166 0 21 0 25 0 26 0 79]
#[0 5 85 0 26]
#[0 2 150 0 21 0 25 0 26 0 79]
#[0 5 89 0 80]
#[0 3 82 0 21 0 60 0 82]
#[0 2 178 0 21 0 82]
#[1 2 218 0 20 2 218 0 23 2 218 0 24 2 218 0 25 2 218 0 28 2 218 0 31 2 218 0 32 2 218 0 34 2 218 0 35 2 218 0 36 2 218 0 38 2 218 0 39 2 218 0 42 5 93 0 46 2 218 0 47 2 218 0 48 2 218 0 49 2 218 0 50 2 218 0 52 2 218 0 53 2 218 0 54 2 218 0 56 2 218 0 60 2 218 0 76 2 218 0 77 2 218 0 78 2 218 0 81 2 218 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 5 97 0 143]
#[1 3 81 0 21 5 101 0 26]
#[0 2 226 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 2 230 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 3 81 0 21 5 105 0 26]
#[0 0 58 0 21 0 26]
#[0 0 250 0 16 0 21 0 26 0 60 0 80 0 82]
#[0 2 170 0 21 0 25 0 26 0 79]
#[0 2 154 0 21 0 25 0 26 0 79]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 5 109 0 143]
#[0 2 238 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 20 1 49 0 23 1 53 0 24 1 57 0 25 1 61 0 28 1 65 0 31 1 69 0 32 1 73 0 34 1 77 0 35 1 81 0 36 1 85 0 38 1 89 0 39 1 93 0 42 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 52 1 117 0 53 1 121 0 54 1 125 0 56 1 129 0 60 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 87 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 101 1 213 0 102 1 217 0 119 1 221 0 137 1 225 0 138 1 229 0 139 1 233 0 140 1 237 0 141 1 241 0 142 5 113 0 143]
#[0 5 117 0 60]
#[0 2 222 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 2 242 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
#[0 2 234 0 20 0 23 0 24 0 25 0 28 0 31 0 32 0 34 0 35 0 36 0 38 0 39 0 42 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 56 0 60 0 76 0 77 0 78 0 81 0 82]
)! !

SmaCCParser subclass: #JavaParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Examples'!

!JavaParser classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:50'!
parserDefinitionComment

	"goal :	compilation_unit
	;

# 19.3) Lexical Structure.
literal :	<INTEGER_LITERAL>
	|	<FLOATING_POINT_LITERAL>
	|	<BOOLEAN_LITERAL>
#	| 	""true""
#	| 	""false""
	|	<CHARACTER_LITERAL>
	|	<STRING_LITERAL>
	|	<NULL_LITERAL>
	;

# 19.4) Types, Values, and Variables
type	:	primitive_type
	|	reference_type
	;
primitive_type :
		numeric_type
	|	""boolean""
	;
numeric_type:	integral_type
	|	floating_point_type
	;
integral_type : 
		""byte"" 
	|	""short"" 
	|	""int"" 
	|	""long"" 
	|	""char"" 
	;
floating_point_type : 
		""float"" 
	|	""double""
	;

reference_type :
		class_or_interface_type
	|	array_type
	;
class_or_interface_type : name;

class_type :	class_or_interface_type;
interface_type : class_or_interface_type;		

array_type :	primitive_type dims
	|	name dims
	;

# 19.5) Names
name	:	simple_name
	|	qualified_name
	;
simple_name :	<IDENTIFIER>
	;
qualified_name :
		name ""."" <IDENTIFIER>
	;

# 19.6) ""package""s
compilation_unit :
		package_declaration_opt 
		import_declarations_opt
		type_declarations_opt
		;
package_declaration_opt : package_declaration | ;
import_declarations_opt : import_declarations | ;
type_declarations_opt   : type_declarations   | ;

import_declarations : 
		import_declaration
	|	import_declarations import_declaration
	;
type_declarations : 
		type_declaration
	|	type_declarations type_declaration
	;
package_declaration : 
		""package"" name "";""
	;
import_declaration : 
		single_type_import_declaration
	|	type_import_on_demand_declaration
	;
single_type_import_declaration : 
		""import"" name "";""
	;
type_import_on_demand_declaration :
		""import"" name ""."" ""*"" "";""
	;
type_declaration :
		class_declaration
	|	interface_declaration
	|	"";""
	;

# 19.7) Productions used only in the LALR(1) grammar
modifiers_opt:
	|	modifiers
	;
modifiers : 	modifier
	|	modifiers modifier
	;
modifier :	""public"" | ""protected"" | ""private""
	|	""static""
	|	""abstract"" | ""final"" | ""native"" | ""synchronized"" | ""transient"" | ""volatile""
	|	""strictfp"" # note that semantic analysis must check that the
	                 # context of the modifier allows strictfp.
	;

# 19.8) Classes

# 19.8.1) Class Declaration:
class_declaration : 
	modifiers_opt ""class"" <IDENTIFIER> super_opt interfaces_opt class_body
	;
super :	""extends"" class_type
	;
super_opt :	
	|	super
	;
interfaces :	""implements"" interface_type_list
	;
interfaces_opt:
	|	interfaces 
	;
interface_type_list : 
		interface_type
	|	interface_type_list "","" interface_type
	;
class_body :	""{"" class_body_declarations_opt ""}"" 
	;
class_body_declarations_opt : 
	|	class_body_declarations ;
class_body_declarations : 
		class_body_declaration
	|	class_body_declarations class_body_declaration
	;
class_body_declaration :
		class_member_declaration
	|	static_initializer
	|	constructor_declaration
	|	block
	;
class_member_declaration :
		field_declaration
	|	method_declaration
	# repeat the prod for 'class_declaration' here: 
	|	modifiers_opt ""class"" <IDENTIFIER> super_opt interfaces_opt class_body
	|	interface_declaration
	|	"";""
	;

# 19.8.2) Field Declarations
field_declaration : 
		modifiers_opt type variable_declarators "";""
	;
variable_declarators :
		variable_declarator
	|	variable_declarators "","" variable_declarator
	;
variable_declarator :
		variable_declarator_id
	|	variable_declarator_id ""="" variable_initializer
	;
variable_declarator_id :
		<IDENTIFIER>
	|	variable_declarator_id ""["" ""]""
	;
variable_initializer :
		expression
	|	array_initializer
	;

# 19.8.3) Method Declarations
method_declaration :
		method_header method_body
	;
method_header :
		modifiers_opt type method_declarator throws_opt
	|	modifiers_opt ""void"" method_declarator throws_opt
	;
method_declarator :
		<IDENTIFIER> ""("" formal_parameter_list_opt "")""
	|	method_declarator ""["" ""]"" # deprecated
	# be careful; the above production also allows 'void foo() []'
	;
formal_parameter_list_opt :
	|	formal_parameter_list
	;
formal_parameter_list :
		formal_parameter
	|	formal_parameter_list "","" formal_parameter
	;
formal_parameter :
		type variable_declarator_id
	|	""final"" type variable_declarator_id
	;
throws_opt :	
	|	throws
	;
throws :	""throws"" class_type_list
	;
class_type_list :
		class_type
	|	class_type_list "","" class_type
	;
method_body :	block
	|	"";""
	;

# 19.8.4) Static Initializers
static_initializer :
		""static"" block
	;

# 19.8.5) Constructor Declarations
constructor_declaration :
		modifiers_opt constructor_declarator throws_opt 
			constructor_body
	;
constructor_declarator :
		simple_name ""("" formal_parameter_list_opt "")""
	;
constructor_body :
		""{"" explicit_constructor_invocation
			block_statements ""}""
	|	""{"" explicit_constructor_invocation ""}""
	|	""{"" block_statements ""}""
	|	""{"" ""}""
	;
explicit_constructor_invocation :
		""this"" ""("" argument_list_opt "")"" "";""
	|	""super"" ""("" argument_list_opt "")"" "";""
	|	primary ""."" ""this"" ""("" argument_list_opt "")"" "";""
	|	primary ""."" ""super"" ""("" argument_list_opt "")"" "";""
	;

# 19.9) Interfaces

# 19.9.1) Interface Declarations
interface_declaration :
		modifiers_opt ""interface"" <IDENTIFIER> extends_interfaces_opt 
			interface_body
	;
extends_interfaces_opt :
	|	extends_interfaces
	;
extends_interfaces :
		""extends"" interface_type
	|	extends_interfaces "","" interface_type
	;
interface_body :
		""{"" interface_member_declarations_opt ""}""
	;
interface_member_declarations_opt :
	|	interface_member_declarations
	;
interface_member_declarations :
		interface_member_declaration
	|	interface_member_declarations interface_member_declaration
	;
interface_member_declaration :
		constant_declaration
	|	abstract_method_declaration
	|	class_declaration
	|	interface_declaration
	;
constant_declaration :
		field_declaration
	# need to semantically check that modifiers of field declaration
	# include only PUBLIC, ""static"", or ""final"".  Other modifiers are
	# disallowed.
	;
abstract_method_declaration :
		method_header "";""
	;

# 19.10) Arrays
array_initializer :
		""{"" variable_initializers "","" ""}""
	|	""{"" variable_initializers ""}""
	|	""{"" "","" ""}""
	|	""{"" ""}""
	;
variable_initializers :
		variable_initializer
	|	variable_initializers "","" variable_initializer
	;

# 19.11) Blocks and Statements
block :	""{"" block_statements_opt ""}""
	;
block_statements_opt :
	|	block_statements
	;
block_statements :
		block_statement
	|	block_statements block_statement
	;
block_statement :
		local_variable_declaration_statement
	|	statement
	|	class_declaration
	|	interface_declaration
	;
local_variable_declaration_statement :
		local_variable_declaration "";""
	;
local_variable_declaration :
		type variable_declarators
	|	""final"" type variable_declarators
	;
statement :	statement_without_trailing_substatement
	|	labeled_statement
	|	if_then_statement
	|	if_then_else_statement
	|	while_statement
	|	for_statement
	;
statement_no_short_if :
		statement_without_trailing_substatement
	|	labeled_statement_no_short_if
	|	if_then_else_statement_no_short_if
	|	while_statement_no_short_if
	|	for_statement_no_short_if
	;
statement_without_trailing_substatement :
		block
	|	empty_statement
	|	expression_statement
	|	switch_statement
	|	do_statement
	|	break_statement
	|	continue_statement
	|	return_statement
	|	synchronized_statement
	|	throw_statement
	|	try_statement
	;
empty_statement :
		"";""
	;
labeled_statement :
		<IDENTIFIER> "":"" statement
	;
labeled_statement_no_short_if :
		<IDENTIFIER> "":"" statement_no_short_if
	;
expression_statement :
		statement_expression "";""
	;
statement_expression :
		assignment
	|	preincrement_expression
	|	predecrement_expression
	|	postincrement_expression
	|	postdecrement_expression
	|	method_invocation
	|	class_instance_creation_expression
	;
if_then_statement :
		""if"" ""("" expression "")"" statement
	;
if_then_else_statement :
		""if"" ""("" expression "")"" statement_no_short_if 
			""else"" statement
	;
if_then_else_statement_no_short_if :
		""if"" ""("" expression "")"" statement_no_short_if
			""else"" statement_no_short_if
	;
switch_statement :
		""switch"" ""("" expression "")"" switch_block
	;
switch_block :
		""{"" switch_block_statement_groups switch_labels ""}""
	|	""{"" switch_block_statement_groups ""}""
	|	""{"" switch_labels ""}""
	|	""{"" ""}""
	;
switch_block_statement_groups :
		switch_block_statement_group
	|	switch_block_statement_groups switch_block_statement_group
	;
switch_block_statement_group :
		switch_labels block_statements
	;
switch_labels :
		switch_label
	|	switch_labels switch_label
	;
switch_label :
		""case"" constant_expression "":""
	|	""default"" "":""
	;

while_statement :
		""while"" ""("" expression "")"" statement
	;
while_statement_no_short_if :
		""while"" ""("" expression "")"" statement_no_short_if
	;
do_statement :
		""do"" statement ""while"" ""("" expression "")"" "";""
	;
for_statement :
		""for"" ""("" for_init_opt "";"" expression_opt "";""
			for_update_opt "")"" statement
	;
for_statement_no_short_if :
		""for"" ""("" for_init_opt "";"" expression_opt "";""
			for_update_opt "")"" statement_no_short_if
	;
for_init_opt :
	|	for_init
	;
for_init :	statement_expression_list
	|	local_variable_declaration
	;
for_update_opt :
	|	for_update
	;
for_update :	statement_expression_list
	;
statement_expression_list :
		statement_expression
	|	statement_expression_list "","" statement_expression
	;

identifier_opt : 
	|	<IDENTIFIER>
	;

break_statement :
		""break"" identifier_opt "";""
	;

continue_statement :
		""continue"" identifier_opt "";""
	;
return_statement :
		""return"" expression_opt "";""
	;
throw_statement :
		""throw"" expression "";""
	;
synchronized_statement :
		""synchronized"" ""("" expression "")"" block
	;
try_statement :
		""try"" block catches
	|	""try"" block catches_opt finally
	;
catches_opt :
	|	catches
	;
catches :	catch_clause
	|	catches catch_clause
	;
catch_clause :
		""catch"" ""("" formal_parameter "")"" block
	;
finally :	""finally"" block
	;

# 19.12) Expressions
primary :	primary_no_new_array
	|	array_creation_expression
	;
primary_no_new_array :
		literal
	|	""this""
	|	""("" expression "")""
	|	class_instance_creation_expression
	|	field_access
	|	method_invocation
	|	array_access
	|	primitive_type ""."" ""class""
	|	""void"" ""."" ""class""
	|	array_type ""."" ""class""
	|	name ""."" ""class""
	|	name ""."" ""this""
	;
class_instance_creation_expression :
		""new"" class_type ""("" argument_list_opt "")""
	|	""new"" class_type ""("" argument_list_opt "")"" class_body
	|	primary ""."" ""new"" <IDENTIFIER>
			""("" argument_list_opt "")""
	|	primary ""."" ""new"" <IDENTIFIER>
			""("" argument_list_opt "")"" class_body
	;
argument_list_opt :
	|	argument_list
	;
argument_list :
		expression
	|	argument_list "","" expression
	;
array_creation_expression :
		""new"" primitive_type dim_exprs dims_opt
	|	""new"" class_or_interface_type dim_exprs dims_opt
	|	""new"" primitive_type dims array_initializer
	|	""new"" class_or_interface_type dims array_initializer
	;
dim_exprs :	dim_expr
	|	dim_exprs dim_expr
	;
dim_expr :	""["" expression ""]""
	;
dims_opt :
	|	dims
	;
dims :	""["" ""]""
	|	dims ""["" ""]""
	;
field_access :
		primary ""."" <IDENTIFIER>
	|	""super"" ""."" <IDENTIFIER>
	|	name ""."" ""super"" ""."" <IDENTIFIER>
	;
method_invocation :
		name ""("" argument_list_opt "")""
	|	primary ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	|	""super"" ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	|	name ""."" ""super"" ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	;
array_access :
		name ""["" expression ""]""
	|	primary_no_new_array ""["" expression ""]""
	;
postfix_expression :
		primary
	|	name
	|	postincrement_expression
	|	postdecrement_expression
	;
postincrement_expression :
		postfix_expression ""++""
	;
postdecrement_expression :
		postfix_expression ""--""
	;
unary_expression :
		preincrement_expression
	|	predecrement_expression
	|	""+"" unary_expression
	|	""-"" unary_expression
	|	unary_expression_not_plus_minus
	;
preincrement_expression :
		""++"" unary_expression
	;
predecrement_expression :
		""--"" unary_expression
	;
unary_expression_not_plus_minus :
		postfix_expression
	|	""~"" unary_expression
	|	""!!"" unary_expression
	|	cast_expression
	;
cast_expression :
		""("" primitive_type dims_opt "")"" unary_expression
	|	""("" expression "")"" unary_expression_not_plus_minus
	|	""("" name dims "")"" unary_expression_not_plus_minus
	;
multiplicative_expression :
		unary_expression
	|	multiplicative_expression ""*"" unary_expression
	|	multiplicative_expression ""/"" unary_expression
	|	multiplicative_expression ""%"" unary_expression
	;
additive_expression :
		multiplicative_expression
	|	additive_expression ""+"" multiplicative_expression
	|	additive_expression ""-"" multiplicative_expression
	;
shift_expression :
		additive_expression
	|	shift_expression ""<<"" additive_expression
	|	shift_expression "">>"" additive_expression
	|	shift_expression "">>>"" additive_expression
	;
relational_expression :
		shift_expression
	|	relational_expression ""<"" shift_expression
	|	relational_expression "">"" shift_expression
	|	relational_expression ""<="" shift_expression
	|	relational_expression "">="" shift_expression
	|	relational_expression ""instanceof"" reference_type
	;
equality_expression :
		relational_expression
	|	equality_expression ""=="" relational_expression
	|	equality_expression ""!!="" relational_expression
	;
and_expression :
		equality_expression
	|	and_expression ""&"" equality_expression
	;
exclusive_or_expression :
		and_expression
	|	exclusive_or_expression ""^"" and_expression
	;
inclusive_or_expression :
		exclusive_or_expression
	|	inclusive_or_expression ""|"" exclusive_or_expression
	;
conditional_and_expression :
		inclusive_or_expression
	|	conditional_and_expression ""&&"" inclusive_or_expression
	;
conditional_or_expression :
		conditional_and_expression
	|	conditional_or_expression ""||"" conditional_and_expression
	;
conditional_expression :
		conditional_or_expression
	|	conditional_or_expression ""?"" expression 
			"":"" conditional_expression
	;
assignment_expression :
		conditional_expression
	|	assignment
	;
assignment :	left_hand_side assignment_operator assignment_expression
	;
left_hand_side :
		name
	|	field_access
	|	array_access
	;
assignment_operator :
		""=""
	|	""*=""
	|	""/=""
	|	""%=""
	|	""+=""
	|	""-=""
	|	""<<=""
	|	"">>=""
	|	"">>>=""
	|	""&=""
	|	""^=""
	|	""|=""
	;
expression_opt :
	|	expression
	;
expression :	assignment_expression
	;
constant_expression :
		expression
	;"! !

!JavaParser classSide methodsFor: 'generated-accessing' stamp: 'lr 4/12/2010 17:50'!
scannerClass
	^JavaScanner! !

!JavaParser classSide methodsFor: 'generated-starting states' stamp: 'lr 4/12/2010 17:50'!
startingStateForgoal
	^1! !

!JavaParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:50'!
reduceTable
	^#(
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(104 1 #reduceFor:)
#(104 1 #reduceFor:)
#(105 1 #reduceFor:)
#(105 1 #reduceFor:)
#(106 1 #reduceFor:)
#(106 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(109 1 #reduceFor:)
#(110 2 #reduceFor:)
#(110 2 #reduceFor:)
#(111 1 #reduceFor:)
#(111 1 #reduceFor:)
#(112 1 #reduceFor:)
#(113 1 #reduceFor:)
#(114 2 #reduceFor:)
#(114 3 #reduceFor:)
#(115 1 #reduceFor:)
#(116 3 #reduceFor:)
#(117 1 #reduceFor:)
#(117 1 #reduceFor:)
#(117 1 #reduceFor:)
#(117 1 #reduceFor:)
#(117 1 #reduceFor:)
#(117 1 #reduceFor:)
#(118 1 #reduceFor:)
#(118 0 #reduceFor:)
#(119 1 #reduceFor:)
#(119 0 #reduceFor:)
#(120 1 #reduceFor:)
#(120 0 #reduceFor:)
#(121 3 #reduceFor:)
#(122 1 #reduceFor:)
#(122 2 #reduceFor:)
#(123 1 #reduceFor:)
#(123 2 #reduceFor:)
#(124 1 #reduceFor:)
#(124 1 #reduceFor:)
#(125 1 #reduceFor:)
#(125 1 #reduceFor:)
#(125 1 #reduceFor:)
#(126 3 #reduceFor:)
#(127 5 #reduceFor:)
#(128 6 #reduceFor:)
#(129 5 #reduceFor:)
#(130 1 #reduceFor:)
#(131 0 #reduceFor:)
#(131 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(132 1 #reduceFor:)
#(133 0 #reduceFor:)
#(133 1 #reduceFor:)
#(134 0 #reduceFor:)
#(134 1 #reduceFor:)
#(135 3 #reduceFor:)
#(136 2 #reduceFor:)
#(137 1 #reduceFor:)
#(137 3 #reduceFor:)
#(138 2 #reduceFor:)
#(139 0 #reduceFor:)
#(139 1 #reduceFor:)
#(140 1 #reduceFor:)
#(140 2 #reduceFor:)
#(141 1 #reduceFor:)
#(141 1 #reduceFor:)
#(141 1 #reduceFor:)
#(141 1 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(142 6 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(143 2 #reduceFor:)
#(144 4 #reduceFor:)
#(145 3 #reduceFor:)
#(146 4 #reduceFor:)
#(147 2 #reduceFor:)
#(148 1 #reduceFor:)
#(148 3 #reduceFor:)
#(149 1 #reduceFor:)
#(149 3 #reduceFor:)
#(150 1 #reduceFor:)
#(150 3 #reduceFor:)
#(151 1 #reduceFor:)
#(151 1 #reduceFor:)
#(152 1 #reduceFor:)
#(153 4 #reduceFor:)
#(153 3 #reduceFor:)
#(153 3 #reduceFor:)
#(153 2 #reduceFor:)
#(154 4 #reduceFor:)
#(154 4 #reduceFor:)
#(155 1 #reduceFor:)
#(155 1 #reduceFor:)
#(156 4 #reduceFor:)
#(156 3 #reduceFor:)
#(157 0 #reduceFor:)
#(157 1 #reduceFor:)
#(158 0 #reduceFor:)
#(158 1 #reduceFor:)
#(159 1 #reduceFor:)
#(159 3 #reduceFor:)
#(160 2 #reduceFor:)
#(160 3 #reduceFor:)
#(161 2 #reduceFor:)
#(162 1 #reduceFor:)
#(162 3 #reduceFor:)
#(163 4 #reduceFor:)
#(164 4 #reduceFor:)
#(164 3 #reduceFor:)
#(164 3 #reduceFor:)
#(164 2 #reduceFor:)
#(165 5 #reduceFor:)
#(165 5 #reduceFor:)
#(165 7 #reduceFor:)
#(165 7 #reduceFor:)
#(166 1 #reduceFor:)
#(166 2 #reduceFor:)
#(167 0 #reduceFor:)
#(167 1 #reduceFor:)
#(168 1 #reduceFor:)
#(168 1 #reduceFor:)
#(169 0 #reduceFor:)
#(169 1 #reduceFor:)
#(170 3 #reduceFor:)
#(171 2 #reduceFor:)
#(171 3 #reduceFor:)
#(172 0 #reduceFor:)
#(172 1 #reduceFor:)
#(173 1 #reduceFor:)
#(173 2 #reduceFor:)
#(174 1 #reduceFor:)
#(174 1 #reduceFor:)
#(174 1 #reduceFor:)
#(174 1 #reduceFor:)
#(175 1 #reduceFor:)
#(176 2 #reduceFor:)
#(177 1 #reduceFor:)
#(177 3 #reduceFor:)
#(178 0 #reduceFor:)
#(178 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(180 2 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(181 1 #reduceFor:)
#(182 2 #reduceFor:)
#(182 3 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(183 1 #reduceFor:)
#(184 3 #reduceFor:)
#(185 5 #reduceFor:)
#(186 7 #reduceFor:)
#(187 5 #reduceFor:)
#(188 9 #reduceFor:)
#(189 3 #reduceFor:)
#(190 7 #reduceFor:)
#(191 5 #reduceFor:)
#(192 9 #reduceFor:)
#(193 1 #reduceFor:)
#(193 1 #reduceFor:)
#(193 1 #reduceFor:)
#(193 1 #reduceFor:)
#(193 1 #reduceFor:)
#(194 1 #reduceFor:)
#(195 2 #reduceFor:)
#(196 5 #reduceFor:)
#(197 7 #reduceFor:)
#(198 3 #reduceFor:)
#(199 3 #reduceFor:)
#(200 3 #reduceFor:)
#(201 5 #reduceFor:)
#(202 3 #reduceFor:)
#(203 3 #reduceFor:)
#(203 4 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(204 1 #reduceFor:)
#(205 3 #reduceFor:)
#(206 2 #reduceFor:)
#(207 2 #reduceFor:)
#(208 2 #reduceFor:)
#(209 2 #reduceFor:)
#(210 4 #reduceFor:)
#(210 6 #reduceFor:)
#(210 6 #reduceFor:)
#(210 8 #reduceFor:)
#(211 5 #reduceFor:)
#(211 6 #reduceFor:)
#(211 7 #reduceFor:)
#(211 8 #reduceFor:)
#(212 4 #reduceFor:)
#(212 3 #reduceFor:)
#(212 3 #reduceFor:)
#(212 2 #reduceFor:)
#(213 1 #reduceFor:)
#(213 2 #reduceFor:)
#(214 1 #reduceFor:)
#(214 2 #reduceFor:)
#(215 2 #reduceFor:)
#(216 3 #reduceFor:)
#(216 2 #reduceFor:)
#(217 1 #reduceFor:)
#(218 0 #reduceFor:)
#(218 1 #reduceFor:)
#(219 0 #reduceFor:)
#(219 1 #reduceFor:)
#(220 0 #reduceFor:)
#(220 1 #reduceFor:)
#(221 1 #reduceFor:)
#(221 1 #reduceFor:)
#(222 1 #reduceFor:)
#(222 3 #reduceFor:)
#(223 1 #reduceFor:)
#(224 0 #reduceFor:)
#(224 1 #reduceFor:)
#(225 1 #reduceFor:)
#(225 2 #reduceFor:)
#(226 0 #reduceFor:)
#(226 1 #reduceFor:)
#(227 2 #reduceFor:)
#(228 5 #reduceFor:)
#(229 1 #reduceFor:)
#(229 1 #reduceFor:)
#(229 3 #reduceFor:)
#(229 1 #reduceFor:)
#(229 1 #reduceFor:)
#(229 1 #reduceFor:)
#(229 1 #reduceFor:)
#(229 3 #reduceFor:)
#(229 3 #reduceFor:)
#(229 3 #reduceFor:)
#(229 3 #reduceFor:)
#(229 3 #reduceFor:)
#(230 4 #reduceFor:)
#(230 4 #reduceFor:)
#(230 4 #reduceFor:)
#(230 4 #reduceFor:)
#(231 3 #reduceFor:)
#(231 3 #reduceFor:)
#(231 5 #reduceFor:)
#(232 4 #reduceFor:)
#(232 4 #reduceFor:)
#(233 1 #reduceFor:)
#(233 3 #reduceFor:)
#(234 1 #reduceFor:)
#(234 2 #reduceFor:)
#(235 0 #reduceFor:)
#(235 1 #reduceFor:)
#(236 3 #reduceFor:)
#(237 1 #reduceFor:)
#(237 1 #reduceFor:)
#(237 1 #reduceFor:)
#(237 1 #reduceFor:)
#(238 1 #reduceFor:)
#(238 1 #reduceFor:)
#(238 2 #reduceFor:)
#(238 2 #reduceFor:)
#(238 1 #reduceFor:)
#(239 1 #reduceFor:)
#(239 2 #reduceFor:)
#(239 2 #reduceFor:)
#(239 1 #reduceFor:)
#(240 5 #reduceFor:)
#(240 4 #reduceFor:)
#(240 5 #reduceFor:)
#(241 1 #reduceFor:)
#(241 3 #reduceFor:)
#(241 3 #reduceFor:)
#(241 3 #reduceFor:)
#(242 1 #reduceFor:)
#(242 3 #reduceFor:)
#(242 3 #reduceFor:)
#(243 1 #reduceFor:)
#(243 3 #reduceFor:)
#(243 3 #reduceFor:)
#(243 3 #reduceFor:)
#(244 1 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(245 1 #reduceFor:)
#(245 3 #reduceFor:)
#(245 3 #reduceFor:)
#(246 1 #reduceFor:)
#(246 3 #reduceFor:)
#(247 1 #reduceFor:)
#(247 3 #reduceFor:)
#(248 1 #reduceFor:)
#(248 3 #reduceFor:)
#(249 1 #reduceFor:)
#(249 3 #reduceFor:)
#(250 1 #reduceFor:)
#(250 3 #reduceFor:)
#(251 1 #reduceFor:)
#(251 5 #reduceFor:)
#(252 1 #reduceFor:)
#(252 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(254 1 #reduceFor:)
#(257 1 #reduceFor:)
#(258 3 #reduceFor:)
#(259 1 #reduceFor:)
#(259 2 #reduceFor:)
)! !

!JavaParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:50'!
transitionTable
	^#(
#[1 0 138 0 7 0 138 0 8 0 138 0 12 0 138 0 16 0 138 0 18 0 9 0 29 0 138 0 32 0 138 0 36 0 138 0 37 0 138 0 38 0 138 0 39 0 138 0 40 0 138 0 43 0 138 0 44 0 138 0 45 0 138 0 46 0 13 0 118 0 17 0 121 0 138 0 255 0 21 1 1 0 25 1 2]
#[1 0 29 0 99 0 33 0 111 0 37 0 115 0 41 0 116]
#[1 0 146 0 7 0 146 0 8 0 146 0 12 0 146 0 16 0 146 0 18 0 146 0 32 0 146 0 36 0 146 0 37 0 146 0 38 0 146 0 39 0 146 0 40 0 146 0 43 0 45 0 44 0 146 0 45 0 146 0 46 0 49 0 119 0 53 0 122 0 57 0 124 0 61 0 126 0 65 0 127 0 146 0 255]
#[0 0 134 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 45 0 46 0 255]
#[0 0 0 0 255]
#[0 5 126 0 255]
#[0 0 102 0 1 0 2 0 3 0 4 0 5 0 6 0 10 0 13 0 15 0 19 0 21 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90 0 99]
#[1 0 69 0 28 0 73 0 32]
#[0 0 78 0 1 0 2 0 3 0 4 0 5 0 6 0 10 0 13 0 15 0 19 0 21 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90 0 99]
#[0 0 82 0 1 0 2 0 3 0 4 0 5 0 6 0 10 0 13 0 15 0 19 0 21 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90 0 99]
#[1 0 29 0 99 0 77 0 111 0 37 0 115 0 41 0 116]
#[1 0 81 0 7 0 218 0 8 0 85 0 12 0 218 0 16 0 89 0 18 0 93 0 32 0 97 0 36 0 101 0 37 0 105 0 38 0 109 0 39 0 113 0 40 0 117 0 43 0 121 0 45 0 125 0 46 0 129 0 120 0 133 0 123 0 137 0 125 0 141 0 128 0 145 0 129 0 149 0 131 0 153 0 132 0 154 0 255 0 157 1 3]
#[1 0 142 0 7 0 142 0 8 0 142 0 12 0 142 0 16 0 142 0 18 0 142 0 32 0 142 0 36 0 142 0 37 0 142 0 38 0 142 0 39 0 142 0 40 0 142 0 43 0 45 0 44 0 142 0 45 0 142 0 46 0 161 0 124 0 61 0 126 0 65 0 127 0 142 0 255]
#[0 0 162 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 45 0 46 0 255]
#[0 0 178 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 45 0 46 0 255]
#[0 0 182 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 45 0 46 0 255]
#[0 0 165 0 99]
#[0 0 158 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 45 0 46 0 255]
#[1 0 169 0 28 0 173 0 32]
#[0 1 10 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 6 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 2 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 194 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 255]
#[0 0 246 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 250 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 242 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 238 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 254 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 226 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 234 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 230 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 5 130 0 255]
#[1 0 81 0 7 0 218 0 8 0 85 0 12 0 218 0 16 0 89 0 18 0 93 0 32 0 97 0 36 0 101 0 37 0 105 0 38 0 109 0 39 0 113 0 40 0 117 0 43 0 121 0 45 0 125 0 46 0 177 0 125 0 141 0 128 0 145 0 129 0 149 0 131 0 153 0 132 0 150 0 255 0 157 1 3]
#[0 0 170 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 255]
#[0 0 186 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 255]
#[0 0 190 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 255]
#[1 0 181 0 8 0 185 0 16]
#[0 5 134 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 0 81 0 7 0 222 0 8 0 222 0 9 0 85 0 12 0 222 0 16 0 89 0 18 0 222 0 24 0 222 0 25 0 222 0 26 0 222 0 27 0 222 0 30 0 222 0 31 0 222 0 33 0 222 0 34 0 97 0 36 0 101 0 37 0 105 0 38 0 109 0 39 0 113 0 40 0 117 0 43 0 121 0 45 0 125 0 46 0 222 0 99 0 189 0 132]
#[0 0 166 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 45 0 46 0 255]
#[0 0 106 0 1 0 2 0 3 0 4 0 5 0 6 0 10 0 13 0 15 0 19 0 21 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90 0 99]
#[1 0 193 0 42 0 165 0 99]
#[0 0 198 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 45 0 46 0 255]
#[0 0 174 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 255]
#[0 0 197 0 99]
#[0 0 201 0 99]
#[0 5 138 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 0 205 0 32]
#[1 1 14 0 3 1 14 0 10 0 209 0 11 0 213 0 133 0 217 0 136]
#[1 2 46 0 3 0 221 0 11 0 225 0 169 0 229 0 171]
#[0 0 202 0 7 0 8 0 12 0 16 0 18 0 32 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 45 0 46 0 255]
#[1 0 29 0 99 0 233 0 109 0 237 0 111 0 241 0 112 0 37 0 115 0 41 0 116]
#[1 1 22 0 3 0 245 0 10 0 249 0 134 0 253 0 138]
#[0 1 18 0 3 0 10]
#[1 0 29 0 99 1 1 0 109 0 237 0 111 1 5 0 113 0 37 0 115 0 41 0 116]
#[1 1 9 0 3 1 13 0 170]
#[1 2 50 0 3 1 17 0 4]
#[0 0 86 0 3 0 4 0 10 0 32]
#[1 0 66 0 3 0 66 0 4 0 66 0 5 0 66 0 10 0 66 0 21 0 69 0 28 0 66 0 32]
#[0 1 34 0 3 0 10]
#[1 0 29 0 99 1 1 0 109 0 237 0 111 1 21 0 113 0 37 0 115 0 41 0 116 1 25 0 137]
#[1 1 29 0 3 1 33 0 135]
#[0 1 26 0 3]
#[0 0 90 0 3 0 4]
#[0 2 58 0 3 0 4]
#[1 2 66 0 1 0 81 0 7 0 218 0 8 0 218 0 9 0 85 0 12 0 218 0 16 0 89 0 18 0 218 0 24 0 218 0 25 0 218 0 26 0 218 0 27 0 218 0 30 0 218 0 31 0 218 0 33 0 218 0 34 0 97 0 36 0 101 0 37 0 105 0 38 0 109 0 39 0 113 0 40 0 117 0 43 0 121 0 45 0 125 0 46 0 218 0 99 1 37 0 128 1 41 0 129 1 45 0 131 0 153 0 132 1 49 0 146 1 53 0 154 1 57 0 172 1 61 0 173 1 65 0 174 1 69 0 175 1 73 0 176 0 157 1 3]
#[0 0 210 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 255]
#[1 0 29 0 99 1 1 0 109 0 237 0 111 1 77 0 113 0 37 0 115 0 41 0 116]
#[0 1 38 0 3 0 4]
#[1 1 46 0 3 1 81 0 4]
#[1 1 50 0 1 1 85 0 3 0 81 0 7 0 218 0 8 0 218 0 9 0 85 0 12 0 218 0 16 0 89 0 18 0 218 0 24 0 218 0 25 0 218 0 26 0 218 0 27 0 218 0 30 0 218 0 31 1 89 0 32 0 218 0 33 0 218 0 34 0 97 0 36 0 101 0 37 0 105 0 38 1 93 0 39 0 113 0 40 0 117 0 43 0 121 0 45 0 125 0 46 0 218 0 99 1 97 0 129 1 101 0 131 0 153 0 132 1 105 0 139 1 109 0 140 1 113 0 141 1 117 0 142 1 121 0 143 1 125 0 144 1 129 0 145 1 133 0 146 1 137 0 147 1 141 0 154 0 157 1 3]
#[0 0 206 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 255]
#[0 2 90 0 1 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 2 94 0 1 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 0 181 0 8 1 145 0 9 0 185 0 16 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 0 29 0 99 1 181 0 103 1 185 0 104 1 189 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116]
#[0 2 98 0 1 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 217 0 32]
#[0 1 221 0 1]
#[1 2 70 0 1 0 81 0 7 0 218 0 8 0 218 0 9 0 85 0 12 0 218 0 16 0 89 0 18 0 218 0 24 0 218 0 25 0 218 0 26 0 218 0 27 0 218 0 30 0 218 0 31 0 218 0 33 0 218 0 34 0 97 0 36 0 101 0 37 0 105 0 38 0 109 0 39 0 113 0 40 0 117 0 43 0 121 0 45 0 125 0 46 0 218 0 99 1 37 0 128 1 41 0 129 1 45 0 131 0 153 0 132 1 49 0 146 1 53 0 154 1 225 0 174 1 69 0 175 1 73 0 176 0 157 1 3]
#[0 2 74 0 1 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 2 82 0 1 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 2 86 0 1 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 2 62 0 3 0 4]
#[1 0 29 0 99 1 1 0 109 0 237 0 111 1 229 0 113 0 37 0 115 0 41 0 116]
#[1 2 114 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 0 117 0 43 0 121 0 45 0 125 0 46 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 2 117 0 166 2 121 0 168 2 125 0 178 2 129 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[0 1 98 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 1 85 0 3 0 238 0 7 0 238 0 8 0 238 0 9 0 238 0 12 0 238 0 16 0 238 0 18 0 238 0 24 0 238 0 25 0 238 0 26 0 238 0 27 0 238 0 30 0 238 0 31 0 238 0 33 0 238 0 34 0 238 0 36 0 238 0 37 0 238 0 38 0 238 0 39 0 238 0 40 0 238 0 43 0 238 0 45 0 238 0 46 0 238 0 99 3 9 0 145]
#[0 1 94 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 3 13 0 8 1 145 0 9 0 185 0 16 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 0 29 0 99 1 181 0 103 1 185 0 104 1 189 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 3 17 0 115 0 41 0 116 3 21 0 163]
#[0 3 25 0 1]
#[1 1 54 0 1 1 85 0 3 0 81 0 7 0 218 0 8 0 218 0 9 0 85 0 12 0 218 0 16 0 89 0 18 0 218 0 24 0 218 0 25 0 218 0 26 0 218 0 27 0 218 0 30 0 218 0 31 1 89 0 32 0 218 0 33 0 218 0 34 0 97 0 36 0 101 0 37 0 105 0 38 1 93 0 39 0 113 0 40 0 117 0 43 0 121 0 45 0 125 0 46 0 218 0 99 1 97 0 129 1 101 0 131 0 153 0 132 3 29 0 141 1 117 0 142 1 121 0 143 1 125 0 144 1 129 0 145 1 133 0 146 1 137 0 147 1 141 0 154 0 157 1 3]
#[0 1 58 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 66 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 70 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 74 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 78 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 82 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 86 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 1 85 0 3 3 33 0 32 3 37 0 145 3 41 0 155]
#[1 3 45 0 99 3 49 0 156]
#[0 0 58 0 5 0 19 0 28 0 99]
#[0 0 62 0 5 0 19 0 28 0 99]
#[0 0 54 0 5 0 19 0 28 0 99]
#[0 0 50 0 5 0 19 0 28 0 99]
#[0 0 10 0 5 0 19 0 28 0 99]
#[0 0 38 0 5 0 19 0 28 0 99]
#[0 0 46 0 5 0 19 0 28 0 99]
#[0 0 42 0 5 0 19 0 28 0 99]
#[1 3 53 0 5 0 22 0 99 3 57 0 114]
#[0 0 26 0 99]
#[1 3 61 0 99 3 65 0 148 3 69 0 149 3 73 0 150 3 77 0 156]
#[0 0 6 0 5 0 19 0 28 0 99]
#[0 0 30 0 5 0 19 0 28 0 99]
#[0 0 34 0 5 0 19 0 28 0 99]
#[0 0 14 0 1 0 4 0 6 0 15 0 19 0 32 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 99]
#[0 0 18 0 1 0 4 0 6 0 15 0 19 0 32 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 99]
#[1 0 66 0 1 0 66 0 4 3 53 0 5 0 66 0 6 0 66 0 15 0 66 0 19 0 69 0 28 0 66 0 32 0 66 0 48 0 66 0 49 0 66 0 50 0 66 0 51 0 66 0 52 0 66 0 53 0 66 0 54 0 66 0 55 0 66 0 56 0 66 0 58 0 66 0 59 0 66 0 65 0 66 0 71 0 66 0 99 3 81 0 114]
#[0 2 102 0 1 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 2 54 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 255]
#[0 2 78 0 1 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 42 0 3 0 4]
#[0 3 85 0 28]
#[0 3 89 0 21]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 3 125 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 3 221 0 28]
#[0 4 14 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 3 18 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 225 0 21]
#[1 0 246 0 7 0 246 0 8 0 246 0 12 0 246 0 16 0 246 0 18 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 0 246 0 36 0 246 0 37 0 246 0 38 0 246 0 39 0 246 0 40 0 246 0 43 0 246 0 45 0 246 0 46 0 29 0 99 1 181 0 103 1 185 0 104 3 229 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116]
#[1 0 254 0 7 0 254 0 8 0 254 0 12 0 254 0 16 0 254 0 18 3 233 0 21 0 254 0 36 0 254 0 37 0 254 0 38 0 254 0 39 0 254 0 40 0 254 0 43 0 254 0 45 0 254 0 46]
#[0 3 237 0 21]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 3 241 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 3 198 0 32 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 3 245 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 3 249 0 219 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 0 29 0 99 3 253 0 103 1 193 0 106 1 197 0 107 1 201 0 108 4 1 0 109 0 237 0 111 4 5 0 112 0 37 0 115 0 41 0 116]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 4 9 0 40 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 4 13 0 181 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[0 4 17 0 21]
#[1 1 85 0 3 4 21 0 145]
#[1 3 234 0 32 4 25 0 99 4 29 0 224]
#[1 3 234 0 32 4 25 0 99 4 33 0 224]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 4 49 0 238 3 165 0 239 3 169 0 240]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 4 53 0 238 3 165 0 239 3 169 0 240]
#[0 0 110 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 0 114 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 0 118 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 0 122 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 0 126 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 0 130 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 0 102 0 2 0 102 0 5 0 102 0 13 4 57 0 15 0 102 0 21 0 102 0 28 0 102 0 60 0 102 0 61 0 102 0 62 0 102 0 63 0 102 0 64 0 102 0 66 0 102 0 67 0 102 0 68 0 102 0 69 0 102 0 70 0 102 0 82 0 102 0 87 0 102 0 99]
#[1 3 53 0 5 4 61 0 28 0 22 0 99 3 57 0 114]
#[1 4 65 0 99 4 69 0 148 3 69 0 149 3 73 0 150]
#[1 4 73 0 28 0 18 0 99]
#[1 5 66 0 2 4 77 0 5 5 66 0 13 4 81 0 21 4 85 0 28 5 66 0 60 5 66 0 61 5 66 0 62 5 66 0 63 5 66 0 64 5 66 0 66 5 66 0 67 5 66 0 68 5 66 0 69 5 66 0 70 4 126 0 82 4 126 0 87 0 66 0 99 3 81 0 114]
#[0 4 10 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 2 130 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 134 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 174 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 2 118 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 0 117 0 43 0 121 0 45 0 125 0 46 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 2 121 0 168 4 89 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[1 4 122 0 1 4 122 0 4 4 122 0 6 4 122 0 15 4 122 0 19 4 93 0 28 4 122 0 32 4 122 0 42 4 122 0 48 4 122 0 49 4 122 0 50 4 122 0 51 4 122 0 52 4 122 0 53 4 122 0 54 4 122 0 55 4 122 0 56 4 122 0 58 4 122 0 59 4 122 0 65 4 122 0 71 4 122 0 82 4 122 0 83 4 122 0 84 4 122 0 85 4 122 0 86 4 122 0 87 4 122 0 88 4 122 0 89 4 122 0 90]
#[0 4 97 0 1]
#[0 2 22 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 122 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 126 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 101 0 32]
#[0 2 142 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 146 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 150 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 154 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 158 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 162 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 178 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 182 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 186 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 190 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 194 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 198 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 202 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 206 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 210 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 214 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 105 0 32]
#[0 3 62 0 4 0 19 0 32]
#[0 3 66 0 4 0 19 0 32]
#[0 3 70 0 4 0 19 0 32]
#[1 3 74 0 4 3 74 0 19 3 74 0 32 4 130 0 82 4 130 0 87]
#[1 3 78 0 4 3 78 0 19 3 78 0 32 4 134 0 82 4 134 0 87]
#[1 3 82 0 4 4 30 0 5 3 82 0 19 4 30 0 28 3 82 0 32 4 30 0 82 4 30 0 87]
#[1 3 86 0 4 4 22 0 5 3 86 0 19 4 22 0 28 3 86 0 32 4 22 0 82 4 22 0 87]
#[1 2 38 0 1 2 38 0 4 4 109 0 5 2 38 0 6 2 38 0 15 2 38 0 19 2 38 0 28 2 38 0 32 2 38 0 42 2 38 0 48 2 38 0 49 2 38 0 50 2 38 0 51 2 38 0 52 2 38 0 53 2 38 0 54 2 38 0 55 2 38 0 56 2 38 0 58 2 38 0 59 2 38 0 65 2 38 0 71 2 38 0 82 2 38 0 83 2 38 0 84 2 38 0 85 2 38 0 86 2 38 0 87 2 38 0 88 2 38 0 89 2 38 0 90]
#[0 2 42 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 4 26 0 1 5 70 0 2 4 26 0 4 4 26 0 5 4 26 0 6 5 70 0 13 4 26 0 15 4 26 0 19 4 26 0 28 4 26 0 32 4 26 0 42 4 26 0 48 4 26 0 49 4 26 0 50 4 26 0 51 4 26 0 52 4 26 0 53 4 26 0 54 4 26 0 55 4 26 0 56 4 26 0 58 4 26 0 59 5 70 0 60 5 70 0 61 5 70 0 62 5 70 0 63 5 70 0 64 4 26 0 65 5 70 0 66 5 70 0 67 5 70 0 68 5 70 0 69 5 70 0 70 4 26 0 71 4 26 0 82 4 26 0 83 4 26 0 84 4 26 0 85 4 26 0 86 4 26 0 87 4 26 0 88 4 26 0 89 4 26 0 90]
#[1 4 34 0 1 5 74 0 2 4 34 0 4 4 34 0 5 4 34 0 6 5 74 0 13 4 34 0 15 4 34 0 19 4 34 0 28 4 34 0 32 4 34 0 42 4 34 0 48 4 34 0 49 4 34 0 50 4 34 0 51 4 34 0 52 4 34 0 53 4 34 0 54 4 34 0 55 4 34 0 56 4 34 0 58 4 34 0 59 5 74 0 60 5 74 0 61 5 74 0 62 5 74 0 63 5 74 0 64 4 34 0 65 5 74 0 66 5 74 0 67 5 74 0 68 5 74 0 69 5 74 0 70 4 34 0 71 4 34 0 82 4 34 0 83 4 34 0 84 4 34 0 85 4 34 0 86 4 34 0 87 4 34 0 88 4 34 0 89 4 34 0 90]
#[1 4 113 0 82 4 117 0 87]
#[1 4 121 0 2 4 125 0 13 4 129 0 60 4 133 0 61 4 137 0 62 4 141 0 63 4 145 0 64 4 149 0 66 4 153 0 67 4 157 0 68 4 161 0 69 4 165 0 70 4 169 0 254]
#[0 1 102 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 4 173 0 99]
#[1 0 78 0 5 4 177 0 21 0 78 0 28 0 78 0 99]
#[1 1 198 0 3 4 181 0 20 4 185 0 157 4 189 0 161]
#[0 1 30 0 1 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 12 0 15 0 16 0 17 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 65 0 71 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 255]
#[0 1 62 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 186 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 182 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 1 118 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 4 193 0 21]
#[1 1 198 0 3 4 197 0 5 4 181 0 20 1 198 0 32 4 201 0 157 4 189 0 161]
#[0 4 205 0 6]
#[1 0 70 0 1 0 70 0 4 4 209 0 5 0 70 0 6 0 70 0 15 0 70 0 19 0 70 0 28 0 70 0 32 0 70 0 48 0 70 0 49 0 70 0 50 0 70 0 51 0 70 0 52 0 70 0 53 0 70 0 54 0 70 0 55 0 70 0 56 0 70 0 58 0 70 0 59 0 70 0 65 0 70 0 71 0 70 0 99]
#[1 1 138 0 2 1 138 0 4 1 138 0 5 4 193 0 21 1 138 0 32]
#[1 4 213 0 4 4 217 0 32]
#[0 1 122 0 4 0 32]
#[1 4 221 0 2 1 130 0 4 4 225 0 5 1 130 0 32]
#[1 1 198 0 3 4 197 0 5 4 181 0 20 1 198 0 32 4 229 0 157 4 189 0 161]
#[1 0 74 0 1 0 74 0 4 4 209 0 5 0 74 0 6 0 74 0 15 0 74 0 19 0 74 0 28 0 74 0 32 0 74 0 48 0 74 0 49 0 74 0 50 0 74 0 51 0 74 0 52 0 74 0 53 0 74 0 54 0 74 0 55 0 74 0 56 0 74 0 58 0 74 0 59 0 74 0 65 0 74 0 71 0 74 0 99]
#[0 4 233 0 8]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 4 237 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 4 241 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 245 0 111 0 37 0 115 0 41 0 116 2 101 0 117 4 249 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 4 253 0 238 3 165 0 239 3 169 0 240]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 5 1 0 238 3 165 0 239 3 169 0 240]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 5 5 0 238 3 165 0 239 3 169 0 240]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 5 9 0 238 3 165 0 239 3 169 0 240]
#[1 3 53 0 5 4 61 0 28 3 57 0 114]
#[0 4 73 0 28]
#[1 4 126 0 1 5 66 0 2 4 126 0 4 4 77 0 5 4 126 0 6 5 66 0 13 4 126 0 15 4 126 0 19 4 81 0 21 4 85 0 28 4 126 0 32 4 126 0 42 4 126 0 48 4 126 0 49 4 126 0 50 4 126 0 51 4 126 0 52 4 126 0 53 4 126 0 54 4 126 0 55 4 126 0 56 4 126 0 58 4 126 0 59 5 66 0 60 5 66 0 61 5 66 0 62 5 66 0 63 5 66 0 64 4 126 0 65 5 66 0 66 5 66 0 67 5 66 0 68 5 66 0 69 5 66 0 70 4 126 0 71 4 126 0 82 4 126 0 83 4 126 0 84 4 126 0 85 4 126 0 86 4 126 0 87 4 126 0 88 4 126 0 89 4 126 0 90 3 81 0 114]
#[0 5 13 0 19]
#[0 5 62 0 1 0 4 0 6 0 15 0 19 0 32]
#[0 4 138 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 142 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 130 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 4 134 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 4 30 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 4 22 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 4 158 0 1 4 158 0 4 4 158 0 6 4 158 0 15 4 158 0 19 4 158 0 32 4 158 0 42 4 158 0 48 4 158 0 49 4 158 0 50 4 158 0 51 4 158 0 52 4 158 0 53 4 158 0 54 4 158 0 55 4 158 0 56 4 158 0 58 4 158 0 59 4 158 0 65 4 158 0 71 4 113 0 82 4 158 0 83 4 158 0 84 4 158 0 85 4 158 0 86 4 117 0 87 4 158 0 88 4 158 0 89 4 158 0 90]
#[0 4 186 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 154 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 170 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[1 4 202 0 1 4 202 0 4 4 202 0 6 4 202 0 15 4 202 0 19 4 202 0 32 5 17 0 42 4 202 0 48 4 202 0 49 4 202 0 50 4 202 0 51 4 202 0 52 4 202 0 53 4 202 0 54 4 202 0 55 4 202 0 56 4 202 0 58 4 202 0 59 4 202 0 65 4 202 0 71 4 202 0 83 4 202 0 84 5 21 0 85 4 202 0 86 5 25 0 88 4 202 0 89 4 202 0 90]
#[1 4 214 0 1 4 214 0 4 4 214 0 6 4 214 0 15 4 214 0 19 4 214 0 32 4 214 0 48 4 214 0 49 4 214 0 50 4 214 0 51 4 214 0 52 4 214 0 53 4 214 0 54 4 214 0 55 4 214 0 56 4 214 0 58 4 214 0 59 4 214 0 65 4 214 0 71 4 214 0 83 4 214 0 84 4 214 0 86 5 29 0 89 5 33 0 90]
#[1 4 230 0 1 4 230 0 4 4 230 0 6 4 230 0 15 4 230 0 19 4 230 0 32 4 230 0 48 4 230 0 49 4 230 0 50 4 230 0 51 4 230 0 52 4 230 0 53 4 230 0 54 4 230 0 55 4 230 0 56 4 230 0 58 4 230 0 59 4 230 0 65 4 230 0 71 5 37 0 83 5 41 0 84 5 45 0 86]
#[1 4 254 0 1 4 254 0 4 4 254 0 6 4 254 0 15 4 254 0 19 4 254 0 32 4 254 0 48 4 254 0 49 4 254 0 50 4 254 0 51 4 254 0 52 4 254 0 53 5 49 0 54 5 53 0 55 4 254 0 56 5 57 0 58 5 61 0 59 4 254 0 65 5 65 0 71]
#[1 5 10 0 1 5 10 0 4 5 10 0 6 5 10 0 15 5 10 0 19 5 10 0 32 5 10 0 48 5 10 0 49 5 10 0 50 5 69 0 51 5 10 0 52 5 10 0 53 5 10 0 56 5 73 0 65]
#[1 5 18 0 1 5 18 0 4 5 18 0 6 5 18 0 15 5 18 0 19 5 18 0 32 5 18 0 48 5 18 0 49 5 77 0 50 5 18 0 52 5 18 0 53 5 18 0 56]
#[1 5 26 0 1 5 26 0 4 5 26 0 6 5 26 0 15 5 26 0 19 5 26 0 32 5 81 0 48 5 26 0 49 5 26 0 52 5 26 0 53 5 26 0 56]
#[1 5 34 0 1 5 34 0 4 5 34 0 6 5 34 0 15 5 34 0 19 5 34 0 32 5 85 0 49 5 34 0 52 5 34 0 53 5 34 0 56]
#[1 5 42 0 1 5 42 0 4 5 42 0 6 5 42 0 15 5 42 0 19 5 42 0 32 5 89 0 52 5 42 0 53 5 42 0 56]
#[1 5 50 0 1 5 50 0 4 5 50 0 6 5 50 0 15 5 50 0 19 5 50 0 32 5 93 0 53 5 97 0 56]
#[0 5 58 0 1 0 4 0 6 0 15 0 19 0 32]
#[0 1 154 0 1 0 4 0 6 0 15 0 19 0 32]
#[0 5 101 0 99]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 105 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 4 65 0 99 5 109 0 148 3 69 0 149 3 73 0 150]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 113 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 117 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 5 121 0 32]
#[0 3 202 0 32]
#[0 5 125 0 32]
#[1 5 129 0 5 5 133 0 114 5 137 0 234 5 141 0 236]
#[1 5 129 0 5 0 86 0 21 5 145 0 114 5 149 0 234 5 141 0 236]
#[0 5 153 0 21]
#[0 3 233 0 21]
#[0 5 157 0 57]
#[1 1 233 0 9 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 3 190 0 32 1 173 0 33 1 177 0 34 5 161 0 36 2 25 0 76 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 5 165 0 182 5 169 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 5 173 0 218 5 177 0 221 5 181 0 222 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 5 185 0 72 3 250 0 75 5 189 0 225 5 193 0 226 5 197 0 228]
#[0 3 238 0 32]
#[0 5 201 0 32]
#[0 5 205 0 32]
#[1 4 126 0 1 4 126 0 4 4 77 0 5 4 126 0 6 4 126 0 15 4 126 0 19 4 81 0 21 4 85 0 28 4 126 0 32 4 126 0 42 4 126 0 48 4 126 0 49 4 126 0 50 4 126 0 51 4 126 0 52 4 126 0 53 4 126 0 54 4 126 0 55 4 126 0 56 4 126 0 58 4 126 0 59 4 126 0 65 4 126 0 71 4 126 0 82 4 126 0 83 4 126 0 84 4 126 0 85 4 126 0 86 4 126 0 87 4 126 0 88 4 126 0 89 4 126 0 90 3 81 0 114]
#[0 4 26 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 4 34 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 3 94 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 3 98 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 4 9 0 40 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 5 209 0 181 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[0 5 213 0 8]
#[0 1 138 0 2 0 4 0 5 0 19 0 32]
#[1 4 213 0 4 2 166 0 32]
#[0 5 217 0 8]
#[1 4 205 0 6 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 221 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 5 229 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 5 237 0 8 5 241 0 22 5 245 0 23 0 165 0 99]
#[0 2 26 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 5 249 0 76 5 253 0 99]
#[0 1 110 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 138 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 22 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 6 1 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 3 102 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 3 106 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 5 78 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 122 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 110 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 114 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 106 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 102 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 118 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 86 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 90 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 82 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 98 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 94 0 9 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 33 0 34 0 76 0 82 0 87 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 6 5 0 252 3 5 0 253]
#[1 1 14 0 3 1 14 0 10 0 209 0 11 6 9 0 133 0 217 0 136]
#[1 1 206 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 6 13 0 36 0 29 0 99 1 181 0 103 1 185 0 104 6 17 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116 6 21 0 158 6 25 0 159 6 29 0 160]
#[1 0 29 0 99 0 233 0 109 0 237 0 111 6 33 0 112 0 37 0 115 0 41 0 116 6 37 0 162]
#[1 6 41 0 3 6 45 0 164]
#[0 1 202 0 3 0 32]
#[1 1 206 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 6 13 0 36 0 29 0 99 1 181 0 103 1 185 0 104 6 17 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116 6 49 0 158 6 25 0 159 6 29 0 160]
#[0 6 53 0 6]
#[0 1 178 0 3 0 32]
#[0 0 94 0 1 0 3 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90 0 99]
#[0 6 57 0 6]
#[1 4 65 0 99 6 61 0 149 3 73 0 150]
#[0 1 114 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 6 65 0 3 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 6 69 0 151 6 73 0 152 6 77 0 153 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 6 81 0 6]
#[0 1 174 0 3 0 32]
#[0 4 42 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 6 85 0 19]
#[1 3 53 0 5 4 110 0 19 4 61 0 28 6 89 0 114 6 93 0 235]
#[1 5 66 0 2 4 77 0 5 5 66 0 13 4 126 0 19 4 81 0 21 4 85 0 28 4 126 0 42 4 126 0 48 4 126 0 49 4 126 0 50 4 126 0 51 4 126 0 52 4 126 0 53 4 126 0 54 4 126 0 55 4 126 0 56 4 126 0 58 4 126 0 59 5 66 0 60 5 66 0 61 5 66 0 62 5 66 0 63 5 66 0 64 4 126 0 65 5 66 0 66 5 66 0 67 5 66 0 68 5 66 0 69 5 66 0 70 4 126 0 71 4 126 0 82 4 126 0 83 4 126 0 84 4 126 0 85 4 126 0 86 4 126 0 87 4 126 0 88 4 126 0 89 4 126 0 90 6 97 0 114]
#[0 6 101 0 19]
#[0 4 146 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 150 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 166 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 162 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 18 0 5 0 28 0 82 0 87]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 6 105 0 238 3 165 0 239 3 169 0 240]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 6 109 0 238 3 165 0 239 3 169 0 240]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 6 113 0 238 3 165 0 239 3 169 0 240]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 6 117 0 241]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 6 121 0 241]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 6 125 0 242]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 6 129 0 242]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 6 133 0 242]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 6 137 0 243]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 6 141 0 243]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 0 29 0 99 6 145 0 103 6 149 0 104 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 6 153 0 243]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 6 157 0 243]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 6 161 0 244]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 6 165 0 244]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 6 169 0 245]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 6 173 0 246]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 6 177 0 247]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 6 181 0 248]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 6 185 0 249]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 6 189 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 4 78 0 1 4 78 0 2 4 78 0 4 4 78 0 5 4 78 0 6 4 78 0 13 4 78 0 15 4 78 0 19 6 193 0 21 4 78 0 28 4 78 0 32 4 78 0 42 4 78 0 48 4 78 0 49 4 78 0 50 4 78 0 51 4 78 0 52 4 78 0 53 4 78 0 54 4 78 0 55 4 78 0 56 4 78 0 58 4 78 0 59 4 78 0 60 4 78 0 61 4 78 0 62 4 78 0 63 4 78 0 64 4 78 0 65 4 78 0 66 4 78 0 67 4 78 0 68 4 78 0 69 4 78 0 70 4 78 0 71 4 78 0 82 4 78 0 83 4 78 0 84 4 78 0 85 4 78 0 86 4 78 0 87 4 78 0 88 4 78 0 89 4 78 0 90]
#[0 6 197 0 19]
#[1 4 213 0 4 2 170 0 32]
#[0 6 201 0 19]
#[0 6 205 0 19]
#[0 3 50 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 42 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 4 205 0 6 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 6 209 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 6 65 0 3 4 209 0 5 6 213 0 153]
#[1 4 110 0 1 4 110 0 4 5 129 0 5 4 110 0 6 4 110 0 15 4 110 0 19 4 110 0 28 4 110 0 32 4 110 0 42 4 110 0 48 4 110 0 49 4 110 0 50 4 110 0 51 4 110 0 52 4 110 0 53 4 110 0 54 4 110 0 55 4 110 0 56 4 110 0 58 4 110 0 59 4 110 0 65 4 110 0 71 4 110 0 82 4 110 0 83 4 110 0 84 4 110 0 85 4 110 0 86 4 110 0 87 4 110 0 88 4 110 0 89 4 110 0 90 6 217 0 114 6 221 0 235 6 225 0 236]
#[0 4 102 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 6 65 0 3 4 209 0 5 6 229 0 153]
#[1 4 110 0 1 4 110 0 4 5 129 0 5 4 110 0 6 4 110 0 15 4 110 0 19 4 110 0 28 4 110 0 32 4 110 0 42 4 110 0 48 4 110 0 49 4 110 0 50 4 110 0 51 4 110 0 52 4 110 0 53 4 110 0 54 4 110 0 55 4 110 0 56 4 110 0 58 4 110 0 59 4 110 0 65 4 110 0 71 4 110 0 82 4 110 0 83 4 110 0 84 4 110 0 85 4 110 0 86 4 110 0 87 4 110 0 88 4 110 0 89 4 110 0 90 6 217 0 114 6 233 0 235 6 225 0 236]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 6 237 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 6 241 0 21]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 0 29 0 99 1 181 0 103 1 185 0 104 3 229 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116]
#[0 3 218 0 32]
#[0 3 222 0 4 0 19 0 32]
#[0 6 245 0 32]
#[0 3 194 0 32]
#[1 6 249 0 4 3 214 0 32]
#[0 6 253 0 21]
#[1 3 54 0 1 3 54 0 3 3 54 0 7 3 54 0 8 3 54 0 9 3 54 0 12 3 54 0 14 3 54 0 16 3 54 0 17 3 54 0 18 3 54 0 21 3 54 0 22 3 54 0 23 3 54 0 24 3 54 0 25 3 54 0 26 3 54 0 27 3 54 0 30 3 54 0 31 3 54 0 32 3 54 0 33 3 54 0 34 3 54 0 35 3 54 0 36 3 54 0 37 3 54 0 38 3 54 0 39 3 54 0 40 3 54 0 41 3 54 0 43 3 54 0 45 3 54 0 46 3 54 0 47 3 54 0 57 5 185 0 72 3 54 0 73 3 54 0 74 3 254 0 75 3 54 0 76 3 54 0 77 3 54 0 78 3 54 0 79 3 54 0 80 3 54 0 81 3 54 0 82 3 54 0 87 3 54 0 93 3 54 0 94 3 54 0 95 3 54 0 96 3 54 0 97 3 54 0 98 3 54 0 99 7 1 0 228]
#[1 7 5 0 75 7 9 0 227]
#[0 3 242 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 38 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 34 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 218 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 38 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 4 46 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 7 13 0 6]
#[0 4 94 0 4 0 19]
#[0 7 17 0 19]
#[1 7 21 0 4 2 34 0 19]
#[0 4 50 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 7 25 0 28]
#[0 4 54 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 7 29 0 99]
#[1 4 74 0 1 4 74 0 2 4 74 0 4 4 74 0 5 4 74 0 6 4 74 0 13 4 74 0 15 4 74 0 19 7 33 0 21 4 74 0 28 4 74 0 32 4 74 0 42 4 74 0 48 4 74 0 49 4 74 0 50 4 74 0 51 4 74 0 52 4 74 0 53 4 74 0 54 4 74 0 55 4 74 0 56 4 74 0 58 4 74 0 59 4 74 0 60 4 74 0 61 4 74 0 62 4 74 0 63 4 74 0 64 4 74 0 65 4 74 0 66 4 74 0 67 4 74 0 68 4 74 0 69 4 74 0 70 4 74 0 71 4 74 0 82 4 74 0 83 4 74 0 84 4 74 0 85 4 74 0 86 4 74 0 87 4 74 0 88 4 74 0 89 4 74 0 90]
#[0 7 37 0 6]
#[0 3 90 0 1 0 4 0 6 0 15 0 19 0 32]
#[1 1 22 0 3 0 245 0 10 7 41 0 134 0 253 0 138]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 0 29 0 99 1 181 0 103 1 185 0 104 7 45 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116]
#[1 4 65 0 99 7 49 0 150]
#[0 7 53 0 19]
#[1 7 57 0 4 1 210 0 19]
#[0 1 214 0 4 0 19]
#[0 1 234 0 3 0 4 0 32]
#[1 1 230 0 3 7 61 0 4 1 230 0 32]
#[1 7 65 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 7 69 0 22 7 73 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 0 117 0 43 0 121 0 45 0 125 0 46 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 7 77 0 165 7 81 0 166 7 85 0 168 2 129 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[0 1 106 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 7 89 0 19]
#[0 1 194 0 3 0 5 0 20 0 32]
#[0 0 98 0 1 0 3 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90 0 99]
#[0 1 126 0 4 0 32]
#[1 7 93 0 1 6 65 0 3 7 97 0 4 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 7 101 0 151 6 73 0 152 6 77 0 153 2 121 0 168 7 105 0 177 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 1 134 0 4 0 32]
#[0 1 146 0 1 0 4 0 32]
#[0 1 150 0 1 0 4 0 32]
#[0 1 142 0 2 0 4 0 5 0 19 0 32]
#[1 7 109 0 3 7 113 0 212]
#[1 4 209 0 5 4 114 0 19 0 70 0 28]
#[0 7 117 0 19]
#[1 4 209 0 5 7 121 0 19 0 74 0 28]
#[1 4 18 0 1 4 18 0 4 4 18 0 5 4 18 0 6 1 233 0 9 4 18 0 15 4 18 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 4 18 0 28 1 165 0 30 1 169 0 31 4 18 0 32 1 173 0 33 1 177 0 34 4 18 0 42 4 18 0 48 4 18 0 49 4 18 0 50 4 18 0 51 4 18 0 52 4 18 0 53 4 18 0 54 4 18 0 55 4 18 0 56 4 18 0 58 4 18 0 59 4 18 0 65 4 18 0 71 2 25 0 76 4 18 0 82 4 18 0 83 4 18 0 84 4 18 0 85 4 18 0 86 4 18 0 87 4 18 0 88 4 18 0 89 4 18 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 7 125 0 239 3 169 0 240]
#[0 4 190 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 198 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 194 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[1 4 206 0 1 4 206 0 4 4 206 0 6 4 206 0 15 4 206 0 19 4 206 0 32 5 17 0 42 4 206 0 48 4 206 0 49 4 206 0 50 4 206 0 51 4 206 0 52 4 206 0 53 4 206 0 54 4 206 0 55 4 206 0 56 4 206 0 58 4 206 0 59 4 206 0 65 4 206 0 71 4 206 0 83 4 206 0 84 5 21 0 85 4 206 0 86 5 25 0 88 4 206 0 89 4 206 0 90]
#[1 4 210 0 1 4 210 0 4 4 210 0 6 4 210 0 15 4 210 0 19 4 210 0 32 5 17 0 42 4 210 0 48 4 210 0 49 4 210 0 50 4 210 0 51 4 210 0 52 4 210 0 53 4 210 0 54 4 210 0 55 4 210 0 56 4 210 0 58 4 210 0 59 4 210 0 65 4 210 0 71 4 210 0 83 4 210 0 84 5 21 0 85 4 210 0 86 5 25 0 88 4 210 0 89 4 210 0 90]
#[1 4 218 0 1 4 218 0 4 4 218 0 6 4 218 0 15 4 218 0 19 4 218 0 32 4 218 0 48 4 218 0 49 4 218 0 50 4 218 0 51 4 218 0 52 4 218 0 53 4 218 0 54 4 218 0 55 4 218 0 56 4 218 0 58 4 218 0 59 4 218 0 65 4 218 0 71 4 218 0 83 4 218 0 84 4 218 0 86 5 29 0 89 5 33 0 90]
#[1 4 222 0 1 4 222 0 4 4 222 0 6 4 222 0 15 4 222 0 19 4 222 0 32 4 222 0 48 4 222 0 49 4 222 0 50 4 222 0 51 4 222 0 52 4 222 0 53 4 222 0 54 4 222 0 55 4 222 0 56 4 222 0 58 4 222 0 59 4 222 0 65 4 222 0 71 4 222 0 83 4 222 0 84 4 222 0 86 5 29 0 89 5 33 0 90]
#[1 4 226 0 1 4 226 0 4 4 226 0 6 4 226 0 15 4 226 0 19 4 226 0 32 4 226 0 48 4 226 0 49 4 226 0 50 4 226 0 51 4 226 0 52 4 226 0 53 4 226 0 54 4 226 0 55 4 226 0 56 4 226 0 58 4 226 0 59 4 226 0 65 4 226 0 71 4 226 0 83 4 226 0 84 4 226 0 86 5 29 0 89 5 33 0 90]
#[1 4 242 0 1 4 242 0 4 4 242 0 6 4 242 0 15 4 242 0 19 4 242 0 32 4 242 0 48 4 242 0 49 4 242 0 50 4 242 0 51 4 242 0 52 4 242 0 53 4 242 0 54 4 242 0 55 4 242 0 56 4 242 0 58 4 242 0 59 4 242 0 65 4 242 0 71 5 37 0 83 5 41 0 84 5 45 0 86]
#[1 4 246 0 1 4 246 0 4 4 246 0 6 4 246 0 15 4 246 0 19 4 246 0 32 4 246 0 48 4 246 0 49 4 246 0 50 4 246 0 51 4 246 0 52 4 246 0 53 4 246 0 54 4 246 0 55 4 246 0 56 4 246 0 58 4 246 0 59 4 246 0 65 4 246 0 71 5 37 0 83 5 41 0 84 5 45 0 86]
#[1 3 53 0 5 3 57 0 114]
#[0 4 250 0 1 0 4 0 6 0 15 0 19 0 32 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71]
#[1 4 238 0 1 4 238 0 4 4 238 0 6 4 238 0 15 4 238 0 19 4 238 0 32 4 238 0 48 4 238 0 49 4 238 0 50 4 238 0 51 4 238 0 52 4 238 0 53 4 238 0 54 4 238 0 55 4 238 0 56 4 238 0 58 4 238 0 59 4 238 0 65 4 238 0 71 5 37 0 83 5 41 0 84 5 45 0 86]
#[1 4 234 0 1 4 234 0 4 4 234 0 6 4 234 0 15 4 234 0 19 4 234 0 32 4 234 0 48 4 234 0 49 4 234 0 50 4 234 0 51 4 234 0 52 4 234 0 53 4 234 0 54 4 234 0 55 4 234 0 56 4 234 0 58 4 234 0 59 4 234 0 65 4 234 0 71 5 37 0 83 5 41 0 84 5 45 0 86]
#[1 5 6 0 1 5 6 0 4 5 6 0 6 5 6 0 15 5 6 0 19 5 6 0 32 5 6 0 48 5 6 0 49 5 6 0 50 5 6 0 51 5 6 0 52 5 6 0 53 5 49 0 54 5 53 0 55 5 6 0 56 5 57 0 58 5 61 0 59 5 6 0 65 5 65 0 71]
#[1 5 2 0 1 5 2 0 4 5 2 0 6 5 2 0 15 5 2 0 19 5 2 0 32 5 2 0 48 5 2 0 49 5 2 0 50 5 2 0 51 5 2 0 52 5 2 0 53 5 49 0 54 5 53 0 55 5 2 0 56 5 57 0 58 5 61 0 59 5 2 0 65 5 65 0 71]
#[1 5 14 0 1 5 14 0 4 5 14 0 6 5 14 0 15 5 14 0 19 5 14 0 32 5 14 0 48 5 14 0 49 5 14 0 50 5 69 0 51 5 14 0 52 5 14 0 53 5 14 0 56 5 73 0 65]
#[1 5 22 0 1 5 22 0 4 5 22 0 6 5 22 0 15 5 22 0 19 5 22 0 32 5 22 0 48 5 22 0 49 5 77 0 50 5 22 0 52 5 22 0 53 5 22 0 56]
#[1 5 30 0 1 5 30 0 4 5 30 0 6 5 30 0 15 5 30 0 19 5 30 0 32 5 81 0 48 5 30 0 49 5 30 0 52 5 30 0 53 5 30 0 56]
#[1 5 38 0 1 5 38 0 4 5 38 0 6 5 38 0 15 5 38 0 19 5 38 0 32 5 85 0 49 5 38 0 52 5 38 0 53 5 38 0 56]
#[1 5 46 0 1 5 46 0 4 5 46 0 6 5 46 0 15 5 46 0 19 5 46 0 32 5 89 0 52 5 46 0 53 5 46 0 56]
#[0 7 129 0 15]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 7 133 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 7 137 0 35 4 9 0 40 7 141 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 7 145 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 149 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 7 153 0 181 7 157 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 7 161 0 189 7 165 0 190 7 169 0 191 7 173 0 192 7 177 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 1 85 0 3 7 181 0 145]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 4 9 0 40 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 7 185 0 181 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[0 7 189 0 6]
#[0 4 66 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 4 114 0 1 4 114 0 4 4 209 0 5 4 114 0 6 4 114 0 15 4 114 0 19 4 114 0 28 4 114 0 32 4 114 0 42 4 114 0 48 4 114 0 49 4 114 0 50 4 114 0 51 4 114 0 52 4 114 0 53 4 114 0 54 4 114 0 55 4 114 0 56 4 114 0 58 4 114 0 59 4 114 0 65 4 114 0 71 4 114 0 82 4 114 0 83 4 114 0 84 4 114 0 85 4 114 0 86 4 114 0 87 4 114 0 88 4 114 0 89 4 114 0 90]
#[0 4 58 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 4 106 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 4 70 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 4 62 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 7 193 0 19]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 7 197 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 3 198 0 32 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 3 245 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 7 201 0 219 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 7 205 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 6 13 0 36 0 29 0 99 1 181 0 103 1 185 0 104 6 17 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116 7 209 0 160]
#[0 3 246 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 85 0 3 7 213 0 145]
#[0 3 58 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 86 0 1 0 2 0 4 0 5 0 6 0 13 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 3 110 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 7 217 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 7 221 0 99]
#[0 7 225 0 21]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 7 229 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 4 90 0 1 0 2 0 4 0 5 0 6 0 13 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 1 29 0 3 7 233 0 135]
#[1 4 65 0 99 7 237 0 150]
#[1 1 222 0 4 4 225 0 5 1 222 0 19]
#[0 1 242 0 3 0 20]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 6 13 0 36 0 29 0 99 1 181 0 103 1 185 0 104 6 17 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 1 209 0 110 1 213 0 111 0 37 0 115 0 41 0 116 7 241 0 160]
#[1 0 29 0 99 0 233 0 109 0 237 0 111 7 245 0 112 0 37 0 115 0 41 0 116]
#[0 2 2 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 7 249 0 21 3 221 0 28]
#[1 4 14 0 5 7 253 0 21 4 14 0 28 4 14 0 82 4 14 0 87]
#[1 8 1 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 0 117 0 43 0 121 0 45 0 125 0 46 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 8 5 0 166 2 121 0 168 2 129 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[1 8 9 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 0 117 0 43 0 121 0 45 0 125 0 46 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 2 121 0 168 4 89 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[1 8 13 0 28 4 122 0 82 4 122 0 87]
#[0 1 190 0 3 0 5 0 20 0 32]
#[0 1 170 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 8 17 0 1]
#[0 2 106 0 1 0 4]
#[1 8 21 0 1 8 25 0 4]
#[1 8 29 0 1 8 33 0 41 8 37 0 47 8 41 0 213 8 45 0 214 8 49 0 215 8 53 0 216]
#[0 3 26 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 8 57 0 238 3 165 0 239 3 169 0 240]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 8 61 0 239 3 169 0 240]
#[0 4 178 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 4 37 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 4 41 0 231 4 45 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 8 65 0 251]
#[0 8 69 0 19]
#[0 8 73 0 21]
#[0 8 77 0 21]
#[0 8 81 0 21]
#[1 0 102 0 2 0 102 0 5 0 102 0 13 8 85 0 15 0 102 0 21 0 102 0 28 0 102 0 60 0 102 0 61 0 102 0 62 0 102 0 63 0 102 0 64 0 102 0 66 0 102 0 67 0 102 0 68 0 102 0 69 0 102 0 70 0 102 0 82 0 102 0 87]
#[0 2 222 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 2 142 0 1 2 142 0 3 2 142 0 7 2 142 0 8 2 142 0 9 2 142 0 12 2 254 0 14 2 142 0 16 2 142 0 17 2 142 0 18 2 142 0 21 2 142 0 22 2 142 0 23 2 142 0 24 2 142 0 25 2 142 0 26 2 142 0 27 2 142 0 30 2 142 0 31 2 142 0 32 2 142 0 33 2 142 0 34 2 142 0 35 2 142 0 36 2 142 0 37 2 142 0 38 2 142 0 39 2 142 0 40 2 142 0 41 2 142 0 43 2 142 0 45 2 142 0 46 2 142 0 47 2 142 0 57 2 142 0 73 2 142 0 74 2 142 0 76 2 142 0 77 2 142 0 78 2 142 0 79 2 142 0 80 2 142 0 81 2 142 0 82 2 142 0 87 2 142 0 93 2 142 0 94 2 142 0 95 2 142 0 96 2 142 0 97 2 142 0 98 2 142 0 99]
#[0 3 2 0 14]
#[0 3 6 0 14]
#[0 3 10 0 14]
#[0 3 14 0 14]
#[0 8 89 0 14]
#[0 3 46 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 230 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 118 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 3 126 0 1 1 29 0 3 3 126 0 4 3 126 0 5 3 126 0 6 3 126 0 15 3 126 0 19 3 126 0 28 3 126 0 32 3 126 0 42 3 126 0 48 3 126 0 49 3 126 0 50 3 126 0 51 3 126 0 52 3 126 0 53 3 126 0 54 3 126 0 55 3 126 0 56 3 126 0 58 3 126 0 59 3 126 0 65 3 126 0 71 3 126 0 82 3 126 0 83 3 126 0 84 3 126 0 85 3 126 0 86 3 126 0 87 3 126 0 88 3 126 0 89 3 126 0 90 8 93 0 135]
#[0 8 97 0 19]
#[0 8 101 0 32]
#[0 3 226 0 4 0 19 0 32]
#[0 8 105 0 19]
#[0 4 2 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 98 0 4 0 19]
#[1 4 82 0 1 4 82 0 2 4 82 0 4 4 82 0 5 4 82 0 6 4 82 0 13 4 82 0 15 4 82 0 19 8 109 0 21 4 82 0 28 4 82 0 32 4 82 0 42 4 82 0 48 4 82 0 49 4 82 0 50 4 82 0 51 4 82 0 52 4 82 0 53 4 82 0 54 4 82 0 55 4 82 0 56 4 82 0 58 4 82 0 59 4 82 0 60 4 82 0 61 4 82 0 62 4 82 0 63 4 82 0 64 4 82 0 65 4 82 0 66 4 82 0 67 4 82 0 68 4 82 0 69 4 82 0 70 4 82 0 71 4 82 0 82 4 82 0 83 4 82 0 84 4 82 0 85 4 82 0 86 4 82 0 87 4 82 0 88 4 82 0 89 4 82 0 90]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 8 113 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 8 117 0 19]
#[0 1 90 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 1 226 0 4 4 225 0 5 1 226 0 19]
#[0 1 218 0 4 0 19]
#[0 1 238 0 3 0 4 0 32]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 8 121 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 8 125 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 1 250 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 8 129 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 0 117 0 43 0 121 0 45 0 125 0 46 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 2 121 0 168 4 89 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[0 1 254 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[1 8 133 0 22 8 137 0 23 5 249 0 76 5 253 0 99]
#[0 1 166 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 1 162 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 8 141 0 1 6 65 0 3 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 8 145 0 151 6 73 0 152 6 77 0 153 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 3 154 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 8 149 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 8 153 0 217 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 8 157 0 15]
#[1 8 161 0 1 8 33 0 41 8 37 0 47 8 165 0 214 8 169 0 215 8 53 0 216]
#[1 8 173 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 8 33 0 41 0 117 0 43 0 121 0 45 0 125 0 46 8 37 0 47 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 8 177 0 166 2 121 0 168 2 129 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 8 181 0 216 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[0 3 158 0 1 0 41 0 47]
#[0 3 166 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 174 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 4 182 0 1 0 4 0 6 0 15 0 19 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 83 0 84 0 85 0 86 0 88 0 89 0 90]
#[0 5 54 0 1 0 4 0 6 0 15 0 19 0 32]
#[0 3 118 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 8 185 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 8 189 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 3 190 0 32 1 173 0 33 1 177 0 34 5 161 0 36 2 25 0 76 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 5 165 0 182 5 169 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 8 193 0 218 5 177 0 221 5 181 0 222 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 7 137 0 35 4 9 0 40 7 141 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 7 145 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 149 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 5 209 0 181 7 157 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 7 161 0 189 7 165 0 190 7 169 0 191 7 173 0 192 8 197 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 4 9 0 40 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 8 201 0 181 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[0 3 130 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 8 205 0 32]
#[1 1 233 0 9 3 206 0 19 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 5 169 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 8 209 0 220 8 213 0 222 8 217 0 223 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 1 85 0 3 8 221 0 145]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 8 225 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 8 229 0 19]
#[0 3 114 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 8 233 0 19]
#[0 8 237 0 19]
#[0 1 246 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 18 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 99]
#[0 8 241 0 21]
#[0 8 245 0 21]
#[0 1 158 0 1 0 4 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 2 110 0 1 0 4]
#[0 3 186 0 15]
#[0 8 249 0 15]
#[0 3 182 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 146 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 8 253 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 8 33 0 41 0 117 0 43 0 121 0 45 0 125 0 46 8 37 0 47 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 8 177 0 166 2 121 0 168 2 129 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 8 181 0 216 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[0 3 162 0 1 0 41 0 47]
#[0 3 150 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 3 174 0 1 1 85 0 3 0 81 0 7 0 218 0 8 1 233 0 9 0 85 0 12 0 218 0 16 1 237 0 17 0 89 0 18 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 2 5 0 36 0 101 0 37 0 105 0 38 0 109 0 39 2 9 0 40 3 174 0 41 0 117 0 43 0 121 0 45 0 125 0 46 3 174 0 47 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 2 85 0 103 1 185 0 104 2 89 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 2 93 0 110 2 97 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 105 0 128 2 109 0 129 0 149 0 131 0 153 0 132 2 113 0 145 2 121 0 168 4 89 0 179 2 133 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253 0 157 1 3]
#[0 3 170 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 1 0 19]
#[0 9 5 0 19]
#[0 9 9 0 32]
#[0 2 238 0 14]
#[0 2 226 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 30 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 13 0 19]
#[1 6 249 0 4 3 230 0 19]
#[0 3 210 0 19]
#[0 4 6 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 17 0 19]
#[1 3 134 0 1 1 29 0 3 3 134 0 4 3 134 0 5 3 134 0 6 3 134 0 15 3 134 0 19 3 134 0 28 3 134 0 32 3 134 0 42 3 134 0 48 3 134 0 49 3 134 0 50 3 134 0 51 3 134 0 52 3 134 0 53 3 134 0 54 3 134 0 55 3 134 0 56 3 134 0 58 3 134 0 59 3 134 0 65 3 134 0 71 3 134 0 82 3 134 0 83 3 134 0 84 3 134 0 85 3 134 0 86 3 134 0 87 3 134 0 88 3 134 0 89 3 134 0 90 9 21 0 135]
#[0 9 25 0 32]
#[0 9 29 0 32]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 9 33 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 233 0 9 2 30 0 19 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 5 225 0 152 9 37 0 167 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 5 233 0 233 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[0 3 178 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 142 0 1 0 3 0 7 0 8 0 9 0 12 0 14 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 7 137 0 35 4 9 0 40 7 141 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 7 145 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 149 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 7 153 0 181 7 157 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 7 161 0 189 7 165 0 190 7 169 0 191 7 173 0 192 9 41 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 7 137 0 35 4 9 0 40 7 141 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 7 145 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 149 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 7 185 0 181 7 157 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 7 161 0 189 7 165 0 190 7 169 0 191 7 173 0 192 9 45 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 1 233 0 9 3 93 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 3 198 0 32 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 3 97 0 89 3 101 0 90 3 105 0 91 3 109 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 3 245 0 152 2 121 0 168 3 129 0 205 3 133 0 206 3 137 0 207 3 141 0 208 3 145 0 209 3 149 0 210 3 153 0 211 9 49 0 219 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 157 0 237 3 161 0 238 3 165 0 239 3 169 0 240 3 173 0 241 3 177 0 242 3 181 0 243 3 185 0 244 3 189 0 245 3 193 0 246 3 197 0 247 3 201 0 248 3 205 0 249 3 209 0 250 3 213 0 251 3 217 0 252 3 5 0 253]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 2 1 0 35 4 9 0 40 2 13 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 2 33 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 9 53 0 181 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[0 3 122 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 3 138 0 1 0 4 0 5 0 6 0 15 0 19 0 28 0 32 0 42 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 58 0 59 0 65 0 71 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90]
#[0 2 10 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 6 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 57 0 19]
#[0 9 61 0 19]
#[0 9 65 0 14]
#[0 2 246 0 14]
#[0 9 69 0 32]
#[0 2 234 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 45 0 46 0 47 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 73 0 32]
#[0 9 77 0 32]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 7 137 0 35 4 9 0 40 7 141 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 7 145 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 149 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 8 201 0 181 7 157 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 7 161 0 189 7 165 0 190 7 169 0 191 7 173 0 192 9 81 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[1 1 233 0 9 3 206 0 19 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 173 0 33 1 177 0 34 2 25 0 76 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 121 0 168 5 169 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 9 85 0 220 8 213 0 222 8 217 0 223 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[0 2 18 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 14 0 1 0 3 0 7 0 8 0 9 0 12 0 16 0 17 0 18 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 45 0 46 0 57 0 73 0 74 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 87 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 242 0 14]
#[0 9 89 0 19]
#[1 1 85 0 3 1 233 0 9 1 237 0 17 1 241 0 21 1 245 0 22 1 249 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 30 1 169 0 31 1 253 0 32 1 173 0 33 1 177 0 34 7 137 0 35 4 9 0 40 7 141 0 57 2 17 0 73 2 21 0 74 2 25 0 76 2 29 0 77 7 145 0 78 2 37 0 79 2 41 0 80 2 45 0 81 2 49 0 82 2 53 0 87 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 149 0 99 3 113 0 103 1 193 0 106 1 197 0 107 1 201 0 108 3 117 0 110 3 121 0 111 0 37 0 115 0 41 0 116 2 101 0 117 2 113 0 145 2 121 0 168 9 53 0 181 7 157 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 188 7 161 0 189 7 165 0 190 7 169 0 191 7 173 0 192 9 93 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 211 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 232 3 1 0 237 3 5 0 253]
#[0 2 250 0 14]
)! !

SmaCCParser subclass: #SmaCCGrammarParser
	instanceVariableNames: 'grammar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCGrammarParser commentStamp: 'jmb' prior: 0!
SmaCCGrammarParser is a parser for grammars.

Instance Variables:
	grammar	<SmaCCGrammar>	the grammar we are producing
!

!SmaCCGrammarParser classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:49'!
parserDefinitionComment

	"File:	Parser {grammar addEmptySymbol; yourself};

Parser:	Rule
	| Parser Rule ;

Rule : ProductionRule {grammar setStartSymbolIfNone: '1'. nil}
	| LeftLine 
	| RightLine 
	| NonAssociativeLine
	| IdMethodLine
	| StartLine ;

LeftLine:	""%left"" TokenList 'tokens' "";"" { tokens do: [:each | grammar leftPrecedenceFor: each; setOperatorPrecedenceFor: each to: scanner lineNumber]. nil };
RightLine:	""%right"" TokenList 'tokens' "";"" { tokens do: [:each | grammar rightPrecedenceFor: each; setOperatorPrecedenceFor: each to: scanner lineNumber]. nil };
NonAssociativeLine: ""%nonassoc"" TokenList 'tokens' "";"" { tokens do: [:each | grammar nonAssociativePrecedenceFor: each; setOperatorPrecedenceFor: each to: scanner lineNumber]. nil };
IdMethodLine: ""%id"" IdTokens 'tokens' "";"" {tokens do: [:each | grammar makeTokenIdMethodFor: each]. nil};
StartLine: ""%start"" StartingTokens "";"";

IdTokens: <tokenname> {OrderedCollection with: '1' value}
	| IdTokens <tokenname> {'1' add: '2' value; yourself};
TokenList:	Term
	| TokenList Term	;
StartingTokens: <symbolname> 'symbol' {grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: symbol value)}
	| StartingTokens <symbolname> 'symbol' {grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: symbol value)};

ProductionRule: <symbolname> <production> ParserRules "";"" {| symbol | symbol := grammar nonTerminalSymbolNamed: '1' value. '3' do: [:each | symbol addProduction: each]. symbol};

ParserRules:	ParserRules ""|"" ParserRule {'1' add: '3'; yourself}
	| ParserRule	 ;

ParserRule : Terms 'rhs' {rhs}
	| Terms 'rhs' <code> 'code' {self verifyCodeToken: code for: rhs} ;

Terms :	{SmaCCRHS new}
	| Terms 'rhs' Term 'term'	{rhs add: term; yourself}	
	| Terms 'rhs' Term 'term' <variablename> 'variableNameToken'	{rhs add: term; nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); yourself}	
	| Terms 'rhs' Term 'term' ""?"" {rhs add: (grammar makeOptionalSymbolFor: term); yourself}
	| Terms 'rhs' Term 'term' ""?"" <variablename> 'variableNameToken' {rhs add: (grammar makeOptionalSymbolFor: term); nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); yourself}	
	| Terms 'rhs' Term 'term' ""*"" {rhs add: (grammar makeRepeatSymbolFor: term); yourself}
	| Terms 'rhs' Term 'term' ""*"" <variablename> 'variableNameToken' {rhs add: (grammar makeRepeatSymbolFor: term); nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); yourself}		
	| Terms 'rhs' Term 'term' ""+"" {rhs add: (grammar makeRepeatMultipleSymbolFor: term); yourself}
	| Terms 'rhs' Term 'term' ""+"" <variablename> 'variableNameToken' {rhs add: (grammar makeRepeatMultipleSymbolFor: term); nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); yourself}	;

Term:	<keyword> {grammar keywordTerminalNamed: '1' value}
	| <tokenname> {grammar terminalSymbolNamed: '1' value ifAbsent: [currentToken := '1'. self reportErrorMessage: 'Token not specified']}
	| <symbolname> {grammar nonTerminalSymbolNamed: '1' value}
	| ""error"" {SmaCCSymbol error}
	| ""("" SimpleTerms "")"" {grammar makeGroupFor: '2'}
	| ""<%"" SimpleTerms ""%>"" {grammar makeRepeatSymbolFor: (grammar makeGroupFor: '2')}
	| ""["" SimpleTerms ""]"" {grammar makeOptionalSymbolFor: (grammar makeGroupFor: '2')};

SimpleTerms :
	SimpleTerm {OrderedCollection with: '1'}
	| SimpleTerms 'terms' ""|"" SimpleTerm 'term' {terms add: term; yourself};

SimpleTerm :
	{ SmaCCRHS new }
	| SimpleTerm 'rhs' Term 'term' {rhs add: term; yourself} 
	| SimpleTerm 'rhs' Term 'term' ""?"" {rhs add: (grammar makeOptionalSymbolFor: term); yourself}
	| SimpleTerm 'rhs' Term 'term' ""*"" {rhs add: (grammar makeRepeatSymbolFor: term); yourself}
	| SimpleTerm 'rhs' Term 'term' ""+"" {rhs add: (grammar makeRepeatMultipleSymbolFor: term); yourself}	;"! !

!SmaCCGrammarParser classSide methodsFor: 'generated-accessing' stamp: 'lr 4/12/2010 17:49'!
scannerClass
	^SmaCCGrammarScanner! !

!SmaCCGrammarParser classSide methodsFor: 'generated-starting states' stamp: 'lr 4/12/2010 17:49'!
startingStateForFile
	^1! !

!SmaCCGrammarParser methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
grammar: aSmaCCGrammar
	grammar := aSmaCCGrammar! !

!SmaCCGrammarParser methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	super initialize.
	grammar := SmaCCGrammar new! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForFile1: nodes
	^ grammar
		addEmptySymbol;
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForIdMethodLine1: nodes
	(nodes at: 2) do: [ :each | grammar makeTokenIdMethodFor: each ].
	^ nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForIdTokens1: nodes
	^ OrderedCollection with: (nodes at: 1) value! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForIdTokens2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2) value;
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForLeftLine1: nodes
	(nodes at: 2)
		do: [ :each | 
			grammar
				leftPrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber ].
	^ nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForNonAssociativeLine1: nodes
	(nodes at: 2)
		do: [ :each | 
			grammar
				nonAssociativePrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber ].
	^ nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForParserRule1: nodes
	^ nodes at: 1! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForParserRule2: nodes
	^ self verifyCodeToken: (nodes at: 2) for: (nodes at: 1)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForParserRules1: nodes
	^ (nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForProductionRule1: nodes
	| symbol |
	symbol := grammar nonTerminalSymbolNamed: (nodes at: 1) value.
	(nodes at: 3) do: [ :each | symbol addProduction: each ].
	^ symbol! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRightLine1: nodes
	(nodes at: 2)
		do: [ :each | 
			grammar
				rightPrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber ].
	^ nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRule1: nodes
	grammar setStartSymbolIfNone: (nodes at: 1).
	^ nil! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForSimpleTerm1: nodes
	^ SmaCCRHS new! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForSimpleTerm2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForSimpleTerm3: nodes
	^ (nodes at: 1)
		add: (grammar makeOptionalSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForSimpleTerm4: nodes
	^ (nodes at: 1)
		add: (grammar makeRepeatSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForSimpleTerm5: nodes
	^ (nodes at: 1)
		add: (grammar makeRepeatMultipleSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForSimpleTerms1: nodes
	^ OrderedCollection with: (nodes at: 1)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForSimpleTerms2: nodes
	^ (nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForStartingTokens1: nodes
	^ grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: (nodes at: 1) value)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForStartingTokens2: nodes
	^ grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: (nodes at: 2) value)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerm1: nodes
	^ grammar keywordTerminalNamed: (nodes at: 1) value! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerm2: nodes
	^ grammar
		terminalSymbolNamed: (nodes at: 1) value
		ifAbsent: [ 
			currentToken := nodes at: 1.
			self reportErrorMessage: 'Token not specified' ]! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerm3: nodes
	^ grammar nonTerminalSymbolNamed: (nodes at: 1) value! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerm4: nodes
	^ SmaCCSymbol error! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerm5: nodes
	^ grammar makeGroupFor: (nodes at: 2)! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerm6: nodes
	^ grammar makeRepeatSymbolFor: (grammar makeGroupFor: (nodes at: 2))! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerm7: nodes
	^ grammar makeOptionalSymbolFor: (grammar makeGroupFor: (nodes at: 2))! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms1: nodes
	^ SmaCCRHS new! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms3: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		nameLastItem: ((nodes at: 3) value copyFrom: 2 to: (nodes at: 3) value size - 1);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms4: nodes
	^ (nodes at: 1)
		add: (grammar makeOptionalSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms5: nodes
	^ (nodes at: 1)
		add: (grammar makeOptionalSymbolFor: (nodes at: 2));
		nameLastItem: ((nodes at: 4) value copyFrom: 2 to: (nodes at: 4) value size - 1);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms6: nodes
	^ (nodes at: 1)
		add: (grammar makeRepeatSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms7: nodes
	^ (nodes at: 1)
		add: (grammar makeRepeatSymbolFor: (nodes at: 2));
		nameLastItem: ((nodes at: 4) value copyFrom: 2 to: (nodes at: 4) value size - 1);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms8: nodes
	^ (nodes at: 1)
		add: (grammar makeRepeatMultipleSymbolFor: (nodes at: 2));
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForTerms9: nodes
	^ (nodes at: 1)
		add: (grammar makeRepeatMultipleSymbolFor: (nodes at: 2));
		nameLastItem: ((nodes at: 4) value copyFrom: 2 to: (nodes at: 4) value size - 1);
		yourself! !

!SmaCCGrammarParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:49'!
reduceTable
	^#(
#(26 3 #reduceActionForIdMethodLine1:)
#(27 3 #reduceFor:)
#(28 1 #reduceFor:)
#(28 2 #reduceFor:)
#(29 1 #reduceActionForIdTokens1:)
#(29 2 #reduceActionForIdTokens2:)
#(30 1 #reduceActionForStartingTokens1:)
#(30 2 #reduceActionForStartingTokens2:)
#(31 3 #reduceActionForNonAssociativeLine1:)
#(32 1 #reduceActionForTerm1:)
#(32 1 #reduceActionForTerm2:)
#(32 1 #reduceActionForTerm3:)
#(32 1 #reduceActionForTerm4:)
#(32 3 #reduceActionForTerm5:)
#(32 3 #reduceActionForTerm6:)
#(32 3 #reduceActionForTerm7:)
#(33 1 #reduceFor:)
#(34 4 #reduceActionForProductionRule1:)
#(35 3 #reduceActionForParserRules1:)
#(35 1 #reduceFor:)
#(36 1 #reduceActionForParserRule1:)
#(36 2 #reduceActionForParserRule2:)
#(37 0 #reduceActionForTerms1:)
#(37 2 #reduceActionForTerms2:)
#(37 3 #reduceActionForTerms3:)
#(37 3 #reduceActionForTerms4:)
#(37 4 #reduceActionForTerms5:)
#(37 3 #reduceActionForTerms6:)
#(37 4 #reduceActionForTerms7:)
#(37 3 #reduceActionForTerms8:)
#(37 4 #reduceActionForTerms9:)
#(38 3 #reduceActionForRightLine1:)
#(39 1 #reduceActionForRule1:)
#(39 1 #reduceFor:)
#(39 1 #reduceFor:)
#(39 1 #reduceFor:)
#(39 1 #reduceFor:)
#(39 1 #reduceFor:)
#(40 1 #reduceActionForFile1:)
#(41 1 #reduceActionForSimpleTerms1:)
#(41 3 #reduceActionForSimpleTerms2:)
#(42 0 #reduceActionForSimpleTerm1:)
#(42 2 #reduceActionForSimpleTerm2:)
#(42 3 #reduceActionForSimpleTerm3:)
#(42 3 #reduceActionForSimpleTerm4:)
#(42 3 #reduceActionForSimpleTerm5:)
#(45 1 #reduceFor:)
#(45 2 #reduceFor:)
#(46 3 #reduceActionForLeftLine1:)
)! !

!SmaCCGrammarParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:49'!
transitionTable
	^#(
#[1 0 9 0 1 0 13 0 3 0 17 0 4 0 21 0 6 0 25 0 8 0 29 0 20 0 33 0 26 0 37 0 27 0 41 0 31 0 45 0 34 0 49 0 38 0 53 0 39 0 57 0 40 0 61 0 45 0 65 0 46]
#[1 0 69 0 20 0 73 0 30]
#[1 0 77 0 11 0 81 0 13 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 105 0 28 0 109 0 32]
#[1 0 113 0 19 0 117 0 29]
#[1 0 77 0 11 0 81 0 13 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 121 0 28 0 109 0 32]
#[1 0 77 0 11 0 81 0 13 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 125 0 28 0 109 0 32]
#[0 0 129 0 25]
#[0 0 150 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 154 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 146 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 134 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 142 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 190 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 0 0 43]
#[1 0 9 0 1 0 13 0 3 0 17 0 4 0 21 0 6 0 25 0 8 0 29 0 20 0 33 0 26 0 37 0 27 0 41 0 31 0 45 0 34 0 49 0 38 0 133 0 39 0 158 0 43 0 65 0 46]
#[0 0 138 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 30 0 7 0 20]
#[1 0 137 0 7 0 141 0 20]
#[1 0 170 0 2 0 170 0 9 0 170 0 11 0 170 0 13 0 170 0 15 0 170 0 17 0 170 0 19 0 170 0 20 0 170 0 21 0 145 0 41 0 149 0 42]
#[1 0 170 0 9 0 170 0 11 0 170 0 12 0 170 0 13 0 170 0 15 0 170 0 17 0 170 0 19 0 170 0 20 0 170 0 21 0 153 0 41 0 149 0 42]
#[0 0 54 0 2 0 5 0 7 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 23 0 24]
#[1 0 170 0 9 0 170 0 11 0 170 0 13 0 170 0 14 0 170 0 15 0 170 0 17 0 170 0 19 0 170 0 20 0 170 0 21 0 157 0 41 0 149 0 42]
#[0 0 46 0 2 0 5 0 7 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 23 0 24]
#[0 0 50 0 2 0 5 0 7 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 23 0 24]
#[0 0 42 0 2 0 5 0 7 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 23 0 24]
#[1 0 161 0 7 0 77 0 11 0 81 0 13 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 165 0 32]
#[0 0 14 0 7 0 11 0 13 0 15 0 17 0 19 0 20 0 21]
#[0 0 22 0 7 0 19]
#[1 0 169 0 7 0 173 0 19]
#[1 0 177 0 7 0 77 0 11 0 81 0 13 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 165 0 32]
#[1 0 181 0 7 0 77 0 11 0 81 0 13 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 165 0 32]
#[1 0 94 0 7 0 94 0 9 0 94 0 11 0 94 0 13 0 94 0 15 0 94 0 17 0 94 0 19 0 94 0 20 0 94 0 21 0 94 0 23 0 185 0 35 0 189 0 36 0 193 0 37]
#[0 0 194 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 10 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 34 0 7 0 20]
#[1 0 197 0 2 0 201 0 9]
#[1 0 162 0 2 0 162 0 9 0 77 0 11 0 162 0 12 0 81 0 13 0 162 0 14 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 205 0 32]
#[1 0 201 0 9 0 209 0 12]
#[1 0 201 0 9 0 213 0 14]
#[0 0 38 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 18 0 7 0 11 0 13 0 15 0 17 0 19 0 20 0 21]
#[0 0 6 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 26 0 7 0 19]
#[0 0 198 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[0 0 130 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[1 0 217 0 7 0 221 0 9]
#[0 0 82 0 7 0 9]
#[1 0 86 0 7 0 86 0 9 0 77 0 11 0 81 0 13 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 225 0 23 0 229 0 32]
#[0 0 66 0 2 0 5 0 7 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 23 0 24]
#[1 0 170 0 2 0 170 0 9 0 170 0 11 0 170 0 12 0 170 0 13 0 170 0 14 0 170 0 15 0 170 0 17 0 170 0 19 0 170 0 20 0 170 0 21 0 233 0 42]
#[1 0 174 0 2 0 237 0 5 0 174 0 9 0 241 0 10 0 174 0 11 0 174 0 12 0 174 0 13 0 174 0 14 0 174 0 15 0 245 0 16 0 174 0 17 0 174 0 19 0 174 0 20 0 174 0 21]
#[0 0 62 0 2 0 5 0 7 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 23 0 24]
#[0 0 58 0 2 0 5 0 7 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 23 0 24]
#[0 0 74 0 1 0 3 0 4 0 6 0 8 0 20 0 43]
#[1 0 94 0 7 0 94 0 9 0 94 0 11 0 94 0 13 0 94 0 15 0 94 0 17 0 94 0 19 0 94 0 20 0 94 0 21 0 94 0 23 0 249 0 36 0 193 0 37]
#[0 0 90 0 7 0 9]
#[1 0 253 0 5 0 98 0 7 0 98 0 9 1 1 0 10 0 98 0 11 0 98 0 13 0 98 0 15 1 5 0 16 0 98 0 17 0 98 0 19 0 98 0 20 0 98 0 21 0 98 0 23 1 9 0 24]
#[1 0 166 0 2 0 166 0 9 0 77 0 11 0 166 0 12 0 81 0 13 0 166 0 14 0 85 0 15 0 89 0 17 0 93 0 19 0 97 0 20 0 101 0 21 0 205 0 32]
#[0 0 178 0 2 0 9 0 11 0 12 0 13 0 14 0 15 0 17 0 19 0 20 0 21]
#[0 0 182 0 2 0 9 0 11 0 12 0 13 0 14 0 15 0 17 0 19 0 20 0 21]
#[0 0 186 0 2 0 9 0 11 0 12 0 13 0 14 0 15 0 17 0 19 0 20 0 21]
#[0 0 78 0 7 0 9]
#[1 0 106 0 7 0 106 0 9 0 106 0 11 0 106 0 13 0 106 0 15 0 106 0 17 0 106 0 19 0 106 0 20 0 106 0 21 0 106 0 23 1 13 0 24]
#[1 0 114 0 7 0 114 0 9 0 114 0 11 0 114 0 13 0 114 0 15 0 114 0 17 0 114 0 19 0 114 0 20 0 114 0 21 0 114 0 23 1 17 0 24]
#[1 0 122 0 7 0 122 0 9 0 122 0 11 0 122 0 13 0 122 0 15 0 122 0 17 0 122 0 19 0 122 0 20 0 122 0 21 0 122 0 23 1 21 0 24]
#[0 0 102 0 7 0 9 0 11 0 13 0 15 0 17 0 19 0 20 0 21 0 23]
#[0 0 110 0 7 0 9 0 11 0 13 0 15 0 17 0 19 0 20 0 21 0 23]
#[0 0 118 0 7 0 9 0 11 0 13 0 15 0 17 0 19 0 20 0 21 0 23]
#[0 0 126 0 7 0 9 0 11 0 13 0 15 0 17 0 19 0 20 0 21 0 23]
)! !

!SmaCCGrammarParser methodsFor: 'private' stamp: ' 6/1/07 21:19'!
verifyCodeToken: codeToken for: aSmaCCRHS 
	| code |
	code := codeToken value copyFrom: 2 to: codeToken value size - 1.
	RBParser parseExpression: code
		onError: 
			[:string :position | 
			currentToken := nil.
			scanner position: codeToken startPosition + position.
			self reportErrorMessage: string].
	aSmaCCRHS reduceAction: code.
	^aSmaCCRHS! !

SmaCCParser subclass: #SmaCCScannerParser
	instanceVariableNames: 'scannerDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCScannerParser commentStamp: '<historical>' prior: 0!
SmaCCScannerParser is the parser for the scanner definition.

Instance Variables:
	tokens	<Dictionary key: String value: SmaCCRegularExpressionNode>	the tokens that are parsed

!

!SmaCCScannerParser classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:49'!
parserDefinitionComment

	"%left	""|"";
%left ""("" <character> <backslashcharacter> <characterblock> <anycharacter> <tokenname> <symbol>;
%left ""*"" ""+"" ""?"" <repeat> ;

File: Rules	 {scannerDefinition} 
	|  {scannerDefinition};

Rules: Rule "";""
	| Rules Rule "";"" ;

Rule: RegexRule {'1' states isEmpty ifTrue: ['1' addStates: scannerDefinition nonExcludeStates]}
	| ExcludeStatesLine 
	| StatesLine ;

RegexRule : <tokenname> "":"" Regex {'3' position: '1' startPosition. scannerDefinition addToken: '3' withName: '1' value. '3'}
	| Symbol RegexRule {'2' addState: '1'; yourself};

StatesLine : ""%states"" States ;
States :
	| States Symbol {scannerDefinition addState: '2'};

ExcludeStatesLine : ""%excludes"" ExcludeStates ;
ExcludeStates : 
	| ExcludeStates Symbol {scannerDefinition addExcludeState: '2'};

Symbol : <symbol> {'1' value asSymbol};

Regex: RegexTerm {'1'}
	| Regex ""|"" Regex {'1' | '3'}
	| Regex RegexTerm {'1' , '2'};

RegexTerm:	<character> {SmaCCCharacterRENode characters: '1' value}
	| <anycharacter> {SmaCCCharacterRENode characters: self allCharacters}
	| <backslashcharacter> {self nodeFor: (ReadStream on: ('1' value copyFrom: 2 to: '1' value size))} 
	| ""("" Regex "")"" {'2'}
	| <characterblock> {SmaCCCharacterRENode characters: (self parseCharacterBlock: '1')}
	| <tokenname> {(scannerDefinition tokenNamed: '1' value ifAbsentPut: [self generateImplicitToken: '1']) copy}
	| <symbol> {SmaCCSequenceRENode nodes: ('1' value asOrderedCollection collect: [:each | SmaCCCharacterRENode characters: (String with: each)])}
	| RegexTerm ""*""	{'1' repeat}
	| RegexTerm ""+"" {'1' repeatForAtLeast: 1}
	| RegexTerm ""?"" {'1' repeatFor: 0 to: 1}
	| RegexTerm <repeat> {| readStream start stop | 
					readStream := ReadStream on: ('2' value copyFrom: 2 to: '2' value size - 1). 
					start := readStream upTo: $,. 
					stop := readStream upToEnd.
					'1' repeatFor: (start isEmpty ifTrue: [0] ifFalse: [start asNumber]) to: (stop isEmpty ifTrue: [(1 bitShift: 31)] ifFalse: [stop asNumber])} ;"! !

!SmaCCScannerParser classSide methodsFor: 'generated-accessing' stamp: 'lr 4/12/2010 17:49'!
scannerClass
	^SmaCCScannerScanner! !

!SmaCCScannerParser classSide methodsFor: 'generated-starting states' stamp: 'lr 4/12/2010 17:49'!
startingStateForFile
	^1! !

!SmaCCScannerParser methodsFor: 'private' stamp: ' 6/1/07 21:19'!
allCharacters
	^SmaCCGrammar allCharacters! !

!SmaCCScannerParser methodsFor: 'private' stamp: ' 6/1/07 21:19'!
charactersFor: aStream in: aToken 
	| characters char endCharacters |
	aStream atEnd ifTrue: [self reportCharacterBlockErrorForToken: aToken].
	char := aStream next.
	characters := char == $\ 
				ifTrue: [(self nodeFor: aStream) characters]
				ifFalse: [OrderedCollection with: char].
	(characters size = 1 and: [aStream peekFor: $-]) ifFalse: [^characters].
	endCharacters := self charactersFor: aStream in: aToken.
	endCharacters size > 1 
		ifTrue: [self reportCharacterBlockErrorForToken: aToken].
	^(characters first asInteger to: endCharacters first asInteger) 
		collect: [:each | Character value: each]! !

!SmaCCScannerParser methodsFor: 'private' stamp: ' 6/1/07 21:19'!
generateImplicitToken: aSmaCCToken 
	| node |
	node := SmaCCGrammar implicitToken: aSmaCCToken value.
	node isNil 
		ifTrue: 
			[currentToken := aSmaCCToken.
			self reportErrorMessage: 'Token not specified'].
	^node! !

!SmaCCScannerParser methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	super initialize.
	scannerDefinition := SmaCCScannerDefinition new! !

!SmaCCScannerParser methodsFor: 'private' stamp: 'lr 1/6/2007 21:44'!
nodeFor: aStream 
	| block char value count |
	char := aStream next.
	char == $f 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String with: (Character value: 12))].
	char == $n 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String with: (Character value: 10))].
	char == $r 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String with: (Character value: 13))].
	char == $t ifTrue: [^SmaCCCharacterRENode characters: '	'].
	char == $v 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String with: (Character value: 11))].
	char == $c 
		ifTrue: 
			[^SmaCCCharacterRENode characters: (String 
						with: (Character value: aStream next asInteger - $A asInteger))].
	char == $x 
		ifTrue: 
			[count := value := 0.
			
			[aStream atEnd not and: 
					[count < 4 and: 
							[char := aStream peek.
							(char between: $0 and: $9) 
								or: [(char between: $A and: $F) or: [char between: $a and: $f]]]]] 
					whileTrue: 
						[count := count + 1.
						value := value * 16 + aStream next digitValue].
			^SmaCCCharacterRENode characters: (String with: (Character value: value))].
	char == $d ifTrue: [block := [:each | each between: $0 and: $9]].
	char == $D ifTrue: [block := [:each | (each between: $0 and: $9) not]].
	char == $s 
		ifTrue: [block := [:each | #(9 10 11 12 13 32) includes: each asInteger]].
	char == $S 
		ifTrue: 
			[block := [:each | (#(9 10 11 12 13 32) includes: each asInteger) not]].
	char == $w 
		ifTrue: 
			[block := 
					[:each | 
					(each between: $a and: $z) or: 
							[(each between: $A and: $Z) 
								or: [(each between: $0 and: $9) or: [each == $_]]]]].
	char == $W 
		ifTrue: 
			[block := 
					[:each | 
					((each between: $a and: $z) or: 
							[(each between: $A and: $Z) 
								or: [(each between: $0 and: $9) or: [each == $_]]]) 
						not]].
	block isNil 
		ifTrue: [^SmaCCCharacterRENode characters: (String with: char)].
	^SmaCCCharacterRENode 
		characters: (String withAll: (self allCharacters select: block))! !

!SmaCCScannerParser methodsFor: 'private' stamp: ' 6/1/07 21:19'!
parseCharacterBlock: aToken 
	| characters aStream invert |
	aStream := ReadStream 
				on: (aToken value copyFrom: 2 to: aToken value size - 1).
	characters := OrderedCollection new.
	invert := aStream peekFor: $^.
	[aStream atEnd] 
		whileFalse: [characters addAll: (self charactersFor: aStream in: aToken)].
	^String withAll: (invert 
				ifTrue: [self allCharacters reject: [:each | characters includes: each]]
				ifFalse: [characters])! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForExcludeStates2: nodes
	^ scannerDefinition addExcludeState: (nodes at: 2)! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForFile1: nodes
	^ scannerDefinition! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForFile2: nodes
	^ scannerDefinition! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegex1: nodes
	^ nodes at: 1! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegex2: nodes
	^ (nodes at: 1) | (nodes at: 3)! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegex3: nodes
	^ (nodes at: 1) , (nodes at: 2)! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexRule1: nodes
	(nodes at: 3) position: (nodes at: 1) startPosition.
	scannerDefinition addToken: (nodes at: 3) withName: (nodes at: 1) value.
	^ nodes at: 3! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexRule2: nodes
	^ (nodes at: 2)
		addState: (nodes at: 1);
		yourself! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm10: nodes
	^ (nodes at: 1) repeatFor: 0 to: 1! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm11: nodes
	| readStream start stop |
	readStream := ReadStream on: ((nodes at: 2) value copyFrom: 2 to: (nodes at: 2) value size - 1).
	start := readStream upTo: $,.
	stop := readStream upToEnd.
	^ (nodes at: 1)
		repeatFor:
			(start isEmpty
				ifTrue: [ 0 ]
				ifFalse: [ start asNumber ])
		to:
			(stop isEmpty
				ifTrue: [ 1 bitShift: 31 ]
				ifFalse: [ stop asNumber ])! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm1: nodes
	^ SmaCCCharacterRENode characters: (nodes at: 1) value! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm2: nodes
	^ SmaCCCharacterRENode characters: self allCharacters! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm3: nodes
	^ self nodeFor: (ReadStream on: ((nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size))! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm4: nodes
	^ nodes at: 2! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm5: nodes
	^ SmaCCCharacterRENode characters: (self parseCharacterBlock: (nodes at: 1))! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm6: nodes
	^ (scannerDefinition tokenNamed: (nodes at: 1) value ifAbsentPut: [ self generateImplicitToken: (nodes at: 1) ]) copy! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm7: nodes
	^ SmaCCSequenceRENode
		nodes:
			((nodes at: 1) value asOrderedCollection collect: [ :each | SmaCCCharacterRENode characters: (String with: each) ])! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm8: nodes
	^ (nodes at: 1) repeat! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRegexTerm9: nodes
	^ (nodes at: 1) repeatForAtLeast: 1! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForRule1: nodes
	^ (nodes at: 1) states isEmpty
		ifTrue: [ (nodes at: 1) addStates: scannerDefinition nonExcludeStates ]! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForStates2: nodes
	^ scannerDefinition addState: (nodes at: 2)! !

!SmaCCScannerParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:49'!
reduceActionForSymbol1: nodes
	^ (nodes at: 1) value asSymbol! !

!SmaCCScannerParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:49'!
reduceTable
	^#(
#(20 1 #reduceFor:)
#(21 1 #reduceActionForFile1:)
#(21 0 #reduceActionForFile2:)
#(22 3 #reduceActionForRegexRule1:)
#(22 2 #reduceActionForRegexRule2:)
#(23 2 #reduceFor:)
#(24 1 #reduceActionForRule1:)
#(24 1 #reduceFor:)
#(24 1 #reduceFor:)
#(25 1 #reduceActionForRegex1:)
#(25 3 #reduceActionForRegex2:)
#(25 2 #reduceActionForRegex3:)
#(26 1 #reduceActionForSymbol1:)
#(27 0 #reduceFor:)
#(27 2 #reduceActionForStates2:)
#(28 0 #reduceFor:)
#(28 2 #reduceActionForExcludeStates2:)
#(29 1 #reduceActionForRegexTerm1:)
#(29 1 #reduceActionForRegexTerm2:)
#(29 1 #reduceActionForRegexTerm3:)
#(29 3 #reduceActionForRegexTerm4:)
#(29 1 #reduceActionForRegexTerm5:)
#(29 1 #reduceActionForRegexTerm6:)
#(29 1 #reduceActionForRegexTerm7:)
#(29 2 #reduceActionForRegexTerm8:)
#(29 2 #reduceActionForRegexTerm9:)
#(29 2 #reduceActionForRegexTerm10:)
#(29 2 #reduceActionForRegexTerm11:)
#(32 2 #reduceFor:)
#(32 3 #reduceFor:)
#(33 2 #reduceFor:)
)! !

!SmaCCScannerParser methodsFor: 'private' stamp: ' 6/1/07 21:19'!
reportCharacterBlockErrorForToken: aToken 
	currentToken := aToken.
	self reportErrorMessage: 'Invalid character block'! !

!SmaCCScannerParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:49'!
transitionTable
	^#(
#[1 0 9 0 7 0 13 0 8 0 17 0 14 0 21 0 17 0 25 0 21 0 29 0 22 0 33 0 23 0 37 0 24 0 41 0 26 0 14 0 30 0 45 0 32 0 49 0 33]
#[1 0 66 0 9 0 66 0 17 0 53 0 28]
#[1 0 58 0 9 0 58 0 17 0 57 0 27]
#[0 0 61 0 10]
#[0 0 54 0 9 0 14 0 17]
#[0 0 0 0 30]
#[0 0 30 0 9]
#[0 0 34 0 9]
#[0 0 65 0 9]
#[1 0 17 0 14 0 21 0 17 0 69 0 22 0 41 0 26]
#[1 0 9 0 7 0 13 0 8 0 17 0 14 0 21 0 17 0 29 0 22 0 33 0 23 0 73 0 24 0 41 0 26 0 10 0 30 0 49 0 33]
#[0 0 38 0 9]
#[1 0 26 0 9 0 21 0 17 0 77 0 26]
#[1 0 126 0 9 0 21 0 17 0 81 0 26]
#[1 0 85 0 2 0 89 0 11 0 93 0 12 0 97 0 14 0 101 0 17 0 105 0 18 0 109 0 19 0 113 0 25 0 117 0 29]
#[0 0 118 0 7 0 8 0 14 0 17 0 30]
#[0 0 22 0 9]
#[0 0 121 0 9]
#[0 0 70 0 9 0 17]
#[0 0 62 0 9 0 17]
#[1 0 85 0 2 0 89 0 11 0 93 0 12 0 97 0 14 0 101 0 17 0 105 0 18 0 109 0 19 0 125 0 25 0 117 0 29]
#[0 0 82 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 90 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 94 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 98 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 74 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 78 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[1 0 85 0 2 0 129 0 5 0 18 0 9 0 89 0 11 0 93 0 12 0 97 0 14 0 101 0 17 0 105 0 18 0 109 0 19 0 133 0 29]
#[1 0 42 0 1 0 42 0 2 0 137 0 3 0 141 0 4 0 42 0 5 0 145 0 6 0 42 0 9 0 42 0 11 0 42 0 12 0 42 0 14 0 149 0 16 0 42 0 17 0 42 0 18 0 42 0 19]
#[0 0 122 0 7 0 8 0 14 0 17 0 30]
#[1 0 153 0 1 0 85 0 2 0 129 0 5 0 89 0 11 0 93 0 12 0 97 0 14 0 101 0 17 0 105 0 18 0 109 0 19 0 133 0 29]
#[1 0 85 0 2 0 89 0 11 0 93 0 12 0 97 0 14 0 101 0 17 0 105 0 18 0 109 0 19 0 157 0 25 0 117 0 29]
#[1 0 50 0 1 0 50 0 2 0 137 0 3 0 141 0 4 0 50 0 5 0 145 0 6 0 50 0 9 0 50 0 11 0 50 0 12 0 50 0 14 0 149 0 16 0 50 0 17 0 50 0 18 0 50 0 19]
#[0 0 106 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 102 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 110 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 114 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[0 0 86 0 1 0 2 0 3 0 4 0 5 0 6 0 9 0 11 0 12 0 14 0 16 0 17 0 18 0 19]
#[1 0 46 0 1 0 85 0 2 0 46 0 5 0 46 0 9 0 89 0 11 0 93 0 12 0 97 0 14 0 101 0 17 0 105 0 18 0 109 0 19 0 133 0 29]
)! !

SmaCCParser subclass: #StParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Examples'!

!StParser classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
parseExpression: aString 
	^self simplifyExpression: (self parse: aString
				startingAt: self startingStateForSequenceNode)! !

!StParser classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
parseExpression: aString onError: aBlock 
	^self simplifyExpression: (self 
				parse: aString
				startingAt: self startingStateForSequenceNode
				onError: aBlock)! !

!StParser classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
parseMethod: aString 
	^self parse: aString startingAt: self startingStateForMethod! !

!StParser classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
parseMethod: aString onError: aBlock 
	^self 
		parse: aString
		startingAt: self startingStateForMethod
		onError: aBlock! !

!StParser classSide methodsFor: 'generated-comments' stamp: 'lr 4/12/2010 17:50'!
parserDefinitionComment

	"%id <number> <negativeNumber> <name> <binarySymbol>;
%start SequenceNode ;

Method:
	  <name> MethodSequenceNode {(RBMethodNode selector: '1' value asSymbol arguments: #() body: '2' last)}
	| BinaryMethodName MethodSequenceNode {(RBMethodNode selector: '1' first arguments: '1' last body: '2' last)}
	| KeywordMethodName MethodSequenceNode {(RBMethodNode selector: '1' first contents asSymbol arguments: '1' last body: '2' last)};

BinaryMethodName:
	<binarySymbol> Variable {Array with: '1' value asSymbol with: (Array with: '2')} ;

KeywordMethodName:
	<keyword> Variable {| stream | stream := WriteStream on: (String new: 30). stream nextPutAll: '1' value. Array with: stream with: (OrderedCollection with: '2')}
	| KeywordMethodName <keyword> Variable {'1' first nextPutAll: '2' value. '1' last add: '3'. '1'};

Primitives:
	{OrderedCollection new}
	| Primitives ""<"" PrimitiveMessageSend "">"" {'1' add: ('2' startPosition to: '4' startPosition); yourself};

PrimitiveMessageSend:
	| PrimitiveMessageSend <keyword> {nil}
	| PrimitiveMessageSend Literal {nil}
	| PrimitiveMessageSend ""("" {nil}
	| PrimitiveMessageSend "")"" {nil}
	| PrimitiveMessageSend ""{"" {nil}
	| PrimitiveMessageSend ""}"" {nil}
	| PrimitiveMessageSend "";"" {nil}
	| PrimitiveMessageSend ""."" {nil}
	| PrimitiveMessageSend <name> {nil}
	| PrimitiveMessageSend <binarySymbol> {nil};

MethodSequenceNode:
	Primitives ""|"" TemporaryVariables ""|"" Primitives Statements {Array with: ('1' addAll: '5'; yourself) with: (RBSequenceNode temporaries: '3' statements: '6')}
	| Primitives ""||"" Primitives Statements {Array with: ('1' addAll: '3'; yourself) with: (RBSequenceNode temporaries: #() statements: '4')}
	| Primitives Statements {Array with: '1' with: (RBSequenceNode temporaries: #() statements: '2')};

SequenceNode:
	Temporaries Statements {RBSequenceNode temporaries: '1' statements: '2'};

Temporaries:
	{#()}
	| ""||"" {#()}
	| ""|"" TemporaryVariables ""|"" {'2'};

TemporaryVariables:
	{OrderedCollection new}
	| TemporaryVariables Variable {'1' add: '2'; yourself};

Statements:
	{OrderedCollection new}
	| StatementList "".""? {#liftFirstValue:}
	| StatementList ""."" ""^"" Expression "".""? {'1' add: (RBReturnNode value: '4'); yourself}
	| ""^"" Expression "".""? {OrderedCollection with: (RBReturnNode value: '2')};

StatementList:
	Expression
	| StatementList ""."" Expression {'1' add: '3'; yourself};

Block:
	""["" BlockArgs ""|"" SequenceNode ""]"" {RBBlockNode arguments: '2' body: '4'}
	| ""["" SequenceNode ""]"" {RBBlockNode body: '2'}
	| ""["" BlockArgs ""]"" {RBBlockNode arguments: '2' body: (RBSequenceNode statements: #())}
	| ""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"" {RBBlockNode arguments: '2' body: (RBSequenceNode temporaries: '4' statements: '6')};

BlockArgs:
	"":"" Variable {OrderedCollection with: '2'}
	| BlockArgs "":"" Variable {'1' add: '3'; yourself};


Expression:
	Variable "":="" Expression {RBAssignmentNode variable: '1' value: '3'}
|	Cascade {#liftFirstValue:};

Cascade:
	MessageSend CascadeList 
				{| messages |
				'2' isEmpty ifTrue: [^'1'].
				messages := OrderedCollection new: '2' size + 1.
				messages add: '1'.
				'2' do: [:each | messages add: (RBMessageNode receiver: '1' receiver selector: each first contents asSymbol arguments: each last)].
				RBCascadeNode messages: messages}
|	Primary {#liftFirstValue:};

MessageSend:
	KeywordMessageSend {#liftFirstValue:}
|	BinaryMessageSend {#liftFirstValue:}
|	UnaryMessageSend {#liftFirstValue:};

CascadeList:
	{OrderedCollection new}
|	CascadeList "";"" SimpleMessage {'1' add: '3'; yourself};

SimpleMessage:
	UnaryMessage {#liftFirstValue:}
|	BinaryMessage {#liftFirstValue:}
|	KeywordMessage {#liftFirstValue:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage {#createMessageNodeFrom:}
|	UnaryMessageSend KeywordMessage {#createMessageNodeFrom:}
|	Primary KeywordMessage {#createMessageNodeFrom:};

KeywordMessage:
	<keyword> KeywordArgument {| stream | stream := WriteStream on: (String new: 30). stream nextPutAll: '1' value. Array with: stream with: (OrderedCollection with: '2')}
|	KeywordMessage <keyword> KeywordArgument {'1' first nextPutAll: '2' value. '1' last add: '3'. '1'};

KeywordArgument:
	BinaryMessageSend {#liftFirstValue:}
|	UnaryMessageSend {#liftFirstValue:}
|	Primary {#liftFirstValue:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage {#createMessageNodeFrom:}
|	UnaryMessageSend BinaryMessage {#createMessageNodeFrom:}
|	Primary BinaryMessage {#createMessageNodeFrom:} ;

BinaryMessage :
	<binarySymbol> BinaryArgument {Array with: (ReadStream on: '1' value) with: (Array with: '2')};

BinaryArgument:
	UnaryMessageSend {#liftFirstValue:}
|	Primary {#liftFirstValue:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage {#createMessageNodeFrom:}
|	Primary UnaryMessage {#createMessageNodeFrom:};

UnaryMessage :
	<name> {Array with: (ReadStream on: '1' value) with: #()};


Primary: 
	""("" Expression "")"" {#liftSecondValue:}
|	Literal {RBLiteralNode value: '1'}
|	Variable {#liftFirstValue:}
|	Block {#liftFirstValue:};

Variable: 
	<name> {RBVariableNode named: '1' value}
|	<dottedName> {RBVariableNode named: '1' value};

Literal:
	""true"" {true}
|	""false"" {false}
|	""nil"" {nil}
|	<number> {'1' value}
|	<negativeNumber> {'1' value}
|	<character> {'1' value at: 2}
|	<string> {('1' value copyFrom: 2 to: '1' value size - 1) copyReplaceAll: '''''' with: ''''}
|	 ""#"" <string> {(('2' value copyFrom: 2 to: '2' value size - 1) copyReplaceAll: '''''' with: '''') asSymbol}
|	""#"" <name> {'2' value asSymbol}
|	""#"" <binarySymbol> {'2' value asSymbol}
|	""#"" <keyword> {'2' value asSymbol}
|	""#"" <multikeyword> {'2' value asSymbol}
|	""#"" ""["" ByteArray ""]"" {'3' contents}
|	""#"" ""("" Array "")"" {'3' contents}
|	""#"" ""{"" <name> ""}"" {'3' value asQualifiedReference}
|	""#"" ""{"" <dottedName> ""}"" {'3' value asQualifiedReference};

ByteArray: 
	{WriteStream on: ByteArray new}
|	ByteArray <number> {'1' nextPut: '2' value; yourself};

Array: 
	{WriteStream on: Array new}
|	Array ArrayLiteral {'1' nextPut: '2'; yourself} 
|	Array <name> "":="" {'2' stopPosition + 1 = '3' startPosition ifTrue: ['1' nextPut: ('2' value, ':') asSymbol] ifFalse: ['1' nextPut: '2' value asSymbol; nextPut: #':']. scanner position: '3' startPosition. currentToken := nil. '1'};

ArrayLiteral:
	Literal {#liftFirstValue:}
|	<name> {'1' value asSymbol}
|	<binarySymbol> {'1' value asSymbol}
|	<keyword> {'1' value asSymbol}
|	<multikeyword> {'1' value asSymbol}
|	""{"" <name> ""}"" {'2' value asQualifiedReference}
|	""{"" <dottedName> ""}"" {'2' value asQualifiedReference}
|	""("" Array "")"" {'2' contents}
|	""["" ByteArray ""]"" {'2' contents}
|	<anyChar> {'1' value asSymbol}
|	<dottedName> {'1' value};"! !

!StParser classSide methodsFor: 'generated-accessing' stamp: 'lr 4/12/2010 17:50'!
scannerClass
	^StScanner! !

!StParser classSide methodsFor: 'private' stamp: 'lr 4/12/2010 13:58'!
simplifyExpression: aSequenceNode 
	^aSequenceNode isNil
		ifFalse: [ 
	
	(aSequenceNode statements size == 1 
		and: [aSequenceNode temporaries isEmpty]) 
			ifTrue: [aSequenceNode statements first]
			ifFalse: [aSequenceNode] ]! !

!StParser classSide methodsFor: 'generated-starting states' stamp: 'lr 4/12/2010 17:50'!
startingStateForMethod
	^1! !

!StParser classSide methodsFor: 'generated-starting states' stamp: 'lr 4/12/2010 17:50'!
startingStateForSequenceNode
	^2! !

!StParser methodsFor: 'private' stamp: ' 6/1/07 21:19'!
actionForCurrentToken
	| ids action |
	ids := currentToken id.
	1 to: ids size
		do: 
			[:i | 
			action := self actionFor: (ids at: i).
			(action bitAnd: self actionMask) = self errorAction ifFalse: [^action].
			(ids at: i) = scanner negativeNumberId 
				ifTrue: 
					[currentToken := SmaCCToken 
								value: '-'
								start: currentToken startPosition
								id: (Array with: scanner binarySymbolId).
					scanner position: currentToken stopPosition - 1.
					^self actionForCurrentToken]].
	^self errorAction! !

!StParser methodsFor: 'private' stamp: ' 6/1/07 21:19'!
createMessageNodeFrom: aCollection 
	^RBMessageNode 
		receiver: aCollection first
		selector: (aCollection at: 2) first contents asSymbol
		arguments: (aCollection at: 2) last! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArray1: nodes
	^ WriteStream on: Array new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArray2: nodes
	^ (nodes at: 1)
		nextPut: (nodes at: 2);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArray3: nodes
	(nodes at: 2) stopPosition + 1 = (nodes at: 3) startPosition
		ifTrue: [ (nodes at: 1) nextPut: ((nodes at: 2) value , ':') asSymbol ]
		ifFalse: [ 
			(nodes at: 1)
				nextPut: (nodes at: 2) value asSymbol;
				nextPut: #':' ].
	scanner position: (nodes at: 3) startPosition.
	currentToken := nil.
	^ nodes at: 1! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral10: nodes
	^ (nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral11: nodes
	^ (nodes at: 1) value! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral2: nodes
	^ (nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral3: nodes
	^ (nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral4: nodes
	^ (nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral5: nodes
	^ (nodes at: 1) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral6: nodes
	^ (nodes at: 2) value asQualifiedReference! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral7: nodes
	^ (nodes at: 2) value asQualifiedReference! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral8: nodes
	^ (nodes at: 2) contents! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForArrayLiteral9: nodes
	^ (nodes at: 2) contents! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForBinaryMessage1: nodes
	^ Array with: (ReadStream on: (nodes at: 1) value) with: (Array with: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForBinaryMethodName1: nodes
	^ Array with: (nodes at: 1) value asSymbol with: (Array with: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForBlock1: nodes
	^ RBBlockNode arguments: (nodes at: 2) body: (nodes at: 4)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForBlock2: nodes
	^ RBBlockNode body: (nodes at: 2)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForBlock3: nodes
	^ RBBlockNode arguments: (nodes at: 2) body: (RBSequenceNode statements: #())! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForBlock4: nodes
	^ RBBlockNode arguments: (nodes at: 2) body: (RBSequenceNode temporaries: (nodes at: 4) statements: (nodes at: 6))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForBlockArgs1: nodes
	^ OrderedCollection with: (nodes at: 2)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForBlockArgs2: nodes
	^ (nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForByteArray1: nodes
	^ WriteStream on: ByteArray new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForByteArray2: nodes
	^ (nodes at: 1)
		nextPut: (nodes at: 2) value;
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForCascade1: nodes
	| messages |
	(nodes at: 2) isEmpty
		ifTrue: [ ^ nodes at: 1 ].
	messages := OrderedCollection new: (nodes at: 2) size + 1.
	messages add: (nodes at: 1).
	(nodes at: 2)
		do: [ :each | 
			messages
				add: (RBMessageNode receiver: (nodes at: 1) receiver selector: each first contents asSymbol arguments: each last) ].
	^ RBCascadeNode messages: messages! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForCascadeList1: nodes
	^ OrderedCollection new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForCascadeList2: nodes
	^ (nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForExpression1: nodes
	^ RBAssignmentNode variable: (nodes at: 1) value: (nodes at: 3)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForKeywordMessage1: nodes
	| stream |
	stream := WriteStream on: (String new: 30).
	stream nextPutAll: (nodes at: 1) value.
	^ Array with: stream with: (OrderedCollection with: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForKeywordMessage2: nodes
	(nodes at: 1) first nextPutAll: (nodes at: 2) value.
	(nodes at: 1) last add: (nodes at: 3).
	^ nodes at: 1! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForKeywordMethodName1: nodes
	| stream |
	stream := WriteStream on: (String new: 30).
	stream nextPutAll: (nodes at: 1) value.
	^ Array with: stream with: (OrderedCollection with: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForKeywordMethodName2: nodes
	(nodes at: 1) first nextPutAll: (nodes at: 2) value.
	(nodes at: 1) last add: (nodes at: 3).
	^ nodes at: 1! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral10: nodes
	^ (nodes at: 2) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral11: nodes
	^ (nodes at: 2) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral12: nodes
	^ (nodes at: 2) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral13: nodes
	^ (nodes at: 3) contents! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral14: nodes
	^ (nodes at: 3) contents! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral15: nodes
	^ (nodes at: 3) value asQualifiedReference! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral16: nodes
	^ (nodes at: 3) value asQualifiedReference! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral1: nodes
	^ true! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral2: nodes
	^ false! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral3: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral4: nodes
	^ (nodes at: 1) value! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral5: nodes
	^ (nodes at: 1) value! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral6: nodes
	^ (nodes at: 1) value at: 2! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral7: nodes
	^ ((nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1) copyReplaceAll: '''''' with: ''''! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral8: nodes
	^ (((nodes at: 2) value copyFrom: 2 to: (nodes at: 2) value size - 1) copyReplaceAll: '''''' with: '''') asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForLiteral9: nodes
	^ (nodes at: 2) value asSymbol! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForMethod1: nodes
	^ RBMethodNode selector: (nodes at: 1) value asSymbol arguments: #() body: (nodes at: 2) last! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForMethod2: nodes
	^ RBMethodNode selector: (nodes at: 1) first arguments: (nodes at: 1) last body: (nodes at: 2) last! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForMethod3: nodes
	^ RBMethodNode selector: (nodes at: 1) first contents asSymbol arguments: (nodes at: 1) last body: (nodes at: 2) last! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForMethodSequenceNode1: nodes
	^ Array
		with:
			((nodes at: 1)
				addAll: (nodes at: 5);
				yourself)
		with: (RBSequenceNode temporaries: (nodes at: 3) statements: (nodes at: 6))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForMethodSequenceNode2: nodes
	^ Array
		with:
			((nodes at: 1)
				addAll: (nodes at: 3);
				yourself)
		with: (RBSequenceNode temporaries: #() statements: (nodes at: 4))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForMethodSequenceNode3: nodes
	^ Array with: (nodes at: 1) with: (RBSequenceNode temporaries: #() statements: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForOptionalXXXXX1: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForOptionalXXXXX2: nodes
	^ nodes at: 1! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimary2: nodes
	^ RBLiteralNode value: (nodes at: 1)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend10: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend11: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend2: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend3: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend4: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend5: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend6: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend7: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend8: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitiveMessageSend9: nodes
	^ nil! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitives1: nodes
	^ OrderedCollection new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForPrimitives2: nodes
	^ (nodes at: 1)
		add: ((nodes at: 2) startPosition to: (nodes at: 4) startPosition);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForSequenceNode1: nodes
	^ RBSequenceNode temporaries: (nodes at: 1) statements: (nodes at: 2)! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForStatementList2: nodes
	^ (nodes at: 1)
		add: (nodes at: 3);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForStatements1: nodes
	^ OrderedCollection new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForStatements3: nodes
	^ (nodes at: 1)
		add: (RBReturnNode value: (nodes at: 4));
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForStatements4: nodes
	^ OrderedCollection with: (RBReturnNode value: (nodes at: 2))! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForTemporaries1: nodes
	^ #()! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForTemporaries2: nodes
	^ #()! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForTemporaries3: nodes
	^ nodes at: 2! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForTemporaryVariables1: nodes
	^ OrderedCollection new! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForTemporaryVariables2: nodes
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForUnaryMessage1: nodes
	^ Array with: (ReadStream on: (nodes at: 1) value) with: #()! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForVariable1: nodes
	^ RBVariableNode named: (nodes at: 1) value! !

!StParser methodsFor: 'generated-reduction actions' stamp: 'lr 4/12/2010 17:50'!
reduceActionForVariable2: nodes
	^ RBVariableNode named: (nodes at: 1) value! !

!StParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:50'!
reduceTable
	^#(
#(33 0 #reduceFor:)
#(33 2 #reduceActionForPrimitiveMessageSend2:)
#(33 2 #reduceActionForPrimitiveMessageSend3:)
#(33 2 #reduceActionForPrimitiveMessageSend4:)
#(33 2 #reduceActionForPrimitiveMessageSend5:)
#(33 2 #reduceActionForPrimitiveMessageSend6:)
#(33 2 #reduceActionForPrimitiveMessageSend7:)
#(33 2 #reduceActionForPrimitiveMessageSend8:)
#(33 2 #reduceActionForPrimitiveMessageSend9:)
#(33 2 #reduceActionForPrimitiveMessageSend10:)
#(33 2 #reduceActionForPrimitiveMessageSend11:)
#(34 2 #reduceActionForKeywordMethodName1:)
#(34 3 #reduceActionForKeywordMethodName2:)
#(35 0 #reduceActionForTemporaryVariables1:)
#(35 2 #reduceActionForTemporaryVariables2:)
#(36 0 #reduceActionForStatements1:)
#(36 2 #liftFirstValue:)
#(36 5 #reduceActionForStatements3:)
#(36 3 #reduceActionForStatements4:)
#(37 0 #reduceActionForTemporaries1:)
#(37 1 #reduceActionForTemporaries2:)
#(37 3 #reduceActionForTemporaries3:)
#(38 1 #reduceFor:)
#(38 3 #reduceActionForStatementList2:)
#(39 0 #reduceActionForOptionalXXXXX1:)
#(39 1 #reduceActionForOptionalXXXXX2:)
#(40 3 #reduceActionForExpression1:)
#(40 1 #liftFirstValue:)
#(41 2 #reduceActionForBlockArgs1:)
#(41 3 #reduceActionForBlockArgs2:)
#(42 5 #reduceActionForBlock1:)
#(42 3 #reduceActionForBlock2:)
#(42 3 #reduceActionForBlock3:)
#(42 7 #reduceActionForBlock4:)
#(43 2 #reduceActionForCascade1:)
#(43 1 #liftFirstValue:)
#(44 1 #liftFirstValue:)
#(44 1 #liftFirstValue:)
#(44 1 #liftFirstValue:)
#(45 0 #reduceActionForCascadeList1:)
#(45 3 #reduceActionForCascadeList2:)
#(46 0 #reduceActionForPrimitives1:)
#(46 4 #reduceActionForPrimitives2:)
#(47 2 #createMessageNodeFrom:)
#(47 2 #createMessageNodeFrom:)
#(47 2 #createMessageNodeFrom:)
#(48 2 #createMessageNodeFrom:)
#(48 2 #createMessageNodeFrom:)
#(48 2 #createMessageNodeFrom:)
#(49 2 #createMessageNodeFrom:)
#(49 2 #createMessageNodeFrom:)
#(50 1 #liftFirstValue:)
#(50 1 #liftFirstValue:)
#(50 1 #liftFirstValue:)
#(51 1 #reduceActionForUnaryMessage1:)
#(52 2 #reduceActionForBinaryMessage1:)
#(53 2 #reduceActionForKeywordMessage1:)
#(53 3 #reduceActionForKeywordMessage2:)
#(54 1 #liftFirstValue:)
#(54 1 #liftFirstValue:)
#(54 1 #liftFirstValue:)
#(55 1 #liftFirstValue:)
#(55 1 #liftFirstValue:)
#(56 2 #reduceActionForMethod1:)
#(56 2 #reduceActionForMethod2:)
#(56 2 #reduceActionForMethod3:)
#(57 1 #reduceActionForVariable1:)
#(57 1 #reduceActionForVariable2:)
#(58 2 #reduceActionForBinaryMethodName1:)
#(59 6 #reduceActionForMethodSequenceNode1:)
#(59 4 #reduceActionForMethodSequenceNode2:)
#(59 2 #reduceActionForMethodSequenceNode3:)
#(60 0 #reduceActionForByteArray1:)
#(60 2 #reduceActionForByteArray2:)
#(61 0 #reduceActionForArray1:)
#(61 2 #reduceActionForArray2:)
#(61 3 #reduceActionForArray3:)
#(62 1 #liftFirstValue:)
#(62 1 #reduceActionForArrayLiteral2:)
#(62 1 #reduceActionForArrayLiteral3:)
#(62 1 #reduceActionForArrayLiteral4:)
#(62 1 #reduceActionForArrayLiteral5:)
#(62 3 #reduceActionForArrayLiteral6:)
#(62 3 #reduceActionForArrayLiteral7:)
#(62 3 #reduceActionForArrayLiteral8:)
#(62 3 #reduceActionForArrayLiteral9:)
#(62 1 #reduceActionForArrayLiteral10:)
#(62 1 #reduceActionForArrayLiteral11:)
#(63 3 #liftSecondValue:)
#(63 1 #reduceActionForPrimary2:)
#(63 1 #liftFirstValue:)
#(63 1 #liftFirstValue:)
#(66 2 #reduceActionForSequenceNode1:)
#(67 1 #reduceFor:)
#(68 1 #reduceActionForLiteral1:)
#(68 1 #reduceActionForLiteral2:)
#(68 1 #reduceActionForLiteral3:)
#(68 1 #reduceActionForLiteral4:)
#(68 1 #reduceActionForLiteral5:)
#(68 1 #reduceActionForLiteral6:)
#(68 1 #reduceActionForLiteral7:)
#(68 2 #reduceActionForLiteral8:)
#(68 2 #reduceActionForLiteral9:)
#(68 2 #reduceActionForLiteral10:)
#(68 2 #reduceActionForLiteral11:)
#(68 2 #reduceActionForLiteral12:)
#(68 4 #reduceActionForLiteral13:)
#(68 4 #reduceActionForLiteral14:)
#(68 4 #reduceActionForLiteral15:)
#(68 4 #reduceActionForLiteral16:)
)! !

!StParser methodsFor: 'generated-tables' stamp: 'lr 4/12/2010 17:50'!
transitionTable
	^#(
#[1 0 13 0 20 0 17 0 24 0 21 0 26 0 25 0 34 0 29 0 56 0 33 0 58]
#[1 0 82 0 1 0 37 0 9 0 82 0 10 0 82 0 11 0 82 0 12 0 82 0 14 0 41 0 15 0 82 0 16 0 82 0 17 0 82 0 20 0 82 0 21 0 82 0 22 0 82 0 23 0 82 0 29 0 82 0 30 0 45 0 37 0 82 0 64 0 49 0 66]
#[1 0 170 0 1 0 170 0 6 0 170 0 9 0 170 0 10 0 170 0 11 0 170 0 12 0 170 0 14 0 170 0 15 0 170 0 16 0 170 0 17 0 170 0 20 0 170 0 21 0 170 0 22 0 170 0 23 0 170 0 29 0 170 0 30 0 53 0 46 0 57 0 59 0 170 0 64]
#[1 0 61 0 20 0 65 0 29 0 69 0 57]
#[1 0 61 0 20 0 65 0 29 0 73 0 57]
#[1 0 170 0 1 0 170 0 6 0 170 0 9 0 170 0 10 0 170 0 11 0 170 0 12 0 170 0 14 0 170 0 15 0 170 0 16 0 170 0 17 0 170 0 20 0 170 0 21 0 170 0 22 0 170 0 23 0 77 0 24 0 170 0 29 0 170 0 30 0 53 0 46 0 81 0 59 0 170 0 64]
#[0 0 0 0 64]
#[1 0 170 0 1 0 170 0 6 0 170 0 9 0 170 0 10 0 170 0 11 0 170 0 12 0 170 0 14 0 170 0 15 0 170 0 16 0 170 0 17 0 170 0 20 0 170 0 21 0 170 0 22 0 170 0 23 0 170 0 29 0 170 0 30 0 53 0 46 0 85 0 59 0 170 0 64]
#[1 0 58 0 9 0 58 0 20 0 58 0 29 0 89 0 35]
#[0 0 86 0 1 0 10 0 11 0 12 0 14 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 29 0 30 0 64]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 113 0 16 0 117 0 17 0 66 0 19 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 0 137 0 36 0 141 0 38 0 145 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 66 0 64 0 181 0 68]
#[0 0 0 0 64]
#[1 0 93 0 1 0 185 0 6 0 189 0 9 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 193 0 15 0 113 0 16 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 0 197 0 36 0 141 0 38 0 145 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 66 0 64 0 181 0 68]
#[0 1 2 0 64]
#[0 1 14 0 1 0 2 0 4 0 5 0 6 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 29 0 30 0 64]
#[0 1 18 0 1 0 2 0 4 0 5 0 6 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 26 0 29 0 30 0 64]
#[0 0 50 0 1 0 6 0 9 0 10 0 11 0 12 0 14 0 15 0 16 0 17 0 20 0 21 0 22 0 23 0 24 0 29 0 30 0 64]
#[0 1 22 0 1 0 6 0 9 0 10 0 11 0 12 0 14 0 15 0 16 0 17 0 20 0 21 0 22 0 23 0 29 0 30 0 64]
#[1 0 61 0 20 0 65 0 29 0 201 0 57]
#[0 1 10 0 64]
#[0 1 6 0 64]
#[1 0 205 0 9 0 61 0 20 0 65 0 29 0 209 0 57]
#[1 0 213 0 3 0 217 0 10 0 221 0 17 0 225 0 20 0 229 0 23 0 233 0 24 0 237 0 25 0 241 0 26]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 0 245 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 181 0 68]
#[0 1 126 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 130 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 134 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 0 249 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 181 0 68]
#[1 0 82 0 1 0 37 0 9 0 82 0 10 0 82 0 11 0 82 0 12 0 82 0 14 0 41 0 15 0 82 0 16 0 82 0 17 0 253 0 18 0 82 0 19 0 82 0 20 0 82 0 21 0 82 0 22 0 82 0 23 0 82 0 29 0 82 0 30 0 45 0 37 1 1 0 41 1 5 0 66]
#[0 1 138 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 142 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 150 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 146 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 118 0 19 0 64]
#[1 1 9 0 5 0 102 0 19 1 13 0 39 0 102 0 64]
#[0 0 94 0 5 0 19 0 64]
#[0 1 114 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[0 0 114 0 4 0 5 0 19 0 64]
#[1 0 162 0 2 0 162 0 4 0 162 0 5 0 162 0 19 1 17 0 45 0 162 0 64]
#[0 0 150 0 2 0 4 0 5 0 19 0 64]
#[1 0 154 0 2 0 154 0 4 0 154 0 5 0 154 0 19 1 21 0 24 1 25 0 26 1 29 0 52 1 33 0 53 0 154 0 64]
#[1 0 158 0 2 0 158 0 4 0 158 0 5 0 158 0 19 1 37 0 20 1 21 0 24 1 25 0 26 1 41 0 51 1 45 0 52 1 49 0 53 0 158 0 64]
#[1 1 110 0 4 1 110 0 5 1 53 0 13 1 110 0 19 1 110 0 20 1 110 0 24 1 110 0 26 1 110 0 64]
#[1 0 146 0 4 0 146 0 5 0 146 0 19 1 37 0 20 1 21 0 24 1 25 0 26 1 57 0 51 1 61 0 52 1 65 0 53 0 146 0 64]
#[0 1 106 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[1 0 6 0 1 0 6 0 2 0 6 0 3 0 6 0 4 0 6 0 5 0 6 0 7 0 6 0 8 0 6 0 10 0 6 0 11 0 6 0 12 0 6 0 14 0 6 0 20 0 6 0 21 0 6 0 22 0 6 0 23 0 6 0 24 0 6 0 26 0 6 0 30 1 69 0 33]
#[1 0 58 0 9 0 58 0 20 0 58 0 29 1 73 0 35]
#[1 0 170 0 1 0 170 0 6 0 170 0 10 0 170 0 11 0 170 0 12 0 170 0 14 0 170 0 16 0 170 0 17 0 170 0 20 0 170 0 21 0 170 0 22 0 170 0 23 0 170 0 29 0 170 0 30 1 77 0 46 0 170 0 64]
#[0 1 34 0 64]
#[0 0 54 0 1 0 6 0 9 0 10 0 11 0 12 0 14 0 15 0 16 0 17 0 20 0 21 0 22 0 23 0 24 0 29 0 30 0 64]
#[0 0 90 0 1 0 10 0 11 0 12 0 14 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 29 0 30 0 64]
#[0 0 62 0 9 0 20 0 29]
#[1 1 81 0 20 1 85 0 29]
#[1 1 46 0 1 1 46 0 3 1 46 0 4 1 46 0 10 1 46 0 11 1 46 0 12 1 46 0 14 1 46 0 17 1 46 0 20 1 46 0 21 1 46 0 22 1 46 0 23 1 46 0 24 1 46 0 25 1 46 0 26 1 46 0 29 1 46 0 30 1 46 0 32 1 89 0 61]
#[1 1 38 0 19 1 38 0 21 1 93 0 60]
#[0 1 158 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 154 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 170 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 162 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 97 0 4]
#[1 1 101 0 5 0 102 0 19 1 105 0 39 0 102 0 64]
#[1 0 61 0 20 0 65 0 29 1 109 0 57]
#[1 1 113 0 9 1 117 0 15 1 121 0 18 1 125 0 19]
#[0 1 129 0 19]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 1 133 0 16 0 117 0 17 0 106 0 19 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 1 137 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 106 0 64 0 181 0 68]
#[0 0 70 0 19 0 64]
#[1 1 141 0 2 0 142 0 4 0 142 0 5 0 142 0 19 0 142 0 64]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 0 149 0 42 1 145 0 48 1 149 0 49 1 153 0 54 1 157 0 57 1 161 0 63 0 181 0 68]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 0 149 0 42 1 165 0 49 1 169 0 55 1 157 0 57 1 173 0 63 0 181 0 68]
#[0 0 190 0 2 0 4 0 5 0 19 0 24 0 26 0 64]
#[1 0 178 0 2 0 178 0 4 0 178 0 5 0 178 0 19 1 177 0 24 0 178 0 64]
#[0 0 222 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[0 0 202 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[0 0 194 0 2 0 4 0 5 0 19 0 24 0 26 0 64]
#[1 0 182 0 2 0 182 0 4 0 182 0 5 0 182 0 19 1 177 0 24 0 182 0 64]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 1 181 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 181 0 68]
#[0 0 206 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[0 0 198 0 2 0 4 0 5 0 19 0 24 0 26 0 64]
#[1 0 186 0 2 0 186 0 4 0 186 0 5 0 186 0 19 1 177 0 24 0 186 0 64]
#[1 0 93 0 1 1 185 0 2 1 189 0 3 1 193 0 4 1 197 0 5 1 201 0 7 1 205 0 8 1 209 0 10 0 101 0 11 0 105 0 12 0 109 0 14 1 213 0 20 0 121 0 21 0 125 0 22 0 129 0 23 1 217 0 24 1 221 0 26 0 133 0 30 1 225 0 68]
#[1 1 229 0 9 0 61 0 20 0 65 0 29 0 209 0 57]
#[1 0 93 0 1 0 185 0 6 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 113 0 16 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 1 233 0 36 0 141 0 38 0 145 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 66 0 64 0 181 0 68]
#[0 1 237 0 8]
#[0 1 241 0 8]
#[1 0 93 0 1 1 245 0 3 1 249 0 4 1 253 0 10 0 101 0 11 0 105 0 12 0 109 0 14 2 1 0 17 2 5 0 20 0 121 0 21 0 125 0 22 0 129 0 23 2 9 0 24 2 13 0 25 2 17 0 26 2 21 0 29 0 133 0 30 2 25 0 32 2 29 0 62 2 33 0 68]
#[1 2 37 0 19 2 41 0 21]
#[0 1 102 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[0 0 106 0 19 0 64]
#[0 0 78 0 19 0 64]
#[0 0 118 0 9 0 15 0 18 0 19]
#[1 0 82 0 1 0 37 0 9 0 82 0 10 0 82 0 11 0 82 0 12 0 82 0 14 0 41 0 15 0 82 0 16 0 82 0 17 0 82 0 19 0 82 0 20 0 82 0 21 0 82 0 22 0 82 0 23 0 82 0 29 0 82 0 30 0 45 0 37 2 45 0 66]
#[1 0 58 0 9 0 58 0 20 0 58 0 29 2 49 0 35]
#[1 0 61 0 20 0 65 0 29 2 53 0 57]
#[0 0 134 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[0 0 130 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 2 57 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 181 0 68]
#[0 0 98 0 5 0 19 0 64]
#[1 1 37 0 20 1 21 0 24 1 25 0 26 2 61 0 50 2 65 0 51 2 69 0 52 2 73 0 53]
#[1 0 238 0 2 0 238 0 4 0 238 0 5 0 238 0 19 0 238 0 24 1 25 0 26 1 29 0 52 0 238 0 64]
#[1 0 242 0 2 0 242 0 4 0 242 0 5 0 242 0 19 1 37 0 20 0 242 0 24 1 25 0 26 1 41 0 51 1 45 0 52 0 242 0 64]
#[0 0 230 0 2 0 4 0 5 0 19 0 24 0 64]
#[0 1 110 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[1 0 246 0 2 0 246 0 4 0 246 0 5 0 246 0 19 1 37 0 20 0 246 0 24 1 25 0 26 1 57 0 51 1 61 0 52 0 246 0 64]
#[1 0 250 0 2 0 250 0 4 0 250 0 5 0 250 0 19 1 37 0 20 0 250 0 24 0 250 0 26 1 41 0 51 0 250 0 64]
#[0 0 226 0 2 0 4 0 5 0 19 0 24 0 26 0 64]
#[1 0 254 0 2 0 254 0 4 0 254 0 5 0 254 0 19 1 37 0 20 0 254 0 24 0 254 0 26 1 57 0 51 0 254 0 64]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 0 149 0 42 1 145 0 48 1 149 0 49 2 77 0 54 1 157 0 57 1 161 0 63 0 181 0 68]
#[0 0 110 0 4 0 5 0 19 0 64]
#[0 0 34 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 26 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 22 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 38 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 174 0 1 0 6 0 9 0 10 0 11 0 12 0 14 0 15 0 16 0 17 0 20 0 21 0 22 0 23 0 29 0 30 0 64]
#[0 0 30 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 18 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 42 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 10 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 46 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[0 0 14 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 20 0 21 0 22 0 23 0 24 0 26 0 30]
#[1 0 170 0 1 0 170 0 6 0 170 0 10 0 170 0 11 0 170 0 12 0 170 0 14 0 170 0 16 0 170 0 17 0 170 0 20 0 170 0 21 0 170 0 22 0 170 0 23 0 170 0 29 0 170 0 30 2 81 0 46 0 170 0 64]
#[0 1 30 0 64]
#[0 1 182 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 186 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[1 2 85 0 20 2 89 0 29]
#[0 1 178 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[1 1 46 0 1 1 46 0 3 1 46 0 4 1 46 0 10 1 46 0 11 1 46 0 12 1 46 0 14 1 46 0 17 1 46 0 20 1 46 0 21 1 46 0 22 1 46 0 23 1 46 0 24 1 46 0 25 1 46 0 26 1 46 0 29 1 46 0 30 1 46 0 32 2 93 0 61]
#[1 1 38 0 19 1 38 0 21 2 97 0 60]
#[1 1 62 0 1 1 62 0 3 1 62 0 4 1 62 0 10 1 62 0 11 1 62 0 12 2 101 0 13 1 62 0 14 1 62 0 17 1 62 0 20 1 62 0 21 1 62 0 22 1 62 0 23 1 62 0 24 1 62 0 25 1 62 0 26 1 62 0 29 1 62 0 30 1 62 0 32]
#[0 1 70 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 74 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 66 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 98 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 94 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 50 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 58 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 174 0 1 0 2 0 3 0 4 0 5 0 7 0 8 0 10 0 11 0 12 0 14 0 17 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32 0 64]
#[0 1 42 0 19 0 21]
#[0 2 105 0 19]
#[1 2 109 0 9 0 61 0 20 0 65 0 29 0 209 0 57]
#[0 0 122 0 9 0 15 0 18 0 19]
#[1 1 101 0 5 0 102 0 19 2 113 0 39 0 102 0 64]
#[0 0 166 0 2 0 4 0 5 0 19 0 64]
#[0 0 210 0 2 0 4 0 5 0 19 0 64]
#[0 0 214 0 2 0 4 0 5 0 19 0 64]
#[1 0 218 0 2 0 218 0 4 0 218 0 5 0 218 0 19 1 177 0 24 0 218 0 64]
#[0 0 234 0 2 0 4 0 5 0 19 0 24 0 64]
#[1 0 93 0 1 0 185 0 6 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 113 0 16 0 117 0 17 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 2 117 0 36 0 141 0 38 0 145 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 66 0 64 0 181 0 68]
#[0 2 121 0 8]
#[0 2 125 0 8]
#[1 0 93 0 1 1 245 0 3 2 129 0 4 1 253 0 10 0 101 0 11 0 105 0 12 0 109 0 14 2 1 0 17 2 5 0 20 0 121 0 21 0 125 0 22 0 129 0 23 2 9 0 24 2 13 0 25 2 17 0 26 2 21 0 29 0 133 0 30 2 25 0 32 2 29 0 62 2 33 0 68]
#[1 2 133 0 19 2 41 0 21]
#[0 1 54 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 0 126 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
#[1 0 93 0 1 0 97 0 10 0 101 0 11 0 105 0 12 0 109 0 14 0 113 0 16 0 117 0 17 0 66 0 19 0 61 0 20 0 121 0 21 0 125 0 22 0 129 0 23 0 65 0 29 0 133 0 30 2 137 0 36 0 141 0 38 0 145 0 40 0 149 0 42 0 153 0 43 0 157 0 44 0 161 0 47 0 165 0 48 0 169 0 49 0 173 0 57 0 177 0 63 0 181 0 68]
#[0 0 74 0 19 0 64]
#[0 1 26 0 64]
#[0 1 78 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 82 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 86 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 1 90 0 1 0 3 0 4 0 10 0 11 0 12 0 14 0 17 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 29 0 30 0 32]
#[0 2 141 0 19]
#[0 0 138 0 2 0 4 0 5 0 19 0 20 0 24 0 26 0 64]
)! !

SmaCCParser subclass: #TestParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

Object subclass: #ParserRecompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-Tests'!

!ParserRecompiler classSide methodsFor: 'public' stamp: 'lr 1/8/2007 22:45'!
bootstrap
	| scanner grammer |
	scanner := self
		buildScanner: SmaCCScannerScanner
		andParser: SmaCCScannerParser.
	grammer := self
		buildScanner: SmaCCGrammarScanner
		andParser: SmaCCGrammarParser.
	scanner compileChanges.
	grammer compileChanges! !

!ParserRecompiler classSide methodsFor: 'private' stamp: 'lr 1/22/2007 13:12'!
buildScanner: aScannerClass andParser: aParserClass
	| parserCompiler |
	parserCompiler := SmaCCGrammarCompiler new.
	parserCompiler
		buildScanner: (self
			definitionFrom: aScannerClass
			selector: #scannerDefinitionComment)
		andParser: (self
			definitionFrom: aParserClass
			selector: #parserDefinitionComment).
	parserCompiler
		scannerClass: aScannerClass;
		parserClass: aParserClass.
	[ parserCompiler
		createChanges;
		compileDefinitionComments ]
			on: SmaCCCompilationNotification
			do: [ :notification |
				Transcript show: notification messageText; cr.
				notification resume ].
	^ parserCompiler! !

!ParserRecompiler classSide methodsFor: 'private' stamp: 'lr 1/6/2007 22:50'!
definitionFrom: aClass selector: aSymbol
	| source input output |
	source := aClass class sourceCodeAt: aSymbol.
	input := ReadStream on: source.
	output := WriteStream with: String new.
	input upTo: $".
	[ input atEnd ] whileFalse: [
		(input peekFor: $")
			ifTrue: [ output nextPut: $" ].
		output nextPutAll: (input upTo: $") ].
	^ output contents! !

!ParserRecompiler classSide methodsFor: 'public' stamp: 'lr 1/8/2007 11:54'!
examples
	| class |
	#( CParser JavaParser StParser ) do: [ :each |
		class := Smalltalk classNamed: each.
		(self
			buildScanner: class scannerClass
			andParser: class)
				compileChanges ]! !

Object subclass: #SmaCCAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCAction commentStamp: 'jmb' prior: 0!
SmaCCAction is an abstract class that represents an action in the LR parsing table.

Subclasses must implement the following messages:
	accessing
		id!

SmaCCAction subclass: #SmaCCAcceptAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCAcceptAction commentStamp: 'jmb' prior: 0!
SmaCCAcceptAction represents an accept action in the parser (i.e., we have parsed a valid string).!

!SmaCCAcceptAction methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
id
	^2r00! !

!SmaCCAction methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
id
	^self subclassResponsibility! !

!SmaCCAction methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isReduce
	^false! !

!SmaCCAction methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isShift
	^false! !

SmaCCAction subclass: #SmaCCReduceAction
	instanceVariableNames: 'symbol rhs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCReduceAction commentStamp: 'jmb' prior: 0!
SmaCCReduceAction represents a reduce action in our parser's table.

Instance Variables:
	rhs	<SmaCCRHS>	the rhs that is being reduced
	symbol	<SmaCCNonTerminalSymbol>	the symbol that has the rhs!

!SmaCCReduceAction classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
symbol: aSmaCCSymbol rhs: aSmaCCRHS 
	^(self new)
		symbol: aSmaCCSymbol rhs: aSmaCCRHS;
		yourself! !

!SmaCCReduceAction methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
id
	^2r10! !

!SmaCCReduceAction methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isReduce
	^true! !

!SmaCCReduceAction methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
rhs
	^rhs! !

!SmaCCReduceAction methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
size
	^rhs size! !

!SmaCCReduceAction methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
symbol
	^symbol! !

!SmaCCReduceAction methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
symbol: aSmaCCSymbol rhs: aSmaCCRHS
	rhs := aSmaCCRHS.
	symbol := aSmaCCSymbol! !

SmaCCAction subclass: #SmaCCRejectAction
	instanceVariableNames: ''
	classVariableNames: 'Reject'
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCRejectAction commentStamp: 'jmb' prior: 0!
SmaCCRejectAction represents a reject action in the parsing tables.!

!SmaCCRejectAction classSide methodsFor: 'class initialization' stamp: ' 6/1/07 21:19'!
initialize
	Reject := self basicNew! !

!SmaCCRejectAction classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
new
	^Reject! !

!SmaCCRejectAction classSide methodsFor: 'class initialization' stamp: ' 6/1/07 21:19'!
releaseObjects
	Reject := nil! !

!SmaCCRejectAction methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
id
	^2r11! !

SmaCCAction subclass: #SmaCCShiftAction
	instanceVariableNames: ''
	classVariableNames: 'Shift'
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCShiftAction commentStamp: 'jmb' prior: 0!
SmaCCShiftAction represents a shift action in the parser's tables.!

!SmaCCShiftAction classSide methodsFor: 'class initialization' stamp: ' 6/1/07 21:19'!
initialize
	Shift := self basicNew! !

!SmaCCShiftAction classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
new
	^Shift! !

!SmaCCShiftAction classSide methodsFor: 'class initialization' stamp: ' 6/1/07 21:19'!
releaseObjects
	Shift := nil! !

!SmaCCShiftAction methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
id
	^2r01! !

!SmaCCShiftAction methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isShift
	^true! !

Object subclass: #SmaCCEdge
	instanceVariableNames: 'toNode transitionObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCEdge commentStamp: '<historical>' prior: 0!
SmaCCEdge represents a transition in a Finite Automata (directed graph). It is labeled with the characters or states (possibly none, indicating an epsilon transition) that cause the transition.

Instance Variables:
	toNode	<SmaCCNode>	The node that this is transitioning to.
	transitionObjects	<SortedCollection of: (Character | Symbol)>	The characters or symbols that cause the transition. Note that there are no duplicates and all characters/symbols are sorted.!

SmaCCEdge subclass: #SmaCCCharacterEdge
	instanceVariableNames: ''
	classVariableNames: 'IsExpressions'
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCCharacterEdge commentStamp: '<historical>' prior: 0!
SmaCCCharacterEdge is a SmaCCEdge for Character transitions!

!SmaCCCharacterEdge classSide methodsFor: 'class initialization' stamp: 'lr 1/6/2007 22:50'!
generateCharacterSetFor: aSelector 
	| stream |
	stream := WriteStream with: String new.
	0 to: SmaCCGrammar maximumCharacterValue
		do: 
			[:i | 
			| ch |
			ch := Character value: i.
			(ch perform: aSelector) ifTrue: [stream nextPut: ch]].
	^stream contents! !

!SmaCCCharacterEdge classSide methodsFor: 'class initialization' stamp: 'lr 1/8/2007 23:30'!
initializeIsExpressions
	"Creates a map from sets of characters to selectors that start with 'is' on Character. This allows generated scanners to take
	full advantage of selectors that are already implemented on Character"

	IsExpressions := Dictionary new.
	"selectors := Character selectors select: 
					[:each | 
					('is*' match: each) 
						and: [each numArgs = 0 and: [(each at: 3) isUppercase]]].
	selectors do: 
			[:sel | 
			| string |
			string := self generateCharacterSetFor: sel.
			string isEmpty ifFalse: [IsExpressions at: string put: sel]]"! !

!SmaCCCharacterEdge methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
<= aSmaCCEdge 
	^self class = aSmaCCEdge class 
		and: [self transitionObjects <= aSmaCCEdge transitionObjects]! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
closestIsExpression
	"Attempts to find the #is selector that most closely matches the character set that this edge transitions on."

	| expressions closest |
	expressions := IsExpressions keys 
				select: [:each | each allSatisfy: [:ch | self includes: ch]].
	expressions isEmpty ifTrue: [^nil].
	closest := IsExpressions 
				at: (expressions asSortedCollection: [:a :b | a size > b size]) first.
	(self minMaxPairsWithout: closest) size 
		<= (self minMaxPairsWithout: nil) size ifFalse: [^nil].
	^closest! !

!SmaCCCharacterEdge methodsFor: 'private' stamp: ' 6/1/07 21:19'!
does: aSequenceableCollection include: anObject 
	| start stop mid |
	(anObject isKindOf: Character) ifFalse: [^false].
	start := 1.
	stop := aSequenceableCollection size.
	stop = 0 ifTrue: [^false].
	
	[mid := (start + stop) // 2.
	mid = start] whileFalse: 
				[(aSequenceableCollection at: mid) asInteger < anObject asInteger 
					ifTrue: [start := mid]
					ifFalse: [stop := mid]].
	^(aSequenceableCollection at: start) = anObject 
		or: [(aSequenceableCollection at: stop) = anObject]! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
edgeFrequencyUsingTable: frequencyTable 
	^self transitionObjects inject: 0
		into: [:sum :each | sum + (frequencyTable at: each asInteger \\ frequencyTable size + 1)]! !

!SmaCCCharacterEdge methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
edgeLabel
	^transitionObjects! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
expression
	| stream isSelector |
	stream := WriteStream with: String new.
	stream nextPut: $(.
	transitionObjects size = SmaCCGrammar maximumCharacterValue 
		ifTrue: [self outputInvertedMatchOn: stream]
		ifFalse: 
			[isSelector := self outputClosestIsMethodOn: stream.
			self outputExpressionOn: stream without: isSelector].
	stream nextPut: $).
	^stream contents! !

!SmaCCCharacterEdge methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isCharacterTransition
	^true! !

!SmaCCCharacterEdge methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
mergeWith: aSmaCCEdge 
	super mergeWith: aSmaCCEdge.
	transitionObjects := String withAll: (transitionObjects 
						asSortedCollection: [:a :b | a asInteger < b asInteger])! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
minMaxPairsWithout: aSelector 
	"Converts a list of characters into a collection of pairs representing the minimum and maximum of each sequence.
	The list is first filtered to include only those characters that fail aSelector."

	| start last pairs charsLeft |
	charsLeft := aSelector isNil 
				ifTrue: [transitionObjects]
				ifFalse: [transitionObjects reject: [:ch | ch perform: aSelector]].
	pairs := OrderedCollection new.
	charsLeft isEmpty ifTrue: [^pairs].
	last := charsLeft first.
	start := nil.
	charsLeft do: 
			[:each | 
			last asInteger + 1 = each asInteger 
				ifFalse: 
					[start notNil ifTrue: [pairs add: (Array with: start with: last)].
					start := each].
			last := each].
	pairs add: (Array with: start with: last).
	^pairs! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
outputClosestIsMethodOn: aStream 
	| expr |
	expr := self closestIsExpression.
	expr isNil ifFalse: [aStream nextPutAll: 'currentCharacter ' , expr].
	^expr! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
outputExpressionFor: aPair on: aStream 
	aPair first = aPair last 
		ifTrue: [^self outputMatchSingleCharacter: aPair first on: aStream].
	aPair first = (Character value: 0) 
		ifTrue: [^self outputMatchLessThan: aPair last on: aStream].
	aPair last = (Character value: SmaCCGrammar maximumCharacterValue) 
		ifTrue: [^self outputMatchGreaterThan: aPair first on: aStream].
	self outputMatchRange: aPair on: aStream! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
outputExpressionOn: aStream without: aSelector 
	| pairs |
	pairs := self minMaxPairsWithout: aSelector.
	pairs isEmpty ifTrue: [^self].
	aSelector notNil ifTrue: [aStream nextPutAll: ' or: ['].
	pairs do: [:each | self outputExpressionFor: each on: aStream]
		separatedBy: [aStream nextPutAll: ' or: ['].
	aStream next: pairs size - 1 put: $].
	aSelector notNil ifTrue: [aStream nextPut: $]]! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: 'lr 1/7/2007 11:16'!
outputInvertedMatchOn: aStream 
	| char |
	char := Character value: ((0 to: SmaCCGrammar maximumCharacterValue) 
						detect: [:each | (transitionObjects includes: (Character value: each)) not]).
	aStream
		nextPutAll: 'currentCharacter ~= ';
		nextPutAll: char storeString! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
outputMatchGreaterThan: aCharacter on: aStream 
	aStream
		nextPutAll: 'currentCharacter >= ';
		nextPutAll: aCharacter storeString! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
outputMatchLessThan: aCharacter on: aStream 
	aStream
		nextPutAll: 'currentCharacter <= ';
		nextPutAll: aCharacter storeString! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
outputMatchRange: aPair on: aStream 
	aStream
		nextPutAll: '(currentCharacter between: ';
		nextPutAll: aPair first storeString;
		nextPutAll: ' and: ';
		nextPutAll: aPair last storeString;
		nextPutAll: ')'! !

!SmaCCCharacterEdge methodsFor: 'compiling' stamp: 'lr 1/7/2007 11:16'!
outputMatchSingleCharacter: aCharacter on: aStream 
	aStream
		nextPutAll: 'currentCharacter = ';
		nextPutAll: aCharacter storeString! !

!SmaCCEdge classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
to: aSmaCCNode on: aCollectionOrNil 
	| edge |
	edge := self new.
	edge to: aSmaCCNode on: aCollectionOrNil.
	^edge! !

!SmaCCEdge methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
<= aSmaCCEdge 
	^true! !

!SmaCCEdge methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
= aSmaCCEdge 
	self class = aSmaCCEdge class ifFalse: [^false].
	^self to = aSmaCCEdge to and: [self transitionObjects = aSmaCCEdge transitionObjects]! !

!SmaCCEdge methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
canMergeWith: aSmaCCEdge 
	^self class = aSmaCCEdge class! !

!SmaCCEdge methodsFor: 'private' stamp: ' 6/1/07 21:19'!
does: aSequenceableCollection include: anObject 
	^aSequenceableCollection includes: anObject! !

!SmaCCEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
edgeFrequencyUsingTable: frequencyTable 
	^0! !

!SmaCCEdge methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
edgeLabel
	^transitionObjects isNil 
		ifTrue: ['epsilon']
		ifFalse: 
			[transitionObjects inject: '' into: [:sum :each | sum , each printString]]! !

!SmaCCEdge methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
hash
	^(self to hash bitShift: 14) bitXor: transitionObjects hash! !

!SmaCCEdge methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
includes: anObject 
	^self does: transitionObjects include: anObject! !

!SmaCCEdge methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isCharacterTransition
	^false! !

!SmaCCEdge methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isEmpty
	^transitionObjects isEmpty! !

!SmaCCEdge methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isEpsilonTransition
	^transitionObjects isNil! !

!SmaCCEdge methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
mergeWith: aSmaCCEdge 
	transitionObjects := Array 
				withAll: (transitionObjects , aSmaCCEdge transitionObjects) asSet 
						asSortedCollection! !

!SmaCCEdge methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	aStream
		nextPutAll: '---';
		nextPutAll: self edgeLabel;
		nextPutAll: '--->';
		nextPutAll: toNode printString! !

!SmaCCEdge methodsFor: 'private' stamp: ' 6/1/07 21:19'!
remove: aCollection 
	transitionObjects := transitionObjects 
				reject: [:each | self does: aCollection include: each]! !

!SmaCCEdge methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
to
	^toNode! !

!SmaCCEdge methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
to: aSmaCCNode 
	toNode := aSmaCCNode! !

!SmaCCEdge methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
to: aSmaCCNode on: aStringOrNil 
	toNode := aSmaCCNode.
	transitionObjects := aStringOrNil! !

!SmaCCEdge methodsFor: 'private' stamp: ' 6/1/07 21:19'!
transitionObjects
	^transitionObjects! !

SmaCCEdge subclass: #SmaCCStateEdge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCStateEdge commentStamp: '<historical>' prior: 0!
SmaCCStateEdge is a SmaCCEdge for Symbol (state) transitions
!

!SmaCCStateEdge methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
<= aSmaCCEdge 
	^self class ~= aSmaCCEdge class 
		or: [self transitionObjects first <= aSmaCCEdge transitionObjects first]! !

!SmaCCStateEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
edgeFrequencyUsingTable: frequencyTable 
	^SmallInteger maxVal * transitionObjects size! !

!SmaCCStateEdge methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
expression
	^transitionObjects size = 1 
		ifTrue: ['state == #' , transitionObjects asArray first]
		ifFalse: ['(' , transitionObjects asArray storeString , ' includes: state)']! !

Object subclass: #SmaCCGrammar
	instanceVariableNames: 'type shiftReduceTable symbols scannerDefinition otherStartingSymbols'
	classVariableNames: 'IgnoreCase MaximumCharacterValue'
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCGrammar commentStamp: '<historical>' prior: 0!
SmaCCGrammar represents a LR(1) or a LALR(1) grammar.

Instance Variables:
	otherStartingSymbols	<Collection of: SmaCCSymbol>	other starting productions. The first production in the grammar is the defaulting starting position, but this can list other starting positions.
	shiftReduceTable	<Dictionary key: SmaCCSymbol value: SmaCCAction class>	when we have a shift/reduce conflict how should we handle it. This table contains the left/right associative rules. Left is a reduce action and right is a shift action.
	symbols	<OrderedCollection of: SmaCCSymbol>	all symbols in our grammar -- includes both terminal and non-terminal
	tokens	<Dictionary key: String value: SmaCCRegularExpressionNode>	the tokens for our scanner
	type	<Symbol>	the type of grammar (LALR1 or LR1)

!

!SmaCCGrammar classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
allCharacters
	^String withAll: ((0 to: self maximumCharacterValue) 
				collect: [:each | Character value: each])! !

!SmaCCGrammar classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
ignoreCase
	^IgnoreCase! !

!SmaCCGrammar classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
ignoreCase: aBoolean 
	IgnoreCase := aBoolean! !

!SmaCCGrammar classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
implicitToken: aString 
	| symbol node |
	symbol := (aString copyFrom: 2 to: aString size - 1) asSymbol.
	(Character canUnderstand: symbol) ifFalse: [^nil].
	node := SmaCCCharacterRENode 
				characters: (self allCharacters select: [:each | each perform: symbol]).
	node position: SmallInteger maxVal.	"Implicit nodes have least precedence"
	^node! !

!SmaCCGrammar classSide methodsFor: 'class initialization' stamp: ' 6/1/07 21:19'!
initialize
	IgnoreCase := false.
	self maximumCharacterValue: 255! !

!SmaCCGrammar classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
maximumCharacterValue
	^MaximumCharacterValue! !

!SmaCCGrammar classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
maximumCharacterValue: anInteger 
	MaximumCharacterValue := anInteger.
	SmaCCCharacterEdge initializeIsExpressions! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addEmptySymbol
	self addSymbol: SmaCCSymbol empty.
	self addSymbol: SmaCCSymbol error! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addStartingSymbol: aSmaCCSymbol 
	(otherStartingSymbols includes: aSmaCCSymbol) 
		ifFalse: [otherStartingSymbols add: aSmaCCSymbol]! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
addSymbol: aSmaCCSymbol 
	^symbols add: aSmaCCSymbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
allStartingSymbols
	"Return all starting symbols with the default starting symbol listed first."

	| startingSymbols default |
	default := self startSymbol.
	startingSymbols := otherStartingSymbols copy.
	startingSymbols remove: default ifAbsent: [].
	startingSymbols := startingSymbols collect: 
					[:each | 
					(SmaCCStartingSymbol name: 'B e g i n' , each name)
						addProduction: ((SmaCCRHS new)
									add: each;
									yourself);
						yourself].
	startingSymbols addFirst: default.
	^startingSymbols! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
calculateFirstSets
	| changed |
	changed := true.
	[changed] whileTrue: 
			[changed := false.
			self symbols 
				do: [:each | changed := changed | each calculateFirstTerminals]]! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
emptySymbols
	^self symbols select: [:each | each isTerminal not and: [each isEmpty]]! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
initialItemSetFor: aSmaCCSymbol 
	^(aSmaCCSymbol asLRItemSet)
		type: type;
		yourself! !

!SmaCCGrammar methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	type := #LALR1.
	symbols := OrderedCollection new.
	shiftReduceTable := Dictionary new.
	otherStartingSymbols := OrderedCollection new! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
keywordRegularExpressionFor: aString 
	| regularExpressionString regex |
	regularExpressionString := (aString copyFrom: 2 to: aString size - 1) 
				copyReplaceAll: '""'
				with: '"'.
	regex := regularExpressionString inject: nil
				into: 
					[:sum :each | 
					sum isNil 
						ifTrue: [SmaCCCharacterRENode characters: (String with: each)]
						ifFalse: [sum , (SmaCCCharacterRENode characters: (String with: each))]].
	regex addStates: scannerDefinition states.
	^regex! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
keywordTerminalNamed: aString 
	^symbols detect: [:each | each name = aString]
		ifNone: 
			[symbols addFirst: ((SmaCCTerminalSymbol name: aString)
						regularExpression: (self keywordRegularExpressionFor: aString);
						yourself)]! !

!SmaCCGrammar methodsFor: 'precedence' stamp: ' 6/1/07 21:19'!
leftPrecedenceFor: aSmaCCSymbol 
	shiftReduceTable at: aSmaCCSymbol put: SmaCCReduceAction! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
makeGroupFor: aSmaCCRHSCollection 
	| symbol name |
	name := aSmaCCRHSCollection inject: ''
				into: [:sum :each | sum , ' | ' , each printString].
	symbol := self nonTerminalSymbolNamed: 'Group: ' , name.
	symbol isEmpty 
		ifTrue: 
			[(aSmaCCRHSCollection allSatisfy: [:each | each size = 1]) 
				ifTrue: [aSmaCCRHSCollection do: [:each | each reduceAction: '''1''']].
			aSmaCCRHSCollection do: [:each | symbol addProduction: each]].
	^symbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
makeOptionalSymbolFor: aSmaCCSymbol 
	| symbol |
	symbol := self nonTerminalSymbolNamed: 'Optional: ' , aSmaCCSymbol printString.
	symbol isEmpty 
		ifTrue: 
			[symbol
				addProduction: ((SmaCCRHS new)
							reduceAction: 'nil';
							yourself);
				addProduction: ((SmaCCRHS new)
							add: aSmaCCSymbol;
							reduceAction: '''1''';
							yourself)].
	^symbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
makeRepeatMultipleSymbolFor: aSmaCCSymbol 
	| symbol |
	symbol := self 
				nonTerminalSymbolNamed: 'Repeat Multiple: ' , aSmaCCSymbol printString.
	symbol isEmpty 
		ifTrue: 
			[symbol
				addProduction: ((SmaCCRHS new)
							add: aSmaCCSymbol;
							reduceAction: 'OrderedCollection with: ''1''';
							yourself);
				addProduction: ((SmaCCRHS new)
							add: symbol;
							add: aSmaCCSymbol;
							reduceAction: '''1'' add: ''2''; yourself';
							yourself)].
	^symbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
makeRepeatSymbolFor: aSmaCCSymbol 
	| symbol |
	symbol := self nonTerminalSymbolNamed: 'Repeat: ' , aSmaCCSymbol printString.
	symbol isEmpty 
		ifTrue: 
			[symbol
				addProduction: ((SmaCCRHS new)
							reduceAction: 'OrderedCollection new';
							yourself);
				addProduction: ((SmaCCRHS new)
							add: symbol;
							add: aSmaCCSymbol;
							reduceAction: '''1'' add: ''2''; yourself';
							yourself)].
	^symbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
makeTokenIdMethodFor: aString 
	| token |
	token := (scannerDefinition includesTokenNamed: aString) 
				ifTrue: [self terminalSymbolNamed: aString]
				ifFalse: 
					[symbols detect: [:each | each name = aString]
						ifNone: [symbols add: (SmaCCTerminalSymbol name: aString)]].
	token createIdMethod: true! !

!SmaCCGrammar methodsFor: 'precedence' stamp: ' 6/1/07 21:19'!
nonAssociativePrecedenceFor: aSmaCCSymbol 
	shiftReduceTable at: aSmaCCSymbol put: SmaCCRejectAction! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
nonTerminalSymbolNamed: aString 
	^symbols detect: [:each | each name = aString]
		ifNone: [self addSymbol: (SmaCCNonTerminalSymbol name: aString)]! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
preferredActionFor: aSmaCCSymbol 
	^shiftReduceTable at: aSmaCCSymbol ifAbsent: [nil]! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
reduceTableIndexFor: aSmaCCSymbol rhs: aSmaCCRHS 
	| index |
	index := 0.
	self symbols do: 
			[:each | 
			each = aSmaCCSymbol ifTrue: [^index + (each positionOf: aSmaCCRHS)].
			index := index + each size].
	^0! !

!SmaCCGrammar methodsFor: 'precedence' stamp: ' 6/1/07 21:19'!
rightPrecedenceFor: aSmaCCSymbol 
	shiftReduceTable at: aSmaCCSymbol put: SmaCCShiftAction! !

!SmaCCGrammar methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
scannerDefinition: aSmaCCScannerDefinition
	scannerDefinition := aSmaCCScannerDefinition! !

!SmaCCGrammar methodsFor: 'precedence' stamp: ' 6/1/07 21:19'!
setOperatorPrecedenceFor: aSmaCCSymbol to: anInteger
	aSmaCCSymbol precedence: anInteger! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
setStartSymbolIfNone: aSmaCCSymbol 
	| startSymbol |
	self startSymbol notNil ifTrue: [^self].
	startSymbol := SmaCCStartingSymbol name: 'B e g i n'.
	self addSymbol: startSymbol.
	startSymbol addProduction: ((SmaCCRHS new)
				add: aSmaCCSymbol;
				yourself)! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
startSymbol
	^symbols detect: [:each | each isStartingSymbol] ifNone: [nil]! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
symbols
	^symbols! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
symbols: aCollection
	symbols := aCollection! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
terminalSymbolNamed: aString 
	^symbols detect: [:each | each name = aString]
		ifNone: 
			[symbols add: ((SmaCCTerminalSymbol name: aString)
						regularExpression: (scannerDefinition tokenNamed: aString);
						yourself)]! !

!SmaCCGrammar methodsFor: 'private' stamp: ' 6/1/07 21:19'!
terminalSymbolNamed: aString ifAbsent: aBlock 
	^symbols detect: [:each | each name = aString]
		ifNone: 
			[symbols add: ((SmaCCTerminalSymbol name: aString)
						regularExpression: (scannerDefinition tokenNamed: aString
									ifAbsentPut: 
										[| node |
										node := self class implicitToken: aString.
										node isNil ifTrue: [^aBlock value].
										node addStates: scannerDefinition nonExcludeStates.
										node]);
						yourself)]! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
tokens
	^scannerDefinition tokens! !

!SmaCCGrammar methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
type: aSmaCCSymbol
	type := aSmaCCSymbol! !

!SmaCCGrammar methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
unusedSymbols
	| nonTerminals problemSymbols todo symbol |
	nonTerminals := self symbols reject: [:each | each isTerminal].
	problemSymbols := nonTerminals asSet.
	problemSymbols remove: self startSymbol.
	todo := OrderedCollection with: self startSymbol.
	[todo isEmpty] whileFalse: 
			[symbol := todo removeFirst.
			symbol productionsDo: 
					[:rhs | 
					rhs do: 
							[:each | 
							each isTerminal 
								ifFalse: 
									[(problemSymbols includes: each) 
										ifTrue: 
											[todo add: each.
											problemSymbols remove: each]]]]].
	^problemSymbols! !

Object subclass: #SmaCCGrammarCompiler
	instanceVariableNames: 'shiftTable itemSets startingStateMap actions parserClass parserDefinitionString scannerCompiler grammar model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCGrammarCompiler commentStamp: 'jmb' prior: 0!
SmaCCGrammarCompiler compiles a SmaCCGrammar.

Instance Variables:
	actions	<Array>	the action table for the parser. It contains the action (shift/reduce/accept/reject) for each possible state/symbol pair
	grammar	<SmaCCGrammar>	our grammar
	itemSets	<SequenceableCollection of: SmaCCItemSet>	the item sets for our grammar
	model	<RBNameSpace>	where we are compiling our changes into
	parserClass	<RBAbstractClass>	the parser class for our changes
	parserDefinitionString	<String>	the definition of our parser
	scannerCompiler	<SmaCCScannerCompiler>	a compiler for the scanner
	shiftTable	<Dictionary key: (Array with: Integer with: SmaCCSymbol) value: Integer>	a table mapping a state/symbol pair to the new state that is aquired by shifting the symbol
	startingStateMap	<Dictionary key: SmaCCSymbol value: Integer>	the state for SmaCCSymbol's starting item set

!

!SmaCCGrammarCompiler classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
new
	^self basicNew initialize! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
actionForState: anInteger on: aSmaCCSymbol 
	| action newStateIndex |
	action := (itemSets at: anInteger) action: aSmaCCSymbol
				prefer: (grammar preferredActionFor: aSmaCCSymbol).
	action isShift 
		ifTrue: 
			[newStateIndex := shiftTable 
						at: (Array with: anInteger with: aSmaCCSymbol).
			^(newStateIndex bitShift: 2) + action id].
	action isReduce 
		ifTrue: 
			[^((grammar reduceTableIndexFor: action symbol rhs: action rhs) 
				bitShift: 2) + action id].
	^action id! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
arrayTypeMask
	^self hasLiteralByteArrays ifTrue: [0] ifFalse: [2]! !

!SmaCCGrammarCompiler methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
buildScanner: scannerString andParser: parserString 
	| parser |
	scannerCompiler grammar: self grammar.
	scannerCompiler scannerDefinitionString: scannerString.
	parserDefinitionString := parserString.
	scannerCompiler parseTokens.
	parser := SmaCCGrammarParser on: (ReadStream on: parserString).
	parser grammar: grammar.
	parser parse! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
changes
	^model changes! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: 'lr 1/7/2007 11:08'!
checkFor: problemSymbols errorMessage: errorMessage 
	| stream |
	problemSymbols isEmpty ifTrue: [^self].
	stream := WriteStream with: String new.
	problemSymbols do: [:each | stream nextPutAll: each printString]
		separatedBy: [stream space].
	SmaCCCompilationNotification new
		tag: stream contents;
		signal: errorMessage! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: ' 6/1/07 21:19'!
checkForEmptySymbols
	self checkFor: grammar emptySymbols
		errorMessage: 'Missing non-terminal productions'! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: ' 6/1/07 21:19'!
checkForUnusedSymbols
	self checkFor: grammar unusedSymbols
		errorMessage: 'Unused non-terminal symbols'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'ThierryGoubier 3/10/2012 22:52'!
compileChanges
	RBRefactoryChangeManager instance performChange: self changes.
	scannerCompiler scannerClass realClass 
		ifNotNilDo: [:each | each initializeKeywordMap]! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
compileDefinitionComments
	scannerCompiler compileScannerDefinitionComment.
	self compileParserDefinitionComment! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
compileInto: sClass andParser: pClass 
	self scannerClass: sClass.
	self parserClass: pClass.
	self createChanges.
	self compileChanges! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'lr 11/25/2009 18:00'!
compileItemSetsComment
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'itemSetsComment';
		cr;
		cr;
		tab;
		nextPut: $";
		cr.
	itemSets keysAndValuesDo: 
			[:index :each | 
			stream
				nextPutAll: index printString;
				nextPutAll: (each printString copyReplaceAll: '"' with: '""');
				cr].
	stream nextPut: $".
	self parserClass theMetaClass compile: stream contents
		classified: #'generated-comments'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
compileParser
	self compileTransitionTable.
	self compileStartingStateIds.
	self compileReductionTable.
	self compileScannerClassIntoParser! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'lr 11/25/2009 18:00'!
compileParserDefinitionComment
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'parserDefinitionComment';
		cr;
		cr;
		tab;
		nextPut: $";
		nextPutAll: (parserDefinitionString copyReplaceAll: '"' with: '""');
		nextPut: $".
	parserClass theMetaClass compile: stream contents
		classified: #'generated-comments'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
compileReductionTable
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'reduceTable';
		cr;
		tab;
		nextPutAll: '^#(';
		cr.
	self reduceTable do: 
			[:each | 
			stream nextPutAll: '#('.
			each do: [:e | stream nextPutAll: e storeString]
				separatedBy: [stream space].
			stream
				nextPut: $);
				cr].
	stream nextPut: $).
	parserClass compile: stream contents classified: #'generated-tables'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
compileScanner
	scannerCompiler compileScanner! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'lr 11/25/2009 18:00'!
compileScannerClassIntoParser
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'scannerClass';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: scannerCompiler scannerClass name.
	self parserClass theMetaClass compile: stream contents
		classified: #'generated-accessing'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'lr 11/25/2009 18:00'!
compileStartingStateIds
	startingStateMap keysAndValuesDo: 
			[:symbol :position | 
			| stream |
			stream := WriteStream with: String new.
			stream
				nextPutAll: 'startingStateFor';
				nextPutAll: symbol compileName;
				cr;
				tab;
				nextPutAll: '^';
				nextPutAll: position printString.
			parserClass theMetaClass compile: stream contents
				classified: #'generated-starting states']! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'ThierryGoubier 6/14/2012 11:42'!
compileSymbolComment
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'symbolComment';
		cr;
		cr;
		tab;
		nextPut: $";
		cr.
	scannerCompiler symbols keysAndValuesDo: 
			[:index :each | 
			stream
				nextPutAll: index printString;
				nextPutAll: '. ';
				nextPutAll: (each printString copyReplaceAll: '"' with: '""');
				cr].
	stream nextPut: $".
	self parserClass theMetaClass compile: stream contents
		classified: #'generated-comments'! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
compileTransitionTable
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'transitionTable';
		cr;
		tab;
		nextPutAll: '^#(';
		cr.
	self transitionTable do: 
			[:each | 
			stream 
				nextPutAll: (self hasLiteralByteArrays ifTrue: ['#['] ifFalse: ['#(']).
			each do: [:byte | stream nextPutAll: byte printString]
				separatedBy: [stream nextPut: $ ].
			stream
				nextPut: (self hasLiteralByteArrays ifTrue: [$]] ifFalse: [$)]);
				cr].
	stream nextPut: $).
	parserClass compile: stream contents classified: #'generated-tables'! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
compressTable: table 
	^table collect: [:row | self compressTableRow: row]! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
compressTableRow: row 
	| uniqueItems |
	uniqueItems := self uniqueNonErrorActionsForTableRow: row.
	^uniqueItems size = 1 
		ifTrue: [self singleActionTableRow: row forAction: uniqueItems first]
		ifFalse: [self multipleActionTableRow: row]! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
compressedRowStream
	^WriteStream with: (self hasLiteralByteArrays 
				ifTrue: [ByteArray new]
				ifFalse: [Array new])! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
createChanges
	self removeOldMethods.
	self checkForEmptySymbols.
	self checkForUnusedSymbols.
	self compileScanner.
	self compileParser! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
createItemSets
	| itemSet newState index |
	startingStateMap := Dictionary new.
	grammar calculateFirstSets.
	itemSets := OrderedCollection new.
	grammar allStartingSymbols do: 
			[:each | 
			itemSets add: (grammar initialItemSetFor: each).
			startingStateMap at: each put: itemSets size].
	shiftTable := Dictionary new.
	index := 1.
	[index <= itemSets size] whileTrue: 
			[itemSet := itemSets at: index.
			grammar symbols do: 
					[:each | 
					newState := itemSet moveOn: each.
					newState notEmpty 
						ifTrue: 
							[shiftTable at: (Array with: index with: each)
								put: (self indexOfState: newState)]].
			index := index + 1]! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
createTransitionTable
	| table |
	table := (1 to: itemSets size) collect: 
					[:index | 
					scannerCompiler symbols 
						collect: [:each | self actionForState: index on: each]].
	actions := self compressTable: table! !

!SmaCCGrammarCompiler methodsFor: 'compiling' stamp: 'lr 1/6/2007 22:33'!
defineClass: aString asSubclassOf: aBehavior
	model defineClass: aBehavior name , ' subclass: #' , aString , ' instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: '''' '.
	^model classNamed: aString asSymbol! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: ' 6/1/07 21:19'!
generatedMethodsIn: aRBClass 
	^aRBClass selectors select: 
			[:each | 
			(aRBClass protocolsFor: each) 
				allSatisfy: [:protocol | protocol notNil and: ['generated*' match: protocol]]]! !

!SmaCCGrammarCompiler methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
grammar
	^grammar isNil ifTrue: [grammar := SmaCCGrammar new] ifFalse: [grammar]! !

!SmaCCGrammarCompiler methodsFor: 'testing' stamp: 'lr 11/25/2009 18:59'!
hasLiteralByteArrays
	"The #hasLiteralByteArrays wasn't meant to be changed without also changing the SmaCCParser #actionForState:and: and #binarySearchIn:for:size: methods. This issue is fixed now and the SmaCCParser can now handle both cases."

	^ true! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
indexOfState: newState 
	| newStateIndex |
	newStateIndex := itemSets indexOf: newState.
	newStateIndex = 0 
		ifTrue: 
			[itemSets add: newState.
			newStateIndex := itemSets size]
		ifFalse: [(itemSets at: newStateIndex) mergeWith: newState].
	^newStateIndex! !

!SmaCCGrammarCompiler methodsFor: 'initialize-release' stamp: 'lr 1/6/2007 21:55'!
initialize
	scannerCompiler := SmaCCScannerCompiler new.
	model := (RBNamespace new)
				name: 'Compile Scanner/Parser';
				yourself.
	startingStateMap := Dictionary new! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
multipleActionTableRow: row 
	| stream |
	stream := self compressedRowStream.
	stream nextPut: 1 + self arrayTypeMask.
	row keysAndValuesDo: 
			[:index :each | 
			each ~= 3 
				ifTrue: 
					[self writeInteger: each on: stream.
					self writeInteger: index on: stream]].
	^stream contents! !

!SmaCCGrammarCompiler methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
parserClass
	^parserClass! !

!SmaCCGrammarCompiler methodsFor: 'accessing' stamp: 'lr 1/7/2007 12:05'!
parserClass: aClassOrString 
	(aClassOrString isKindOf: Behavior) 
		ifTrue: [parserClass := model classFor: aClassOrString]
		ifFalse: 
			[parserClass := model classNamed: aClassOrString.
			parserClass isNil 
				ifTrue: [parserClass := self defineClass: aClassOrString asSubclassOf: SmaCCParser]]! !

!SmaCCGrammarCompiler methodsFor: 'reduction table' stamp: ' 6/1/07 21:19'!
reduceTable
	| table nonterminals |
	table := OrderedCollection new.
	nonterminals := scannerCompiler symbols reject: [:each | each isTerminal].
	nonterminals do: 
			[:each | 
			each productionsDo: 
					[:rhs | 
					table add: (Array 
								with: (scannerCompiler symbols indexOf: each)
								with: rhs size
								with: (rhs compileSourceFor: each in: parserClass))]].
	^table! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: 'lr 11/25/2009 18:00'!
removeOldMethods
	self
		removeOldMethodsFrom: scannerCompiler scannerClass;
		removeOldMethodsFrom: scannerCompiler scannerClass theMetaClass;
		removeOldMethodsFrom: parserClass;
		removeOldMethodsFrom: parserClass theMetaClass! !

!SmaCCGrammarCompiler methodsFor: 'private' stamp: ' 6/1/07 21:19'!
removeOldMethodsFrom: aRBClass 
	(self generatedMethodsIn: aRBClass) 
		do: [:each | aRBClass removeMethod: each]! !

!SmaCCGrammarCompiler methodsFor: 'accessing' stamp: 'lr 1/7/2007 12:05'!
scannerClass: aClassOrString 
	(aClassOrString isKindOf: Behavior) 
		ifTrue: [scannerCompiler scannerClass: (model classFor: aClassOrString)]
		ifFalse: 
			[scannerCompiler scannerClass: (model classNamed: aClassOrString).
			scannerCompiler scannerClass isNil 
				ifTrue: 
					[scannerCompiler 
						scannerClass: (self defineClass: aClassOrString asSubclassOf: SmaCCScanner)]]! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
singleActionTableRow: row forAction: anInteger 
	| stream |
	stream := self compressedRowStream.
	stream nextPut: 0 + self arrayTypeMask.
	self writeInteger: anInteger on: stream.
	row 
		keysAndValuesDo: [:index :each | each ~= 3 ifTrue: [self writeInteger: index on: stream]].
	^stream contents! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
transitionTable
	actions isNil 
		ifTrue: 
			[self createItemSets.
			self createTransitionTable].
	^actions! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
uniqueNonErrorActionsForTableRow: row 
	^(row asSet)
		remove: 3 ifAbsent: [];
		asArray! !

!SmaCCGrammarCompiler methodsFor: 'action table' stamp: ' 6/1/07 21:19'!
writeInteger: anInteger on: aStream 
	self hasLiteralByteArrays 
		ifTrue: 
			[aStream
				nextPut: (anInteger bitShift: -8);
				nextPut: (anInteger bitAnd: 16rFF)]
		ifFalse: [aStream nextPut: anInteger]! !

Object subclass: #SmaCCGraphAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCGraphAlgorithm commentStamp: '<historical>' prior: 0!
SmaCCGraphAlgorithm is an abstract class that has support for the graph transformation algorithms.

!

SmaCCGraphAlgorithm subclass: #SmaCCDuplicateNodeEliminator
	instanceVariableNames: 'comparisonState root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCDuplicateNodeEliminator commentStamp: '<historical>' prior: 0!
SmaCCDuplicateNodeEliminator removes duplicate nodes in a SmaCCNode graph.

Instance Variables:
	comparisonState	<Dictionary>	dictionary mapping equivalent nodes
	root	<SmaCCNode>	the root of the graph

!

!SmaCCDuplicateNodeEliminator classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
removeDuplicateNodesIn: aSmaCCNode 
	^self new removeDuplicateNodesIn: aSmaCCNode! !

!SmaCCDuplicateNodeEliminator methodsFor: 'algorithm' stamp: ' 6/1/07 21:19'!
isNode: firstSmaCCNode equivalentTo: secondSmaCCNode 
	| firstTransitions secondTransitions |
	firstSmaCCNode = secondSmaCCNode ifTrue: [^true].
	firstSmaCCNode transitions size = secondSmaCCNode transitions size 
		ifFalse: [^false].
	firstSmaCCNode action = secondSmaCCNode action ifFalse: [^false].
	((comparisonState at: firstSmaCCNode ifAbsent: [#()]) 
		includes: secondSmaCCNode) ifTrue: [^true].
	(comparisonState at: firstSmaCCNode ifAbsentPut: [Set new]) 
		add: secondSmaCCNode.
	(comparisonState at: secondSmaCCNode ifAbsentPut: [Set new]) 
		add: firstSmaCCNode.
	firstTransitions := firstSmaCCNode transitions 
				asSortedCollection: [:a :b | a transitionObjects first <= b transitionObjects first].
	secondTransitions := secondSmaCCNode transitions 
				asSortedCollection: [:a :b | a transitionObjects first <= b transitionObjects first].
	firstTransitions with: secondTransitions
		do: 
			[:first :second | 
			first transitionObjects = second transitionObjects ifFalse: [^false].
			(self isNode: first to equivalentTo: second to) ifFalse: [^false]].
	^true! !

!SmaCCDuplicateNodeEliminator methodsFor: 'algorithm' stamp: ' 6/1/07 21:19'!
mergeAllTransitions
	root allStates do: [:each | each mergeTransitions]! !

!SmaCCDuplicateNodeEliminator methodsFor: 'algorithm' stamp: ' 6/1/07 21:19'!
pairsDo: aBlock 
	| nodes |
	nodes := root allStates asOrderedCollection.
	1 to: nodes size - 1
		do: 
			[:i | 
			i + 1 to: nodes size
				do: [:j | aBlock value: (nodes at: i) value: (nodes at: j)]]! !

!SmaCCDuplicateNodeEliminator methodsFor: 'algorithm' stamp: ' 6/1/07 21:19'!
removeDuplicateNodesIn: aSmaCCNode 
	root := aSmaCCNode.
	self removeDuplicates.
	^root! !

!SmaCCDuplicateNodeEliminator methodsFor: 'algorithm' stamp: 'lr 1/8/2007 22:44'!
removeDuplicates
	| changed iterations |
	changed := true.
	iterations := root allStates size.
	[changed and: [iterations > 0]] whileTrue: 
			[changed := false.
			iterations := iterations - 1.
			self mergeAllTransitions.
			self pairsDo: 
					[:firstNode :secondNode | 
					comparisonState := Dictionary new.
					(self isNode: firstNode equivalentTo: secondNode) 
						ifTrue: 
							[firstNode mergeWith: secondNode.
							changed := true]]]! !

SmaCCGraphAlgorithm subclass: #SmaCCEpsilonRemoval
	instanceVariableNames: 'nodeMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCEpsilonRemoval commentStamp: '<historical>' prior: 0!
SmaCCEpsilonRemoval removes epsilon nodes from a NFA.

Instance Variables:
	nodeMap	<Dictionary>	Dictionary mapping sets of states to a new state in the new graph

!

!SmaCCEpsilonRemoval classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
removeEpsilonEdgesFrom: aSmaCCNode 
	"Returns an equivalent graph to aSmaCCNode that doesn't contain any epsilon transitions"

	^self new removeEpsilonEdgesFrom: aSmaCCNode! !

!SmaCCEpsilonRemoval methodsFor: 'algorithm' stamp: ' 6/1/07 21:19'!
createNodeWithoutEpsilonEdges: aSmaCCNode 
	| newNode newTransitions |
	newNode := self 
				createMergedNodeFrom: (self epsilonReachableNodesFrom: aSmaCCNode).
	nodeMap at: aSmaCCNode put: newNode.
	newTransitions := OrderedCollection new.
	newNode transitions do: 
			[:each | 
			each isEpsilonTransition 
				ifFalse: 
					[newTransitions add: (each class to: (self removeEpsilonEdgesFrom: each to)
								on: each transitionObjects)]].
	newNode transitions: newTransitions.
	^newNode! !

!SmaCCEpsilonRemoval methodsFor: 'algorithm' stamp: ' 6/1/07 21:19'!
epsilonReachableNodesFrom: aSmaCCNode 
	| todo reachable node |
	reachable := Set with: aSmaCCNode.
	todo := OrderedCollection with: aSmaCCNode.
	[todo notEmpty] whileTrue: 
			[node := todo removeLast.
			node transitions do: 
					[:each | 
					(each isEpsilonTransition and: [(reachable includes: each to) not]) 
						ifTrue: 
							[reachable add: each to.
							todo add: each to]]].
	^reachable! !

!SmaCCEpsilonRemoval methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	super initialize.
	nodeMap := Dictionary new! !

!SmaCCEpsilonRemoval methodsFor: 'algorithm' stamp: ' 6/1/07 21:19'!
removeEpsilonEdgesFrom: aSmaCCNode 
	^nodeMap at: aSmaCCNode
		ifAbsent: [self createNodeWithoutEpsilonEdges: aSmaCCNode]! !

!SmaCCGraphAlgorithm methodsFor: 'nodes' stamp: ' 6/1/07 21:19'!
createMergedNodeFrom: nodeCollection 
	| newNode |
	newNode := SmaCCNode new.
	self mergeTransitionsFrom: nodeCollection into: newNode.
	self mergeActionsFrom: nodeCollection into: newNode.
	^newNode! !

!SmaCCGraphAlgorithm methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize! !

!SmaCCGraphAlgorithm methodsFor: 'nodes' stamp: ' 6/1/07 21:19'!
mergeActionsFrom: nodeCollection into: aSmaCCNode 
	nodeCollection do: [:each | aSmaCCNode addActions: each action]! !

!SmaCCGraphAlgorithm methodsFor: 'nodes' stamp: ' 6/1/07 21:19'!
mergeTransitionsFrom: nodeCollection into: aSmaCCNode 
	| transitions |
	transitions := Set new.
	nodeCollection 
		do: [:each | each transitions do: [:edge | transitions add: edge copy]].
	aSmaCCNode transitions: transitions.
	aSmaCCNode mergeTransitions! !

SmaCCGraphAlgorithm subclass: #SmaCCNFAtoDFA
	instanceVariableNames: 'mergedStates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCNFAtoDFA commentStamp: '<historical>' prior: 0!
SmaCCNFAtoDFAAlgorithm converts an NFA without epsilon transitions into a DFA. If a node contains edges that lead to multiple nodes for the same character, then a new state is created that merges all states for the given character. 

Instance Variables:
	mergedStates	<Dictionary>	dictionary that maps a collection of states to the resulting merged state
!

!SmaCCNFAtoDFA classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
convertToDFA: aSmaCCNode 
	"Returns an equivalent DFA from the NFA specified by aSmaCCNode -- the NFA must not contain epsilon edges."

	^self new convertToDFA: aSmaCCNode! !

!SmaCCNFAtoDFA methodsFor: 'private-edges' stamp: ' 6/1/07 21:19'!
commonTransitionObjectsForEdges: edgeCollection 
	^edgeCollection inject: edgeCollection first transitionObjects
		into: [:sum :each | sum select: [:char | each includes: char]]! !

!SmaCCNFAtoDFA methodsFor: 'algorithm' stamp: ' 6/1/07 21:19'!
convertToDFA: aSmaCCNode 
	^self mergedNodeFor: (Array with: aSmaCCNode)! !

!SmaCCNFAtoDFA methodsFor: 'private-edges' stamp: ' 6/1/07 21:19'!
createEdgeMerging: conflictingEdgeCollection 
	| newNode common newEdge |
	newNode := self 
				mergedNodeFor: (conflictingEdgeCollection collect: [:each | each to]).
	common := self commonTransitionObjectsForEdges: conflictingEdgeCollection.
	newEdge := conflictingEdgeCollection first class to: newNode on: common.
	conflictingEdgeCollection do: [:each | each remove: common].
	^newEdge! !

!SmaCCNFAtoDFA methodsFor: 'private-merging nodes' stamp: ' 6/1/07 21:19'!
eliminateDuplicateTransitionsIn: aSmaCCNode 
	| newTransitions conflictingObject |
	newTransitions := aSmaCCNode transitions collect: [:each | each copy].
	
	[conflictingObject := self someDuplicateIn: newTransitions.
	conflictingObject notNil] 
			whileTrue: 
				[| conflictingEdges newEdge |
				conflictingEdges := newTransitions 
							select: [:each | each includes: conflictingObject].
				newEdge := self createEdgeMerging: conflictingEdges.
				newTransitions add: newEdge].
	self setTransitionsOn: aSmaCCNode to: newTransitions! !

!SmaCCNFAtoDFA methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	super initialize.
	mergedStates := Dictionary new! !

!SmaCCNFAtoDFA methodsFor: 'private-merging nodes' stamp: ' 6/1/07 21:19'!
mergedNodeFor: nodeCollection 
	| mergedNodes |
	mergedNodes := nodeCollection asSortedCollection asArray.
	^mergedStates at: mergedNodes
		ifAbsent: 
			[| newNode |
			newNode := self createMergedNodeFrom: mergedNodes.
			mergedStates
				at: mergedNodes put: newNode;
				at: (Array with: newNode) put: newNode.
			self eliminateDuplicateTransitionsIn: newNode.
			newNode]! !

!SmaCCNFAtoDFA methodsFor: 'private-edges' stamp: ' 6/1/07 21:19'!
setTransitionsOn: aSmaCCNode to: edgeCollection 
	aSmaCCNode transitions: (edgeCollection reject: [:each | each isEmpty]).
	aSmaCCNode transitions do: [:each | each to: (self convertToDFA: each to)]! !

!SmaCCNFAtoDFA methodsFor: 'private-edges' stamp: ' 6/1/07 21:19'!
someDuplicateIn: edgeCollection 
	| objects |
	objects := Set new.
	edgeCollection do: 
			[:edge | 
			edge transitionObjects do: [:each | (objects includes: each) ifTrue: [^each]].
			objects addAll: edge transitionObjects].
	^nil! !

Object subclass: #SmaCCLR1Item
	instanceVariableNames: 'rhs symbol location followers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCLR1Item commentStamp: 'jmb' prior: 0!
SmaCCLR1Item represents an item in a SmaCCItemSet.

Instance Variables:
	followers	<SmaCCSymbolSet>	all possible symbols that can follow this production in this state
	location	<Integer>	the position in the rhs of the production we are at
	rhs	<SmaCCRHS>	the rhs of the production
	symbol	<SmaCCSymbol>	the symbol for the production!

!SmaCCLR1Item classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
symbol: aSmaCCSymbol rhs: aSmaCCRHS follow: aSmaCCSymbolCollection 
	^(self new)
		symbol: aSmaCCSymbol
			rhs: aSmaCCRHS
			follow: aSmaCCSymbolCollection;
		yourself! !

!SmaCCLR1Item methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
= aSmaCCLR1Item 
	^self class == aSmaCCLR1Item class and: 
			[location = aSmaCCLR1Item location 
				and: [rhs == aSmaCCLR1Item rhs and: [symbol == aSmaCCLR1Item symbol]]]! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
action: aSmaCCSymbol 
	location > rhs size 
		ifTrue: 
			[(symbol isStartingSymbol and: [aSmaCCSymbol isEmptySymbol]) 
				ifTrue: [^SmaCCAcceptAction new].
			(followers includes: aSmaCCSymbol) 
				ifTrue: [^SmaCCReduceAction symbol: symbol rhs: rhs]]
		ifFalse: [(rhs at: location) = aSmaCCSymbol ifTrue: [^SmaCCShiftAction new]].
	^SmaCCRejectAction new! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
followers
	^followers! !

!SmaCCLR1Item methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
followers: aSmaCCSymbolSet 
	followers := aSmaCCSymbolSet! !

!SmaCCLR1Item methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
hash
	^(symbol identityHash bitXor: (location bitShift: 14)) 
		bitXor: rhs identityHash! !

!SmaCCLR1Item methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isLR1EqualTo: aSmaCCLR1Item 
	^self followers size = aSmaCCLR1Item followers size 
		and: [self followers allSatisfy: [:each | aSmaCCLR1Item followers includes: each]]! !

!SmaCCLR1Item methodsFor: 'private' stamp: ' 6/1/07 21:19'!
location
	^location! !

!SmaCCLR1Item methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
location: anInteger 
	location := anInteger! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
mergeWith: aSmaCCLR1Item 
	followers mergeWith: aSmaCCLR1Item followers! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
moveNext
	^(self copy)
		followers: (followers class basedOn: followers);
		location: location + 1;
		yourself! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
nextSymbol
	^location > rhs size 
		ifTrue: [SmaCCSymbol sentinel]
		ifFalse: [rhs at: location]! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
precedence
	"If we don't have a precedence, then assume we are the lowest precedence (which will cause a shift action)."

	| max |
	max := -1.
	rhs do: [:each | max := max max: (each precedence ifNil: [max])].
	^max! !

!SmaCCLR1Item methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	| i |
	aStream
		nextPut: $[;
		nextPutAll: symbol printString;
		nextPutAll: ' :'.
	i := 1.
	rhs do: 
			[:each | 
			i = location ifTrue: [aStream nextPutAll: ' . '].
			aStream
				space;
				nextPutAll: each printString.
			i := i + 1].
	location > rhs size ifTrue: [aStream nextPutAll: ' . '].
	aStream nextPut: $;.
	followers printOn: aStream.
	aStream nextPut: $]! !

!SmaCCLR1Item methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
rest
	| newRHS |
	newRHS := SmaCCRHS new.
	location + 1 to: rhs size do: [:each | newRHS add: (rhs at: each)].
	^newRHS! !

!SmaCCLR1Item methodsFor: 'private' stamp: ' 6/1/07 21:19'!
rhs
	^rhs! !

!SmaCCLR1Item methodsFor: 'private' stamp: ' 6/1/07 21:19'!
symbol
	^symbol! !

!SmaCCLR1Item methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
symbol: aSmaCCSymbol rhs: aSmaCCRHS follow: aSmaCCSymbolCollection 
	symbol := aSmaCCSymbol.
	rhs := aSmaCCRHS.
	location := 1.
	followers := aSmaCCSymbolCollection! !

Object subclass: #SmaCCNode
	instanceVariableNames: 'transitions action id'
	classVariableNames: 'MaxSubNodesInMethod NextId'
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCNode commentStamp: '<historical>' prior: 0!
SmaCCNode is a node in a directed graph.

Instance Variables:
	action	<SequenceableCollection>	a collection of integers or a symbol. This contains the action to be performed when we match and can't find a longer match.
	id	<Integer>	a unique number that allows us to sort the nodes
	transitions	<Collection of: SmaCCEdge>	our transitions

!

!SmaCCNode classSide methodsFor: 'class initialization' stamp: ' 6/1/07 21:19'!
initialize
	NextId := 0.
	MaxSubNodesInMethod := 20! !

!SmaCCNode classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
maxSubNodesInMethod
	^MaxSubNodesInMethod! !

!SmaCCNode classSide methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
maxSubNodesInMethod: anInteger
	MaxSubNodesInMethod := anInteger! !

!SmaCCNode methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
<= aSmaCCNode 
	^self id <= aSmaCCNode id! !

!SmaCCNode methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
= anObject 
	^self class = anObject class and: [self id = anObject id]! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
action
	^action! !

!SmaCCNode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
action: anObject 
	anObject isNil ifTrue: [^self].
	action := anObject isSymbol 
				ifTrue: [anObject]
				ifFalse: [SortedCollection with: anObject]! !

!SmaCCNode methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
actionForSpecificRegularExpression: aSmaCCRegularExpression 
	| matchedAction strings |
	strings := aSmaCCRegularExpression possibleMatches.
	matchedAction := self simulate: (ReadStream on: strings first).
	strings 
		do: [:each | matchedAction = (self simulate: (ReadStream on: each)) ifFalse: [^nil]].
	^matchedAction! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
addActions: aCollection 
	aCollection isNil ifTrue: [^self].
	action isNil 
		ifTrue: 
			[action := aCollection copy.
			^self].
	action isSymbol ifTrue: [^self].
	aCollection isSymbol ifTrue: [^action := aCollection].
	aCollection 
		do: [:each | (action includes: each) ifFalse: [action add: each]]! !

!SmaCCNode methodsFor: 'edges' stamp: ' 6/1/07 21:19'!
addEdgeTo: aSmaCCNode 
	transitions add: (SmaCCEdge to: aSmaCCNode on: nil)! !

!SmaCCNode methodsFor: 'edges' stamp: ' 6/1/07 21:19'!
addEdgeTo: aSmaCCNode onCharacters: characterCollection 
	transitions add: (SmaCCCharacterEdge to: aSmaCCNode on: characterCollection)! !

!SmaCCNode methodsFor: 'edges' stamp: ' 6/1/07 21:19'!
addEdgeTo: aSmaCCNode onStates: symbolCollection 
	transitions add: (SmaCCStateEdge to: aSmaCCNode on: symbolCollection)! !

!SmaCCNode methodsFor: 'compiling' stamp: 'lr 1/7/2007 11:22'!
addImplementationSpecificRewritesTo: rewriter! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
allStates
	| nodes |
	nodes := Set new.
	self allStatesInto: nodes.
	^nodes! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
allStatesInto: aSet 
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	transitions do: [:each | each to allStatesInto: aSet]! !

!SmaCCNode methodsFor: 'converting' stamp: ' 6/1/07 21:19'!
asDFA
	| new |
	new := (SmaCCNFAtoDFA convertToDFA: self asNFAWithoutEpsilonTransitions) 
				startingNodeWithoutUnnecessaryDefaultTransition.
	new removeDuplicateNodes.
	^new! !

!SmaCCNode methodsFor: 'converting' stamp: ' 6/1/07 21:19'!
asNFAWithoutEpsilonTransitions
	^SmaCCEpsilonRemoval removeEpsilonEdgesFrom: self! !

!SmaCCNode methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
asStatement: methodMap usingSelectorMap: aDictionary forClass: aClass 
	| stream |
	stream := WriteStream with: String new.
	self hasSimpleLoop ifTrue: [stream nextPut: $[].
	self writeMatchingCodeOn: stream usingSelectorMap: aDictionary.
	(self sortedTransitionsFor: aClass) do: 
			[:each | 
			each to = self 
				ifTrue: 
					[stream
						nextPutAll: each expression;
						nextPut: $];
						nextPutAll: ' whileTrue.';
						cr]
				ifFalse: 
					[stream
						nextPutAll: each expression;
						nextPutAll: ' ifTrue: ['.
					stream
						nextPutAll: (methodMap at: each to
									ifAbsentPut: 
										[each to 
											asStatement: methodMap
											usingSelectorMap: aDictionary
											forClass: aClass]);
						nextPutAll: '].';
						cr]].
	(transitions notEmpty or: [action isNil]) 
		ifTrue: 
			[stream
				nextPutAll: '^self reportLastMatch';
				cr].
	^stream contents! !

!SmaCCNode methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
compileInto: aClass usingSelectorMap: aDictionary 
	| methodNodes methodMap index |
	methodNodes := self statesToMakeIntoMethods.
	methodMap := self methodNameMapFor: methodNodes.
	index := 0.
	methodNodes do: 
			[:each | 
			| stream |
			stream := WriteStream with: String new.
			stream
				nextPutAll: (each = self 
							ifTrue: ['scanForToken']
							ifFalse: ['scan' , (index := index + 1) printString]);
				cr.
			stream nextPutAll: (each 
						asStatement: methodMap
						usingSelectorMap: aDictionary
						forClass: aClass).
			aClass 
				compile: (self optimizedParseTreeFor: stream contents) formattedCode
				classified: #'generated-scanner']! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
groupedTransitions
	^transitions inject: OrderedCollection new
		into: 
			[:sum :each | 
			(sum detect: [:edgeCollection | edgeCollection first canMergeWith: each]
				ifNone: [sum add: OrderedCollection new]) add: each.
			sum]! !

!SmaCCNode methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
hasSimpleLoop
	^transitions anySatisfy: [:each | each to = self]! !

!SmaCCNode methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
hash
	^id bitShift: 4! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
id
	^id! !

!SmaCCNode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	id := NextId := NextId + 1.
	transitions := SortedCollection new! !

!SmaCCNode methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isTerminalNode
	^transitions isEmpty or: [transitions size = 1 and: [self hasSimpleLoop]]! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
mergeTransitions
	self groupedTransitions do: 
			[:edges | 
			| toMap |
			toMap := Dictionary new.
			edges do: 
					[:each | 
					(toMap includesKey: each to) 
						ifTrue: 
							[(toMap at: each to) mergeWith: each.
							transitions remove: each]
						ifFalse: [toMap at: each to put: each]]]! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
mergeWith: aSmaCCNode 
	id := aSmaCCNode id.
	transitions := aSmaCCNode transitions.
	action := aSmaCCNode action! !

!SmaCCNode methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
methodNameMapFor: methodNodes 
	| index methodMap |
	methodMap := Dictionary new.
	index := 0.
	methodNodes do: 
			[:value | 
			methodMap at: value
				put: (value = self 
						ifTrue: ['^self scanForToken']
						ifFalse: ['^self scan' , (index := index + 1) printString])].
	^methodMap! !

!SmaCCNode methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
needsSeparateMethod
	^self allStates size > MaxSubNodesInMethod! !

!SmaCCNode methodsFor: 'compiling' stamp: 'lr 11/25/2009 18:01'!
optimizationRewriter
	| rewriter |
	rewriter := RBParseTreeRewriter new.
	rewriter
		replace: '`@.Stmts1.
				[`@.Stmts2.
				currentCharacter ~~ `#l] whileTrue.
				currentCharacter == `#l ifTrue: [`@.Stmts3].
				`@.Stmts4'
			with: '`@.Stmts1.
				[`@.Stmts2.
				currentCharacter ~~ `#l] whileTrue.
				`@.Stmts3';
		replaceMethod: '`name
							`@.Stmts1.
							`@a ifTrue: [	^self `name].
							`@.Stmts3'
			with: '`name
				[`@.Stmts1.
				`@a] whileTrue.
				`@.Stmts3';
		replaceMethod: '`name
							`@.Stmts1.
							`@a ifTrue: [`@.Stmts2.
									^self `name].
							`@.Stmts3'
			with: '`name
				[`@.Stmts1.
				`@a] whileTrue: [`@.Stmts2].
				`@.Stmts3';
		replace: '`@.Stmts1.
				currentCharacter isLiteral ifTrue: [`@.Stmts2].
				`@.Stmts3'
			with: '`@.Stmts1.
				`@.Stmts2';
		replace: '`@.Stmts1.
				`.Stmt.
				`@.Stmts.
				`@a ifTrue: [self step. `.Stmt. `@.Stmts].
				`@.Stmts2'
			with: '`@.Stmts1.
				`@a ifTrue: [self step].
				`.Stmt.
				`@.Stmts.
				`@.Stmts2';
		replace: '`@.Stmts1.
				`@a ifTrue: [`@.Stmts. ^self reportLastMatch]'
			with: '`@.Stmts1.
				`@a ifTrue: [`@.Stmts]'.
	self addImplementationSpecificRewritesTo: rewriter.
	^rewriter! !

!SmaCCNode methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
optimizedParseTreeFor: aString 
	| tree rewriter |
	tree := RBParser parseMethod: aString.
	rewriter := self optimizationRewriter.
	[rewriter executeTree: tree] whileTrue: [tree := rewriter tree].
	^tree! !

!SmaCCNode methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	aStream
		nextPutAll: self class name;
		nextPut: $(;
		nextPutAll: id printString;
		nextPut: $)! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
removeDuplicateNodes
	^SmaCCDuplicateNodeEliminator removeDuplicateNodesIn: self! !

!SmaCCNode methodsFor: 'simulating' stamp: ' 6/1/07 21:19'!
simulate: aStream 
	| char |
	aStream atEnd ifTrue: [^action].
	char := aStream next.
	transitions 
		do: [:each | (each includes: char) ifTrue: [^each to simulate: aStream]].
	^nil! !

!SmaCCNode methodsFor: 'compiling' stamp: 'lr 1/6/2007 22:10'!
sortedTransitionsFor: aClass 
	| frequencies |
	frequencies := (aClass realClass ifNil: [SmaCCScanner]) frequencyTable.
	^transitions asSortedCollection: 
			[:a :b | 
			| aFrequency bFrequency |
			aFrequency := a edgeFrequencyUsingTable: frequencies.
			bFrequency := b edgeFrequencyUsingTable: frequencies.
			aFrequency > bFrequency or: [aFrequency = bFrequency and: [a <= b]]]! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
startingNodeWithoutUnnecessaryDefaultTransition
	| edge |
	self transitions size = 1 ifFalse: [^self].
	edge := self transitions first.
	(edge includes: #default) ifTrue: [^edge to].
	^self! !

!SmaCCNode methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
statesToMakeIntoMethods
	| allStates incoming |
	allStates := self allStates.
	incoming := Dictionary new.
	allStates do: 
			[:each | 
			each transitions do: 
					[:edge | 
					each ~= edge to 
						ifTrue: [(incoming at: edge to ifAbsentPut: [Set new]) add: each]]].
	^(allStates asOrderedCollection select: 
			[:each | 
			self = each or: 
					[each isTerminalNode not and: 
							[(incoming at: each ifAbsent: [#()]) size > 1 
								or: [each needsSeparateMethod]]]]) 
		asSortedCollection: [:a :b | a id < b id]! !

!SmaCCNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
transitions
	^transitions! !

!SmaCCNode methodsFor: 'private' stamp: 'lr 1/6/2007 22:08'!
transitions: aCollection 
	transitions reset.
	transitions addAll: aCollection! !

!SmaCCNode methodsFor: 'compiling' stamp: ' 6/1/07 21:19'!
writeMatchingCodeOn: aStream usingSelectorMap: aDictionary 
	| matchedItem |
	(action notNil and: [action size > 0]) 
		ifTrue: 
			[matchedItem := aDictionary at: action first ifAbsent: [action asArray].
			aStream nextPutAll: (transitions isEmpty 
						ifTrue: ['^self recordAndReportMatch:']
						ifFalse: ['self recordMatch: ']).
			matchedItem isSymbol 
				ifTrue: [aStream nextPutAll: matchedItem storeString]
				ifFalse: 
					[aStream nextPutAll: '#('.
					matchedItem do: [:each | aStream nextPutAll: each storeString]
						separatedBy: [aStream nextPut: $ ].
					aStream nextPut: $)].
			aStream
				nextPut: $.;
				cr].
	(transitions anySatisfy: [:each | each isCharacterTransition]) 
		ifTrue: 
			[aStream
				nextPutAll: 'self step.';
				cr]! !

Object subclass: #SmaCCParserGenerator
	instanceVariableNames: 'tabList parserClassMorph scannerClassMorph findScannerClassButton findParserClassButton conflicts generateDefinitionComments generateSymbolComments generateItemSetComments ignoreCase mainWindow parserCodeHolder scannerCodeHolder testCodeHolder tutorialTextHolder conflictTextMorph'
	classVariableNames: 'ShowPrecedenceConflicts'
	poolDictionaries: ''
	category: 'SmaCCDev-UI'!

!SmaCCParserGenerator commentStamp: 'jmb 1/23/2003 15:59' prior: 0!
SmaCC: The Smalltalk Compiler-Compiler 
from John Brant and Don Roberts
(http://www.refactory.com/Software/SmaCC)

Tutorial

This is a walk-through tutorial to demonstrate many of the features of SmaCC, the Smalltalk Compiler Compiler. In this example, we will incrementally develop a simple calculator. 

Our first calculator is going to be relatively simple. It is going to take two  numbers  and add them together. To start things off, we have to tell the scanner how to recognize a  number. It starts with one or more digits, possibly followed by an decimal point with zero or more digits after it. The scanner definition for this token is: 
<number>        :       [0-9]+ (\. [0-9]*) ? ; 

Enter that line into the scanner tab on the interface. Let's go over each part: 

<number> 

Names the token. The name inside the <> must be a legal Smalltalk variable name. 

:

Separates the name of the token from the token's definition. 

[0-9] 

Matches any single character in the range '0' to '9' (a digit). 

+

Matches the previous expression  one or more times. In this case, we are matching one or more digits. 

( ... ) 

Groups subexpressions. 

\. 

Matches the '.' character (. has a special meaning in regular expressions, \ quotes it). 

*

Matches the previous expression zero or more times. 

?

Matches the previous expression  zero or one time (i.e., it is optional). 

;

Terminates a token specification. 

We don't want to have to worry about whitespace in our language, so we need to define what a whitespace is and to ignore it. To do this, enter the following token specification on the next line on the scanner page: 
<whitespace>    :       \s+; 

\s matches any whitespace character (space, tab, linefeed, etc.). So how do  we tell the scanner to ignore it? If you look in the SmaCCScanner class, you will find a method named 'whitespace'. If a scanner understands a method that has the same name as a token name, that method will get called whenever the scanner matches that kind of token. As you can see, the whitespace method eats whitespace. There is also a 'comment' method that behaves similarly. 

The only other token that will appear in our system would be the '+' token for addition. However, since this is token is always the same, we don't have to tell the scanner what it looks like. It will figure it out from our grammar. 

Speaking of our grammar, let's go ahead and define it. Enter the following specification in the Parser tab: 
Expression : 
          Expression "+" Number
        | Number ;
Number : <number>; 

This basically says that an expressions is either a number  or an expression added to a number. 

We should be able to compile a parser now. Switch to the Compile tab. You need to enter the class name for both  the scanner and parser. Use CalculatorScanner and CalculatorParser respectively.  Once the class names are entered, we are ready to compile the parser. Press the  'Compile LALR(1)' button (you should always push this one unless you know what  you are doing. Basically, it will generate smaller parsers than the other  option). This will create new Smalltalk classes for the CalculatorScanner and  CalculatorParser and compile several methods in those classes. All methods that  SmaCC compiles will go into a "generated-*" method protocol. You should not  change those methods since they are replace each time you compile. 

Whenever SmaCC creates new classes, they are compiled in the default application/package. If you are using VisualAge,  you will need to make sure that the default application is an open edition and  that it prereqs the SmaCCRuntime application. 

If you have already created the scanner and parser classes, you can load their  definitions by using the "..." buttons next to the class name entry fields. If  you answer "Yes" to the dialog, the text in the scanner/parser tabs will be  replaced with the definition that was last compiled (assuming that the "Generate  definition comments" was checked during the last compile). 

Now we are ready to test our parser. Go to the test pane, enter 3 + 4, and press the parse button; you will see that the parser correctly parses it. If you press Parse and Inspect you will see and inspector on an OrderedCollection that contains the parsed tokens. This is because we haven't specified what the parser is supposed to do when it parses. You can also enter incorrect  items. For example, try to parse "3 + + 4" or "3 + a". An  error message should appear in the text. 

Now we need to define the actions that need to happen when we parse our  expressions. Currently, our parser is just validating that the expression is a  bunch of numbers added together. Generally, you will create some structure that  represents what you've parsed (e.g., a parse tree). However, in this case, we  are not concerned about the structure, but we are concerned about the result  (the value of the expression). For our example, you need to modify the grammar  definition to be: 
Expression : 
          Expression "+" Number {'1' + '3'} | Number {'1'} ;
Number : <number> {'1' value asNumber} ;

The text between the braces is Smalltalk code that gets evaluated when the rule is applied. Strings with a number get replaced with the corresponding parse node. In the first Expression rule, the '1' will get replaced by the ParseNode that matches Expression and the '3' gets replaced by the ParseNode that matches Number. The second item in the rule is the "+" token. Since we already know what  it is, it is not interesting. Compile the new parser. Now when you do a 'Parse  and Inspect' from the test pane, you should see the result: 7. 

One problem with the previous code is that if you need to change a rule then you  may also need to change the code for that rule. For example, suppose you  inserted a new token at the beginning of a rule, then you would need to change  all of your references in the Smalltalk code. We can alleviate this problem by  using named expressions. After each part of a rule, we can specify its name.  Names are specified with single quotes and must be legal Smalltalk variable  names. Doing this for our grammar we get: 
Expression : 
          Expression 'expression' "+" Number 'number' {expression + number} | Number 'number' {number} ;
Number : <number> 'numberToken' {numberToken value asNumber} ;

While this will result in the same language being parsed, it makes it easier  to maintain your parsers. Let's extend our language to add subtraction. Here's the new grammar: 
Expression : 
          Expression 'expression' "+" Number 'number' {expression + number} | Expression 'expression' "-" Number 'number' {expression - number} | Number 'number' {number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

After you've compiled this, '3 + 4 - 2 ' should return '5'. Next, let's add multiplication and division: 
Expression : 
          Expression 'expression' "+" Number 'number' {expression + number}
        | Expression 'expression' "-" Number 'number' {expression - number} | Expression 'expression' "*" Number 'number' {expression * number}
        | Expression 'expression' "/" Number 'number' {expression / number} | Number 'number' {number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

Here we run into a problem. If you evaluate '2 + 3 * 4' you end up with 20. The problem is that in standard mathematics, multiplication has a higher precedence than addition. Our grammar evaluates strictly left-to-right. The standard solution for this problem is to define additional nonterminals to force the sequence of evaluation. Our grammar with that solution would look like: 
Expression : 
          Term 'term' {term}
        | Expression 'expression' "+" Term 'term' {expression + term}
        | Expression 'expression' "-" Term 'term' {expression - term};
Term : 
          Number 'number' {number}
        | Term 'term' "*" Number 'number' {term * number}
        | Term 'term' "/" Number 'number' {term / number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

If you compile this grammar, you will see that '2 + 3 * 4' evaluates to 14 like we would expect. Now, as you can imagine, this gets pretty complicated as the number of precedence rules increases (e.g., C). We can use ambiguous grammars and precedence rules to simplify this situation. Here is the same grammar using precedence to enforce our evaluation order: 
%left "+" "-";
%left "*" "/"; Expression : 
          Expression 'exp1' "+" Expression 'exp2' {exp1 + exp2} | Expression 'exp1' "-" Expression 'exp2' {exp1 - exp2} | Expression 'exp1' "*" Expression 'exp2' {exp1 * exp2} | Expression 'exp1' "/" Expression 'exp2' {exp1 / exp2} | Number 'number' {number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

Notice that we changed the grammar so that there are Expressions on both sides  of the operator.  The two lines that we added to the top of the grammar mean that + and - are evaluated left-to-right and have the same precedence, which is lower than * and /. Likewise, the second line means that * and / have equal precedence.  Grammars in this form are usually much more intuitive, especially in cases with many precedence levels. Just as an example, let's add exponentiation and parentheses: 
%left "+" "-";
%left "*" "/"; %right "^"; Expression : 
          Expression 'exp1' "+" Expression 'exp2' {exp1 + exp2}
        | Expression 'exp1' "-" Expression 'exp2' {exp1 - exp2}
        | Expression 'exp1' "*" Expression 'exp2' {exp1 * exp2}
        | Expression 'exp1' "/" Expression 'exp2' {exp1 / exp2} | Expression 'exp1' "^" Expression 'exp2' {exp1 raisedTo: exp2} | "(" Expression 'expression' ")" {expression} | Number 'number' {number};
Number : <number> 'numberToken' {numberToken value asNumber}; 

Once you have compiled the grammar, you will be able to evaluate '3 + 4 * 5 ^ 2  ^ 2' to get 2503. Since the exponent operator is right associative, this  expression is evaluated like 3 + (4 * (5 ^ (2 ^ 2))). We can also evaluate  expressions with parentheses. For example, evaluating '(3 + 4) * (5 - 2) ^ 3'  results in 189. 

The Scanner

Scanning takes an input stream of characters and converts that into a stream of tokens. The tokens are then passed on to the parsing phase. 

The scanner is specified by a collection of token specifications. Each token is specified by: 
    TokenName    :    RegularExpression ;

TokenName is a valid Smalltalk variable name that is surrounded by <>. For example, "<token>" is a valid TokenName, but "<token name>" is not since "token name" isn't a valid Smalltalk variable name. The RegularExpression is a regular expression that matches a token. It should match one or more characters in the input stream. The colon character, ":", is used to separate the TokenName and the RegularExpression, and the semicolon character, ";", is used to terminate the token specification. 


Regular Expression Syntax

While the rules are specified as regular expressions, there are many different syntaxes for regular expressions. We choose a relatively simple syntax that is specified below. If you wish to have a more rich syntax, you can modify the scanner's parser: SmaCCScannerScanner & SmaCCScannerParser. These classes were created using SmaCC. 
\character Matches a special character. The character immediately following the backslash is matched exactly, unless it is a letter. Backslash-letter combinations have other meanings and are specified below. 
\cLetter Matches a control character. Control characters are the first 26 characters (e.g., \cA equals "Character value: 0"). The letter that follows the "\c" must be an uppercase letter. 
\d Matches a digit, 0-9. 
\D Matches anything that is not a digit. 
\f Matches a form-feed character, "Character value: 12". 
\n Matches a newline character, "Character value: 10". 
\r Matches a carriage return character, "Character value: 13". 
\s Matches any whitespace character, [ \f\n\r\t\v]. 
\S Matches any non-whitespace character. 
\t Matches a tab, "Character value: 9". 
\v Matches a vertical tab, "Character value: 11" 
\w Matches any letter, number or underscore, [A-Za-z0-9_]. 
\W Matches anything that is not a letter, number or underscore. 
\xHexNumber Matches a character specified by the hex number following the "\x". The hex number must be at least one character long and no more than four characters for Unicode characters and two characters for non-Unicode characters. For example, "\x20" matches the space character (Character value: 16r20), and "\x1FFF" matches "Character value: 16r1FFF". 
<token> Copies the definition of <token> into the current regular expression. For example, if we have "<hexdigit> : \d | [A-F] ;", we can use <hexdigit> in a later rule: "<hexnumber> : <hexdigit> + ;". 
[characters] Matches one of the characters inside the []. This is a shortcut for the "|" operator. In addition to single characters, you can also specify character ranges with the "-" character. For example, "[a-z]" matches any lower case letter. 
[^characters] Matches any character not listed in the characters block. "[^a]" matches anything except for "a". 
# comment Creates a comment that is ignored by SmaCC. Everything from the # to the end of the line is ignored. 
exp1| exp2 Matches either exp1 or exp2. 
exp1 exp2 Matches exp1 followed by exp2. "\d \d" matches two digits. 
exp* Matches exp zero or more times. "0*" matches "" and "000". 
exp? Matches exp zero or one time. "0?" matches only "" or "0". 
exp+ Matches exp one or more times. "0+" matches "0" and "000", but not "". 
exp{min,max} Matches exp at least min times but no more than max times. "0{1,2}" matches only "0" or "00". It does not match "" or "000". 
(exp) Groups exp for precedence. For example, "(a b)*" matches "ababab". Without the parentheses, "a b *" would match "abbbb" but not "ababab". 

Since there are multiple ways to combine expressions, we need precedence rules for their combination. The or operator, "|", has the lowest precedence and the "*", "?", "+", and "{,}" operators have the highest precedence. For example, "a | b c *" matches "a" or "bcccc", but not "accc" or "bcbcbc". If you wish to match "a" or "b" followed by any number of c's, you need to use "(a | b) c *". 


Overlapping Tokens

Unlike T-Gen, SmaCC can handle overlapping tokens with any problems. For example, the following is a legal SmaCC scanner definition: 
	<variable>	: [a-zA-Z] \w* ;
	<any_character>	: . ;
This definition will match a variable or a single character. A variable can also be a single character [a-zA-Z], so the two tokens overlap. SmaCC handles overlapping characters by preferring the first token specified by the grammar. For example, an "a" could be a <variable> or an <any_character> token, but since <variable> is specified first, SmaCC will use it. 


Matching Methods

If your scanner has a method name that matches the name of the token, (e.g. whitespace), that method will get called upon a match of that type. The SmaCCScanner superclass already has a default implementation of #whitespace and #comment. These methods ignore those tokens by default. Matching methods can also be used to handle overlapping token classes. For example, in the C grammar, a type definition is the same as an identifier. The only way that they can be disambiguated is by looking up the name in the type table. In our example C parser, we have an IDENTIFIER method that is used to determine whether the token is really an IDENTIFIER or whether it is a TYPE_NAME. 


Unreferenced Tokens

If a token is not referenced from a grammar specification, it will not be included in the generated scanner, unless the token's name is also a name of a method (see previous section). This, coupled with the ability to do substitutions, allows you to have the equivalent of macros within your scanner specification. However, be aware that if you are simply trying to generate a scanner, you will have to make sure that you create a dummy parser specification that references all of the tokens that you want in the final scanner. 


Case Insensitive Scanning

You can specify that the scanner should ignore case differences by checking the "Ignore Case" option on the compile tab. If you have a language that is case insensitive and has several keywords, this can be a handy feature to have. For example, if you have "THEN" as a keyword in a case insensitive language, you would need to specify a token for then as "<then> : [tT] [hH] [eE] [nN] ;". This is a pain to enter correctly. When the ignore case option is checked, SmaCC will automatically convert "THEN" into "[tT][hH][eE][nN]". 


Unicode Characters

SmaCC compiles the scanner into a bunch of conditional tests on characters. Normally, it assumes that characters have values between 0 and 255, and it can make some optimizations based on this fact. With the "Allow Unicode Characters" option checked, it will assume that characters have values between 0 and 65535. 

The Parser
Parsing converts the stream of tokens provided by the scanner into some object. Normally, this object will be a parse tree, but it does not have to be a parse tree. For example, the SmaCC tutorial shows a calculator. This calculator does not produce a parse tree; it produces the result, a number. 

In SmaCC the parser is defined by the grammar specification entered in the 'Parser' tab. The grammar specification has two parts, an optional directives section and the production rules. The directives section is used to tell SmaCC how to handle ambiguous grammars as well as how it should generate the code for the parser. The production rules section contains the grammar for the parser and the code that executes when a production rule is matched. 


Directives

The optional directives section consists of a set of directives. The system currently has 5 directives. Each directive begins with a "%" character and the directive keyword, then lists a set of symbols, and finally ends with the semicolon character, ";". 


Ambiguous Grammars and Precedence

SmaCC can handle ambiguous grammars. Given an ambiguous grammar, SmaCC will produce some parser. However, it may not parse correctly. For an LR parser, there are two basic types of ambiguities, reduce/reduce conflicts and shift/reduce conflicts. Reduce/reduce conflicts are bad. SmaCC has no directives to handle them and just picks one of the choices. These conflicts normally require a rewrite of your grammar. 

On the other hand, shift/reduce conflicts can be handled by SmaCC without rewriting your grammar. When SmaCC encounters a shift/reduce conflict it will perform the shift action by default. However, you can control this action with the "%left", "%right", and "%nonassoc" directives. If a token has been declared in a "%left" directive, it means that the token is left-associative. Therefore, the parser will perform a reduce operation. However, if it has been declared as right-associative, it will perform a shift operation. A token defined as %nonassoc will produce an error if that is encountered during parsing. For example, you may want to specify that the equal operator, "=", is non-associative, so "a = b = c" is not parsed as a valid expression. All three directives are followed by a list of tokens. 

Additionally, the %left, %right, and %nonassoc directives allow precedence to be specified. The order of the directives specifies the precedence of the tokens. The higher precedence tokens appear on the higher line numbers. For example, the following directive section gives the precedence for the simple calculator in our tutorial: 
%left "+" "-";
%left "*" "/";
%right "^";
The "+" and "-" symbols appear on the first line and have the lowest precedence. They are also left-associative so "1 + 2 +3" will be evaluated as "(1 + 2) + 3". On the next line are the "*" and "/" symbols. Since they appear on a higher line number, they have higher precedence than the "+" and "-". Finally, on line three we have the "^" symbol. It has the highest precedence. Combining all the rules allows us to parse "1 + 2 * 3 / 4 ^ 2 ^ 3" as "1 + ((2 * 3) / (4 ^ (2 ^ 3)))". 


Start Symbols

By default, the left-hand side of the first grammar rule is the start symbol. If you want to multiple start symbols, then you can specify them by using the "%start" directive followed by the nonterminals that are additional start symbols. This is useful for creating two parsers with two grammars that are similar but slightly different. For example, consider a Smalltalk parser. You can parse methods, and you can parse expressions. These are two different operations, but have very similar grammars. Instead of creating two different parsers for parsing methods and expressions, we can specify one grammar that parses methods and also specify another starting position for parsing expressions. The StParser in the SmaCC Example Parsers package has an example of this. The StParser class>>parseMethod: uses the #startingStateForMethod position to parse methods and the StParser class>>parseExpression: uses the #startingStateForSequenceNode position to parse expressions. 


Id Methods

Internally, the various token types are represented as integers. However, there are times that you need to reference the various token types. For example, in the CScanner and CParser classes, the TYPE_NAME token is identical to the IDENTIFIER token. The IDENTIFIER matching method does a lookup in the type table and if it finds a type definition with the same name as the current IDENTIFIER, it want to return the TYPE_NAME token type. To determine what integer this is, the parser was created with an %id directive for <IDENTIFIER> and <TYPE_NAME>. This generates the IDENTIFIERId and TYPE_NAMEId methods on the scanner. These methods simply return the number representing that token type. See the C sample scanner and parser for a good example of how this is used. 


Production Rules

The production rules contains the grammar for the parser. The first production rule is considered to be the starting rule for the parser. Each production rule consists of a non-terminal symbol name followed by a ":" separator which is followed by a list of possible productions separated by vertical bar, "|", and finally terminated by a semicolon, ";". 

Each production consists of a sequence of non-terminal symbols, tokens, or keywords followed by some optional Smalltalk code enclosed in curly brackets, {}. Non-terminal symbols are valid Smalltalk variable names and must be defined somewhere in the parser definition. Forward references are valid. Tokens are enclosed in angle brackets as they are defined in the scanner (e.g., <token>) and keywords are enclosed in double-quotes (e.g., "then"). Keywords that contain double-quotes need to have two double-quotes per each double-quote in the keyword. For example, if you need a keyword for one double-quote character, you would need to enter """" (four double-quote characters). 

The Smalltalk code is evaluated whenever that production is matched. If the code is a zero or a one argument symbol, then that method is performed. For a one argument symbol, the argument is an OrderedCollection that contains one element for each item in the production. If the code isn't a zero or one argument symbol, then the code is executed and whatever is returned by the code is the result of the production. If no Smalltalk code is specified, then the default action is to execute the #reduceFor: method. This method converts all items into an OrderedCollection. If one of the items is another OrderedCollection, then all of its elements are added to the new collection. 

Inside the Smalltalk code you can refer to the values of each production item by using literal strings. The literal string, '1', refers the to value of the first production item. The values for tokens and keywords will be SmaCCToken objects. The value for all non-terminal symbols will be whatever the Smalltalk code evaluates to for that non-terminal symbol. 


Named Symbols

When entering the Smalltalk code, you can get the value for a symbol by using the literal strings (e.g., '2'). However, this creates difficulties when modifying a grammar. If you insert some symbol at the beginning of a production, then you will need to modify your Smalltalk code changing all literal string numbers. Instead you can name each symbol in the production and then refer to the name in the Smalltalk code. To name a symbol (non-terminal, token, or keyword), you need to add a quoted variable name after the symbol in the grammar. For example, "MySymbol : Expression 'expr' "+" <number> 'num' {expr + num} ;" creates two named variables. One for the non-terminal Expression and one for the <number> token. These variables are then used in the Smalltalk code. 


Extended Syntax

SmaCC also has some extended syntax that makes it easier to enter different grammars. Most of the additions are for the productions, but one change that is not for productions is the addition of "::=" as the separator between the non-terminal and the production. The production syntax enhancements are listed in the following table: 
Symbol ? Makes symbol optional. It is equivalent to defining a new production rule: "Optional_Symbol : Symbol {'1'} | {nil};". 
Symbol * or 
Symbol + Makes a repeating symbol. The "*" repeats zero or more times, and the "+" repeats one or more times. It is equivalent to defining a new production rule: "Repeat_Symbol : | Symbol;" for "*" and "Repeat_Symbol : Symbol | Repeat_Symbol Symbol ;" for "+". 
( Productions ) Groups the items in Productions. By itself it is not that useful, but it can be combined with the "?", "*", or "+". It is equivalent to defining "Group_Productions : Productions ;". 
[ Productions ] Equivalent to "( Productions ) ?". 
<% Productions %> Equivalent to "( Productions ) *" 


Parser Comments

The compile page has three options to generate comments. You should always select the "Generate definition comments". That saves the scanner and parser definition strings into the scanner and parser classes. It allows your grammar to be under the same version control system as your Smalltalk code. 

The other two comment options should not be needed unless you need to debug a parser generated. The "generate symbol comments" option will generate a comment that explains what each symbol is mapped to. When SmaCC compiles a grammar it converts all symbols into integers. This comment gives you the integer for each symbol. You may need this information if you have an incorrect scanner definition. For example, you may have overlapping token definitions and SmaCC is picking the wrong one (by default it picks the first one in your scanner definition). When you debug, you can inspect the SmaCCToken object and validate its "id" with those in the symbol comment. If they are different, then you have a bug in your scanner. 

Finally, the "generate item set comments" option should rarely be needed. It generates a listing of all LR(1) item sets in the parser. If you are familiar with LR parsing, then it might be interesting to look at. However, for a moderate sized grammar (e.g., Java), this comment can be a few MB in size. I would not recommend generating such comments when using ENVY -- you don't want to store a 10MB method in your library. For the calculator example in the tutorial, this comment is 9,000 characters long. 


Error Recovery

Normally, when the parser encounters an error, it raises the SmaCCParserError exception and parsing is immediately stopped. However, there are times when you may wish to try to parse more of the input. For example, if you are highlighting code, you do not want to stop highlighting at the first syntax error. Instead you may wish to attempt to recover after the statement separator -- the period ".". SmaCC uses the error symbol to specify where error recovery should be attempted. For example, we may have the following rule to specify a list of Smalltalk statements: 
	Statements : Expression | Statements "." Expression ;
If we wish to attempt recovery from a syntax error when we encounter a period, we can change our rule to be: 
	Statements : Expression | Statements "." Expression | error "." Expression ;
While the error recovery allows you to proceed parsing after a syntax error, it will not allow you to return a parse tree from the input. Once the input has been parsed with errors, it will raise a non-resumable SmaCCParserError. !

!SmaCCParserGenerator classSide methodsFor: 'class initialization' stamp: 'AdrienBarreau 6/9/2010 15:19'!
initialize
	ShowPrecedenceConflicts:=false.
"	(TheWorldMenu respondsTo: #registerOpenCommand:) ifTrue: [
		TheWorldMenu unregisterOpenCommand: 'SmaCC'.
		TheWorldMenu registerOpenCommand: {'SmaCC Generator'. {self. #open}}]
"! !

!SmaCCParserGenerator classSide methodsFor: 'class initialization' stamp: 'AdrienBarreau 6/9/2010 15:21'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'SmaCC Parser Generator')
			parent: #Tools;
			action: [ self open ]; 
			help: 'Create and test parsers with SmaCC'.! !

!SmaCCParserGenerator classSide methodsFor: 'instance creation' stamp: 'lr 11/25/2009 18:03'!
open
	^ self new openInWorld! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'AlainPlantec 12/10/2010 08:12'!
acceptParserCode: aStringOrAText notifying: aRequestor 
	| scannerText |
	scannerText := self scannerCodeHolder contentsMorph text.
	^ [SmaCCGrammarCompiler new buildScanner: scannerText andParser: aStringOrAText.
	true]
		on: SmaCCParserError
		do: [:ex | 
			self tabList selectedPageIndex: 2.
			self 
				displayError: ex description
				at: ex tag position
				notifying: aRequestor.
			ex return: false]! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'lr 11/25/2009 18:27'!
acceptScannerCode: aStringOrAText notifying: aRequestor 
	SmaCCScannerParser
		parse: aStringOrAText
		onError: [:aString :position | 
			| morph | 
			self tabList selectedPageIndex: 1.
			self
				displayError: aString
				at: position
				notifying: aRequestor.
			^ false].
	^ true! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'AlainPlantec 12/10/2010 08:13'!
acceptTestCode: aStringOrAText notifying: aRequestor 
	| class |
	class := self parserClass.
	class isNil
		ifTrue: [UIManager default inform: 'No parser defined'.
			^ false].
	^ self parse! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 4/25/2009 10:16'!
addButtonsToTestPage: aTestPage 
	| aParserButton aParserInspectButton aParserExploreButton |
	aParserButton := PluggableButtonMorph
				on: self
				getState: nil
				action: #parse.
	aParserButton hResizing: #spaceFill;
		 vResizing: #shrinkWrap;
		 label: 'Parse'.
	aParserInspectButton := PluggableButtonMorph
				on: self
				getState: nil
				action: #parseAndInspect.
	aParserInspectButton hResizing: #spaceFill;
		 vResizing: #shrinkWrap;
		 label: 'Parse and inspect'.
	aParserExploreButton := PluggableButtonMorph
				on: self
				getState: nil
				action: #parseAndExplore.
	aParserExploreButton hResizing: #spaceFill;
		 vResizing: #shrinkWrap;
		 label: 'Parse and explore'.
	aTestPage
		addMorph: aParserButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 0.33 @ 1)
				offsets: (0 @ (1 - 25) corner: 0 @ 0));	
		addMorph: aParserInspectButton
		fullFrame: (LayoutFrame
				fractions: (0.33 @ 1 corner: 0.66 @ 1)
				offsets: (0 @ (1 - 25) corner: 0 @ 0));
		addMorph: aParserExploreButton
		fullFrame: (LayoutFrame
				fractions: (0.66 @ 1 corner: 1 @ 1)
				offsets: (0 @ (1 - 25) corner: 0 @ 0))! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 11/25/2009 18:18'!
addCheckBoxesToCompilePage: aCompilePage
	#((toggleIgnoreCase ignoreCase 'Ignore Case') 
	  (toggleGenerateDefinitionComments generateDefinitionComments 'Generate definition comments')
	  (toggleGenerateSymbolComments generateSymbolComments 'Generate symbol comments')
	  (toggleGenerateItemSetComments generateItemSetComments 'Generate item set comments')) withIndexDo: [ :each :index |
			| checkbox | 
			checkbox := self theme
				newCheckboxIn: World
				for: self
				getSelected: each second
				setSelected: each first
				getEnabled: nil
				label: each third
				help: nil.
			checkbox position: 10 @ 35 + (index * (0 @ 20)).
			aCompilePage addMorph: checkbox ]! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 4/25/2009 09:30'!
addClassSelectorsToCompilePage: aCompilePage 
	| aScannerLabel aParserLabel |
	aScannerLabel := 'Scanner class:' asMorph position: 10 @ 10.
	aParserLabel := 'Parser class:' asMorph position: 10 @ 30.
	findScannerClassButton := PluggableButtonMorph
				on: self
				getState: nil
				action: #findScannerClass.
	findScannerClassButton label: ' ... ';
		 position: 410 @ 6.
	findParserClassButton := PluggableButtonMorph
				on: self
				getState: nil
				action: #findParserClass.
	findParserClassButton label: ' ... ';
		 position: 410 @ 26.
	scannerClassMorph := TextMorph new 
		newContents: '';
		extent: 300 @ 70;
		position: 100 @ 8.
	scannerClassMorph
		on: #keyStroke
		send: #updateWindowLabel
		to: self.
	scannerClassMorph addDependent: self.
	parserClassMorph := TextMorph new
		newContents: '';
		extent: 300 @ 70;
		position: 100 @ 28.
	parserClassMorph
		on: #keyStroke
		send: #updateWindowLabel
		to: self.
	parserClassMorph addDependent: self.
	{aScannerLabel. aParserLabel. scannerClassMorph. parserClassMorph. findScannerClassButton. findParserClassButton}
		do: [:e | aCompilePage addMorph: e]! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 1/8/2007 23:21'!
addCompileButtonsToCompilePage: aCompilePage 
	| aLALRButton aLR1Button | 
	aLALRButton := PluggableButtonMorph
				on: self
				getState: nil
				action: #compileLALR1.
	aLALRButton label: 'Compile LALR(1)';
		onColor: self defaultBackgroundColor offColor: self defaultBackgroundColor lighter;
		 position: 10 @ 140.
	aCompilePage addMorph: aLALRButton.
	aLR1Button := PluggableButtonMorph
				on: self
				getState: nil
				action: #compileLR1.
	aLR1Button label: 'Compile LR(1)';
		onColor: self defaultBackgroundColor offColor: self defaultBackgroundColor lighter;
		 position: 150 @ 140.
	aCompilePage addMorph: aLR1Button! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'apl 2/20/2003 16:23'!
addMessageBoxToCompilePage: aCompilePage 
	aCompilePage addMorph: ('Messages:' asMorph position: 10 @ 180;
			 yourself).
	self conflictTextMorph: (PluggableTextMorph
				on: self
				text: #conflicts
				accept: nil
				readSelection: nil
				menu: nil).
	aCompilePage
		addMorph: (self conflictTextMorph)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (10 @ 200 corner: -10 @ -10))! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 4/25/2009 10:15'!
addTextToTestPage: aTestPage 
	| aTestText |
	testCodeHolder := SmaCCCodeHolder owner: self ownerAcceptSelector: #acceptTestCode:notifying:.
	aTestText := testCodeHolder contentsMorph.
	aTestText
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent.
	aTestPage
		addMorph: aTestText
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ -25))! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'AlainPlantec 12/10/2010 08:14'!
choose: aString from: aCollection 
	| choice |
	choice := UIManager default chooseFrom: aCollection title: aString withCRs.
	choice > 0
		ifTrue: [^ aCollection at: choice].
	^ nil! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'ThierryGoubier 4/20/2012 15:31'!
compile: aSymbol 
	| grammar stream oldIgnoreCase oldCharacterSize parserCompiler |
	(self scannerClassString isEmpty
			or: [self parserClassString isEmpty])
		ifTrue: [^ UIManager default inform: 'Both classes are not specified'].
	Cursor read
		showWhile: [self verifySyntax
				ifFalse: [^ self]].
	Cursor wait
		showWhile: [oldIgnoreCase := SmaCCGrammar ignoreCase.
			oldCharacterSize := SmaCCGrammar maximumCharacterValue.
			[SmaCCGrammar ignoreCase: self ignoreCase;
				 maximumCharacterValue: 255.
			parserCompiler := SmaCCGrammarCompiler new.
			parserCompiler buildScanner: self scannerText andParser: self parserText;
				 scannerClass: self scannerClassString;
				 parserClass: self parserClassString.
			grammar := parserCompiler grammar.
			grammar type: aSymbol.
			stream := WriteStream on: Text new.
			[parserCompiler createChanges.
			self generateDefinitionComments
				ifTrue: [parserCompiler compileDefinitionComments].
			self generateSymbolComments
				ifTrue: [parserCompiler compileSymbolComment].
			self generateItemSetComments
				ifTrue: [parserCompiler compileItemSetsComment].
			parserCompiler compileChanges]
				on: SmaCCCompilationNotification
				do: [:ex | 
					(ShowPrecedenceConflicts
							or: [('*precedence*' match: ex messageText) not])
						ifTrue: [stream nextPutAll: '-------------------------\' withCRs asText , ex messageText asText allBold;
								 cr;
								 cr;
								 nextPutAll: ex description;
								 cr;
								 nextPutAll: ex tag; cr;
								 cr.].
					ex pass].
			self conflicts: stream contents.
			self testText string trimBoth notEmpty ifTrue: [self testCodeHolder hasUnacceptedEdits: true]]
				ensure: [SmaCCGrammar ignoreCase: oldIgnoreCase;
						 maximumCharacterValue: oldCharacterSize]]! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 2/15/2003 12:55'!
compileLALR1
	
	self compile: #LALR1! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/18/2003 14:41'!
compileLR1
	self compile: #LR1! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/20/2003 16:22'!
conflictTextMorph
	^conflictTextMorph! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/20/2003 16:22'!
conflictTextMorph: anObject
	conflictTextMorph := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 16:00'!
conflicts
	conflicts isNil ifTrue: [conflicts:=String new].
	^conflicts! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/20/2003 16:35'!
conflicts: aString 
	conflicts := aString.
	self changed: #conflicts! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 4/25/2009 08:57'!
createCompilePage
	| aCompilePage |
	aCompilePage := (Morph new)
				layoutPolicy: ProportionalLayout new;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				color: Color transparent.
	self tabList 
		addPage: (self tabList newContentMorph 
			addMorph: aCompilePage; 
			yourself) 
		label: 'Compile'.
	self
		addClassSelectorsToCompilePage: aCompilePage;
		addCompileButtonsToCompilePage: aCompilePage;
		addCheckBoxesToCompilePage: aCompilePage;
		addMessageBoxToCompilePage: aCompilePage! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 4/25/2009 09:50'!
createParserPage
	| aParserPage |
	parserCodeHolder := SmaCCCodeHolder owner: self
				ownerAcceptSelector: #acceptParserCode:notifying:.
	aParserPage := parserCodeHolder contentsMorph.
	aParserPage
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	self tabList 
		addPage: (self tabList newContentMorph 
			addMorph: aParserPage; 
			yourself) 
		label: 'Parser'.! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 4/25/2009 09:50'!
createScannerPage
	| aScannerPage |
	scannerCodeHolder := SmaCCCodeHolder owner: self
				ownerAcceptSelector: #acceptScannerCode:notifying:.
	aScannerPage := scannerCodeHolder contentsMorph.
	aScannerPage
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	self tabList 
		addPage: (self tabList newContentMorph 
			addMorph: aScannerPage; 
			yourself) 
		label: 'Scanner'! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 11/25/2009 18:13'!
createTabbedPalette
	self tabList: (self theme newTabGroupIn: World for: #()).
	self mainWindow 
		addMorph: self tabList
		frame: (0 @ 0 corner: 1 @ 1)! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 4/25/2009 09:52'!
createTestPage
	| aTestPage |
	aTestPage := (Morph new)
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				layoutPolicy: ProportionalLayout new;
				color: Color transparent;
				yourself.
	self addTextToTestPage: aTestPage.
	self addButtonsToTestPage: aTestPage.
	self tabList 
		addPage: (self tabList newContentMorph 
			addMorph: aTestPage; 
			yourself) 
		label: 'Test'! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 4/25/2009 09:49'!
createTutorialPage
	| aTutorialPage |
	tutorialTextHolder := SmaCCCodeHolder owner: self ownerAcceptSelector: nil.
	aTutorialPage := tutorialTextHolder contentsMorph.
	tutorialTextHolder acceptContents: self tutorialText.
	tutorialTextHolder changed: #contents.
	aTutorialPage
		 hResizing: #spaceFill;
		 vResizing: #spaceFill.
	self tabList 
		addPage: (self tabList newContentMorph 
			addMorph: aTutorialPage; 
			yourself) 
		label: 'Tutorial'! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'lr 1/8/2007 23:12'!
defaultBackgroundColor
	^ Color tan! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'apl 2/20/2003 18:20'!
defaultWindowLabelPrefix
	^ 'SmaCCParserGenerator'! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'apl 2/18/2003 20:22'!
displayError: aString at: position notifying: aRequestor 
	aRequestor selectFrom: position to: position - 1.
	aRequestor
		replaceSelectionWith: (Text string: aString , '->' attribute: TextEmphasis bold).
	aRequestor
		setSelection: (position to: position + aString size + 1)! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'AlainPlantec 12/10/2010 08:28'!
findParserClass
	| className class text |
	self scannerClassString isEmpty
		ifTrue: [^ UIManager default inform: 'Undefined scanner class'].
	className := self choose: 'What class do you want to use?' from: (SmaCCParser allSubclasses
					collect: [:c | c name]) asSortedCollection.
	className notNil
		ifTrue: [parserClassMorph hResizing: #rigid.
			parserClassMorph newContents: '';
				 newContents: className.
			parserClassMorph changed: #updateWindowLabel.
			class := Smalltalk at: className asSymbol.
			(class class includesSelector: #parserDefinitionComment)
				ifTrue: [text := self removeCommentedPartOf: (class class sourceCodeAt: #parserDefinitionComment).
					self parserText: text]]! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'AlainPlantec 12/10/2010 08:28'!
findScannerClass
	| className class text |
	className := self choose: 'What class do you want to use?' from: (SmaCCScanner allSubclasses
					collect: [:c | c name]) asSortedCollection.
	className notNil
		ifTrue: [scannerClassMorph newContents: '';
				 newContents: className.
			scannerClassMorph changed: #updateWindowLabel.
			class := Smalltalk at: className asSymbol.
			(class class includesSelector: #scannerDefinitionComment)
				ifTrue: [text := self removeCommentedPartOf: (class class sourceCodeAt: #scannerDefinitionComment).
							self scannerText: text]]! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 15:27'!
generateDefinitionComments
	generateDefinitionComments isNil ifTrue: [generateDefinitionComments:=true].
	^generateDefinitionComments! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 15:27'!
generateItemSetComments
	generateItemSetComments isNil ifTrue: [generateItemSetComments:=false].
	^generateItemSetComments! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 15:27'!
generateSymbolComments
	generateSymbolComments isNil ifTrue: [generateSymbolComments:=false].
	^generateSymbolComments! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 15:26'!
ignoreCase
	ignoreCase isNil ifTrue: [ignoreCase:=false].
	^ignoreCase! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'lr 11/25/2009 18:18'!
initialExtent
	^ 750 @ 650! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 11/25/2009 18:16'!
initialize
	mainWindow := StandardWindow labelled: self defaultWindowLabelPrefix.
	mainWindow model: self.
	self createTabbedPalette.
	self createScannerPage.
	self createParserPage.
	self createCompilePage.
	self createTestPage.
	self createTutorialPage.
	self updateWindowLabel.
	self tabList selectedPageIndex: 3! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 2/15/2003 12:58'!
mainWindow
	
	^mainWindow! !

!SmaCCParserGenerator methodsFor: 'initialize-release' stamp: 'lr 11/25/2009 18:16'!
openInWorld
	self mainWindow openInWorld! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/23/2003 09:47'!
paneColorToUse
	^Color blue muchLighter! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'AlainPlantec 12/10/2010 15:52'!
parse
	self
		parseAndEvaluate: [:each | ^ true].
	^ false! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'AlainPlantec 12/10/2010 08:28'!
parseAndEvaluate: aBlock 
	| class |
	self testCodeHolder acceptContents: self testText.
	self testCodeHolder changed: #contents.
	class := self parserClass.
	class isNil
		ifTrue: [UIManager default inform: 'No parser defined'.
			^ false]
		ifFalse: [Cursor wait showWhile: [aBlock
				value: (class
						parse: self testText
						onError: [:aString :position | 
							self
								displayError: aString
								at: position
								notifying: self testCodeHolder contentsMorph.
							self testCodeHolder hasUnacceptedEdits: true.
							^ false])]].
	^ true! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'md 4/3/2003 14:03'!
parseAndExplore
	^self
			parseAndEvaluate: [:each | each explore]
! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/18/2003 20:01'!
parseAndInspect
	^self
			parseAndEvaluate: [:each | each inspect]
! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:47'!
parserClass
	| classname |
	classname := self parserClassString asSymbol.
	^classname notEmpty ifTrue: [Smalltalk at: classname]
! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 12:21'!
parserClassString
	^parserClassMorph contents string! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 10:43'!
parserCodeHolder
	^parserCodeHolder! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 10:43'!
parserCodeHolder: anObject
	parserCodeHolder := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 10:53'!
parserText
	^ self parserCodeHolder contents! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:25'!
parserText: text 
	self parserCodeHolder contents: text.
	self parserCodeHolder contentsMorph setText: text.
! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'mga 1/18/2003 14:42'!
removeCommentedPartOf: aString 
	| inStream outStream |
	inStream := ReadStream on: aString.
	outStream := WriteStream on: String new.
	inStream upTo: $".
	[inStream atEnd]
		whileFalse: [(inStream peekFor: $")
				ifTrue: [outStream nextPut: $"].
			outStream
				nextPutAll: (inStream upTo: $")].
	^ outStream contents! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 12:20'!
scannerClassString
	^scannerClassMorph contents string! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/17/2003 15:22'!
scannerCodeHolder
	^scannerCodeHolder! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/17/2003 15:22'!
scannerCodeHolder: anObject
	scannerCodeHolder := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/19/2003 09:55'!
scannerText
	^ self scannerCodeHolder contents! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:43'!
scannerText: text 
	self scannerCodeHolder contents: text.
	self scannerCodeHolder contentsMorph setText: text! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/22/2003 16:32'!
tabList
	^tabList! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 13:40'!
tabList: anObject
	tabList := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:39'!
testCodeHolder
	^testCodeHolder! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 11:39'!
testCodeHolder: anObject
	testCodeHolder := anObject! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'apl 2/18/2003 19:36'!
testText
	^ self testCodeHolder contentsMorph text! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'lr 11/25/2009 18:12'!
theme
	^ UITheme current! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/22/2003 15:25'!
toggleGenerateDefinitionComments
	generateDefinitionComments:=self generateDefinitionComments not! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/22/2003 15:28'!
toggleGenerateItemSetComments
	generateItemSetComments:=self generateItemSetComments not! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/22/2003 15:28'!
toggleGenerateSymbolComments
	generateSymbolComments:=self generateSymbolComments not! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'mga 1/22/2003 15:25'!
toggleIgnoreCase
	ignoreCase:= self ignoreCase not! !

!SmaCCParserGenerator methodsFor: 'accessing' stamp: 'mga 1/23/2003 11:15'!
tutorialText
	^self class comment! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'apl 2/20/2003 18:14'!
update: anObjectOrASymbol 
	(anObjectOrASymbol isKindOf: Symbol)
		ifTrue: [(self respondsTo: anObjectOrASymbol)
				ifTrue: [self perform: anObjectOrASymbol]].
	super update: anObjectOrASymbol! !

!SmaCCParserGenerator methodsFor: 'actions' stamp: 'lr 1/8/2007 22:58'!
updateWindowLabel
	| scannerLabel parserLabel |
	scannerLabel := self scannerClassString isEmpty ifFalse: [self scannerClassString] ifTrue: ['Undefined'].
	parserLabel := self parserClassString isEmpty ifFalse: [self parserClassString] ifTrue: ['Undefined'].
	^ self mainWindow setLabel: self defaultWindowLabelPrefix , ': ' ,  scannerLabel , '/' , parserLabel! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'ThierryGoubier 4/20/2012 15:30'!
verifyParser
	| parserCode |
	parserCode := self parserCodeHolder contentsMorph text.
	parserCode string trimBoth isEmpty
		ifTrue: [UIManager default inform: 'Empty Parser code'.
			self tabList selectedPageIndex: 2.
			^ false].
	self parserCodeHolder hasUnacceptedEdits
		ifTrue: [(self acceptParserCode: parserCode notifying: self parserCodeHolder contentsMorph)
				ifTrue: [self parserCodeHolder acceptContents: parserCode.
					self parserCodeHolder changed: #contents]
				ifFalse: [^ false]].
	^ true! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'ThierryGoubier 4/20/2012 15:29'!
verifyScanner
	| scannerText |
	scannerText := self scannerCodeHolder contentsMorph text.
	scannerText string trimBoth isEmpty
		ifTrue: [UIManager default inform: 'Empty Scanner code'.
			self tabList selectedPageIndex: 1.
			^ false].
	self scannerCodeHolder hasUnacceptedEdits
		ifTrue: [(self acceptScannerCode: scannerText notifying: self scannerCodeHolder contentsMorph)
				ifTrue: [self scannerCodeHolder acceptContents: scannerText.
					self scannerCodeHolder changed: #contents.
					^ true].
			^ false].
	^ true! !

!SmaCCParserGenerator methodsFor: 'private' stamp: 'apl 2/18/2003 10:37'!
verifySyntax
	self verifyScanner
		ifFalse: [^ false].
	self verifyParser ifFalse: [^false].
	^ true! !

Object subclass: #SmaCCRHS
	instanceVariableNames: 'collection reduceAction variableNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCRHS commentStamp: 'jmb' prior: 0!
SmaCCRHS represents the right hand side of the production.

Instance variables:
	collection	<OrderedCollection of: SmaCCSymbol> the collection of symbols that represent the rhs
	grammar <SmaCCGrammar> the grammar that the production is in
	variableNames	<Dictionary key: String value: Integer>	the name of each symbol in the rhs. These names can be used in the {} code blocks.!

!SmaCCRHS methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
= aSmaCCRHS 
	^self class = aSmaCCRHS class and: [collection = aSmaCCRHS collection]! !

!SmaCCRHS methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
add: aSmaCCSymbol 
	collection add: aSmaCCSymbol! !

!SmaCCRHS methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
at: anInteger 
	^collection at: anInteger! !

!SmaCCRHS methodsFor: 'private' stamp: ' 6/1/07 21:19'!
collection
	^collection! !

!SmaCCRHS methodsFor: 'reduction table' stamp: 'lr 1/7/2007 11:08'!
compileSourceFor: aSmaCCSymbol in: aClass 
	| action rewriter parseTree methodName |
	action := self reduceAction.
	action isNil ifTrue: [^self defaultReduceAction].
	parseTree := RBParser parseExpression: action
				onError: 
					[:s :p | 
					SmaCCCompilationNotification new
						tag: aSmaCCSymbol name , ' : ' , self printString 
								, '\\' withCRs , action;
						signal: 'Invalid Smalltalk code in reduction rule'.
					^self defaultReduceAction].
	(parseTree isLiteral and: 
			[parseTree value isSymbol and: 
					[parseTree value numArgs <= 1 and: [aClass definesMethod: parseTree value]]]) 
		ifTrue: [^parseTree value].
	rewriter := self parseTreeRewriter.
	rewriter executeTree: parseTree.
	parseTree := rewriter tree.
	methodName := ('reduceActionFor' , aSmaCCSymbol safeMethodName 
				, (aSmaCCSymbol positionOf: self) printString , ':') 
				asSymbol.
	parseTree isSequence 
		ifFalse: [parseTree := RBSequenceNode statements: (Array with: parseTree)].
	parseTree := RBMethodNode 
				selector: methodName
				arguments: (Array with: (RBVariableNode named: 'nodes'))
				body: parseTree.
	parseTree addReturn.
	aClass compile: parseTree formattedCode
		classified: 'generated-reduction actions'.
	^methodName! !

!SmaCCRHS methodsFor: 'private' stamp: ' 6/1/07 21:19'!
defaultReduceAction
	^#reduceFor:! !

!SmaCCRHS methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
do: aBlock
	collection do: aBlock! !

!SmaCCRHS methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
firstTerminals
	| items |
	collection isEmpty ifTrue: [^Set with: SmaCCSymbol empty].
	items := Set new.
	1 to: collection size
		do: 
			[:index | 
			items addAll: (collection at: index) firstTerminals.
			(items includes: SmaCCSymbol empty) 
				ifTrue: [index < collection size ifTrue: [items remove: SmaCCSymbol empty]]
				ifFalse: [^items]].
	^items! !

!SmaCCRHS methodsFor: 'comparing' stamp: ' 6/1/07 21:19'!
hash
	^self class hash bitXor: (collection hash bitShift: 14)! !

!SmaCCRHS methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	collection := OrderedCollection new.
	reduceAction := nil.
	variableNames := Dictionary new! !

!SmaCCRHS methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
nameLastItem: aString 
	variableNames at: aString put: collection size! !

!SmaCCRHS methodsFor: 'reduction table' stamp: 'lr 11/25/2009 18:01'!
parseTreeRewriter
	| rewriter |
	rewriter := RBParseTreeRewriter new.
	1 to: self size
		do: 
			[:i | 
			rewriter replace: i printString storeString
				with: '(nodes at: ' , i printString , ')'].
	variableNames keysAndValuesDo: 
			[:key :value | 
			rewriter replace: key with: '(nodes at: ' , value printString , ')'].
	^rewriter! !

!SmaCCRHS methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	^collection do: [:each | each printOn: aStream]
		separatedBy: [aStream space]! !

!SmaCCRHS methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
reduceAction
	^reduceAction! !

!SmaCCRHS methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
reduceAction: anObject
	reduceAction := anObject! !

!SmaCCRHS methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
size
	^collection size! !

Object subclass: #SmaCCRegularExpressionNode
	instanceVariableNames: 'action position states'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCRegularExpressionNode commentStamp: '<historical>' prior: 0!
SmaCCRegularExpressionNode represents a regular expression. The scanner is represented by a regular expression. These are the initial objects created in producing the scanner. From these nodes, we create a directed graph and then we compile the graph.

Subclasses must implement the following messages:
	accessing
		possibleMatchesSize
	private
		asNFAStartingWith:
		possibleMatchesDo:on:

Instance Variables:
	action	<SequenceableCollection>	the actions to be performed when we find a match
	position	<Integer>	the position of the RE in the scanner. If we have multiple matches, we prefer the ones listed first.!

SmaCCRegularExpressionNode subclass: #SmaCCCharacterRENode
	instanceVariableNames: 'characters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCCharacterRENode commentStamp: 'jmb' prior: 0!
SmaCCCharacterRENode represents a regular expression that matches one of a set of characters.

Instance Variables:
	characters	<SortedCollection of: Character>	The characters that this node can accept. Note that there are no duplicates and all characters are sorted.

!

!SmaCCCharacterRENode classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
characters: aString 
	^(self new)
		characters: (self sortedCharactersFor: aString);
		yourself! !

!SmaCCCharacterRENode classSide methodsFor: 'private' stamp: 'lr 1/6/2007 22:50'!
sortedCharactersFor: aString 
	| characters stream |
	stream := WriteStream with: String new.
	SmaCCGrammar ignoreCase 
		ifTrue: 
			[aString do: 
					[:each | 
					stream
						nextPut: each asUppercase;
						nextPut: each asLowercase]]
		ifFalse: [stream nextPutAll: aString].
	characters := stream contents 
				asSortedCollection: [:a :b | a asInteger < b asInteger].
	stream := WriteStream with: String new.
	characters inject: nil
		into: 
			[:sum :each | 
			sum = each ifFalse: [stream nextPut: each].
			each].
	^stream contents! !

!SmaCCCharacterRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
asNFAStartingWith: aSmaCCNode 
	| endNode startNode |
	startNode := self addStateTransitionsTo: aSmaCCNode.
	endNode := SmaCCNode new.
	endNode action: action.
	startNode addEdgeTo: endNode onCharacters: characters.
	^endNode! !

!SmaCCCharacterRENode methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
canMergeWith: aSmaCCRegularExpressionNode 
	^self class = aSmaCCRegularExpressionNode class and: 
			[characters notNil and: 
					[aSmaCCRegularExpressionNode characters notNil 
						and: [self action = aSmaCCRegularExpressionNode action]]]! !

!SmaCCCharacterRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
characters
	^characters! !

!SmaCCCharacterRENode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
characters: aString 
	characters := aString! !

!SmaCCCharacterRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
matchingCharacters
	^SmaCCGrammar ignoreCase 
		ifTrue: [characters reject: [:each | each isLowercase]]
		ifFalse: [characters]! !

!SmaCCCharacterRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
possibleMatchesDo: aBlock on: aStream 
	self matchingCharacters do: 
			[:each | 
			aStream nextPut: each.
			aBlock value.
			aStream skip: -1]! !

!SmaCCCharacterRENode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
possibleMatchesSize
	^self matchingCharacters size! !

!SmaCCCharacterRENode methodsFor: 'printing' stamp: 'lr 11/25/2009 18:29'!
printCharacter: aCharacter on: aStream 
	(aCharacter asInteger between: 32 and: 126) 
		ifTrue: [^aStream nextPut: aCharacter].
	aStream nextPutAll: '\x'.
	aStream nextPutAll: (aCharacter asInteger
		printPaddedWith: $0 to: 2 base: 16)! !

!SmaCCCharacterRENode methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	| allCharacters |
	characters size = 1 
		ifTrue: [^self printCharacter: characters first on: aStream].
	aStream nextPut: $[.
	allCharacters := characters.
	characters size > 128 
		ifTrue: 
			[aStream nextPut: $^.
			allCharacters := ((0 to: SmaCCGrammar maximumCharacterValue) 
						collect: [:each | Character value: each]) 
							reject: [:each | characters includes: each]].
	allCharacters do: [:each | self printCharacter: each on: aStream].
	aStream nextPut: $]! !

!SmaCCCharacterRENode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
| aSmaCCRegularExpressionNode 
	(self canMergeWith: aSmaCCRegularExpressionNode) 
		ifFalse: [^super | aSmaCCRegularExpressionNode].
	characters := String 
				withAll: ((characters , aSmaCCRegularExpressionNode characters) asSet 
						asSortedCollection: [:a :b | a asInteger < b asInteger]).
	^self! !

SmaCCRegularExpressionNode subclass: #SmaCCOrRENode
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCOrRENode commentStamp: 'jmb' prior: 0!
SmaCCOrRENode is a SmaCCRegularExpressionNode that represents an alternative.

Instance Variables:
	nodes	<Collection of: SmaCCRegularExpressionNode>	our possible choices!

!SmaCCOrRENode classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
nodes: aCollection 
	^(self new)
		nodes: aCollection;
		yourself! !

!SmaCCOrRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
asNFAStartingWith: aSmaCCNode 
	| endNode startNode |
	startNode := self addStateTransitionsTo: aSmaCCNode.
	endNode := SmaCCNode new.
	endNode action: action.
	nodes do: 
			[:each | 
			| componentStart |
			componentStart := SmaCCNode new.
			startNode addEdgeTo: componentStart.
			(each asNFAStartingWith: componentStart) addEdgeTo: endNode].
	^endNode! !

!SmaCCOrRENode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
nodes: aCollection 
	nodes := aCollection! !

!SmaCCOrRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
possibleMatchesDo: aBlock on: aStream 
	nodes do: 
			[:each | 
			| pos |
			pos := aStream position.
			each possibleMatchesDo: aBlock on: aStream.
			aStream position: pos]! !

!SmaCCOrRENode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
possibleMatchesSize
	^nodes inject: 0 into: [:sum :each | sum + each possibleMatchesSize]! !

!SmaCCOrRENode methodsFor: 'copying' stamp: ' 6/1/07 21:19'!
postCopy
	super postCopy.
	nodes := nodes copy! !

!SmaCCOrRENode methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	aStream nextPut: $(.
	nodes do: [:each | each printOn: aStream]
		separatedBy: [aStream nextPutAll: ' | '].
	aStream nextPut: $)! !

!SmaCCOrRENode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
| aSmaCCRegularExpressionNode 
	self action = aSmaCCRegularExpressionNode action 
		ifFalse: [^super | aSmaCCRegularExpressionNode].
	nodes add: aSmaCCRegularExpressionNode.
	^self! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
, aSmaCCRegularExpressionNode 
	^SmaCCSequenceRENode 
		nodes: (OrderedCollection with: self with: aSmaCCRegularExpressionNode)! !

!SmaCCRegularExpressionNode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
action
	^action! !

!SmaCCRegularExpressionNode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
action: aString
	action := aString! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addState: aSymbol
	states add: aSymbol! !

!SmaCCRegularExpressionNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
addStateTransitionsTo: aSmaCCNode 
	| endNode |
	states isEmpty ifTrue: [^aSmaCCNode].
	endNode := SmaCCNode new.
	aSmaCCNode addEdgeTo: endNode onStates: states asSortedCollection asArray.
	^endNode! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addStates: aCollection 
	states addAll: aCollection! !

!SmaCCRegularExpressionNode methodsFor: 'converting' stamp: ' 6/1/07 21:19'!
asDFA
	| startNode |
	startNode := SmaCCNode new.
	self asNFAStartingWith: startNode.
	^startNode asDFA! !

!SmaCCRegularExpressionNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
asNFAStartingWith: aSmaCCNode 
	^self subclassResponsibility! !

!SmaCCRegularExpressionNode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	states := Set new! !

!SmaCCRegularExpressionNode methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isKeywordLiteral
	^self possibleMatchesSize < 50 and: 
			[self possibleMatchesDo: [:each | each size > 1 ifTrue: [^true]].
			false]! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
position
	^position! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
position: anInteger
	position := anInteger! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
possibleMatches
	| matches |
	matches := OrderedCollection new.
	self possibleMatchesDo: [:each | matches add: each].
	^matches! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
possibleMatchesDo: aBlock 
	| stream |
	stream := WriteStream with: String new.
	self possibleMatchesDo: [aBlock value: stream contents] on: stream! !

!SmaCCRegularExpressionNode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
possibleMatchesDo: aBlock on: aStream 
	self subclassResponsibility! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
possibleMatchesSize
	^self subclassResponsibility! !

!SmaCCRegularExpressionNode methodsFor: 'copying' stamp: ' 6/1/07 21:19'!
postCopy
	super postCopy.
	states := Set new! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
repeat
	^SmaCCRepeatingRENode component: self! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
repeatFor: minimum to: maximum 
	^SmaCCRepeatingRENode 
		component: self
		minimum: minimum
		maximum: maximum! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
repeatForAtLeast: minimum 
	^SmaCCRepeatingRENode component: self minimum: minimum! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
states
	^states! !

!SmaCCRegularExpressionNode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
| aSmaCCRegularExpressionNode 
	^SmaCCOrRENode 
		nodes: (OrderedCollection with: self with: aSmaCCRegularExpressionNode)! !

SmaCCRegularExpressionNode subclass: #SmaCCRepeatingRENode
	instanceVariableNames: 'node minimumMatches maximumMatches'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCRepeatingRENode commentStamp: 'jmb' prior: 0!
SmaCCRepeatingRENode represents a repeating node in a regular expression.

Instance Variables:
	maximumMatches	<Integer>	the minimum number of matches required
	minimumMatches	<Integer>	the maximum number of matches allowed. An infinite amount of matches is represented by (SmaCCRepeatingRENode finiteInfinity).
	node	<SmaCCRegularExpressionNode>	what we need to match!

!SmaCCRepeatingRENode classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
component: aSmaCCRegularExpressionNode 
	^self component: aSmaCCRegularExpressionNode minimum: 0! !

!SmaCCRepeatingRENode classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
component: aSmaCCRegularExpressionNode minimum: anInteger 
	^self 
		component: aSmaCCRegularExpressionNode
		minimum: anInteger
		maximum: self finiteInfinity! !

!SmaCCRepeatingRENode classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
component: aSmaCCRegularExpressionNode minimum: minInteger maximum: maxInteger 
	^(self new)
		component: aSmaCCRegularExpressionNode
			minimum: minInteger
			maximum: maxInteger;
		yourself! !

!SmaCCRepeatingRENode classSide methodsFor: 'constants' stamp: ' 6/1/07 21:19'!
finiteInfinity
	"The number that we consider to be 'infinite'"

	^2147483648! !

!SmaCCRepeatingRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
asNFAStartingWith: aSmaCCNode 
	| endNode start |
	start := self addStateTransitionsTo: aSmaCCNode.
	endNode := SmaCCNode new.
	endNode action: action.
	minimumMatches timesRepeat: [start := node asNFAStartingWith: start].
	start addEdgeTo: endNode.
	maximumMatches < self class finiteInfinity 
		ifTrue: 
			[maximumMatches - minimumMatches timesRepeat: 
					[start := node asNFAStartingWith: start.
					start addEdgeTo: endNode]]
		ifFalse: [(node asNFAStartingWith: start) addEdgeTo: start].
	^endNode! !

!SmaCCRepeatingRENode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
component: aSmaCCRegularExpressionNode minimum: minInteger maximum: maxInteger 
	node := aSmaCCRegularExpressionNode.
	minimumMatches := minInteger.
	maximumMatches := maxInteger! !

!SmaCCRepeatingRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
possibleMatchesDo: aBlock on: aStream 
	self 
		possibleMatchesDo: aBlock
		on: aStream
		startingAt: 0! !

!SmaCCRepeatingRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
possibleMatchesDo: aBlock on: aStream startingAt: anInteger 
	(anInteger between: minimumMatches and: maximumMatches) 
		ifTrue: [aBlock value].
	anInteger < maximumMatches 
		ifTrue: 
			[node possibleMatchesDo: 
					[self 
						possibleMatchesDo: aBlock
						on: aStream
						startingAt: anInteger + 1]
				on: aStream]! !

!SmaCCRepeatingRENode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
possibleMatchesSize
	^node possibleMatchesSize * (maximumMatches - minimumMatches + 1)! !

!SmaCCRepeatingRENode methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	node printOn: aStream.
	maximumMatches = (1 bitShift: 31) 
		ifTrue: 
			[minimumMatches = 0 ifTrue: [^aStream nextPut: $*].
			minimumMatches = 1 ifTrue: [^aStream nextPut: $+].
			^aStream
				nextPut: ${;
				nextPutAll: minimumMatches printString;
				nextPutAll: ',}'].
	aStream
		nextPut: ${;
		nextPutAll: minimumMatches printString;
		nextPut: $,;
		nextPutAll: maximumMatches printString;
		nextPut: $}! !

SmaCCRegularExpressionNode subclass: #SmaCCSequenceRENode
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCSequenceRENode commentStamp: 'jmb' prior: 0!
SmaCCSequenceRENode represents a regular expression that is made up of several other regular expressions concatenated together.

Instance Variables:
	nodes	<Collection of: SmaCCRegularExpressionNode>	our children nodes in left-to-right order!

!SmaCCSequenceRENode classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
nodes: aCollection 
	^(self new)
		nodes: aCollection;
		yourself! !

!SmaCCSequenceRENode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
, aSmaCCRegularExpressionNode 
	self action = aSmaCCRegularExpressionNode action 
		ifFalse: [^super , aSmaCCRegularExpressionNode].
	nodes add: aSmaCCRegularExpressionNode.
	^self! !

!SmaCCSequenceRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
asNFAStartingWith: aSmaCCNode 
	| endNode startNode |
	startNode := self addStateTransitionsTo: aSmaCCNode.
	endNode := SmaCCNode new.
	endNode action: action.
	(nodes inject: startNode into: [:sum :each | each asNFAStartingWith: sum]) 
		addEdgeTo: endNode.
	^endNode! !

!SmaCCSequenceRENode methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
nodes: aCollection 
	nodes := aCollection! !

!SmaCCSequenceRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
possibleMatchesDo: aBlock on: aStream 
	self 
		possibleMatchesDo: aBlock
		on: aStream
		startingAt: 1! !

!SmaCCSequenceRENode methodsFor: 'private' stamp: ' 6/1/07 21:19'!
possibleMatchesDo: aBlock on: aStream startingAt: anInteger 
	| node |
	node := nodes at: anInteger.
	nodes size = anInteger 
		ifTrue: [node possibleMatchesDo: aBlock on: aStream]
		ifFalse: 
			[node possibleMatchesDo: 
					[self 
						possibleMatchesDo: aBlock
						on: aStream
						startingAt: anInteger + 1]
				on: aStream]! !

!SmaCCSequenceRENode methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
possibleMatchesSize
	^nodes inject: 1 into: [:sum :each | sum * each possibleMatchesSize]! !

!SmaCCSequenceRENode methodsFor: 'copying' stamp: ' 6/1/07 21:19'!
postCopy
	super postCopy.
	nodes := nodes copy! !

!SmaCCSequenceRENode methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	nodes do: [:each | each printOn: aStream] separatedBy: [aStream space]! !

Object subclass: #SmaCCScannerCompiler
	instanceVariableNames: 'grammar scannerClass scannerDefinitionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCScannerCompiler commentStamp: 'jmb' prior: 0!
SmaCCScannerCompiler represents the compiler for the scanner part of the parser.

Instance Variables:
	grammar	<SmaCCGrammar>	the grammar that defines the scanner
	scannerClass	<RBAbstractClass>	the class to compile the scanner into
	scannerDefinitionString	<String>	the string that defines the scanner!

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: 'lr 1/6/2007 21:42'!
addActions
	self symbols keysAndValuesDo: [:index :each | 
		each regularExpression ifNotNilDo: [:eachRegex | eachRegex action: index ]]! !

!SmaCCScannerCompiler methodsFor: 'regular expression construction' stamp: ' 6/1/07 21:19'!
addActionsFrom: aRegularExpression to: aKeywordMap at: states 
	^states do: 
			[:state | 
			state ~= aRegularExpression action 
				ifTrue: 
					[aRegularExpression possibleMatchesDo: 
							[:string | 
							(aKeywordMap at: state ifAbsentPut: [Dictionary new]) at: string
								put: aRegularExpression action]]]! !

!SmaCCScannerCompiler methodsFor: 'regular expression construction' stamp: ' 6/1/07 21:19'!
addNormalSymbols
	grammar 
		symbols: (self symbols asSortedCollection: self filePositionSortBlock)! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
addSpecialSymbols
	grammar tokens keysDo: 
			[:each | 
			(self scannerActionFor: each) notNil 
				ifTrue: [grammar terminalSymbolNamed: each]]! !

!SmaCCScannerCompiler methodsFor: 'regular expression construction' stamp: ' 6/1/07 21:19'!
addSpecificREsWithoutActionsTo: aRegularExpression 
	| dfa regex |
	regex := aRegularExpression.
	dfa := regex isNil ifTrue: [nil] ifFalse: [regex asDFA].
	self specificRegularExpressionsDo: 
			[:each | 
			| actions |
			actions := dfa isNil 
						ifTrue: [nil]
						ifFalse: [dfa actionForSpecificRegularExpression: each].
			actions isNil 
				ifTrue: [regex isNil ifTrue: [regex := each] ifFalse: [regex := regex | each]]].
	^regex! !

!SmaCCScannerCompiler methodsFor: 'regular expression construction' stamp: ' 6/1/07 21:19'!
combinedGeneralRegexes
	| combinedRegex |
	combinedRegex := nil.
	self generalRegularExpressionsDo: 
			[:each | 
			combinedRegex := combinedRegex isNil 
						ifTrue: [each]
						ifFalse: [combinedRegex | each]].
	^combinedRegex! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
compileEmptySymbolTokenId
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'emptySymbolTokenId';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: (self symbols indexOf: SmaCCSymbol empty) printString.
	self scannerClass compile: stream contents classified: #'generated-tokens'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
compileErrorSymbolTokenId
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'errorTokenId';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: (self symbols indexOf: SmaCCSymbol error) printString.
	self scannerClass compile: stream contents classified: #'generated-tokens'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
compileIgnoreCaseMethod
	SmaCCGrammar ignoreCase 
		ifTrue: 
			[scannerClass compile: 'keywordFor: aString 
	^aString asUppercase'
				classified: #'generated-scanner']! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: 'lr 11/25/2009 18:00'!
compileKeywordInitializerUsing: keywordMapDictionary selectorMap: selectorMapDictionary 
	| stream dataStream |
	keywordMapDictionary isEmpty ifTrue: [^self].
	stream := WriteStream with: String new.
	stream nextPutAll: 'initializeKeywordMap'.
	stream nextPutAll: ' keywordMap :=  Dictionary new. '.
	dataStream := WriteStream with: Array new.
	keywordMapDictionary keysAndValuesDo: 
			[:key :value | 
			value keys asSortedCollection do: 
					[:each | 
					dataStream nextPut: (Array 
								with: (selectorMapDictionary at: key ifAbsent: [key])
								with: each
								with: (selectorMapDictionary at: (value at: each) ifAbsent: [value at: each]))]].
	stream
		nextPutAll: '#(';
		cr.
	dataStream contents do: 
			[:each | 
			stream nextPutAll: '#('.
			each do: [:item | item storeOn: stream] separatedBy: [stream nextPut: $ ].
			stream nextPut: $)]
		separatedBy: [stream cr].
	stream nextPut: $).
	stream 
		nextPutAll: ' do: [:each | (keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2) put: each last]. ^keywordMap'.
	scannerClass theMetaClass 
		compile: (RBParser parseMethod: stream contents) formattedCode
		classified: #'generated-initialization'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
compileMethodsFor: regex withSelectors: selectorMap 
	| keywordmap dfa |
	dfa := regex asDFA.
	keywordmap := self computeKeywordMapFor: dfa.
	self compileKeywordInitializerUsing: keywordmap selectorMap: selectorMap.
	dfa compileInto: scannerClass usingSelectorMap: selectorMap.
	self compileEmptySymbolTokenId.
	self compileErrorSymbolTokenId.
	self compileIgnoreCaseMethod! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
compileScanner
	| regex |
	self addSpecialSymbols.
	self addNormalSymbols.
	self addActions.
	self compileTokenIdMethods.
	regex := self addSpecificREsWithoutActionsTo: self combinedGeneralRegexes.
	self compileMethodsFor: regex withSelectors: self computeSelectorMap! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: 'lr 11/25/2009 18:00'!
compileScannerDefinitionComment
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'scannerDefinitionComment';
		cr;
		cr;
		tab;
		nextPut: $";
		nextPutAll: (scannerDefinitionString copyReplaceAll: '"' with: '""');
		nextPut: $".
	self scannerClass theMetaClass compile: stream contents
		classified: #'generated-comments'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
compileTokenIdMethodFor: aTerminalSymbol 
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: aTerminalSymbol safeMethodName;
		nextPutAll: 'Id';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: (self symbols indexOf: aTerminalSymbol) printString.
	scannerClass compile: stream contents classified: #'generated-tokens'! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
compileTokenIdMethods
	(self symbols select: [:each | each createIdMethod]) 
		do: [:each | self compileTokenIdMethodFor: each]! !

!SmaCCScannerCompiler methodsFor: 'regular expression construction' stamp: ' 6/1/07 21:19'!
computeKeywordMapFor: dfa 
	| keywordmap |
	keywordmap := Dictionary new.
	self specificRegularExpressionsDo: 
			[:each | 
			| actions |
			actions := dfa actionForSpecificRegularExpression: each.
			actions isNil 
				ifFalse: 
					[self 
						addActionsFrom: each
						to: keywordmap
						at: actions]].
	^keywordmap! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: 'lr 1/6/2007 21:43'!
computeSelectorMap
	| selectorMap |
	selectorMap := Dictionary new.
	self symbols keysAndValuesDo: 
			[:index :each | 
			(self scannerActionFor: each name) 
				ifNotNilDo: [:selector | selectorMap at: index put: selector]].
	^selectorMap! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
filePositionSortBlock
	^
	[:a :b | 
	| aRegex bRegex |
	aRegex := a regularExpression.
	bRegex := b regularExpression.
	bRegex isNil or: 
			[aRegex notNil 
				and: [(aRegex position ifNil: [0]) < (bRegex position ifNil: [0])]]]! !

!SmaCCScannerCompiler methodsFor: 'regular expression construction' stamp: ' 6/1/07 21:19'!
generalRegularExpressionsDo: aBlock 
	self 
		regularExpressionsDo: [:each | each isKeywordLiteral ifFalse: [aBlock value: each]]! !

!SmaCCScannerCompiler methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
grammar: aGrammar
	grammar := aGrammar! !

!SmaCCScannerCompiler methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
parseTokens
	grammar scannerDefinition: (SmaCCScannerParser parse: scannerDefinitionString)! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: ' 6/1/07 21:19'!
regularExpressionsDo: aBlock 
	self symbols do: [:each | each regularExpression ifNotNil: aBlock]! !

!SmaCCScannerCompiler methodsFor: 'compiling-scanner' stamp: 'ThierryGoubier 5/14/2012 15:41'!
scannerActionFor: aString
	| selector |
	aString size > 2
		ifFalse: [ ^ nil ].
	selector := (aString copyFrom: 2 to: aString size - 1) asSymbol.
	^ ((scannerClass definesMethod: selector)
		and: [ 
			(Object canUnderstand: selector) not
				and: [ 
					((SmaCCScanner canUnderstand: selector) not or: [ #(#comment #whitespace) includes: selector ])
						and: [ selector numArgs = 0 ] ] ])
		ifTrue: [ selector ]
		ifFalse: [ nil ]! !

!SmaCCScannerCompiler methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
scannerClass
	^scannerClass! !

!SmaCCScannerCompiler methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
scannerClass: anObject
	scannerClass := anObject! !

!SmaCCScannerCompiler methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
scannerDefinitionString: aString
	scannerDefinitionString := aString! !

!SmaCCScannerCompiler methodsFor: 'regular expression construction' stamp: ' 6/1/07 21:19'!
specificRegularExpressionsDo: aBlock 
	self 
		regularExpressionsDo: [:each | each isKeywordLiteral ifTrue: [aBlock value: each]]! !

!SmaCCScannerCompiler methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
symbols
	^grammar symbols! !

Object subclass: #SmaCCScannerDefinition
	instanceVariableNames: 'tokens states excludeStates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ScannerGenerator'!

!SmaCCScannerDefinition commentStamp: '<historical>' prior: 0!
SmaCCScannerDefinition is the parsed representation of the scanner. It contains the tokens and states for the scanner.

Instance Variables:
	excludeStates	<Collection>	exclusive states (when we are in one of these, then we shouldn't try to parse the default tokens)
	states	<Collection>	states in the scanner -- if no states are specified, then this will only contain #default
	tokens	<Dictionary>	dictionary mapping token names to their regular expressions

!

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addExcludeState: aSymbol 
	excludeStates add: aSymbol.
	self addState: aSymbol! !

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addState: aSymbol
	states add: aSymbol! !

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addToken: aSmaCCRENode withName: aString
	tokens at: aString put: aSmaCCRENode! !

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
defaultState
	^#default! !

!SmaCCScannerDefinition methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
includesTokenNamed: aString
	^tokens includesKey: aString! !

!SmaCCScannerDefinition methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
initialize
	tokens := Dictionary new.
	states := Set with: self defaultState.
	excludeStates := Set new! !

!SmaCCScannerDefinition methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isExcludeState: aSymbol
	^excludeStates includes: aSymbol! !

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
nonExcludeStates
	| nonExcludeStates |
	nonExcludeStates := states reject: [:each | self isExcludeState: each].
	nonExcludeStates add: self defaultState.
	^nonExcludeStates! !

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
states
	^states! !

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
tokenNamed: aString
	^tokens at: aString! !

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
tokenNamed: aString ifAbsentPut: aBlock 
	^tokens at: aString ifAbsentPut: aBlock! !

!SmaCCScannerDefinition methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
tokens
	^tokens! !

Object subclass: #SmaCCSymbol
	instanceVariableNames: 'name precedence firstItems'
	classVariableNames: 'EmptySymbol ErrorSymbol SentinelSymbol'
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCSymbol commentStamp: '<historical>' prior: 0!
SmaCCSymbol is an abstract class that represents a symbol in the grammar.

Subclasses must implement the following messages:
	accessing
		calculateFirstTerminals
	testing
		isTerminal

Instance Variables:
	firstItems	<Collection of: SmaCCTerminalSymbol>	the first terminals that can be produced from us
	name	<String>	our name
	precedence	<Integer>	our precedence (in case of shift/reduce conflicts)

!

SmaCCSymbol subclass: #SmaCCNonTerminalSymbol
	instanceVariableNames: 'productions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCNonTerminalSymbol commentStamp: 'jmb' prior: 0!
SmaCCNonTerminalSymbol represents a non-terminal symbol in our grammar.

Instance Variables:
	productions	<SequenceableCollection of: SmaCCRHS>	our rhs' for the symbol!

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
addProduction: aSmaCCRHS
	productions add: aSmaCCRHS! !

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
calculateFirstTerminals
	| initialSize |
	initialSize := firstItems size.
	productions isEmpty 
		ifTrue: [firstItems add: self class empty]
		ifFalse: [productions do: [:each | firstItems addAll: each firstTerminals]].
	^initialSize ~= firstItems size! !

!SmaCCNonTerminalSymbol methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isEmpty
	^productions isEmpty! !

!SmaCCNonTerminalSymbol methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isTerminal
	^false! !

!SmaCCNonTerminalSymbol methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
name: aString 
	super name: aString.
	productions := OrderedCollection new! !

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
positionOf: aSmaCCRHS 
	^productions indexOf: aSmaCCRHS! !

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
productionsDo: aBlock 
	productions do: aBlock! !

!SmaCCNonTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
size
	^productions size! !

SmaCCNonTerminalSymbol subclass: #SmaCCStartingSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCStartingSymbol commentStamp: 'jmb' prior: 0!
SmaCCStartingSymbol is the starting symbol in the grammar. A grammar can only have one starting symbol, but it can have may different starting item sets.!

!SmaCCStartingSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
asLRItemSet
	| itemSet |
	itemSet := SmaCCItemSet new.
	productions do: 
			[:each | 
			itemSet add: (SmaCCLR1Item 
						symbol: self
						rhs: each
						follow: ((SmaCCSymbolSet new)
								add: self class empty;
								yourself))].
	^itemSet! !

!SmaCCStartingSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
compileName
	^(productions first at: 1) safeMethodName! !

!SmaCCStartingSymbol methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isStartingSymbol
	^true! !

!SmaCCSymbol classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
empty
	EmptySymbol isNil 
		ifTrue: [EmptySymbol := SmaCCTerminalSymbol name: 'E O F'].
	^EmptySymbol! !

!SmaCCSymbol classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
error
	ErrorSymbol isNil 
		ifTrue: [ErrorSymbol := SmaCCTerminalSymbol name: 'error'].
	^ErrorSymbol! !

!SmaCCSymbol classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
name: aString 
	^(self new)
		name: aString;
		yourself! !

!SmaCCSymbol classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
releaseObjects
	EmptySymbol := nil.
	SentinelSymbol := nil.
	ErrorSymbol := nil! !

!SmaCCSymbol classSide methodsFor: 'instance creation' stamp: ' 6/1/07 21:19'!
sentinel
	SentinelSymbol isNil 
		ifTrue: [SentinelSymbol := SmaCCTerminalSymbol name: 'S e n t i n e l'].
	^SentinelSymbol! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
calculateFirstTerminals
	^self subclassResponsibility! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
createIdMethod
	^false! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
firstTerminals
	^firstItems! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
isEmptySymbol
	^self = self class empty! !

!SmaCCSymbol methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isStartingSymbol
	^false! !

!SmaCCSymbol methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isTerminal
	^self subclassResponsibility! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
name
	^name! !

!SmaCCSymbol methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
name: aString 
	name := aString.
	firstItems := Set new! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
precedence
	^precedence! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
precedence: anInteger
	precedence := anInteger! !

!SmaCCSymbol methodsFor: 'printing' stamp: ' 6/1/07 21:19'!
printOn: aStream 
	aStream nextPutAll: name! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
productionsDo: aBlock! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
regularExpression
	^nil! !

!SmaCCSymbol methodsFor: 'accessing' stamp: 'lr 1/7/2007 10:57'!
safeMethodName
	^self unsafeMethodName 
		collect: [:each | each isAlphaNumeric ifTrue: [each] ifFalse: [$X]]! !

!SmaCCSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
size
	^0! !

!SmaCCSymbol methodsFor: 'private' stamp: ' 6/1/07 21:19'!
unsafeMethodName
	^self printString! !

SmaCCSymbol subclass: #SmaCCTerminalSymbol
	instanceVariableNames: 'regularExpression createIdMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCCDev-ParserGenerator'!

!SmaCCTerminalSymbol commentStamp: 'jmb' prior: 0!
SmaCCTerminalSymbol represents a terminal symbol in our grammar.

Instance Variables:
	createIdMethod	<Boolean>	should we create a symbolNameId method for this symbol.
	regularExpression	<SmaCCRegularExpression>	our regular expression that we must match for this terminal symbol!

!SmaCCTerminalSymbol methodsFor: 'private' stamp: ' 6/1/07 21:19'!
calculateFirstTerminals
	^false! !

!SmaCCTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
createIdMethod
	^createIdMethod! !

!SmaCCTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
createIdMethod: aBoolean
	createIdMethod := aBoolean! !

!SmaCCTerminalSymbol methodsFor: 'testing' stamp: ' 6/1/07 21:19'!
isTerminal
	^true! !

!SmaCCTerminalSymbol methodsFor: 'initialize-release' stamp: ' 6/1/07 21:19'!
name: aString 
	super name: aString.
	firstItems add: self.
	createIdMethod := false! !

!SmaCCTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
regularExpression
	^regularExpression! !

!SmaCCTerminalSymbol methodsFor: 'accessing' stamp: ' 6/1/07 21:19'!
regularExpression: aSmaCCRegularExpressionNode
	regularExpression := aSmaCCRegularExpressionNode! !

!SmaCCTerminalSymbol methodsFor: 'private' stamp: ' 6/1/07 21:19'!
unsafeMethodName
	^name copyFrom: 2 to: name size - 1! !
SmaCCGrammar initialize!
SmaCCNode initialize!
SmaCCParserGenerator initialize!
SmaCCRejectAction initialize!
SmaCCShiftAction initialize!
